var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var _a;
(function polyfill() {
  const relList = document.createElement("link").relList;
  if (relList && relList.supports && relList.supports("modulepreload")) {
    return;
  }
  for (const link of document.querySelectorAll('link[rel="modulepreload"]')) {
    processPreload(link);
  }
  new MutationObserver((mutations) => {
    for (const mutation of mutations) {
      if (mutation.type !== "childList") {
        continue;
      }
      for (const node of mutation.addedNodes) {
        if (node.tagName === "LINK" && node.rel === "modulepreload")
          processPreload(node);
      }
    }
  }).observe(document, { childList: true, subtree: true });
  function getFetchOpts(script) {
    const fetchOpts = {};
    if (script.integrity)
      fetchOpts.integrity = script.integrity;
    if (script.referrerpolicy)
      fetchOpts.referrerPolicy = script.referrerpolicy;
    if (script.crossorigin === "use-credentials")
      fetchOpts.credentials = "include";
    else if (script.crossorigin === "anonymous")
      fetchOpts.credentials = "omit";
    else
      fetchOpts.credentials = "same-origin";
    return fetchOpts;
  }
  function processPreload(link) {
    if (link.ep)
      return;
    link.ep = true;
    const fetchOpts = getFetchOpts(link);
    fetch(link.href, fetchOpts);
  }
})();
/**
* @vue/shared v3.5.13
* (c) 2018-present Yuxi (Evan) You and Vue contributors
* @license MIT
**/
/*! #__NO_SIDE_EFFECTS__ */
function makeMap(str) {
  const map = /* @__PURE__ */ Object.create(null);
  for (const key of str.split(","))
    map[key] = 1;
  return (val) => val in map;
}
const EMPTY_OBJ = {};
const EMPTY_ARR = [];
const NOOP = () => {
};
const NO = () => false;
const isOn = (key) => key.charCodeAt(0) === 111 && key.charCodeAt(1) === 110 && (key.charCodeAt(2) > 122 || key.charCodeAt(2) < 97);
const isModelListener = (key) => key.startsWith("onUpdate:");
const extend = Object.assign;
const remove = (arr, el) => {
  const i2 = arr.indexOf(el);
  if (i2 > -1) {
    arr.splice(i2, 1);
  }
};
const hasOwnProperty$1 = Object.prototype.hasOwnProperty;
const hasOwn = (val, key) => hasOwnProperty$1.call(val, key);
const isArray = Array.isArray;
const isMap$1 = (val) => toTypeString(val) === "[object Map]";
const isSet$1 = (val) => toTypeString(val) === "[object Set]";
const isDate = (val) => toTypeString(val) === "[object Date]";
const isRegExp = (val) => toTypeString(val) === "[object RegExp]";
const isFunction = (val) => typeof val === "function";
const isString$1 = (val) => typeof val === "string";
const isSymbol$1 = (val) => typeof val === "symbol";
const isObject = (val) => val !== null && typeof val === "object";
const isPromise = (val) => {
  return (isObject(val) || isFunction(val)) && isFunction(val.then) && isFunction(val.catch);
};
const objectToString = Object.prototype.toString;
const toTypeString = (value) => objectToString.call(value);
const toRawType = (value) => {
  return toTypeString(value).slice(8, -1);
};
const isPlainObject = (val) => toTypeString(val) === "[object Object]";
const isIntegerKey = (key) => isString$1(key) && key !== "NaN" && key[0] !== "-" && "" + parseInt(key, 10) === key;
const isReservedProp = /* @__PURE__ */ makeMap(
  ",key,ref,ref_for,ref_key,onVnodeBeforeMount,onVnodeMounted,onVnodeBeforeUpdate,onVnodeUpdated,onVnodeBeforeUnmount,onVnodeUnmounted"
);
const cacheStringFunction = (fn) => {
  const cache = /* @__PURE__ */ Object.create(null);
  return (str) => {
    const hit = cache[str];
    return hit || (cache[str] = fn(str));
  };
};
const camelizeRE = /-(\w)/g;
const camelize = cacheStringFunction(
  (str) => {
    return str.replace(camelizeRE, (_2, c) => c ? c.toUpperCase() : "");
  }
);
const hyphenateRE = /\B([A-Z])/g;
const hyphenate = cacheStringFunction(
  (str) => str.replace(hyphenateRE, "-$1").toLowerCase()
);
const capitalize = cacheStringFunction((str) => {
  return str.charAt(0).toUpperCase() + str.slice(1);
});
const toHandlerKey = cacheStringFunction(
  (str) => {
    const s2 = str ? `on${capitalize(str)}` : ``;
    return s2;
  }
);
const hasChanged = (value, oldValue) => !Object.is(value, oldValue);
const invokeArrayFns = (fns, ...arg) => {
  for (let i2 = 0; i2 < fns.length; i2++) {
    fns[i2](...arg);
  }
};
const def = (obj, key, value, writable = false) => {
  Object.defineProperty(obj, key, {
    configurable: true,
    enumerable: false,
    writable,
    value
  });
};
const looseToNumber = (val) => {
  const n = parseFloat(val);
  return isNaN(n) ? val : n;
};
const toNumber = (val) => {
  const n = isString$1(val) ? Number(val) : NaN;
  return isNaN(n) ? val : n;
};
let _globalThis;
const getGlobalThis = () => {
  return _globalThis || (_globalThis = typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : {});
};
function normalizeStyle(value) {
  if (isArray(value)) {
    const res = {};
    for (let i2 = 0; i2 < value.length; i2++) {
      const item = value[i2];
      const normalized = isString$1(item) ? parseStringStyle(item) : normalizeStyle(item);
      if (normalized) {
        for (const key in normalized) {
          res[key] = normalized[key];
        }
      }
    }
    return res;
  } else if (isString$1(value) || isObject(value)) {
    return value;
  }
}
const listDelimiterRE = /;(?![^(]*\))/g;
const propertyDelimiterRE = /:([^]+)/;
const styleCommentRE = /\/\*[^]*?\*\//g;
function parseStringStyle(cssText) {
  const ret = {};
  cssText.replace(styleCommentRE, "").split(listDelimiterRE).forEach((item) => {
    if (item) {
      const tmp = item.split(propertyDelimiterRE);
      tmp.length > 1 && (ret[tmp[0].trim()] = tmp[1].trim());
    }
  });
  return ret;
}
function normalizeClass(value) {
  let res = "";
  if (isString$1(value)) {
    res = value;
  } else if (isArray(value)) {
    for (let i2 = 0; i2 < value.length; i2++) {
      const normalized = normalizeClass(value[i2]);
      if (normalized) {
        res += normalized + " ";
      }
    }
  } else if (isObject(value)) {
    for (const name in value) {
      if (value[name]) {
        res += name + " ";
      }
    }
  }
  return res.trim();
}
const specialBooleanAttrs = `itemscope,allowfullscreen,formnovalidate,ismap,nomodule,novalidate,readonly`;
const isSpecialBooleanAttr = /* @__PURE__ */ makeMap(specialBooleanAttrs);
function includeBooleanAttr(value) {
  return !!value || value === "";
}
function looseCompareArrays(a2, b2) {
  if (a2.length !== b2.length)
    return false;
  let equal = true;
  for (let i2 = 0; equal && i2 < a2.length; i2++) {
    equal = looseEqual(a2[i2], b2[i2]);
  }
  return equal;
}
function looseEqual(a2, b2) {
  if (a2 === b2)
    return true;
  let aValidType = isDate(a2);
  let bValidType = isDate(b2);
  if (aValidType || bValidType) {
    return aValidType && bValidType ? a2.getTime() === b2.getTime() : false;
  }
  aValidType = isSymbol$1(a2);
  bValidType = isSymbol$1(b2);
  if (aValidType || bValidType) {
    return a2 === b2;
  }
  aValidType = isArray(a2);
  bValidType = isArray(b2);
  if (aValidType || bValidType) {
    return aValidType && bValidType ? looseCompareArrays(a2, b2) : false;
  }
  aValidType = isObject(a2);
  bValidType = isObject(b2);
  if (aValidType || bValidType) {
    if (!aValidType || !bValidType) {
      return false;
    }
    const aKeysCount = Object.keys(a2).length;
    const bKeysCount = Object.keys(b2).length;
    if (aKeysCount !== bKeysCount) {
      return false;
    }
    for (const key in a2) {
      const aHasKey = a2.hasOwnProperty(key);
      const bHasKey = b2.hasOwnProperty(key);
      if (aHasKey && !bHasKey || !aHasKey && bHasKey || !looseEqual(a2[key], b2[key])) {
        return false;
      }
    }
  }
  return String(a2) === String(b2);
}
function looseIndexOf(arr, val) {
  return arr.findIndex((item) => looseEqual(item, val));
}
const isRef$1 = (val) => {
  return !!(val && val["__v_isRef"] === true);
};
const toDisplayString = (val) => {
  return isString$1(val) ? val : val == null ? "" : isArray(val) || isObject(val) && (val.toString === objectToString || !isFunction(val.toString)) ? isRef$1(val) ? toDisplayString(val.value) : JSON.stringify(val, replacer, 2) : String(val);
};
const replacer = (_key, val) => {
  if (isRef$1(val)) {
    return replacer(_key, val.value);
  } else if (isMap$1(val)) {
    return {
      [`Map(${val.size})`]: [...val.entries()].reduce(
        (entries, [key, val2], i2) => {
          entries[stringifySymbol(key, i2) + " =>"] = val2;
          return entries;
        },
        {}
      )
    };
  } else if (isSet$1(val)) {
    return {
      [`Set(${val.size})`]: [...val.values()].map((v2) => stringifySymbol(v2))
    };
  } else if (isSymbol$1(val)) {
    return stringifySymbol(val);
  } else if (isObject(val) && !isArray(val) && !isPlainObject(val)) {
    return String(val);
  }
  return val;
};
const stringifySymbol = (v2, i2 = "") => {
  var _a2;
  return isSymbol$1(v2) ? `Symbol(${(_a2 = v2.description) != null ? _a2 : i2})` : v2;
};
/**
* @vue/reactivity v3.5.13
* (c) 2018-present Yuxi (Evan) You and Vue contributors
* @license MIT
**/
let activeEffectScope;
class EffectScope {
  constructor(detached = false) {
    this.detached = detached;
    this._active = true;
    this.effects = [];
    this.cleanups = [];
    this._isPaused = false;
    this.parent = activeEffectScope;
    if (!detached && activeEffectScope) {
      this.index = (activeEffectScope.scopes || (activeEffectScope.scopes = [])).push(
        this
      ) - 1;
    }
  }
  get active() {
    return this._active;
  }
  pause() {
    if (this._active) {
      this._isPaused = true;
      let i2, l;
      if (this.scopes) {
        for (i2 = 0, l = this.scopes.length; i2 < l; i2++) {
          this.scopes[i2].pause();
        }
      }
      for (i2 = 0, l = this.effects.length; i2 < l; i2++) {
        this.effects[i2].pause();
      }
    }
  }
  resume() {
    if (this._active) {
      if (this._isPaused) {
        this._isPaused = false;
        let i2, l;
        if (this.scopes) {
          for (i2 = 0, l = this.scopes.length; i2 < l; i2++) {
            this.scopes[i2].resume();
          }
        }
        for (i2 = 0, l = this.effects.length; i2 < l; i2++) {
          this.effects[i2].resume();
        }
      }
    }
  }
  run(fn) {
    if (this._active) {
      const currentEffectScope = activeEffectScope;
      try {
        activeEffectScope = this;
        return fn();
      } finally {
        activeEffectScope = currentEffectScope;
      }
    }
  }
  on() {
    activeEffectScope = this;
  }
  off() {
    activeEffectScope = this.parent;
  }
  stop(fromParent) {
    if (this._active) {
      this._active = false;
      let i2, l;
      for (i2 = 0, l = this.effects.length; i2 < l; i2++) {
        this.effects[i2].stop();
      }
      this.effects.length = 0;
      for (i2 = 0, l = this.cleanups.length; i2 < l; i2++) {
        this.cleanups[i2]();
      }
      this.cleanups.length = 0;
      if (this.scopes) {
        for (i2 = 0, l = this.scopes.length; i2 < l; i2++) {
          this.scopes[i2].stop(true);
        }
        this.scopes.length = 0;
      }
      if (!this.detached && this.parent && !fromParent) {
        const last = this.parent.scopes.pop();
        if (last && last !== this) {
          this.parent.scopes[this.index] = last;
          last.index = this.index;
        }
      }
      this.parent = void 0;
    }
  }
}
function getCurrentScope() {
  return activeEffectScope;
}
let activeSub;
const pausedQueueEffects = /* @__PURE__ */ new WeakSet();
class ReactiveEffect {
  constructor(fn) {
    this.fn = fn;
    this.deps = void 0;
    this.depsTail = void 0;
    this.flags = 1 | 4;
    this.next = void 0;
    this.cleanup = void 0;
    this.scheduler = void 0;
    if (activeEffectScope && activeEffectScope.active) {
      activeEffectScope.effects.push(this);
    }
  }
  pause() {
    this.flags |= 64;
  }
  resume() {
    if (this.flags & 64) {
      this.flags &= ~64;
      if (pausedQueueEffects.has(this)) {
        pausedQueueEffects.delete(this);
        this.trigger();
      }
    }
  }
  notify() {
    if (this.flags & 2 && !(this.flags & 32)) {
      return;
    }
    if (!(this.flags & 8)) {
      batch(this);
    }
  }
  run() {
    if (!(this.flags & 1)) {
      return this.fn();
    }
    this.flags |= 2;
    cleanupEffect(this);
    prepareDeps(this);
    const prevEffect = activeSub;
    const prevShouldTrack = shouldTrack;
    activeSub = this;
    shouldTrack = true;
    try {
      return this.fn();
    } finally {
      cleanupDeps(this);
      activeSub = prevEffect;
      shouldTrack = prevShouldTrack;
      this.flags &= ~2;
    }
  }
  stop() {
    if (this.flags & 1) {
      for (let link = this.deps; link; link = link.nextDep) {
        removeSub(link);
      }
      this.deps = this.depsTail = void 0;
      cleanupEffect(this);
      this.onStop && this.onStop();
      this.flags &= ~1;
    }
  }
  trigger() {
    if (this.flags & 64) {
      pausedQueueEffects.add(this);
    } else if (this.scheduler) {
      this.scheduler();
    } else {
      this.runIfDirty();
    }
  }
  runIfDirty() {
    if (isDirty(this)) {
      this.run();
    }
  }
  get dirty() {
    return isDirty(this);
  }
}
let batchDepth = 0;
let batchedSub;
let batchedComputed;
function batch(sub, isComputed = false) {
  sub.flags |= 8;
  if (isComputed) {
    sub.next = batchedComputed;
    batchedComputed = sub;
    return;
  }
  sub.next = batchedSub;
  batchedSub = sub;
}
function startBatch() {
  batchDepth++;
}
function endBatch() {
  if (--batchDepth > 0) {
    return;
  }
  if (batchedComputed) {
    let e = batchedComputed;
    batchedComputed = void 0;
    while (e) {
      const next = e.next;
      e.next = void 0;
      e.flags &= ~8;
      e = next;
    }
  }
  let error;
  while (batchedSub) {
    let e = batchedSub;
    batchedSub = void 0;
    while (e) {
      const next = e.next;
      e.next = void 0;
      e.flags &= ~8;
      if (e.flags & 1) {
        try {
          ;
          e.trigger();
        } catch (err2) {
          if (!error)
            error = err2;
        }
      }
      e = next;
    }
  }
  if (error)
    throw error;
}
function prepareDeps(sub) {
  for (let link = sub.deps; link; link = link.nextDep) {
    link.version = -1;
    link.prevActiveLink = link.dep.activeLink;
    link.dep.activeLink = link;
  }
}
function cleanupDeps(sub) {
  let head;
  let tail = sub.depsTail;
  let link = tail;
  while (link) {
    const prev = link.prevDep;
    if (link.version === -1) {
      if (link === tail)
        tail = prev;
      removeSub(link);
      removeDep(link);
    } else {
      head = link;
    }
    link.dep.activeLink = link.prevActiveLink;
    link.prevActiveLink = void 0;
    link = prev;
  }
  sub.deps = head;
  sub.depsTail = tail;
}
function isDirty(sub) {
  for (let link = sub.deps; link; link = link.nextDep) {
    if (link.dep.version !== link.version || link.dep.computed && (refreshComputed(link.dep.computed) || link.dep.version !== link.version)) {
      return true;
    }
  }
  if (sub._dirty) {
    return true;
  }
  return false;
}
function refreshComputed(computed2) {
  if (computed2.flags & 4 && !(computed2.flags & 16)) {
    return;
  }
  computed2.flags &= ~16;
  if (computed2.globalVersion === globalVersion) {
    return;
  }
  computed2.globalVersion = globalVersion;
  const dep = computed2.dep;
  computed2.flags |= 2;
  if (dep.version > 0 && !computed2.isSSR && computed2.deps && !isDirty(computed2)) {
    computed2.flags &= ~2;
    return;
  }
  const prevSub = activeSub;
  const prevShouldTrack = shouldTrack;
  activeSub = computed2;
  shouldTrack = true;
  try {
    prepareDeps(computed2);
    const value = computed2.fn(computed2._value);
    if (dep.version === 0 || hasChanged(value, computed2._value)) {
      computed2._value = value;
      dep.version++;
    }
  } catch (err2) {
    dep.version++;
    throw err2;
  } finally {
    activeSub = prevSub;
    shouldTrack = prevShouldTrack;
    cleanupDeps(computed2);
    computed2.flags &= ~2;
  }
}
function removeSub(link, soft = false) {
  const { dep, prevSub, nextSub } = link;
  if (prevSub) {
    prevSub.nextSub = nextSub;
    link.prevSub = void 0;
  }
  if (nextSub) {
    nextSub.prevSub = prevSub;
    link.nextSub = void 0;
  }
  if (dep.subs === link) {
    dep.subs = prevSub;
    if (!prevSub && dep.computed) {
      dep.computed.flags &= ~4;
      for (let l = dep.computed.deps; l; l = l.nextDep) {
        removeSub(l, true);
      }
    }
  }
  if (!soft && !--dep.sc && dep.map) {
    dep.map.delete(dep.key);
  }
}
function removeDep(link) {
  const { prevDep, nextDep } = link;
  if (prevDep) {
    prevDep.nextDep = nextDep;
    link.prevDep = void 0;
  }
  if (nextDep) {
    nextDep.prevDep = prevDep;
    link.nextDep = void 0;
  }
}
let shouldTrack = true;
const trackStack = [];
function pauseTracking() {
  trackStack.push(shouldTrack);
  shouldTrack = false;
}
function resetTracking() {
  const last = trackStack.pop();
  shouldTrack = last === void 0 ? true : last;
}
function cleanupEffect(e) {
  const { cleanup } = e;
  e.cleanup = void 0;
  if (cleanup) {
    const prevSub = activeSub;
    activeSub = void 0;
    try {
      cleanup();
    } finally {
      activeSub = prevSub;
    }
  }
}
let globalVersion = 0;
class Link {
  constructor(sub, dep) {
    this.sub = sub;
    this.dep = dep;
    this.version = dep.version;
    this.nextDep = this.prevDep = this.nextSub = this.prevSub = this.prevActiveLink = void 0;
  }
}
class Dep {
  constructor(computed2) {
    this.computed = computed2;
    this.version = 0;
    this.activeLink = void 0;
    this.subs = void 0;
    this.map = void 0;
    this.key = void 0;
    this.sc = 0;
  }
  track(debugInfo) {
    if (!activeSub || !shouldTrack || activeSub === this.computed) {
      return;
    }
    let link = this.activeLink;
    if (link === void 0 || link.sub !== activeSub) {
      link = this.activeLink = new Link(activeSub, this);
      if (!activeSub.deps) {
        activeSub.deps = activeSub.depsTail = link;
      } else {
        link.prevDep = activeSub.depsTail;
        activeSub.depsTail.nextDep = link;
        activeSub.depsTail = link;
      }
      addSub(link);
    } else if (link.version === -1) {
      link.version = this.version;
      if (link.nextDep) {
        const next = link.nextDep;
        next.prevDep = link.prevDep;
        if (link.prevDep) {
          link.prevDep.nextDep = next;
        }
        link.prevDep = activeSub.depsTail;
        link.nextDep = void 0;
        activeSub.depsTail.nextDep = link;
        activeSub.depsTail = link;
        if (activeSub.deps === link) {
          activeSub.deps = next;
        }
      }
    }
    return link;
  }
  trigger(debugInfo) {
    this.version++;
    globalVersion++;
    this.notify(debugInfo);
  }
  notify(debugInfo) {
    startBatch();
    try {
      if (false)
        ;
      for (let link = this.subs; link; link = link.prevSub) {
        if (link.sub.notify()) {
          ;
          link.sub.dep.notify();
        }
      }
    } finally {
      endBatch();
    }
  }
}
function addSub(link) {
  link.dep.sc++;
  if (link.sub.flags & 4) {
    const computed2 = link.dep.computed;
    if (computed2 && !link.dep.subs) {
      computed2.flags |= 4 | 16;
      for (let l = computed2.deps; l; l = l.nextDep) {
        addSub(l);
      }
    }
    const currentTail = link.dep.subs;
    if (currentTail !== link) {
      link.prevSub = currentTail;
      if (currentTail)
        currentTail.nextSub = link;
    }
    link.dep.subs = link;
  }
}
const targetMap = /* @__PURE__ */ new WeakMap();
const ITERATE_KEY = Symbol(
  ""
);
const MAP_KEY_ITERATE_KEY = Symbol(
  ""
);
const ARRAY_ITERATE_KEY = Symbol(
  ""
);
function track(target, type2, key) {
  if (shouldTrack && activeSub) {
    let depsMap = targetMap.get(target);
    if (!depsMap) {
      targetMap.set(target, depsMap = /* @__PURE__ */ new Map());
    }
    let dep = depsMap.get(key);
    if (!dep) {
      depsMap.set(key, dep = new Dep());
      dep.map = depsMap;
      dep.key = key;
    }
    {
      dep.track();
    }
  }
}
function trigger(target, type2, key, newValue, oldValue, oldTarget) {
  const depsMap = targetMap.get(target);
  if (!depsMap) {
    globalVersion++;
    return;
  }
  const run = (dep) => {
    if (dep) {
      {
        dep.trigger();
      }
    }
  };
  startBatch();
  if (type2 === "clear") {
    depsMap.forEach(run);
  } else {
    const targetIsArray = isArray(target);
    const isArrayIndex = targetIsArray && isIntegerKey(key);
    if (targetIsArray && key === "length") {
      const newLength = Number(newValue);
      depsMap.forEach((dep, key2) => {
        if (key2 === "length" || key2 === ARRAY_ITERATE_KEY || !isSymbol$1(key2) && key2 >= newLength) {
          run(dep);
        }
      });
    } else {
      if (key !== void 0 || depsMap.has(void 0)) {
        run(depsMap.get(key));
      }
      if (isArrayIndex) {
        run(depsMap.get(ARRAY_ITERATE_KEY));
      }
      switch (type2) {
        case "add":
          if (!targetIsArray) {
            run(depsMap.get(ITERATE_KEY));
            if (isMap$1(target)) {
              run(depsMap.get(MAP_KEY_ITERATE_KEY));
            }
          } else if (isArrayIndex) {
            run(depsMap.get("length"));
          }
          break;
        case "delete":
          if (!targetIsArray) {
            run(depsMap.get(ITERATE_KEY));
            if (isMap$1(target)) {
              run(depsMap.get(MAP_KEY_ITERATE_KEY));
            }
          }
          break;
        case "set":
          if (isMap$1(target)) {
            run(depsMap.get(ITERATE_KEY));
          }
          break;
      }
    }
  }
  endBatch();
}
function reactiveReadArray(array) {
  const raw = toRaw(array);
  if (raw === array)
    return raw;
  track(raw, "iterate", ARRAY_ITERATE_KEY);
  return isShallow(array) ? raw : raw.map(toReactive);
}
function shallowReadArray(arr) {
  track(arr = toRaw(arr), "iterate", ARRAY_ITERATE_KEY);
  return arr;
}
const arrayInstrumentations = {
  __proto__: null,
  [Symbol.iterator]() {
    return iterator(this, Symbol.iterator, toReactive);
  },
  concat(...args) {
    return reactiveReadArray(this).concat(
      ...args.map((x) => isArray(x) ? reactiveReadArray(x) : x)
    );
  },
  entries() {
    return iterator(this, "entries", (value) => {
      value[1] = toReactive(value[1]);
      return value;
    });
  },
  every(fn, thisArg) {
    return apply(this, "every", fn, thisArg, void 0, arguments);
  },
  filter(fn, thisArg) {
    return apply(this, "filter", fn, thisArg, (v2) => v2.map(toReactive), arguments);
  },
  find(fn, thisArg) {
    return apply(this, "find", fn, thisArg, toReactive, arguments);
  },
  findIndex(fn, thisArg) {
    return apply(this, "findIndex", fn, thisArg, void 0, arguments);
  },
  findLast(fn, thisArg) {
    return apply(this, "findLast", fn, thisArg, toReactive, arguments);
  },
  findLastIndex(fn, thisArg) {
    return apply(this, "findLastIndex", fn, thisArg, void 0, arguments);
  },
  forEach(fn, thisArg) {
    return apply(this, "forEach", fn, thisArg, void 0, arguments);
  },
  includes(...args) {
    return searchProxy(this, "includes", args);
  },
  indexOf(...args) {
    return searchProxy(this, "indexOf", args);
  },
  join(separator) {
    return reactiveReadArray(this).join(separator);
  },
  lastIndexOf(...args) {
    return searchProxy(this, "lastIndexOf", args);
  },
  map(fn, thisArg) {
    return apply(this, "map", fn, thisArg, void 0, arguments);
  },
  pop() {
    return noTracking(this, "pop");
  },
  push(...args) {
    return noTracking(this, "push", args);
  },
  reduce(fn, ...args) {
    return reduce(this, "reduce", fn, args);
  },
  reduceRight(fn, ...args) {
    return reduce(this, "reduceRight", fn, args);
  },
  shift() {
    return noTracking(this, "shift");
  },
  some(fn, thisArg) {
    return apply(this, "some", fn, thisArg, void 0, arguments);
  },
  splice(...args) {
    return noTracking(this, "splice", args);
  },
  toReversed() {
    return reactiveReadArray(this).toReversed();
  },
  toSorted(comparer) {
    return reactiveReadArray(this).toSorted(comparer);
  },
  toSpliced(...args) {
    return reactiveReadArray(this).toSpliced(...args);
  },
  unshift(...args) {
    return noTracking(this, "unshift", args);
  },
  values() {
    return iterator(this, "values", toReactive);
  }
};
function iterator(self2, method, wrapValue) {
  const arr = shallowReadArray(self2);
  const iter = arr[method]();
  if (arr !== self2 && !isShallow(self2)) {
    iter._next = iter.next;
    iter.next = () => {
      const result = iter._next();
      if (result.value) {
        result.value = wrapValue(result.value);
      }
      return result;
    };
  }
  return iter;
}
const arrayProto = Array.prototype;
function apply(self2, method, fn, thisArg, wrappedRetFn, args) {
  const arr = shallowReadArray(self2);
  const needsWrap = arr !== self2 && !isShallow(self2);
  const methodFn = arr[method];
  if (methodFn !== arrayProto[method]) {
    const result2 = methodFn.apply(self2, args);
    return needsWrap ? toReactive(result2) : result2;
  }
  let wrappedFn = fn;
  if (arr !== self2) {
    if (needsWrap) {
      wrappedFn = function(item, index2) {
        return fn.call(this, toReactive(item), index2, self2);
      };
    } else if (fn.length > 2) {
      wrappedFn = function(item, index2) {
        return fn.call(this, item, index2, self2);
      };
    }
  }
  const result = methodFn.call(arr, wrappedFn, thisArg);
  return needsWrap && wrappedRetFn ? wrappedRetFn(result) : result;
}
function reduce(self2, method, fn, args) {
  const arr = shallowReadArray(self2);
  let wrappedFn = fn;
  if (arr !== self2) {
    if (!isShallow(self2)) {
      wrappedFn = function(acc, item, index2) {
        return fn.call(this, acc, toReactive(item), index2, self2);
      };
    } else if (fn.length > 3) {
      wrappedFn = function(acc, item, index2) {
        return fn.call(this, acc, item, index2, self2);
      };
    }
  }
  return arr[method](wrappedFn, ...args);
}
function searchProxy(self2, method, args) {
  const arr = toRaw(self2);
  track(arr, "iterate", ARRAY_ITERATE_KEY);
  const res = arr[method](...args);
  if ((res === -1 || res === false) && isProxy(args[0])) {
    args[0] = toRaw(args[0]);
    return arr[method](...args);
  }
  return res;
}
function noTracking(self2, method, args = []) {
  pauseTracking();
  startBatch();
  const res = toRaw(self2)[method].apply(self2, args);
  endBatch();
  resetTracking();
  return res;
}
const isNonTrackableKeys = /* @__PURE__ */ makeMap(`__proto__,__v_isRef,__isVue`);
const builtInSymbols = new Set(
  /* @__PURE__ */ Object.getOwnPropertyNames(Symbol).filter((key) => key !== "arguments" && key !== "caller").map((key) => Symbol[key]).filter(isSymbol$1)
);
function hasOwnProperty(key) {
  if (!isSymbol$1(key))
    key = String(key);
  const obj = toRaw(this);
  track(obj, "has", key);
  return obj.hasOwnProperty(key);
}
class BaseReactiveHandler {
  constructor(_isReadonly = false, _isShallow = false) {
    this._isReadonly = _isReadonly;
    this._isShallow = _isShallow;
  }
  get(target, key, receiver) {
    if (key === "__v_skip")
      return target["__v_skip"];
    const isReadonly2 = this._isReadonly, isShallow2 = this._isShallow;
    if (key === "__v_isReactive") {
      return !isReadonly2;
    } else if (key === "__v_isReadonly") {
      return isReadonly2;
    } else if (key === "__v_isShallow") {
      return isShallow2;
    } else if (key === "__v_raw") {
      if (receiver === (isReadonly2 ? isShallow2 ? shallowReadonlyMap : readonlyMap : isShallow2 ? shallowReactiveMap : reactiveMap).get(target) || Object.getPrototypeOf(target) === Object.getPrototypeOf(receiver)) {
        return target;
      }
      return;
    }
    const targetIsArray = isArray(target);
    if (!isReadonly2) {
      let fn;
      if (targetIsArray && (fn = arrayInstrumentations[key])) {
        return fn;
      }
      if (key === "hasOwnProperty") {
        return hasOwnProperty;
      }
    }
    const res = Reflect.get(
      target,
      key,
      isRef(target) ? target : receiver
    );
    if (isSymbol$1(key) ? builtInSymbols.has(key) : isNonTrackableKeys(key)) {
      return res;
    }
    if (!isReadonly2) {
      track(target, "get", key);
    }
    if (isShallow2) {
      return res;
    }
    if (isRef(res)) {
      return targetIsArray && isIntegerKey(key) ? res : res.value;
    }
    if (isObject(res)) {
      return isReadonly2 ? readonly(res) : reactive(res);
    }
    return res;
  }
}
class MutableReactiveHandler extends BaseReactiveHandler {
  constructor(isShallow2 = false) {
    super(false, isShallow2);
  }
  set(target, key, value, receiver) {
    let oldValue = target[key];
    if (!this._isShallow) {
      const isOldValueReadonly = isReadonly(oldValue);
      if (!isShallow(value) && !isReadonly(value)) {
        oldValue = toRaw(oldValue);
        value = toRaw(value);
      }
      if (!isArray(target) && isRef(oldValue) && !isRef(value)) {
        if (isOldValueReadonly) {
          return false;
        } else {
          oldValue.value = value;
          return true;
        }
      }
    }
    const hadKey = isArray(target) && isIntegerKey(key) ? Number(key) < target.length : hasOwn(target, key);
    const result = Reflect.set(
      target,
      key,
      value,
      isRef(target) ? target : receiver
    );
    if (target === toRaw(receiver)) {
      if (!hadKey) {
        trigger(target, "add", key, value);
      } else if (hasChanged(value, oldValue)) {
        trigger(target, "set", key, value);
      }
    }
    return result;
  }
  deleteProperty(target, key) {
    const hadKey = hasOwn(target, key);
    target[key];
    const result = Reflect.deleteProperty(target, key);
    if (result && hadKey) {
      trigger(target, "delete", key, void 0);
    }
    return result;
  }
  has(target, key) {
    const result = Reflect.has(target, key);
    if (!isSymbol$1(key) || !builtInSymbols.has(key)) {
      track(target, "has", key);
    }
    return result;
  }
  ownKeys(target) {
    track(
      target,
      "iterate",
      isArray(target) ? "length" : ITERATE_KEY
    );
    return Reflect.ownKeys(target);
  }
}
class ReadonlyReactiveHandler extends BaseReactiveHandler {
  constructor(isShallow2 = false) {
    super(true, isShallow2);
  }
  set(target, key) {
    return true;
  }
  deleteProperty(target, key) {
    return true;
  }
}
const mutableHandlers = /* @__PURE__ */ new MutableReactiveHandler();
const readonlyHandlers = /* @__PURE__ */ new ReadonlyReactiveHandler();
const shallowReactiveHandlers = /* @__PURE__ */ new MutableReactiveHandler(true);
const shallowReadonlyHandlers = /* @__PURE__ */ new ReadonlyReactiveHandler(true);
const toShallow = (value) => value;
const getProto = (v2) => Reflect.getPrototypeOf(v2);
function createIterableMethod(method, isReadonly2, isShallow2) {
  return function(...args) {
    const target = this["__v_raw"];
    const rawTarget = toRaw(target);
    const targetIsMap = isMap$1(rawTarget);
    const isPair = method === "entries" || method === Symbol.iterator && targetIsMap;
    const isKeyOnly = method === "keys" && targetIsMap;
    const innerIterator = target[method](...args);
    const wrap = isShallow2 ? toShallow : isReadonly2 ? toReadonly : toReactive;
    !isReadonly2 && track(
      rawTarget,
      "iterate",
      isKeyOnly ? MAP_KEY_ITERATE_KEY : ITERATE_KEY
    );
    return {
      next() {
        const { value, done } = innerIterator.next();
        return done ? { value, done } : {
          value: isPair ? [wrap(value[0]), wrap(value[1])] : wrap(value),
          done
        };
      },
      [Symbol.iterator]() {
        return this;
      }
    };
  };
}
function createReadonlyMethod(type2) {
  return function(...args) {
    return type2 === "delete" ? false : type2 === "clear" ? void 0 : this;
  };
}
function createInstrumentations(readonly2, shallow) {
  const instrumentations = {
    get(key) {
      const target = this["__v_raw"];
      const rawTarget = toRaw(target);
      const rawKey = toRaw(key);
      if (!readonly2) {
        if (hasChanged(key, rawKey)) {
          track(rawTarget, "get", key);
        }
        track(rawTarget, "get", rawKey);
      }
      const { has } = getProto(rawTarget);
      const wrap = shallow ? toShallow : readonly2 ? toReadonly : toReactive;
      if (has.call(rawTarget, key)) {
        return wrap(target.get(key));
      } else if (has.call(rawTarget, rawKey)) {
        return wrap(target.get(rawKey));
      } else if (target !== rawTarget) {
        target.get(key);
      }
    },
    get size() {
      const target = this["__v_raw"];
      !readonly2 && track(toRaw(target), "iterate", ITERATE_KEY);
      return Reflect.get(target, "size", target);
    },
    has(key) {
      const target = this["__v_raw"];
      const rawTarget = toRaw(target);
      const rawKey = toRaw(key);
      if (!readonly2) {
        if (hasChanged(key, rawKey)) {
          track(rawTarget, "has", key);
        }
        track(rawTarget, "has", rawKey);
      }
      return key === rawKey ? target.has(key) : target.has(key) || target.has(rawKey);
    },
    forEach(callback, thisArg) {
      const observed = this;
      const target = observed["__v_raw"];
      const rawTarget = toRaw(target);
      const wrap = shallow ? toShallow : readonly2 ? toReadonly : toReactive;
      !readonly2 && track(rawTarget, "iterate", ITERATE_KEY);
      return target.forEach((value, key) => {
        return callback.call(thisArg, wrap(value), wrap(key), observed);
      });
    }
  };
  extend(
    instrumentations,
    readonly2 ? {
      add: createReadonlyMethod("add"),
      set: createReadonlyMethod("set"),
      delete: createReadonlyMethod("delete"),
      clear: createReadonlyMethod("clear")
    } : {
      add(value) {
        if (!shallow && !isShallow(value) && !isReadonly(value)) {
          value = toRaw(value);
        }
        const target = toRaw(this);
        const proto = getProto(target);
        const hadKey = proto.has.call(target, value);
        if (!hadKey) {
          target.add(value);
          trigger(target, "add", value, value);
        }
        return this;
      },
      set(key, value) {
        if (!shallow && !isShallow(value) && !isReadonly(value)) {
          value = toRaw(value);
        }
        const target = toRaw(this);
        const { has, get } = getProto(target);
        let hadKey = has.call(target, key);
        if (!hadKey) {
          key = toRaw(key);
          hadKey = has.call(target, key);
        }
        const oldValue = get.call(target, key);
        target.set(key, value);
        if (!hadKey) {
          trigger(target, "add", key, value);
        } else if (hasChanged(value, oldValue)) {
          trigger(target, "set", key, value);
        }
        return this;
      },
      delete(key) {
        const target = toRaw(this);
        const { has, get } = getProto(target);
        let hadKey = has.call(target, key);
        if (!hadKey) {
          key = toRaw(key);
          hadKey = has.call(target, key);
        }
        get ? get.call(target, key) : void 0;
        const result = target.delete(key);
        if (hadKey) {
          trigger(target, "delete", key, void 0);
        }
        return result;
      },
      clear() {
        const target = toRaw(this);
        const hadItems = target.size !== 0;
        const result = target.clear();
        if (hadItems) {
          trigger(
            target,
            "clear",
            void 0,
            void 0
          );
        }
        return result;
      }
    }
  );
  const iteratorMethods = [
    "keys",
    "values",
    "entries",
    Symbol.iterator
  ];
  iteratorMethods.forEach((method) => {
    instrumentations[method] = createIterableMethod(method, readonly2, shallow);
  });
  return instrumentations;
}
function createInstrumentationGetter(isReadonly2, shallow) {
  const instrumentations = createInstrumentations(isReadonly2, shallow);
  return (target, key, receiver) => {
    if (key === "__v_isReactive") {
      return !isReadonly2;
    } else if (key === "__v_isReadonly") {
      return isReadonly2;
    } else if (key === "__v_raw") {
      return target;
    }
    return Reflect.get(
      hasOwn(instrumentations, key) && key in target ? instrumentations : target,
      key,
      receiver
    );
  };
}
const mutableCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(false, false)
};
const shallowCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(false, true)
};
const readonlyCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(true, false)
};
const shallowReadonlyCollectionHandlers = {
  get: /* @__PURE__ */ createInstrumentationGetter(true, true)
};
const reactiveMap = /* @__PURE__ */ new WeakMap();
const shallowReactiveMap = /* @__PURE__ */ new WeakMap();
const readonlyMap = /* @__PURE__ */ new WeakMap();
const shallowReadonlyMap = /* @__PURE__ */ new WeakMap();
function targetTypeMap(rawType) {
  switch (rawType) {
    case "Object":
    case "Array":
      return 1;
    case "Map":
    case "Set":
    case "WeakMap":
    case "WeakSet":
      return 2;
    default:
      return 0;
  }
}
function getTargetType(value) {
  return value["__v_skip"] || !Object.isExtensible(value) ? 0 : targetTypeMap(toRawType(value));
}
function reactive(target) {
  if (isReadonly(target)) {
    return target;
  }
  return createReactiveObject(
    target,
    false,
    mutableHandlers,
    mutableCollectionHandlers,
    reactiveMap
  );
}
function shallowReactive(target) {
  return createReactiveObject(
    target,
    false,
    shallowReactiveHandlers,
    shallowCollectionHandlers,
    shallowReactiveMap
  );
}
function readonly(target) {
  return createReactiveObject(
    target,
    true,
    readonlyHandlers,
    readonlyCollectionHandlers,
    readonlyMap
  );
}
function shallowReadonly(target) {
  return createReactiveObject(
    target,
    true,
    shallowReadonlyHandlers,
    shallowReadonlyCollectionHandlers,
    shallowReadonlyMap
  );
}
function createReactiveObject(target, isReadonly2, baseHandlers, collectionHandlers, proxyMap) {
  if (!isObject(target)) {
    return target;
  }
  if (target["__v_raw"] && !(isReadonly2 && target["__v_isReactive"])) {
    return target;
  }
  const existingProxy = proxyMap.get(target);
  if (existingProxy) {
    return existingProxy;
  }
  const targetType = getTargetType(target);
  if (targetType === 0) {
    return target;
  }
  const proxy = new Proxy(
    target,
    targetType === 2 ? collectionHandlers : baseHandlers
  );
  proxyMap.set(target, proxy);
  return proxy;
}
function isReactive(value) {
  if (isReadonly(value)) {
    return isReactive(value["__v_raw"]);
  }
  return !!(value && value["__v_isReactive"]);
}
function isReadonly(value) {
  return !!(value && value["__v_isReadonly"]);
}
function isShallow(value) {
  return !!(value && value["__v_isShallow"]);
}
function isProxy(value) {
  return value ? !!value["__v_raw"] : false;
}
function toRaw(observed) {
  const raw = observed && observed["__v_raw"];
  return raw ? toRaw(raw) : observed;
}
function markRaw(value) {
  if (!hasOwn(value, "__v_skip") && Object.isExtensible(value)) {
    def(value, "__v_skip", true);
  }
  return value;
}
const toReactive = (value) => isObject(value) ? reactive(value) : value;
const toReadonly = (value) => isObject(value) ? readonly(value) : value;
function isRef(r2) {
  return r2 ? r2["__v_isRef"] === true : false;
}
function ref$1(value) {
  return createRef(value, false);
}
function shallowRef(value) {
  return createRef(value, true);
}
function createRef(rawValue, shallow) {
  if (isRef(rawValue)) {
    return rawValue;
  }
  return new RefImpl(rawValue, shallow);
}
class RefImpl {
  constructor(value, isShallow2) {
    this.dep = new Dep();
    this["__v_isRef"] = true;
    this["__v_isShallow"] = false;
    this._rawValue = isShallow2 ? value : toRaw(value);
    this._value = isShallow2 ? value : toReactive(value);
    this["__v_isShallow"] = isShallow2;
  }
  get value() {
    {
      this.dep.track();
    }
    return this._value;
  }
  set value(newValue) {
    const oldValue = this._rawValue;
    const useDirectValue = this["__v_isShallow"] || isShallow(newValue) || isReadonly(newValue);
    newValue = useDirectValue ? newValue : toRaw(newValue);
    if (hasChanged(newValue, oldValue)) {
      this._rawValue = newValue;
      this._value = useDirectValue ? newValue : toReactive(newValue);
      {
        this.dep.trigger();
      }
    }
  }
}
function unref(ref2) {
  return isRef(ref2) ? ref2.value : ref2;
}
const shallowUnwrapHandlers = {
  get: (target, key, receiver) => key === "__v_raw" ? target : unref(Reflect.get(target, key, receiver)),
  set: (target, key, value, receiver) => {
    const oldValue = target[key];
    if (isRef(oldValue) && !isRef(value)) {
      oldValue.value = value;
      return true;
    } else {
      return Reflect.set(target, key, value, receiver);
    }
  }
};
function proxyRefs(objectWithRefs) {
  return isReactive(objectWithRefs) ? objectWithRefs : new Proxy(objectWithRefs, shallowUnwrapHandlers);
}
class CustomRefImpl {
  constructor(factory) {
    this["__v_isRef"] = true;
    this._value = void 0;
    const dep = this.dep = new Dep();
    const { get, set } = factory(dep.track.bind(dep), dep.trigger.bind(dep));
    this._get = get;
    this._set = set;
  }
  get value() {
    return this._value = this._get();
  }
  set value(newVal) {
    this._set(newVal);
  }
}
function customRef(factory) {
  return new CustomRefImpl(factory);
}
class ComputedRefImpl {
  constructor(fn, setter, isSSR) {
    this.fn = fn;
    this.setter = setter;
    this._value = void 0;
    this.dep = new Dep(this);
    this.__v_isRef = true;
    this.deps = void 0;
    this.depsTail = void 0;
    this.flags = 16;
    this.globalVersion = globalVersion - 1;
    this.next = void 0;
    this.effect = this;
    this["__v_isReadonly"] = !setter;
    this.isSSR = isSSR;
  }
  notify() {
    this.flags |= 16;
    if (!(this.flags & 8) && activeSub !== this) {
      batch(this, true);
      return true;
    }
  }
  get value() {
    const link = this.dep.track();
    refreshComputed(this);
    if (link) {
      link.version = this.dep.version;
    }
    return this._value;
  }
  set value(newValue) {
    if (this.setter) {
      this.setter(newValue);
    }
  }
}
function computed$1(getterOrOptions, debugOptions, isSSR = false) {
  let getter;
  let setter;
  if (isFunction(getterOrOptions)) {
    getter = getterOrOptions;
  } else {
    getter = getterOrOptions.get;
    setter = getterOrOptions.set;
  }
  const cRef = new ComputedRefImpl(getter, setter, isSSR);
  return cRef;
}
const INITIAL_WATCHER_VALUE = {};
const cleanupMap = /* @__PURE__ */ new WeakMap();
let activeWatcher = void 0;
function onWatcherCleanup(cleanupFn, failSilently = false, owner = activeWatcher) {
  if (owner) {
    let cleanups = cleanupMap.get(owner);
    if (!cleanups)
      cleanupMap.set(owner, cleanups = []);
    cleanups.push(cleanupFn);
  }
}
function watch$1(source, cb, options = EMPTY_OBJ) {
  const { immediate, deep, once, scheduler, augmentJob, call } = options;
  const reactiveGetter = (source2) => {
    if (deep)
      return source2;
    if (isShallow(source2) || deep === false || deep === 0)
      return traverse(source2, 1);
    return traverse(source2);
  };
  let effect;
  let getter;
  let cleanup;
  let boundCleanup;
  let forceTrigger = false;
  let isMultiSource = false;
  if (isRef(source)) {
    getter = () => source.value;
    forceTrigger = isShallow(source);
  } else if (isReactive(source)) {
    getter = () => reactiveGetter(source);
    forceTrigger = true;
  } else if (isArray(source)) {
    isMultiSource = true;
    forceTrigger = source.some((s2) => isReactive(s2) || isShallow(s2));
    getter = () => source.map((s2) => {
      if (isRef(s2)) {
        return s2.value;
      } else if (isReactive(s2)) {
        return reactiveGetter(s2);
      } else if (isFunction(s2)) {
        return call ? call(s2, 2) : s2();
      } else
        ;
    });
  } else if (isFunction(source)) {
    if (cb) {
      getter = call ? () => call(source, 2) : source;
    } else {
      getter = () => {
        if (cleanup) {
          pauseTracking();
          try {
            cleanup();
          } finally {
            resetTracking();
          }
        }
        const currentEffect = activeWatcher;
        activeWatcher = effect;
        try {
          return call ? call(source, 3, [boundCleanup]) : source(boundCleanup);
        } finally {
          activeWatcher = currentEffect;
        }
      };
    }
  } else {
    getter = NOOP;
  }
  if (cb && deep) {
    const baseGetter = getter;
    const depth = deep === true ? Infinity : deep;
    getter = () => traverse(baseGetter(), depth);
  }
  const scope = getCurrentScope();
  const watchHandle = () => {
    effect.stop();
    if (scope && scope.active) {
      remove(scope.effects, effect);
    }
  };
  if (once && cb) {
    const _cb = cb;
    cb = (...args) => {
      _cb(...args);
      watchHandle();
    };
  }
  let oldValue = isMultiSource ? new Array(source.length).fill(INITIAL_WATCHER_VALUE) : INITIAL_WATCHER_VALUE;
  const job = (immediateFirstRun) => {
    if (!(effect.flags & 1) || !effect.dirty && !immediateFirstRun) {
      return;
    }
    if (cb) {
      const newValue = effect.run();
      if (deep || forceTrigger || (isMultiSource ? newValue.some((v2, i2) => hasChanged(v2, oldValue[i2])) : hasChanged(newValue, oldValue))) {
        if (cleanup) {
          cleanup();
        }
        const currentWatcher = activeWatcher;
        activeWatcher = effect;
        try {
          const args = [
            newValue,
            oldValue === INITIAL_WATCHER_VALUE ? void 0 : isMultiSource && oldValue[0] === INITIAL_WATCHER_VALUE ? [] : oldValue,
            boundCleanup
          ];
          call ? call(cb, 3, args) : cb(...args);
          oldValue = newValue;
        } finally {
          activeWatcher = currentWatcher;
        }
      }
    } else {
      effect.run();
    }
  };
  if (augmentJob) {
    augmentJob(job);
  }
  effect = new ReactiveEffect(getter);
  effect.scheduler = scheduler ? () => scheduler(job, false) : job;
  boundCleanup = (fn) => onWatcherCleanup(fn, false, effect);
  cleanup = effect.onStop = () => {
    const cleanups = cleanupMap.get(effect);
    if (cleanups) {
      if (call) {
        call(cleanups, 4);
      } else {
        for (const cleanup2 of cleanups)
          cleanup2();
      }
      cleanupMap.delete(effect);
    }
  };
  if (cb) {
    if (immediate) {
      job(true);
    } else {
      oldValue = effect.run();
    }
  } else if (scheduler) {
    scheduler(job.bind(null, true), true);
  } else {
    effect.run();
  }
  watchHandle.pause = effect.pause.bind(effect);
  watchHandle.resume = effect.resume.bind(effect);
  watchHandle.stop = watchHandle;
  return watchHandle;
}
function traverse(value, depth = Infinity, seen2) {
  if (depth <= 0 || !isObject(value) || value["__v_skip"]) {
    return value;
  }
  seen2 = seen2 || /* @__PURE__ */ new Set();
  if (seen2.has(value)) {
    return value;
  }
  seen2.add(value);
  depth--;
  if (isRef(value)) {
    traverse(value.value, depth, seen2);
  } else if (isArray(value)) {
    for (let i2 = 0; i2 < value.length; i2++) {
      traverse(value[i2], depth, seen2);
    }
  } else if (isSet$1(value) || isMap$1(value)) {
    value.forEach((v2) => {
      traverse(v2, depth, seen2);
    });
  } else if (isPlainObject(value)) {
    for (const key in value) {
      traverse(value[key], depth, seen2);
    }
    for (const key of Object.getOwnPropertySymbols(value)) {
      if (Object.prototype.propertyIsEnumerable.call(value, key)) {
        traverse(value[key], depth, seen2);
      }
    }
  }
  return value;
}
/**
* @vue/runtime-core v3.5.13
* (c) 2018-present Yuxi (Evan) You and Vue contributors
* @license MIT
**/
const stack = [];
let isWarning = false;
function warn$1(msg, ...args) {
  if (isWarning)
    return;
  isWarning = true;
  pauseTracking();
  const instance = stack.length ? stack[stack.length - 1].component : null;
  const appWarnHandler = instance && instance.appContext.config.warnHandler;
  const trace = getComponentTrace();
  if (appWarnHandler) {
    callWithErrorHandling(
      appWarnHandler,
      instance,
      11,
      [
        msg + args.map((a2) => {
          var _a2, _b;
          return (_b = (_a2 = a2.toString) == null ? void 0 : _a2.call(a2)) != null ? _b : JSON.stringify(a2);
        }).join(""),
        instance && instance.proxy,
        trace.map(
          ({ vnode }) => `at <${formatComponentName(instance, vnode.type)}>`
        ).join("\n"),
        trace
      ]
    );
  } else {
    const warnArgs = [`[Vue warn]: ${msg}`, ...args];
    if (trace.length && true) {
      warnArgs.push(`
`, ...formatTrace(trace));
    }
    console.warn(...warnArgs);
  }
  resetTracking();
  isWarning = false;
}
function getComponentTrace() {
  let currentVNode = stack[stack.length - 1];
  if (!currentVNode) {
    return [];
  }
  const normalizedStack = [];
  while (currentVNode) {
    const last = normalizedStack[0];
    if (last && last.vnode === currentVNode) {
      last.recurseCount++;
    } else {
      normalizedStack.push({
        vnode: currentVNode,
        recurseCount: 0
      });
    }
    const parentInstance = currentVNode.component && currentVNode.component.parent;
    currentVNode = parentInstance && parentInstance.vnode;
  }
  return normalizedStack;
}
function formatTrace(trace) {
  const logs = [];
  trace.forEach((entry, i2) => {
    logs.push(...i2 === 0 ? [] : [`
`], ...formatTraceEntry(entry));
  });
  return logs;
}
function formatTraceEntry({ vnode, recurseCount }) {
  const postfix = recurseCount > 0 ? `... (${recurseCount} recursive calls)` : ``;
  const isRoot = vnode.component ? vnode.component.parent == null : false;
  const open = ` at <${formatComponentName(
    vnode.component,
    vnode.type,
    isRoot
  )}`;
  const close = `>` + postfix;
  return vnode.props ? [open, ...formatProps(vnode.props), close] : [open + close];
}
function formatProps(props) {
  const res = [];
  const keys = Object.keys(props);
  keys.slice(0, 3).forEach((key) => {
    res.push(...formatProp(key, props[key]));
  });
  if (keys.length > 3) {
    res.push(` ...`);
  }
  return res;
}
function formatProp(key, value, raw) {
  if (isString$1(value)) {
    value = JSON.stringify(value);
    return raw ? value : [`${key}=${value}`];
  } else if (typeof value === "number" || typeof value === "boolean" || value == null) {
    return raw ? value : [`${key}=${value}`];
  } else if (isRef(value)) {
    value = formatProp(key, toRaw(value.value), true);
    return raw ? value : [`${key}=Ref<`, value, `>`];
  } else if (isFunction(value)) {
    return [`${key}=fn${value.name ? `<${value.name}>` : ``}`];
  } else {
    value = toRaw(value);
    return raw ? value : [`${key}=`, value];
  }
}
function callWithErrorHandling(fn, instance, type2, args) {
  try {
    return args ? fn(...args) : fn();
  } catch (err2) {
    handleError(err2, instance, type2);
  }
}
function callWithAsyncErrorHandling(fn, instance, type2, args) {
  if (isFunction(fn)) {
    const res = callWithErrorHandling(fn, instance, type2, args);
    if (res && isPromise(res)) {
      res.catch((err2) => {
        handleError(err2, instance, type2);
      });
    }
    return res;
  }
  if (isArray(fn)) {
    const values = [];
    for (let i2 = 0; i2 < fn.length; i2++) {
      values.push(callWithAsyncErrorHandling(fn[i2], instance, type2, args));
    }
    return values;
  }
}
function handleError(err2, instance, type2, throwInDev = true) {
  const contextVNode = instance ? instance.vnode : null;
  const { errorHandler, throwUnhandledErrorInProduction } = instance && instance.appContext.config || EMPTY_OBJ;
  if (instance) {
    let cur = instance.parent;
    const exposedInstance = instance.proxy;
    const errorInfo = `https://vuejs.org/error-reference/#runtime-${type2}`;
    while (cur) {
      const errorCapturedHooks = cur.ec;
      if (errorCapturedHooks) {
        for (let i2 = 0; i2 < errorCapturedHooks.length; i2++) {
          if (errorCapturedHooks[i2](err2, exposedInstance, errorInfo) === false) {
            return;
          }
        }
      }
      cur = cur.parent;
    }
    if (errorHandler) {
      pauseTracking();
      callWithErrorHandling(errorHandler, null, 10, [
        err2,
        exposedInstance,
        errorInfo
      ]);
      resetTracking();
      return;
    }
  }
  logError(err2, type2, contextVNode, throwInDev, throwUnhandledErrorInProduction);
}
function logError(err2, type2, contextVNode, throwInDev = true, throwInProd = false) {
  if (throwInProd) {
    throw err2;
  } else {
    console.error(err2);
  }
}
const queue = [];
let flushIndex = -1;
const pendingPostFlushCbs = [];
let activePostFlushCbs = null;
let postFlushIndex = 0;
const resolvedPromise = /* @__PURE__ */ Promise.resolve();
let currentFlushPromise = null;
function nextTick(fn) {
  const p2 = currentFlushPromise || resolvedPromise;
  return fn ? p2.then(this ? fn.bind(this) : fn) : p2;
}
function findInsertionIndex(id) {
  let start = flushIndex + 1;
  let end = queue.length;
  while (start < end) {
    const middle = start + end >>> 1;
    const middleJob = queue[middle];
    const middleJobId = getId(middleJob);
    if (middleJobId < id || middleJobId === id && middleJob.flags & 2) {
      start = middle + 1;
    } else {
      end = middle;
    }
  }
  return start;
}
function queueJob(job) {
  if (!(job.flags & 1)) {
    const jobId = getId(job);
    const lastJob = queue[queue.length - 1];
    if (!lastJob || !(job.flags & 2) && jobId >= getId(lastJob)) {
      queue.push(job);
    } else {
      queue.splice(findInsertionIndex(jobId), 0, job);
    }
    job.flags |= 1;
    queueFlush();
  }
}
function queueFlush() {
  if (!currentFlushPromise) {
    currentFlushPromise = resolvedPromise.then(flushJobs);
  }
}
function queuePostFlushCb(cb) {
  if (!isArray(cb)) {
    if (activePostFlushCbs && cb.id === -1) {
      activePostFlushCbs.splice(postFlushIndex + 1, 0, cb);
    } else if (!(cb.flags & 1)) {
      pendingPostFlushCbs.push(cb);
      cb.flags |= 1;
    }
  } else {
    pendingPostFlushCbs.push(...cb);
  }
  queueFlush();
}
function flushPreFlushCbs(instance, seen2, i2 = flushIndex + 1) {
  for (; i2 < queue.length; i2++) {
    const cb = queue[i2];
    if (cb && cb.flags & 2) {
      if (instance && cb.id !== instance.uid) {
        continue;
      }
      queue.splice(i2, 1);
      i2--;
      if (cb.flags & 4) {
        cb.flags &= ~1;
      }
      cb();
      if (!(cb.flags & 4)) {
        cb.flags &= ~1;
      }
    }
  }
}
function flushPostFlushCbs(seen2) {
  if (pendingPostFlushCbs.length) {
    const deduped = [...new Set(pendingPostFlushCbs)].sort(
      (a2, b2) => getId(a2) - getId(b2)
    );
    pendingPostFlushCbs.length = 0;
    if (activePostFlushCbs) {
      activePostFlushCbs.push(...deduped);
      return;
    }
    activePostFlushCbs = deduped;
    for (postFlushIndex = 0; postFlushIndex < activePostFlushCbs.length; postFlushIndex++) {
      const cb = activePostFlushCbs[postFlushIndex];
      if (cb.flags & 4) {
        cb.flags &= ~1;
      }
      if (!(cb.flags & 8))
        cb();
      cb.flags &= ~1;
    }
    activePostFlushCbs = null;
    postFlushIndex = 0;
  }
}
const getId = (job) => job.id == null ? job.flags & 2 ? -1 : Infinity : job.id;
function flushJobs(seen2) {
  const check = NOOP;
  try {
    for (flushIndex = 0; flushIndex < queue.length; flushIndex++) {
      const job = queue[flushIndex];
      if (job && !(job.flags & 8)) {
        if (false)
          ;
        if (job.flags & 4) {
          job.flags &= ~1;
        }
        callWithErrorHandling(
          job,
          job.i,
          job.i ? 15 : 14
        );
        if (!(job.flags & 4)) {
          job.flags &= ~1;
        }
      }
    }
  } finally {
    for (; flushIndex < queue.length; flushIndex++) {
      const job = queue[flushIndex];
      if (job) {
        job.flags &= ~1;
      }
    }
    flushIndex = -1;
    queue.length = 0;
    flushPostFlushCbs();
    currentFlushPromise = null;
    if (queue.length || pendingPostFlushCbs.length) {
      flushJobs();
    }
  }
}
let currentRenderingInstance = null;
let currentScopeId = null;
function setCurrentRenderingInstance(instance) {
  const prev = currentRenderingInstance;
  currentRenderingInstance = instance;
  currentScopeId = instance && instance.type.__scopeId || null;
  return prev;
}
function withCtx(fn, ctx = currentRenderingInstance, isNonScopedSlot) {
  if (!ctx)
    return fn;
  if (fn._n) {
    return fn;
  }
  const renderFnWithContext = (...args) => {
    if (renderFnWithContext._d) {
      setBlockTracking(-1);
    }
    const prevInstance = setCurrentRenderingInstance(ctx);
    let res;
    try {
      res = fn(...args);
    } finally {
      setCurrentRenderingInstance(prevInstance);
      if (renderFnWithContext._d) {
        setBlockTracking(1);
      }
    }
    return res;
  };
  renderFnWithContext._n = true;
  renderFnWithContext._c = true;
  renderFnWithContext._d = true;
  return renderFnWithContext;
}
function withDirectives(vnode, directives) {
  if (currentRenderingInstance === null) {
    return vnode;
  }
  const instance = getComponentPublicInstance(currentRenderingInstance);
  const bindings = vnode.dirs || (vnode.dirs = []);
  for (let i2 = 0; i2 < directives.length; i2++) {
    let [dir, value, arg, modifiers = EMPTY_OBJ] = directives[i2];
    if (dir) {
      if (isFunction(dir)) {
        dir = {
          mounted: dir,
          updated: dir
        };
      }
      if (dir.deep) {
        traverse(value);
      }
      bindings.push({
        dir,
        instance,
        value,
        oldValue: void 0,
        arg,
        modifiers
      });
    }
  }
  return vnode;
}
function invokeDirectiveHook(vnode, prevVNode, instance, name) {
  const bindings = vnode.dirs;
  const oldBindings = prevVNode && prevVNode.dirs;
  for (let i2 = 0; i2 < bindings.length; i2++) {
    const binding = bindings[i2];
    if (oldBindings) {
      binding.oldValue = oldBindings[i2].value;
    }
    let hook = binding.dir[name];
    if (hook) {
      pauseTracking();
      callWithAsyncErrorHandling(hook, instance, 8, [
        vnode.el,
        binding,
        vnode,
        prevVNode
      ]);
      resetTracking();
    }
  }
}
const TeleportEndKey = Symbol("_vte");
const isTeleport = (type2) => type2.__isTeleport;
const isTeleportDisabled = (props) => props && (props.disabled || props.disabled === "");
const isTeleportDeferred = (props) => props && (props.defer || props.defer === "");
const isTargetSVG = (target) => typeof SVGElement !== "undefined" && target instanceof SVGElement;
const isTargetMathML = (target) => typeof MathMLElement === "function" && target instanceof MathMLElement;
const resolveTarget = (props, select) => {
  const targetSelector = props && props.to;
  if (isString$1(targetSelector)) {
    if (!select) {
      return null;
    } else {
      const target = select(targetSelector);
      return target;
    }
  } else {
    return targetSelector;
  }
};
const TeleportImpl = {
  name: "Teleport",
  __isTeleport: true,
  process(n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized, internals) {
    const {
      mc: mountChildren,
      pc: patchChildren,
      pbc: patchBlockChildren,
      o: { insert, querySelector, createText, createComment }
    } = internals;
    const disabled = isTeleportDisabled(n2.props);
    let { shapeFlag, children, dynamicChildren } = n2;
    if (n1 == null) {
      const placeholder = n2.el = createText("");
      const mainAnchor = n2.anchor = createText("");
      insert(placeholder, container, anchor);
      insert(mainAnchor, container, anchor);
      const mount = (container2, anchor2) => {
        if (shapeFlag & 16) {
          if (parentComponent && parentComponent.isCE) {
            parentComponent.ce._teleportTarget = container2;
          }
          mountChildren(
            children,
            container2,
            anchor2,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        }
      };
      const mountToTarget = () => {
        const target = n2.target = resolveTarget(n2.props, querySelector);
        const targetAnchor = prepareAnchor(target, n2, createText, insert);
        if (target) {
          if (namespace !== "svg" && isTargetSVG(target)) {
            namespace = "svg";
          } else if (namespace !== "mathml" && isTargetMathML(target)) {
            namespace = "mathml";
          }
          if (!disabled) {
            mount(target, targetAnchor);
            updateCssVars(n2, false);
          }
        }
      };
      if (disabled) {
        mount(container, mainAnchor);
        updateCssVars(n2, true);
      }
      if (isTeleportDeferred(n2.props)) {
        queuePostRenderEffect(() => {
          mountToTarget();
          n2.el.__isMounted = true;
        }, parentSuspense);
      } else {
        mountToTarget();
      }
    } else {
      if (isTeleportDeferred(n2.props) && !n1.el.__isMounted) {
        queuePostRenderEffect(() => {
          TeleportImpl.process(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized,
            internals
          );
          delete n1.el.__isMounted;
        }, parentSuspense);
        return;
      }
      n2.el = n1.el;
      n2.targetStart = n1.targetStart;
      const mainAnchor = n2.anchor = n1.anchor;
      const target = n2.target = n1.target;
      const targetAnchor = n2.targetAnchor = n1.targetAnchor;
      const wasDisabled = isTeleportDisabled(n1.props);
      const currentContainer = wasDisabled ? container : target;
      const currentAnchor = wasDisabled ? mainAnchor : targetAnchor;
      if (namespace === "svg" || isTargetSVG(target)) {
        namespace = "svg";
      } else if (namespace === "mathml" || isTargetMathML(target)) {
        namespace = "mathml";
      }
      if (dynamicChildren) {
        patchBlockChildren(
          n1.dynamicChildren,
          dynamicChildren,
          currentContainer,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds
        );
        traverseStaticChildren(n1, n2, true);
      } else if (!optimized) {
        patchChildren(
          n1,
          n2,
          currentContainer,
          currentAnchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          false
        );
      }
      if (disabled) {
        if (!wasDisabled) {
          moveTeleport(
            n2,
            container,
            mainAnchor,
            internals,
            1
          );
        } else {
          if (n2.props && n1.props && n2.props.to !== n1.props.to) {
            n2.props.to = n1.props.to;
          }
        }
      } else {
        if ((n2.props && n2.props.to) !== (n1.props && n1.props.to)) {
          const nextTarget = n2.target = resolveTarget(
            n2.props,
            querySelector
          );
          if (nextTarget) {
            moveTeleport(
              n2,
              nextTarget,
              null,
              internals,
              0
            );
          }
        } else if (wasDisabled) {
          moveTeleport(
            n2,
            target,
            targetAnchor,
            internals,
            1
          );
        }
      }
      updateCssVars(n2, disabled);
    }
  },
  remove(vnode, parentComponent, parentSuspense, { um: unmount, o: { remove: hostRemove } }, doRemove) {
    const {
      shapeFlag,
      children,
      anchor,
      targetStart,
      targetAnchor,
      target,
      props
    } = vnode;
    if (target) {
      hostRemove(targetStart);
      hostRemove(targetAnchor);
    }
    doRemove && hostRemove(anchor);
    if (shapeFlag & 16) {
      const shouldRemove = doRemove || !isTeleportDisabled(props);
      for (let i2 = 0; i2 < children.length; i2++) {
        const child = children[i2];
        unmount(
          child,
          parentComponent,
          parentSuspense,
          shouldRemove,
          !!child.dynamicChildren
        );
      }
    }
  },
  move: moveTeleport,
  hydrate: hydrateTeleport
};
function moveTeleport(vnode, container, parentAnchor, { o: { insert }, m: move }, moveType = 2) {
  if (moveType === 0) {
    insert(vnode.targetAnchor, container, parentAnchor);
  }
  const { el, anchor, shapeFlag, children, props } = vnode;
  const isReorder = moveType === 2;
  if (isReorder) {
    insert(el, container, parentAnchor);
  }
  if (!isReorder || isTeleportDisabled(props)) {
    if (shapeFlag & 16) {
      for (let i2 = 0; i2 < children.length; i2++) {
        move(
          children[i2],
          container,
          parentAnchor,
          2
        );
      }
    }
  }
  if (isReorder) {
    insert(anchor, container, parentAnchor);
  }
}
function hydrateTeleport(node, vnode, parentComponent, parentSuspense, slotScopeIds, optimized, {
  o: { nextSibling, parentNode, querySelector, insert, createText }
}, hydrateChildren) {
  const target = vnode.target = resolveTarget(
    vnode.props,
    querySelector
  );
  if (target) {
    const disabled = isTeleportDisabled(vnode.props);
    const targetNode = target._lpa || target.firstChild;
    if (vnode.shapeFlag & 16) {
      if (disabled) {
        vnode.anchor = hydrateChildren(
          nextSibling(node),
          vnode,
          parentNode(node),
          parentComponent,
          parentSuspense,
          slotScopeIds,
          optimized
        );
        vnode.targetStart = targetNode;
        vnode.targetAnchor = targetNode && nextSibling(targetNode);
      } else {
        vnode.anchor = nextSibling(node);
        let targetAnchor = targetNode;
        while (targetAnchor) {
          if (targetAnchor && targetAnchor.nodeType === 8) {
            if (targetAnchor.data === "teleport start anchor") {
              vnode.targetStart = targetAnchor;
            } else if (targetAnchor.data === "teleport anchor") {
              vnode.targetAnchor = targetAnchor;
              target._lpa = vnode.targetAnchor && nextSibling(vnode.targetAnchor);
              break;
            }
          }
          targetAnchor = nextSibling(targetAnchor);
        }
        if (!vnode.targetAnchor) {
          prepareAnchor(target, vnode, createText, insert);
        }
        hydrateChildren(
          targetNode && nextSibling(targetNode),
          vnode,
          target,
          parentComponent,
          parentSuspense,
          slotScopeIds,
          optimized
        );
      }
    }
    updateCssVars(vnode, disabled);
  }
  return vnode.anchor && nextSibling(vnode.anchor);
}
const Teleport = TeleportImpl;
function updateCssVars(vnode, isDisabled) {
  const ctx = vnode.ctx;
  if (ctx && ctx.ut) {
    let node, anchor;
    if (isDisabled) {
      node = vnode.el;
      anchor = vnode.anchor;
    } else {
      node = vnode.targetStart;
      anchor = vnode.targetAnchor;
    }
    while (node && node !== anchor) {
      if (node.nodeType === 1)
        node.setAttribute("data-v-owner", ctx.uid);
      node = node.nextSibling;
    }
    ctx.ut();
  }
}
function prepareAnchor(target, vnode, createText, insert) {
  const targetStart = vnode.targetStart = createText("");
  const targetAnchor = vnode.targetAnchor = createText("");
  targetStart[TeleportEndKey] = targetAnchor;
  if (target) {
    insert(targetStart, target);
    insert(targetAnchor, target);
  }
  return targetAnchor;
}
const leaveCbKey = Symbol("_leaveCb");
const enterCbKey$1 = Symbol("_enterCb");
function useTransitionState() {
  const state = {
    isMounted: false,
    isLeaving: false,
    isUnmounting: false,
    leavingVNodes: /* @__PURE__ */ new Map()
  };
  onMounted(() => {
    state.isMounted = true;
  });
  onBeforeUnmount(() => {
    state.isUnmounting = true;
  });
  return state;
}
const TransitionHookValidator = [Function, Array];
const BaseTransitionPropsValidators = {
  mode: String,
  appear: Boolean,
  persisted: Boolean,
  onBeforeEnter: TransitionHookValidator,
  onEnter: TransitionHookValidator,
  onAfterEnter: TransitionHookValidator,
  onEnterCancelled: TransitionHookValidator,
  onBeforeLeave: TransitionHookValidator,
  onLeave: TransitionHookValidator,
  onAfterLeave: TransitionHookValidator,
  onLeaveCancelled: TransitionHookValidator,
  onBeforeAppear: TransitionHookValidator,
  onAppear: TransitionHookValidator,
  onAfterAppear: TransitionHookValidator,
  onAppearCancelled: TransitionHookValidator
};
const recursiveGetSubtree = (instance) => {
  const subTree = instance.subTree;
  return subTree.component ? recursiveGetSubtree(subTree.component) : subTree;
};
const BaseTransitionImpl = {
  name: `BaseTransition`,
  props: BaseTransitionPropsValidators,
  setup(props, { slots }) {
    const instance = getCurrentInstance();
    const state = useTransitionState();
    return () => {
      const children = slots.default && getTransitionRawChildren(slots.default(), true);
      if (!children || !children.length) {
        return;
      }
      const child = findNonCommentChild(children);
      const rawProps = toRaw(props);
      const { mode } = rawProps;
      if (state.isLeaving) {
        return emptyPlaceholder(child);
      }
      const innerChild = getInnerChild$1(child);
      if (!innerChild) {
        return emptyPlaceholder(child);
      }
      let enterHooks = resolveTransitionHooks(
        innerChild,
        rawProps,
        state,
        instance,
        (hooks) => enterHooks = hooks
      );
      if (innerChild.type !== Comment) {
        setTransitionHooks(innerChild, enterHooks);
      }
      let oldInnerChild = instance.subTree && getInnerChild$1(instance.subTree);
      if (oldInnerChild && oldInnerChild.type !== Comment && !isSameVNodeType(innerChild, oldInnerChild) && recursiveGetSubtree(instance).type !== Comment) {
        let leavingHooks = resolveTransitionHooks(
          oldInnerChild,
          rawProps,
          state,
          instance
        );
        setTransitionHooks(oldInnerChild, leavingHooks);
        if (mode === "out-in" && innerChild.type !== Comment) {
          state.isLeaving = true;
          leavingHooks.afterLeave = () => {
            state.isLeaving = false;
            if (!(instance.job.flags & 8)) {
              instance.update();
            }
            delete leavingHooks.afterLeave;
            oldInnerChild = void 0;
          };
          return emptyPlaceholder(child);
        } else if (mode === "in-out" && innerChild.type !== Comment) {
          leavingHooks.delayLeave = (el, earlyRemove, delayedLeave) => {
            const leavingVNodesCache = getLeavingNodesForType(
              state,
              oldInnerChild
            );
            leavingVNodesCache[String(oldInnerChild.key)] = oldInnerChild;
            el[leaveCbKey] = () => {
              earlyRemove();
              el[leaveCbKey] = void 0;
              delete enterHooks.delayedLeave;
              oldInnerChild = void 0;
            };
            enterHooks.delayedLeave = () => {
              delayedLeave();
              delete enterHooks.delayedLeave;
              oldInnerChild = void 0;
            };
          };
        } else {
          oldInnerChild = void 0;
        }
      } else if (oldInnerChild) {
        oldInnerChild = void 0;
      }
      return child;
    };
  }
};
function findNonCommentChild(children) {
  let child = children[0];
  if (children.length > 1) {
    for (const c of children) {
      if (c.type !== Comment) {
        child = c;
        break;
      }
    }
  }
  return child;
}
const BaseTransition = BaseTransitionImpl;
function getLeavingNodesForType(state, vnode) {
  const { leavingVNodes } = state;
  let leavingVNodesCache = leavingVNodes.get(vnode.type);
  if (!leavingVNodesCache) {
    leavingVNodesCache = /* @__PURE__ */ Object.create(null);
    leavingVNodes.set(vnode.type, leavingVNodesCache);
  }
  return leavingVNodesCache;
}
function resolveTransitionHooks(vnode, props, state, instance, postClone) {
  const {
    appear,
    mode,
    persisted = false,
    onBeforeEnter,
    onEnter,
    onAfterEnter,
    onEnterCancelled,
    onBeforeLeave,
    onLeave,
    onAfterLeave,
    onLeaveCancelled,
    onBeforeAppear,
    onAppear,
    onAfterAppear,
    onAppearCancelled
  } = props;
  const key = String(vnode.key);
  const leavingVNodesCache = getLeavingNodesForType(state, vnode);
  const callHook2 = (hook, args) => {
    hook && callWithAsyncErrorHandling(
      hook,
      instance,
      9,
      args
    );
  };
  const callAsyncHook = (hook, args) => {
    const done = args[1];
    callHook2(hook, args);
    if (isArray(hook)) {
      if (hook.every((hook2) => hook2.length <= 1))
        done();
    } else if (hook.length <= 1) {
      done();
    }
  };
  const hooks = {
    mode,
    persisted,
    beforeEnter(el) {
      let hook = onBeforeEnter;
      if (!state.isMounted) {
        if (appear) {
          hook = onBeforeAppear || onBeforeEnter;
        } else {
          return;
        }
      }
      if (el[leaveCbKey]) {
        el[leaveCbKey](
          true
        );
      }
      const leavingVNode = leavingVNodesCache[key];
      if (leavingVNode && isSameVNodeType(vnode, leavingVNode) && leavingVNode.el[leaveCbKey]) {
        leavingVNode.el[leaveCbKey]();
      }
      callHook2(hook, [el]);
    },
    enter(el) {
      let hook = onEnter;
      let afterHook = onAfterEnter;
      let cancelHook = onEnterCancelled;
      if (!state.isMounted) {
        if (appear) {
          hook = onAppear || onEnter;
          afterHook = onAfterAppear || onAfterEnter;
          cancelHook = onAppearCancelled || onEnterCancelled;
        } else {
          return;
        }
      }
      let called = false;
      const done = el[enterCbKey$1] = (cancelled) => {
        if (called)
          return;
        called = true;
        if (cancelled) {
          callHook2(cancelHook, [el]);
        } else {
          callHook2(afterHook, [el]);
        }
        if (hooks.delayedLeave) {
          hooks.delayedLeave();
        }
        el[enterCbKey$1] = void 0;
      };
      if (hook) {
        callAsyncHook(hook, [el, done]);
      } else {
        done();
      }
    },
    leave(el, remove2) {
      const key2 = String(vnode.key);
      if (el[enterCbKey$1]) {
        el[enterCbKey$1](
          true
        );
      }
      if (state.isUnmounting) {
        return remove2();
      }
      callHook2(onBeforeLeave, [el]);
      let called = false;
      const done = el[leaveCbKey] = (cancelled) => {
        if (called)
          return;
        called = true;
        remove2();
        if (cancelled) {
          callHook2(onLeaveCancelled, [el]);
        } else {
          callHook2(onAfterLeave, [el]);
        }
        el[leaveCbKey] = void 0;
        if (leavingVNodesCache[key2] === vnode) {
          delete leavingVNodesCache[key2];
        }
      };
      leavingVNodesCache[key2] = vnode;
      if (onLeave) {
        callAsyncHook(onLeave, [el, done]);
      } else {
        done();
      }
    },
    clone(vnode2) {
      const hooks2 = resolveTransitionHooks(
        vnode2,
        props,
        state,
        instance,
        postClone
      );
      if (postClone)
        postClone(hooks2);
      return hooks2;
    }
  };
  return hooks;
}
function emptyPlaceholder(vnode) {
  if (isKeepAlive(vnode)) {
    vnode = cloneVNode(vnode);
    vnode.children = null;
    return vnode;
  }
}
function getInnerChild$1(vnode) {
  if (!isKeepAlive(vnode)) {
    if (isTeleport(vnode.type) && vnode.children) {
      return findNonCommentChild(vnode.children);
    }
    return vnode;
  }
  const { shapeFlag, children } = vnode;
  if (children) {
    if (shapeFlag & 16) {
      return children[0];
    }
    if (shapeFlag & 32 && isFunction(children.default)) {
      return children.default();
    }
  }
}
function setTransitionHooks(vnode, hooks) {
  if (vnode.shapeFlag & 6 && vnode.component) {
    vnode.transition = hooks;
    setTransitionHooks(vnode.component.subTree, hooks);
  } else if (vnode.shapeFlag & 128) {
    vnode.ssContent.transition = hooks.clone(vnode.ssContent);
    vnode.ssFallback.transition = hooks.clone(vnode.ssFallback);
  } else {
    vnode.transition = hooks;
  }
}
function getTransitionRawChildren(children, keepComment = false, parentKey) {
  let ret = [];
  let keyedFragmentCount = 0;
  for (let i2 = 0; i2 < children.length; i2++) {
    let child = children[i2];
    const key = parentKey == null ? child.key : String(parentKey) + String(child.key != null ? child.key : i2);
    if (child.type === Fragment) {
      if (child.patchFlag & 128)
        keyedFragmentCount++;
      ret = ret.concat(
        getTransitionRawChildren(child.children, keepComment, key)
      );
    } else if (keepComment || child.type !== Comment) {
      ret.push(key != null ? cloneVNode(child, { key }) : child);
    }
  }
  if (keyedFragmentCount > 1) {
    for (let i2 = 0; i2 < ret.length; i2++) {
      ret[i2].patchFlag = -2;
    }
  }
  return ret;
}
/*! #__NO_SIDE_EFFECTS__ */
function defineComponent(options, extraOptions) {
  return isFunction(options) ? /* @__PURE__ */ (() => extend({ name: options.name }, extraOptions, { setup: options }))() : options;
}
function useId() {
  const i2 = getCurrentInstance();
  if (i2) {
    return (i2.appContext.config.idPrefix || "v") + "-" + i2.ids[0] + i2.ids[1]++;
  }
  return "";
}
function markAsyncBoundary(instance) {
  instance.ids = [instance.ids[0] + instance.ids[2]++ + "-", 0, 0];
}
function setRef(rawRef, oldRawRef, parentSuspense, vnode, isUnmount = false) {
  if (isArray(rawRef)) {
    rawRef.forEach(
      (r2, i2) => setRef(
        r2,
        oldRawRef && (isArray(oldRawRef) ? oldRawRef[i2] : oldRawRef),
        parentSuspense,
        vnode,
        isUnmount
      )
    );
    return;
  }
  if (isAsyncWrapper(vnode) && !isUnmount) {
    if (vnode.shapeFlag & 512 && vnode.type.__asyncResolved && vnode.component.subTree.component) {
      setRef(rawRef, oldRawRef, parentSuspense, vnode.component.subTree);
    }
    return;
  }
  const refValue = vnode.shapeFlag & 4 ? getComponentPublicInstance(vnode.component) : vnode.el;
  const value = isUnmount ? null : refValue;
  const { i: owner, r: ref2 } = rawRef;
  const oldRef = oldRawRef && oldRawRef.r;
  const refs = owner.refs === EMPTY_OBJ ? owner.refs = {} : owner.refs;
  const setupState = owner.setupState;
  const rawSetupState = toRaw(setupState);
  const canSetSetupRef = setupState === EMPTY_OBJ ? () => false : (key) => {
    return hasOwn(rawSetupState, key);
  };
  if (oldRef != null && oldRef !== ref2) {
    if (isString$1(oldRef)) {
      refs[oldRef] = null;
      if (canSetSetupRef(oldRef)) {
        setupState[oldRef] = null;
      }
    } else if (isRef(oldRef)) {
      oldRef.value = null;
    }
  }
  if (isFunction(ref2)) {
    callWithErrorHandling(ref2, owner, 12, [value, refs]);
  } else {
    const _isString = isString$1(ref2);
    const _isRef = isRef(ref2);
    if (_isString || _isRef) {
      const doSet = () => {
        if (rawRef.f) {
          const existing = _isString ? canSetSetupRef(ref2) ? setupState[ref2] : refs[ref2] : ref2.value;
          if (isUnmount) {
            isArray(existing) && remove(existing, refValue);
          } else {
            if (!isArray(existing)) {
              if (_isString) {
                refs[ref2] = [refValue];
                if (canSetSetupRef(ref2)) {
                  setupState[ref2] = refs[ref2];
                }
              } else {
                ref2.value = [refValue];
                if (rawRef.k)
                  refs[rawRef.k] = ref2.value;
              }
            } else if (!existing.includes(refValue)) {
              existing.push(refValue);
            }
          }
        } else if (_isString) {
          refs[ref2] = value;
          if (canSetSetupRef(ref2)) {
            setupState[ref2] = value;
          }
        } else if (_isRef) {
          ref2.value = value;
          if (rawRef.k)
            refs[rawRef.k] = value;
        } else
          ;
      };
      if (value) {
        doSet.id = -1;
        queuePostRenderEffect(doSet, parentSuspense);
      } else {
        doSet();
      }
    }
  }
}
getGlobalThis().requestIdleCallback || ((cb) => setTimeout(cb, 1));
getGlobalThis().cancelIdleCallback || ((id) => clearTimeout(id));
const isAsyncWrapper = (i2) => !!i2.type.__asyncLoader;
const isKeepAlive = (vnode) => vnode.type.__isKeepAlive;
const KeepAliveImpl = {
  name: `KeepAlive`,
  __isKeepAlive: true,
  props: {
    include: [String, RegExp, Array],
    exclude: [String, RegExp, Array],
    max: [String, Number]
  },
  setup(props, { slots }) {
    const instance = getCurrentInstance();
    const sharedContext = instance.ctx;
    if (!sharedContext.renderer) {
      return () => {
        const children = slots.default && slots.default();
        return children && children.length === 1 ? children[0] : children;
      };
    }
    const cache = /* @__PURE__ */ new Map();
    const keys = /* @__PURE__ */ new Set();
    let current = null;
    const parentSuspense = instance.suspense;
    const {
      renderer: {
        p: patch,
        m: move,
        um: _unmount,
        o: { createElement }
      }
    } = sharedContext;
    const storageContainer = createElement("div");
    sharedContext.activate = (vnode, container, anchor, namespace, optimized) => {
      const instance2 = vnode.component;
      move(vnode, container, anchor, 0, parentSuspense);
      patch(
        instance2.vnode,
        vnode,
        container,
        anchor,
        instance2,
        parentSuspense,
        namespace,
        vnode.slotScopeIds,
        optimized
      );
      queuePostRenderEffect(() => {
        instance2.isDeactivated = false;
        if (instance2.a) {
          invokeArrayFns(instance2.a);
        }
        const vnodeHook = vnode.props && vnode.props.onVnodeMounted;
        if (vnodeHook) {
          invokeVNodeHook(vnodeHook, instance2.parent, vnode);
        }
      }, parentSuspense);
    };
    sharedContext.deactivate = (vnode) => {
      const instance2 = vnode.component;
      invalidateMount(instance2.m);
      invalidateMount(instance2.a);
      move(vnode, storageContainer, null, 1, parentSuspense);
      queuePostRenderEffect(() => {
        if (instance2.da) {
          invokeArrayFns(instance2.da);
        }
        const vnodeHook = vnode.props && vnode.props.onVnodeUnmounted;
        if (vnodeHook) {
          invokeVNodeHook(vnodeHook, instance2.parent, vnode);
        }
        instance2.isDeactivated = true;
      }, parentSuspense);
    };
    function unmount(vnode) {
      resetShapeFlag(vnode);
      _unmount(vnode, instance, parentSuspense, true);
    }
    function pruneCache(filter) {
      cache.forEach((vnode, key) => {
        const name = getComponentName(vnode.type);
        if (name && !filter(name)) {
          pruneCacheEntry(key);
        }
      });
    }
    function pruneCacheEntry(key) {
      const cached = cache.get(key);
      if (cached && (!current || !isSameVNodeType(cached, current))) {
        unmount(cached);
      } else if (current) {
        resetShapeFlag(current);
      }
      cache.delete(key);
      keys.delete(key);
    }
    watch(
      () => [props.include, props.exclude],
      ([include, exclude]) => {
        include && pruneCache((name) => matches(include, name));
        exclude && pruneCache((name) => !matches(exclude, name));
      },
      { flush: "post", deep: true }
    );
    let pendingCacheKey = null;
    const cacheSubtree = () => {
      if (pendingCacheKey != null) {
        if (isSuspense(instance.subTree.type)) {
          queuePostRenderEffect(() => {
            cache.set(pendingCacheKey, getInnerChild(instance.subTree));
          }, instance.subTree.suspense);
        } else {
          cache.set(pendingCacheKey, getInnerChild(instance.subTree));
        }
      }
    };
    onMounted(cacheSubtree);
    onUpdated(cacheSubtree);
    onBeforeUnmount(() => {
      cache.forEach((cached) => {
        const { subTree, suspense } = instance;
        const vnode = getInnerChild(subTree);
        if (cached.type === vnode.type && cached.key === vnode.key) {
          resetShapeFlag(vnode);
          const da = vnode.component.da;
          da && queuePostRenderEffect(da, suspense);
          return;
        }
        unmount(cached);
      });
    });
    return () => {
      pendingCacheKey = null;
      if (!slots.default) {
        return current = null;
      }
      const children = slots.default();
      const rawVNode = children[0];
      if (children.length > 1) {
        current = null;
        return children;
      } else if (!isVNode(rawVNode) || !(rawVNode.shapeFlag & 4) && !(rawVNode.shapeFlag & 128)) {
        current = null;
        return rawVNode;
      }
      let vnode = getInnerChild(rawVNode);
      if (vnode.type === Comment) {
        current = null;
        return vnode;
      }
      const comp = vnode.type;
      const name = getComponentName(
        isAsyncWrapper(vnode) ? vnode.type.__asyncResolved || {} : comp
      );
      const { include, exclude, max } = props;
      if (include && (!name || !matches(include, name)) || exclude && name && matches(exclude, name)) {
        vnode.shapeFlag &= ~256;
        current = vnode;
        return rawVNode;
      }
      const key = vnode.key == null ? comp : vnode.key;
      const cachedVNode = cache.get(key);
      if (vnode.el) {
        vnode = cloneVNode(vnode);
        if (rawVNode.shapeFlag & 128) {
          rawVNode.ssContent = vnode;
        }
      }
      pendingCacheKey = key;
      if (cachedVNode) {
        vnode.el = cachedVNode.el;
        vnode.component = cachedVNode.component;
        if (vnode.transition) {
          setTransitionHooks(vnode, vnode.transition);
        }
        vnode.shapeFlag |= 512;
        keys.delete(key);
        keys.add(key);
      } else {
        keys.add(key);
        if (max && keys.size > parseInt(max, 10)) {
          pruneCacheEntry(keys.values().next().value);
        }
      }
      vnode.shapeFlag |= 256;
      current = vnode;
      return isSuspense(rawVNode.type) ? rawVNode : vnode;
    };
  }
};
const KeepAlive = KeepAliveImpl;
function matches(pattern, name) {
  if (isArray(pattern)) {
    return pattern.some((p2) => matches(p2, name));
  } else if (isString$1(pattern)) {
    return pattern.split(",").includes(name);
  } else if (isRegExp(pattern)) {
    pattern.lastIndex = 0;
    return pattern.test(name);
  }
  return false;
}
function onActivated(hook, target) {
  registerKeepAliveHook(hook, "a", target);
}
function onDeactivated(hook, target) {
  registerKeepAliveHook(hook, "da", target);
}
function registerKeepAliveHook(hook, type2, target = currentInstance) {
  const wrappedHook = hook.__wdc || (hook.__wdc = () => {
    let current = target;
    while (current) {
      if (current.isDeactivated) {
        return;
      }
      current = current.parent;
    }
    return hook();
  });
  injectHook(type2, wrappedHook, target);
  if (target) {
    let current = target.parent;
    while (current && current.parent) {
      if (isKeepAlive(current.parent.vnode)) {
        injectToKeepAliveRoot(wrappedHook, type2, target, current);
      }
      current = current.parent;
    }
  }
}
function injectToKeepAliveRoot(hook, type2, target, keepAliveRoot) {
  const injected = injectHook(
    type2,
    hook,
    keepAliveRoot,
    true
  );
  onUnmounted(() => {
    remove(keepAliveRoot[type2], injected);
  }, target);
}
function resetShapeFlag(vnode) {
  vnode.shapeFlag &= ~256;
  vnode.shapeFlag &= ~512;
}
function getInnerChild(vnode) {
  return vnode.shapeFlag & 128 ? vnode.ssContent : vnode;
}
function injectHook(type2, hook, target = currentInstance, prepend = false) {
  if (target) {
    const hooks = target[type2] || (target[type2] = []);
    const wrappedHook = hook.__weh || (hook.__weh = (...args) => {
      pauseTracking();
      const reset = setCurrentInstance(target);
      const res = callWithAsyncErrorHandling(hook, target, type2, args);
      reset();
      resetTracking();
      return res;
    });
    if (prepend) {
      hooks.unshift(wrappedHook);
    } else {
      hooks.push(wrappedHook);
    }
    return wrappedHook;
  }
}
const createHook = (lifecycle) => (hook, target = currentInstance) => {
  if (!isInSSRComponentSetup || lifecycle === "sp") {
    injectHook(lifecycle, (...args) => hook(...args), target);
  }
};
const onBeforeMount = createHook("bm");
const onMounted = createHook("m");
const onBeforeUpdate = createHook(
  "bu"
);
const onUpdated = createHook("u");
const onBeforeUnmount = createHook(
  "bum"
);
const onUnmounted = createHook("um");
const onServerPrefetch = createHook(
  "sp"
);
const onRenderTriggered = createHook("rtg");
const onRenderTracked = createHook("rtc");
function onErrorCaptured(hook, target = currentInstance) {
  injectHook("ec", hook, target);
}
const COMPONENTS = "components";
function resolveComponent(name, maybeSelfReference) {
  return resolveAsset(COMPONENTS, name, true, maybeSelfReference) || name;
}
const NULL_DYNAMIC_COMPONENT = Symbol.for("v-ndc");
function resolveDynamicComponent(component) {
  if (isString$1(component)) {
    return resolveAsset(COMPONENTS, component, false) || component;
  } else {
    return component || NULL_DYNAMIC_COMPONENT;
  }
}
function resolveAsset(type2, name, warnMissing = true, maybeSelfReference = false) {
  const instance = currentRenderingInstance || currentInstance;
  if (instance) {
    const Component = instance.type;
    if (type2 === COMPONENTS) {
      const selfName = getComponentName(
        Component,
        false
      );
      if (selfName && (selfName === name || selfName === camelize(name) || selfName === capitalize(camelize(name)))) {
        return Component;
      }
    }
    const res = resolve(instance[type2] || Component[type2], name) || resolve(instance.appContext[type2], name);
    if (!res && maybeSelfReference) {
      return Component;
    }
    return res;
  }
}
function resolve(registry, name) {
  return registry && (registry[name] || registry[camelize(name)] || registry[capitalize(camelize(name))]);
}
function renderList(source, renderItem, cache, index2) {
  let ret;
  const cached = cache && cache[index2];
  const sourceIsArray = isArray(source);
  if (sourceIsArray || isString$1(source)) {
    const sourceIsReactiveArray = sourceIsArray && isReactive(source);
    let needsWrap = false;
    if (sourceIsReactiveArray) {
      needsWrap = !isShallow(source);
      source = shallowReadArray(source);
    }
    ret = new Array(source.length);
    for (let i2 = 0, l = source.length; i2 < l; i2++) {
      ret[i2] = renderItem(
        needsWrap ? toReactive(source[i2]) : source[i2],
        i2,
        void 0,
        cached && cached[i2]
      );
    }
  } else if (typeof source === "number") {
    ret = new Array(source);
    for (let i2 = 0; i2 < source; i2++) {
      ret[i2] = renderItem(i2 + 1, i2, void 0, cached && cached[i2]);
    }
  } else if (isObject(source)) {
    if (source[Symbol.iterator]) {
      ret = Array.from(
        source,
        (item, i2) => renderItem(item, i2, void 0, cached && cached[i2])
      );
    } else {
      const keys = Object.keys(source);
      ret = new Array(keys.length);
      for (let i2 = 0, l = keys.length; i2 < l; i2++) {
        const key = keys[i2];
        ret[i2] = renderItem(source[key], key, i2, cached && cached[i2]);
      }
    }
  } else {
    ret = [];
  }
  if (cache) {
    cache[index2] = ret;
  }
  return ret;
}
function createSlots(slots, dynamicSlots) {
  for (let i2 = 0; i2 < dynamicSlots.length; i2++) {
    const slot = dynamicSlots[i2];
    if (isArray(slot)) {
      for (let j2 = 0; j2 < slot.length; j2++) {
        slots[slot[j2].name] = slot[j2].fn;
      }
    } else if (slot) {
      slots[slot.name] = slot.key ? (...args) => {
        const res = slot.fn(...args);
        if (res)
          res.key = slot.key;
        return res;
      } : slot.fn;
    }
  }
  return slots;
}
function renderSlot(slots, name, props = {}, fallback, noSlotted) {
  if (currentRenderingInstance.ce || currentRenderingInstance.parent && isAsyncWrapper(currentRenderingInstance.parent) && currentRenderingInstance.parent.ce) {
    if (name !== "default")
      props.name = name;
    return openBlock(), createBlock(
      Fragment,
      null,
      [createVNode("slot", props, fallback && fallback())],
      64
    );
  }
  let slot = slots[name];
  if (slot && slot._c) {
    slot._d = false;
  }
  openBlock();
  const validSlotContent = slot && ensureValidVNode(slot(props));
  const slotKey = props.key || validSlotContent && validSlotContent.key;
  const rendered = createBlock(
    Fragment,
    {
      key: (slotKey && !isSymbol$1(slotKey) ? slotKey : `_${name}`) + (!validSlotContent && fallback ? "_fb" : "")
    },
    validSlotContent || (fallback ? fallback() : []),
    validSlotContent && slots._ === 1 ? 64 : -2
  );
  if (!noSlotted && rendered.scopeId) {
    rendered.slotScopeIds = [rendered.scopeId + "-s"];
  }
  if (slot && slot._c) {
    slot._d = true;
  }
  return rendered;
}
function ensureValidVNode(vnodes) {
  return vnodes.some((child) => {
    if (!isVNode(child))
      return true;
    if (child.type === Comment)
      return false;
    if (child.type === Fragment && !ensureValidVNode(child.children))
      return false;
    return true;
  }) ? vnodes : null;
}
const getPublicInstance = (i2) => {
  if (!i2)
    return null;
  if (isStatefulComponent(i2))
    return getComponentPublicInstance(i2);
  return getPublicInstance(i2.parent);
};
const publicPropertiesMap = /* @__PURE__ */ extend(/* @__PURE__ */ Object.create(null), {
  $: (i2) => i2,
  $el: (i2) => i2.vnode.el,
  $data: (i2) => i2.data,
  $props: (i2) => i2.props,
  $attrs: (i2) => i2.attrs,
  $slots: (i2) => i2.slots,
  $refs: (i2) => i2.refs,
  $parent: (i2) => getPublicInstance(i2.parent),
  $root: (i2) => getPublicInstance(i2.root),
  $host: (i2) => i2.ce,
  $emit: (i2) => i2.emit,
  $options: (i2) => resolveMergedOptions(i2),
  $forceUpdate: (i2) => i2.f || (i2.f = () => {
    queueJob(i2.update);
  }),
  $nextTick: (i2) => i2.n || (i2.n = nextTick.bind(i2.proxy)),
  $watch: (i2) => instanceWatch.bind(i2)
});
const hasSetupBinding = (state, key) => state !== EMPTY_OBJ && !state.__isScriptSetup && hasOwn(state, key);
const PublicInstanceProxyHandlers = {
  get({ _: instance }, key) {
    if (key === "__v_skip") {
      return true;
    }
    const { ctx, setupState, data, props, accessCache, type: type2, appContext } = instance;
    let normalizedProps;
    if (key[0] !== "$") {
      const n = accessCache[key];
      if (n !== void 0) {
        switch (n) {
          case 1:
            return setupState[key];
          case 2:
            return data[key];
          case 4:
            return ctx[key];
          case 3:
            return props[key];
        }
      } else if (hasSetupBinding(setupState, key)) {
        accessCache[key] = 1;
        return setupState[key];
      } else if (data !== EMPTY_OBJ && hasOwn(data, key)) {
        accessCache[key] = 2;
        return data[key];
      } else if ((normalizedProps = instance.propsOptions[0]) && hasOwn(normalizedProps, key)) {
        accessCache[key] = 3;
        return props[key];
      } else if (ctx !== EMPTY_OBJ && hasOwn(ctx, key)) {
        accessCache[key] = 4;
        return ctx[key];
      } else if (shouldCacheAccess) {
        accessCache[key] = 0;
      }
    }
    const publicGetter = publicPropertiesMap[key];
    let cssModule, globalProperties;
    if (publicGetter) {
      if (key === "$attrs") {
        track(instance.attrs, "get", "");
      }
      return publicGetter(instance);
    } else if ((cssModule = type2.__cssModules) && (cssModule = cssModule[key])) {
      return cssModule;
    } else if (ctx !== EMPTY_OBJ && hasOwn(ctx, key)) {
      accessCache[key] = 4;
      return ctx[key];
    } else if (globalProperties = appContext.config.globalProperties, hasOwn(globalProperties, key)) {
      {
        return globalProperties[key];
      }
    } else
      ;
  },
  set({ _: instance }, key, value) {
    const { data, setupState, ctx } = instance;
    if (hasSetupBinding(setupState, key)) {
      setupState[key] = value;
      return true;
    } else if (data !== EMPTY_OBJ && hasOwn(data, key)) {
      data[key] = value;
      return true;
    } else if (hasOwn(instance.props, key)) {
      return false;
    }
    if (key[0] === "$" && key.slice(1) in instance) {
      return false;
    } else {
      {
        ctx[key] = value;
      }
    }
    return true;
  },
  has({
    _: { data, setupState, accessCache, ctx, appContext, propsOptions }
  }, key) {
    let normalizedProps;
    return !!accessCache[key] || data !== EMPTY_OBJ && hasOwn(data, key) || hasSetupBinding(setupState, key) || (normalizedProps = propsOptions[0]) && hasOwn(normalizedProps, key) || hasOwn(ctx, key) || hasOwn(publicPropertiesMap, key) || hasOwn(appContext.config.globalProperties, key);
  },
  defineProperty(target, key, descriptor) {
    if (descriptor.get != null) {
      target._.accessCache[key] = 0;
    } else if (hasOwn(descriptor, "value")) {
      this.set(target, key, descriptor.value, null);
    }
    return Reflect.defineProperty(target, key, descriptor);
  }
};
function normalizePropsOrEmits(props) {
  return isArray(props) ? props.reduce(
    (normalized, p2) => (normalized[p2] = null, normalized),
    {}
  ) : props;
}
function mergeModels(a2, b2) {
  if (!a2 || !b2)
    return a2 || b2;
  if (isArray(a2) && isArray(b2))
    return a2.concat(b2);
  return extend({}, normalizePropsOrEmits(a2), normalizePropsOrEmits(b2));
}
let shouldCacheAccess = true;
function applyOptions(instance) {
  const options = resolveMergedOptions(instance);
  const publicThis = instance.proxy;
  const ctx = instance.ctx;
  shouldCacheAccess = false;
  if (options.beforeCreate) {
    callHook$1(options.beforeCreate, instance, "bc");
  }
  const {
    data: dataOptions,
    computed: computedOptions,
    methods,
    watch: watchOptions,
    provide: provideOptions,
    inject: injectOptions,
    created,
    beforeMount,
    mounted,
    beforeUpdate,
    updated,
    activated,
    deactivated,
    beforeDestroy,
    beforeUnmount,
    destroyed,
    unmounted,
    render: render2,
    renderTracked,
    renderTriggered,
    errorCaptured,
    serverPrefetch,
    expose,
    inheritAttrs,
    components,
    directives,
    filters
  } = options;
  const checkDuplicateProperties = null;
  if (injectOptions) {
    resolveInjections(injectOptions, ctx, checkDuplicateProperties);
  }
  if (methods) {
    for (const key in methods) {
      const methodHandler = methods[key];
      if (isFunction(methodHandler)) {
        {
          ctx[key] = methodHandler.bind(publicThis);
        }
      }
    }
  }
  if (dataOptions) {
    const data = dataOptions.call(publicThis, publicThis);
    if (!isObject(data))
      ;
    else {
      instance.data = reactive(data);
    }
  }
  shouldCacheAccess = true;
  if (computedOptions) {
    for (const key in computedOptions) {
      const opt = computedOptions[key];
      const get = isFunction(opt) ? opt.bind(publicThis, publicThis) : isFunction(opt.get) ? opt.get.bind(publicThis, publicThis) : NOOP;
      const set = !isFunction(opt) && isFunction(opt.set) ? opt.set.bind(publicThis) : NOOP;
      const c = computed({
        get,
        set
      });
      Object.defineProperty(ctx, key, {
        enumerable: true,
        configurable: true,
        get: () => c.value,
        set: (v2) => c.value = v2
      });
    }
  }
  if (watchOptions) {
    for (const key in watchOptions) {
      createWatcher(watchOptions[key], ctx, publicThis, key);
    }
  }
  if (provideOptions) {
    const provides = isFunction(provideOptions) ? provideOptions.call(publicThis) : provideOptions;
    Reflect.ownKeys(provides).forEach((key) => {
      provide(key, provides[key]);
    });
  }
  if (created) {
    callHook$1(created, instance, "c");
  }
  function registerLifecycleHook(register, hook) {
    if (isArray(hook)) {
      hook.forEach((_hook) => register(_hook.bind(publicThis)));
    } else if (hook) {
      register(hook.bind(publicThis));
    }
  }
  registerLifecycleHook(onBeforeMount, beforeMount);
  registerLifecycleHook(onMounted, mounted);
  registerLifecycleHook(onBeforeUpdate, beforeUpdate);
  registerLifecycleHook(onUpdated, updated);
  registerLifecycleHook(onActivated, activated);
  registerLifecycleHook(onDeactivated, deactivated);
  registerLifecycleHook(onErrorCaptured, errorCaptured);
  registerLifecycleHook(onRenderTracked, renderTracked);
  registerLifecycleHook(onRenderTriggered, renderTriggered);
  registerLifecycleHook(onBeforeUnmount, beforeUnmount);
  registerLifecycleHook(onUnmounted, unmounted);
  registerLifecycleHook(onServerPrefetch, serverPrefetch);
  if (isArray(expose)) {
    if (expose.length) {
      const exposed = instance.exposed || (instance.exposed = {});
      expose.forEach((key) => {
        Object.defineProperty(exposed, key, {
          get: () => publicThis[key],
          set: (val) => publicThis[key] = val
        });
      });
    } else if (!instance.exposed) {
      instance.exposed = {};
    }
  }
  if (render2 && instance.render === NOOP) {
    instance.render = render2;
  }
  if (inheritAttrs != null) {
    instance.inheritAttrs = inheritAttrs;
  }
  if (components)
    instance.components = components;
  if (directives)
    instance.directives = directives;
  if (serverPrefetch) {
    markAsyncBoundary(instance);
  }
}
function resolveInjections(injectOptions, ctx, checkDuplicateProperties = NOOP) {
  if (isArray(injectOptions)) {
    injectOptions = normalizeInject(injectOptions);
  }
  for (const key in injectOptions) {
    const opt = injectOptions[key];
    let injected;
    if (isObject(opt)) {
      if ("default" in opt) {
        injected = inject(
          opt.from || key,
          opt.default,
          true
        );
      } else {
        injected = inject(opt.from || key);
      }
    } else {
      injected = inject(opt);
    }
    if (isRef(injected)) {
      Object.defineProperty(ctx, key, {
        enumerable: true,
        configurable: true,
        get: () => injected.value,
        set: (v2) => injected.value = v2
      });
    } else {
      ctx[key] = injected;
    }
  }
}
function callHook$1(hook, instance, type2) {
  callWithAsyncErrorHandling(
    isArray(hook) ? hook.map((h2) => h2.bind(instance.proxy)) : hook.bind(instance.proxy),
    instance,
    type2
  );
}
function createWatcher(raw, ctx, publicThis, key) {
  let getter = key.includes(".") ? createPathGetter(publicThis, key) : () => publicThis[key];
  if (isString$1(raw)) {
    const handler = ctx[raw];
    if (isFunction(handler)) {
      {
        watch(getter, handler);
      }
    }
  } else if (isFunction(raw)) {
    {
      watch(getter, raw.bind(publicThis));
    }
  } else if (isObject(raw)) {
    if (isArray(raw)) {
      raw.forEach((r2) => createWatcher(r2, ctx, publicThis, key));
    } else {
      const handler = isFunction(raw.handler) ? raw.handler.bind(publicThis) : ctx[raw.handler];
      if (isFunction(handler)) {
        watch(getter, handler, raw);
      }
    }
  } else
    ;
}
function resolveMergedOptions(instance) {
  const base = instance.type;
  const { mixins, extends: extendsOptions } = base;
  const {
    mixins: globalMixins,
    optionsCache: cache,
    config: { optionMergeStrategies }
  } = instance.appContext;
  const cached = cache.get(base);
  let resolved;
  if (cached) {
    resolved = cached;
  } else if (!globalMixins.length && !mixins && !extendsOptions) {
    {
      resolved = base;
    }
  } else {
    resolved = {};
    if (globalMixins.length) {
      globalMixins.forEach(
        (m) => mergeOptions(resolved, m, optionMergeStrategies, true)
      );
    }
    mergeOptions(resolved, base, optionMergeStrategies);
  }
  if (isObject(base)) {
    cache.set(base, resolved);
  }
  return resolved;
}
function mergeOptions(to, from, strats, asMixin = false) {
  const { mixins, extends: extendsOptions } = from;
  if (extendsOptions) {
    mergeOptions(to, extendsOptions, strats, true);
  }
  if (mixins) {
    mixins.forEach(
      (m) => mergeOptions(to, m, strats, true)
    );
  }
  for (const key in from) {
    if (asMixin && key === "expose")
      ;
    else {
      const strat = internalOptionMergeStrats[key] || strats && strats[key];
      to[key] = strat ? strat(to[key], from[key]) : from[key];
    }
  }
  return to;
}
const internalOptionMergeStrats = {
  data: mergeDataFn,
  props: mergeEmitsOrPropsOptions,
  emits: mergeEmitsOrPropsOptions,
  methods: mergeObjectOptions,
  computed: mergeObjectOptions,
  beforeCreate: mergeAsArray,
  created: mergeAsArray,
  beforeMount: mergeAsArray,
  mounted: mergeAsArray,
  beforeUpdate: mergeAsArray,
  updated: mergeAsArray,
  beforeDestroy: mergeAsArray,
  beforeUnmount: mergeAsArray,
  destroyed: mergeAsArray,
  unmounted: mergeAsArray,
  activated: mergeAsArray,
  deactivated: mergeAsArray,
  errorCaptured: mergeAsArray,
  serverPrefetch: mergeAsArray,
  components: mergeObjectOptions,
  directives: mergeObjectOptions,
  watch: mergeWatchOptions,
  provide: mergeDataFn,
  inject: mergeInject
};
function mergeDataFn(to, from) {
  if (!from) {
    return to;
  }
  if (!to) {
    return from;
  }
  return function mergedDataFn() {
    return extend(
      isFunction(to) ? to.call(this, this) : to,
      isFunction(from) ? from.call(this, this) : from
    );
  };
}
function mergeInject(to, from) {
  return mergeObjectOptions(normalizeInject(to), normalizeInject(from));
}
function normalizeInject(raw) {
  if (isArray(raw)) {
    const res = {};
    for (let i2 = 0; i2 < raw.length; i2++) {
      res[raw[i2]] = raw[i2];
    }
    return res;
  }
  return raw;
}
function mergeAsArray(to, from) {
  return to ? [...new Set([].concat(to, from))] : from;
}
function mergeObjectOptions(to, from) {
  return to ? extend(/* @__PURE__ */ Object.create(null), to, from) : from;
}
function mergeEmitsOrPropsOptions(to, from) {
  if (to) {
    if (isArray(to) && isArray(from)) {
      return [.../* @__PURE__ */ new Set([...to, ...from])];
    }
    return extend(
      /* @__PURE__ */ Object.create(null),
      normalizePropsOrEmits(to),
      normalizePropsOrEmits(from != null ? from : {})
    );
  } else {
    return from;
  }
}
function mergeWatchOptions(to, from) {
  if (!to)
    return from;
  if (!from)
    return to;
  const merged = extend(/* @__PURE__ */ Object.create(null), to);
  for (const key in from) {
    merged[key] = mergeAsArray(to[key], from[key]);
  }
  return merged;
}
function createAppContext() {
  return {
    app: null,
    config: {
      isNativeTag: NO,
      performance: false,
      globalProperties: {},
      optionMergeStrategies: {},
      errorHandler: void 0,
      warnHandler: void 0,
      compilerOptions: {}
    },
    mixins: [],
    components: {},
    directives: {},
    provides: /* @__PURE__ */ Object.create(null),
    optionsCache: /* @__PURE__ */ new WeakMap(),
    propsCache: /* @__PURE__ */ new WeakMap(),
    emitsCache: /* @__PURE__ */ new WeakMap()
  };
}
let uid$1 = 0;
function createAppAPI(render2, hydrate) {
  return function createApp2(rootComponent, rootProps = null) {
    if (!isFunction(rootComponent)) {
      rootComponent = extend({}, rootComponent);
    }
    if (rootProps != null && !isObject(rootProps)) {
      rootProps = null;
    }
    const context = createAppContext();
    const installedPlugins = /* @__PURE__ */ new WeakSet();
    const pluginCleanupFns = [];
    let isMounted = false;
    const app2 = context.app = {
      _uid: uid$1++,
      _component: rootComponent,
      _props: rootProps,
      _container: null,
      _context: context,
      _instance: null,
      version,
      get config() {
        return context.config;
      },
      set config(v2) {
      },
      use(plugin, ...options) {
        if (installedPlugins.has(plugin))
          ;
        else if (plugin && isFunction(plugin.install)) {
          installedPlugins.add(plugin);
          plugin.install(app2, ...options);
        } else if (isFunction(plugin)) {
          installedPlugins.add(plugin);
          plugin(app2, ...options);
        } else
          ;
        return app2;
      },
      mixin(mixin) {
        {
          if (!context.mixins.includes(mixin)) {
            context.mixins.push(mixin);
          }
        }
        return app2;
      },
      component(name, component) {
        if (!component) {
          return context.components[name];
        }
        context.components[name] = component;
        return app2;
      },
      directive(name, directive) {
        if (!directive) {
          return context.directives[name];
        }
        context.directives[name] = directive;
        return app2;
      },
      mount(rootContainer, isHydrate, namespace) {
        if (!isMounted) {
          const vnode = app2._ceVNode || createVNode(rootComponent, rootProps);
          vnode.appContext = context;
          if (namespace === true) {
            namespace = "svg";
          } else if (namespace === false) {
            namespace = void 0;
          }
          if (isHydrate && hydrate) {
            hydrate(vnode, rootContainer);
          } else {
            render2(vnode, rootContainer, namespace);
          }
          isMounted = true;
          app2._container = rootContainer;
          rootContainer.__vue_app__ = app2;
          return getComponentPublicInstance(vnode.component);
        }
      },
      onUnmount(cleanupFn) {
        pluginCleanupFns.push(cleanupFn);
      },
      unmount() {
        if (isMounted) {
          callWithAsyncErrorHandling(
            pluginCleanupFns,
            app2._instance,
            16
          );
          render2(null, app2._container);
          delete app2._container.__vue_app__;
        }
      },
      provide(key, value) {
        context.provides[key] = value;
        return app2;
      },
      runWithContext(fn) {
        const lastApp = currentApp;
        currentApp = app2;
        try {
          return fn();
        } finally {
          currentApp = lastApp;
        }
      }
    };
    return app2;
  };
}
let currentApp = null;
function provide(key, value) {
  if (!currentInstance)
    ;
  else {
    let provides = currentInstance.provides;
    const parentProvides = currentInstance.parent && currentInstance.parent.provides;
    if (parentProvides === provides) {
      provides = currentInstance.provides = Object.create(parentProvides);
    }
    provides[key] = value;
  }
}
function inject(key, defaultValue, treatDefaultAsFactory = false) {
  const instance = currentInstance || currentRenderingInstance;
  if (instance || currentApp) {
    const provides = currentApp ? currentApp._context.provides : instance ? instance.parent == null ? instance.vnode.appContext && instance.vnode.appContext.provides : instance.parent.provides : void 0;
    if (provides && key in provides) {
      return provides[key];
    } else if (arguments.length > 1) {
      return treatDefaultAsFactory && isFunction(defaultValue) ? defaultValue.call(instance && instance.proxy) : defaultValue;
    } else
      ;
  }
}
const internalObjectProto = {};
const createInternalObject = () => Object.create(internalObjectProto);
const isInternalObject = (obj) => Object.getPrototypeOf(obj) === internalObjectProto;
function initProps(instance, rawProps, isStateful, isSSR = false) {
  const props = {};
  const attrs = createInternalObject();
  instance.propsDefaults = /* @__PURE__ */ Object.create(null);
  setFullProps(instance, rawProps, props, attrs);
  for (const key in instance.propsOptions[0]) {
    if (!(key in props)) {
      props[key] = void 0;
    }
  }
  if (isStateful) {
    instance.props = isSSR ? props : shallowReactive(props);
  } else {
    if (!instance.type.props) {
      instance.props = attrs;
    } else {
      instance.props = props;
    }
  }
  instance.attrs = attrs;
}
function updateProps(instance, rawProps, rawPrevProps, optimized) {
  const {
    props,
    attrs,
    vnode: { patchFlag }
  } = instance;
  const rawCurrentProps = toRaw(props);
  const [options] = instance.propsOptions;
  let hasAttrsChanged = false;
  if ((optimized || patchFlag > 0) && !(patchFlag & 16)) {
    if (patchFlag & 8) {
      const propsToUpdate = instance.vnode.dynamicProps;
      for (let i2 = 0; i2 < propsToUpdate.length; i2++) {
        let key = propsToUpdate[i2];
        if (isEmitListener(instance.emitsOptions, key)) {
          continue;
        }
        const value = rawProps[key];
        if (options) {
          if (hasOwn(attrs, key)) {
            if (value !== attrs[key]) {
              attrs[key] = value;
              hasAttrsChanged = true;
            }
          } else {
            const camelizedKey = camelize(key);
            props[camelizedKey] = resolvePropValue(
              options,
              rawCurrentProps,
              camelizedKey,
              value,
              instance,
              false
            );
          }
        } else {
          if (value !== attrs[key]) {
            attrs[key] = value;
            hasAttrsChanged = true;
          }
        }
      }
    }
  } else {
    if (setFullProps(instance, rawProps, props, attrs)) {
      hasAttrsChanged = true;
    }
    let kebabKey;
    for (const key in rawCurrentProps) {
      if (!rawProps || !hasOwn(rawProps, key) && ((kebabKey = hyphenate(key)) === key || !hasOwn(rawProps, kebabKey))) {
        if (options) {
          if (rawPrevProps && (rawPrevProps[key] !== void 0 || rawPrevProps[kebabKey] !== void 0)) {
            props[key] = resolvePropValue(
              options,
              rawCurrentProps,
              key,
              void 0,
              instance,
              true
            );
          }
        } else {
          delete props[key];
        }
      }
    }
    if (attrs !== rawCurrentProps) {
      for (const key in attrs) {
        if (!rawProps || !hasOwn(rawProps, key) && true) {
          delete attrs[key];
          hasAttrsChanged = true;
        }
      }
    }
  }
  if (hasAttrsChanged) {
    trigger(instance.attrs, "set", "");
  }
}
function setFullProps(instance, rawProps, props, attrs) {
  const [options, needCastKeys] = instance.propsOptions;
  let hasAttrsChanged = false;
  let rawCastValues;
  if (rawProps) {
    for (let key in rawProps) {
      if (isReservedProp(key)) {
        continue;
      }
      const value = rawProps[key];
      let camelKey;
      if (options && hasOwn(options, camelKey = camelize(key))) {
        if (!needCastKeys || !needCastKeys.includes(camelKey)) {
          props[camelKey] = value;
        } else {
          (rawCastValues || (rawCastValues = {}))[camelKey] = value;
        }
      } else if (!isEmitListener(instance.emitsOptions, key)) {
        if (!(key in attrs) || value !== attrs[key]) {
          attrs[key] = value;
          hasAttrsChanged = true;
        }
      }
    }
  }
  if (needCastKeys) {
    const rawCurrentProps = toRaw(props);
    const castValues = rawCastValues || EMPTY_OBJ;
    for (let i2 = 0; i2 < needCastKeys.length; i2++) {
      const key = needCastKeys[i2];
      props[key] = resolvePropValue(
        options,
        rawCurrentProps,
        key,
        castValues[key],
        instance,
        !hasOwn(castValues, key)
      );
    }
  }
  return hasAttrsChanged;
}
function resolvePropValue(options, props, key, value, instance, isAbsent) {
  const opt = options[key];
  if (opt != null) {
    const hasDefault = hasOwn(opt, "default");
    if (hasDefault && value === void 0) {
      const defaultValue = opt.default;
      if (opt.type !== Function && !opt.skipFactory && isFunction(defaultValue)) {
        const { propsDefaults } = instance;
        if (key in propsDefaults) {
          value = propsDefaults[key];
        } else {
          const reset = setCurrentInstance(instance);
          value = propsDefaults[key] = defaultValue.call(
            null,
            props
          );
          reset();
        }
      } else {
        value = defaultValue;
      }
      if (instance.ce) {
        instance.ce._setProp(key, value);
      }
    }
    if (opt[0]) {
      if (isAbsent && !hasDefault) {
        value = false;
      } else if (opt[1] && (value === "" || value === hyphenate(key))) {
        value = true;
      }
    }
  }
  return value;
}
const mixinPropsCache = /* @__PURE__ */ new WeakMap();
function normalizePropsOptions(comp, appContext, asMixin = false) {
  const cache = asMixin ? mixinPropsCache : appContext.propsCache;
  const cached = cache.get(comp);
  if (cached) {
    return cached;
  }
  const raw = comp.props;
  const normalized = {};
  const needCastKeys = [];
  let hasExtends = false;
  if (!isFunction(comp)) {
    const extendProps = (raw2) => {
      hasExtends = true;
      const [props, keys] = normalizePropsOptions(raw2, appContext, true);
      extend(normalized, props);
      if (keys)
        needCastKeys.push(...keys);
    };
    if (!asMixin && appContext.mixins.length) {
      appContext.mixins.forEach(extendProps);
    }
    if (comp.extends) {
      extendProps(comp.extends);
    }
    if (comp.mixins) {
      comp.mixins.forEach(extendProps);
    }
  }
  if (!raw && !hasExtends) {
    if (isObject(comp)) {
      cache.set(comp, EMPTY_ARR);
    }
    return EMPTY_ARR;
  }
  if (isArray(raw)) {
    for (let i2 = 0; i2 < raw.length; i2++) {
      const normalizedKey = camelize(raw[i2]);
      if (validatePropName(normalizedKey)) {
        normalized[normalizedKey] = EMPTY_OBJ;
      }
    }
  } else if (raw) {
    for (const key in raw) {
      const normalizedKey = camelize(key);
      if (validatePropName(normalizedKey)) {
        const opt = raw[key];
        const prop = normalized[normalizedKey] = isArray(opt) || isFunction(opt) ? { type: opt } : extend({}, opt);
        const propType = prop.type;
        let shouldCast = false;
        let shouldCastTrue = true;
        if (isArray(propType)) {
          for (let index2 = 0; index2 < propType.length; ++index2) {
            const type2 = propType[index2];
            const typeName = isFunction(type2) && type2.name;
            if (typeName === "Boolean") {
              shouldCast = true;
              break;
            } else if (typeName === "String") {
              shouldCastTrue = false;
            }
          }
        } else {
          shouldCast = isFunction(propType) && propType.name === "Boolean";
        }
        prop[0] = shouldCast;
        prop[1] = shouldCastTrue;
        if (shouldCast || hasOwn(prop, "default")) {
          needCastKeys.push(normalizedKey);
        }
      }
    }
  }
  const res = [normalized, needCastKeys];
  if (isObject(comp)) {
    cache.set(comp, res);
  }
  return res;
}
function validatePropName(key) {
  if (key[0] !== "$" && !isReservedProp(key)) {
    return true;
  }
  return false;
}
const isInternalKey = (key) => key[0] === "_" || key === "$stable";
const normalizeSlotValue = (value) => isArray(value) ? value.map(normalizeVNode) : [normalizeVNode(value)];
const normalizeSlot = (key, rawSlot, ctx) => {
  if (rawSlot._n) {
    return rawSlot;
  }
  const normalized = withCtx((...args) => {
    if (false)
      ;
    return normalizeSlotValue(rawSlot(...args));
  }, ctx);
  normalized._c = false;
  return normalized;
};
const normalizeObjectSlots = (rawSlots, slots, instance) => {
  const ctx = rawSlots._ctx;
  for (const key in rawSlots) {
    if (isInternalKey(key))
      continue;
    const value = rawSlots[key];
    if (isFunction(value)) {
      slots[key] = normalizeSlot(key, value, ctx);
    } else if (value != null) {
      const normalized = normalizeSlotValue(value);
      slots[key] = () => normalized;
    }
  }
};
const normalizeVNodeSlots = (instance, children) => {
  const normalized = normalizeSlotValue(children);
  instance.slots.default = () => normalized;
};
const assignSlots = (slots, children, optimized) => {
  for (const key in children) {
    if (optimized || key !== "_") {
      slots[key] = children[key];
    }
  }
};
const initSlots = (instance, children, optimized) => {
  const slots = instance.slots = createInternalObject();
  if (instance.vnode.shapeFlag & 32) {
    const type2 = children._;
    if (type2) {
      assignSlots(slots, children, optimized);
      if (optimized) {
        def(slots, "_", type2, true);
      }
    } else {
      normalizeObjectSlots(children, slots);
    }
  } else if (children) {
    normalizeVNodeSlots(instance, children);
  }
};
const updateSlots = (instance, children, optimized) => {
  const { vnode, slots } = instance;
  let needDeletionCheck = true;
  let deletionComparisonTarget = EMPTY_OBJ;
  if (vnode.shapeFlag & 32) {
    const type2 = children._;
    if (type2) {
      if (optimized && type2 === 1) {
        needDeletionCheck = false;
      } else {
        assignSlots(slots, children, optimized);
      }
    } else {
      needDeletionCheck = !children.$stable;
      normalizeObjectSlots(children, slots);
    }
    deletionComparisonTarget = children;
  } else if (children) {
    normalizeVNodeSlots(instance, children);
    deletionComparisonTarget = { default: 1 };
  }
  if (needDeletionCheck) {
    for (const key in slots) {
      if (!isInternalKey(key) && deletionComparisonTarget[key] == null) {
        delete slots[key];
      }
    }
  }
};
function initFeatureFlags() {
  if (typeof __VUE_PROD_HYDRATION_MISMATCH_DETAILS__ !== "boolean") {
    getGlobalThis().__VUE_PROD_HYDRATION_MISMATCH_DETAILS__ = false;
  }
}
const queuePostRenderEffect = queueEffectWithSuspense;
function createRenderer(options) {
  return baseCreateRenderer(options);
}
function baseCreateRenderer(options, createHydrationFns) {
  {
    initFeatureFlags();
  }
  const target = getGlobalThis();
  target.__VUE__ = true;
  const {
    insert: hostInsert,
    remove: hostRemove,
    patchProp: hostPatchProp,
    createElement: hostCreateElement,
    createText: hostCreateText,
    createComment: hostCreateComment,
    setText: hostSetText,
    setElementText: hostSetElementText,
    parentNode: hostParentNode,
    nextSibling: hostNextSibling,
    setScopeId: hostSetScopeId = NOOP,
    insertStaticContent: hostInsertStaticContent
  } = options;
  const patch = (n1, n2, container, anchor = null, parentComponent = null, parentSuspense = null, namespace = void 0, slotScopeIds = null, optimized = !!n2.dynamicChildren) => {
    if (n1 === n2) {
      return;
    }
    if (n1 && !isSameVNodeType(n1, n2)) {
      anchor = getNextHostNode(n1);
      unmount(n1, parentComponent, parentSuspense, true);
      n1 = null;
    }
    if (n2.patchFlag === -2) {
      optimized = false;
      n2.dynamicChildren = null;
    }
    const { type: type2, ref: ref2, shapeFlag } = n2;
    switch (type2) {
      case Text:
        processText(n1, n2, container, anchor);
        break;
      case Comment:
        processCommentNode(n1, n2, container, anchor);
        break;
      case Static:
        if (n1 == null) {
          mountStaticNode(n2, container, anchor, namespace);
        }
        break;
      case Fragment:
        processFragment(
          n1,
          n2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
        break;
      default:
        if (shapeFlag & 1) {
          processElement(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else if (shapeFlag & 6) {
          processComponent(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else if (shapeFlag & 64) {
          type2.process(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized,
            internals
          );
        } else if (shapeFlag & 128) {
          type2.process(
            n1,
            n2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized,
            internals
          );
        } else
          ;
    }
    if (ref2 != null && parentComponent) {
      setRef(ref2, n1 && n1.ref, parentSuspense, n2 || n1, !n2);
    }
  };
  const processText = (n1, n2, container, anchor) => {
    if (n1 == null) {
      hostInsert(
        n2.el = hostCreateText(n2.children),
        container,
        anchor
      );
    } else {
      const el = n2.el = n1.el;
      if (n2.children !== n1.children) {
        hostSetText(el, n2.children);
      }
    }
  };
  const processCommentNode = (n1, n2, container, anchor) => {
    if (n1 == null) {
      hostInsert(
        n2.el = hostCreateComment(n2.children || ""),
        container,
        anchor
      );
    } else {
      n2.el = n1.el;
    }
  };
  const mountStaticNode = (n2, container, anchor, namespace) => {
    [n2.el, n2.anchor] = hostInsertStaticContent(
      n2.children,
      container,
      anchor,
      namespace,
      n2.el,
      n2.anchor
    );
  };
  const moveStaticNode = ({ el, anchor }, container, nextSibling) => {
    let next;
    while (el && el !== anchor) {
      next = hostNextSibling(el);
      hostInsert(el, container, nextSibling);
      el = next;
    }
    hostInsert(anchor, container, nextSibling);
  };
  const removeStaticNode = ({ el, anchor }) => {
    let next;
    while (el && el !== anchor) {
      next = hostNextSibling(el);
      hostRemove(el);
      el = next;
    }
    hostRemove(anchor);
  };
  const processElement = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    if (n2.type === "svg") {
      namespace = "svg";
    } else if (n2.type === "math") {
      namespace = "mathml";
    }
    if (n1 == null) {
      mountElement(
        n2,
        container,
        anchor,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    } else {
      patchElement(
        n1,
        n2,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    }
  };
  const mountElement = (vnode, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    let el;
    let vnodeHook;
    const { props, shapeFlag, transition, dirs } = vnode;
    el = vnode.el = hostCreateElement(
      vnode.type,
      namespace,
      props && props.is,
      props
    );
    if (shapeFlag & 8) {
      hostSetElementText(el, vnode.children);
    } else if (shapeFlag & 16) {
      mountChildren(
        vnode.children,
        el,
        null,
        parentComponent,
        parentSuspense,
        resolveChildrenNamespace(vnode, namespace),
        slotScopeIds,
        optimized
      );
    }
    if (dirs) {
      invokeDirectiveHook(vnode, null, parentComponent, "created");
    }
    setScopeId(el, vnode, vnode.scopeId, slotScopeIds, parentComponent);
    if (props) {
      for (const key in props) {
        if (key !== "value" && !isReservedProp(key)) {
          hostPatchProp(el, key, null, props[key], namespace, parentComponent);
        }
      }
      if ("value" in props) {
        hostPatchProp(el, "value", null, props.value, namespace);
      }
      if (vnodeHook = props.onVnodeBeforeMount) {
        invokeVNodeHook(vnodeHook, parentComponent, vnode);
      }
    }
    if (dirs) {
      invokeDirectiveHook(vnode, null, parentComponent, "beforeMount");
    }
    const needCallTransitionHooks = needTransition(parentSuspense, transition);
    if (needCallTransitionHooks) {
      transition.beforeEnter(el);
    }
    hostInsert(el, container, anchor);
    if ((vnodeHook = props && props.onVnodeMounted) || needCallTransitionHooks || dirs) {
      queuePostRenderEffect(() => {
        vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, vnode);
        needCallTransitionHooks && transition.enter(el);
        dirs && invokeDirectiveHook(vnode, null, parentComponent, "mounted");
      }, parentSuspense);
    }
  };
  const setScopeId = (el, vnode, scopeId, slotScopeIds, parentComponent) => {
    if (scopeId) {
      hostSetScopeId(el, scopeId);
    }
    if (slotScopeIds) {
      for (let i2 = 0; i2 < slotScopeIds.length; i2++) {
        hostSetScopeId(el, slotScopeIds[i2]);
      }
    }
    if (parentComponent) {
      let subTree = parentComponent.subTree;
      if (vnode === subTree || isSuspense(subTree.type) && (subTree.ssContent === vnode || subTree.ssFallback === vnode)) {
        const parentVNode = parentComponent.vnode;
        setScopeId(
          el,
          parentVNode,
          parentVNode.scopeId,
          parentVNode.slotScopeIds,
          parentComponent.parent
        );
      }
    }
  };
  const mountChildren = (children, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized, start = 0) => {
    for (let i2 = start; i2 < children.length; i2++) {
      const child = children[i2] = optimized ? cloneIfMounted(children[i2]) : normalizeVNode(children[i2]);
      patch(
        null,
        child,
        container,
        anchor,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    }
  };
  const patchElement = (n1, n2, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    const el = n2.el = n1.el;
    let { patchFlag, dynamicChildren, dirs } = n2;
    patchFlag |= n1.patchFlag & 16;
    const oldProps = n1.props || EMPTY_OBJ;
    const newProps = n2.props || EMPTY_OBJ;
    let vnodeHook;
    parentComponent && toggleRecurse(parentComponent, false);
    if (vnodeHook = newProps.onVnodeBeforeUpdate) {
      invokeVNodeHook(vnodeHook, parentComponent, n2, n1);
    }
    if (dirs) {
      invokeDirectiveHook(n2, n1, parentComponent, "beforeUpdate");
    }
    parentComponent && toggleRecurse(parentComponent, true);
    if (oldProps.innerHTML && newProps.innerHTML == null || oldProps.textContent && newProps.textContent == null) {
      hostSetElementText(el, "");
    }
    if (dynamicChildren) {
      patchBlockChildren(
        n1.dynamicChildren,
        dynamicChildren,
        el,
        parentComponent,
        parentSuspense,
        resolveChildrenNamespace(n2, namespace),
        slotScopeIds
      );
    } else if (!optimized) {
      patchChildren(
        n1,
        n2,
        el,
        null,
        parentComponent,
        parentSuspense,
        resolveChildrenNamespace(n2, namespace),
        slotScopeIds,
        false
      );
    }
    if (patchFlag > 0) {
      if (patchFlag & 16) {
        patchProps(el, oldProps, newProps, parentComponent, namespace);
      } else {
        if (patchFlag & 2) {
          if (oldProps.class !== newProps.class) {
            hostPatchProp(el, "class", null, newProps.class, namespace);
          }
        }
        if (patchFlag & 4) {
          hostPatchProp(el, "style", oldProps.style, newProps.style, namespace);
        }
        if (patchFlag & 8) {
          const propsToUpdate = n2.dynamicProps;
          for (let i2 = 0; i2 < propsToUpdate.length; i2++) {
            const key = propsToUpdate[i2];
            const prev = oldProps[key];
            const next = newProps[key];
            if (next !== prev || key === "value") {
              hostPatchProp(el, key, prev, next, namespace, parentComponent);
            }
          }
        }
      }
      if (patchFlag & 1) {
        if (n1.children !== n2.children) {
          hostSetElementText(el, n2.children);
        }
      }
    } else if (!optimized && dynamicChildren == null) {
      patchProps(el, oldProps, newProps, parentComponent, namespace);
    }
    if ((vnodeHook = newProps.onVnodeUpdated) || dirs) {
      queuePostRenderEffect(() => {
        vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, n2, n1);
        dirs && invokeDirectiveHook(n2, n1, parentComponent, "updated");
      }, parentSuspense);
    }
  };
  const patchBlockChildren = (oldChildren, newChildren, fallbackContainer, parentComponent, parentSuspense, namespace, slotScopeIds) => {
    for (let i2 = 0; i2 < newChildren.length; i2++) {
      const oldVNode = oldChildren[i2];
      const newVNode = newChildren[i2];
      const container = oldVNode.el && (oldVNode.type === Fragment || !isSameVNodeType(oldVNode, newVNode) || oldVNode.shapeFlag & (6 | 64)) ? hostParentNode(oldVNode.el) : fallbackContainer;
      patch(
        oldVNode,
        newVNode,
        container,
        null,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        true
      );
    }
  };
  const patchProps = (el, oldProps, newProps, parentComponent, namespace) => {
    if (oldProps !== newProps) {
      if (oldProps !== EMPTY_OBJ) {
        for (const key in oldProps) {
          if (!isReservedProp(key) && !(key in newProps)) {
            hostPatchProp(
              el,
              key,
              oldProps[key],
              null,
              namespace,
              parentComponent
            );
          }
        }
      }
      for (const key in newProps) {
        if (isReservedProp(key))
          continue;
        const next = newProps[key];
        const prev = oldProps[key];
        if (next !== prev && key !== "value") {
          hostPatchProp(el, key, prev, next, namespace, parentComponent);
        }
      }
      if ("value" in newProps) {
        hostPatchProp(el, "value", oldProps.value, newProps.value, namespace);
      }
    }
  };
  const processFragment = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    const fragmentStartAnchor = n2.el = n1 ? n1.el : hostCreateText("");
    const fragmentEndAnchor = n2.anchor = n1 ? n1.anchor : hostCreateText("");
    let { patchFlag, dynamicChildren, slotScopeIds: fragmentSlotScopeIds } = n2;
    if (fragmentSlotScopeIds) {
      slotScopeIds = slotScopeIds ? slotScopeIds.concat(fragmentSlotScopeIds) : fragmentSlotScopeIds;
    }
    if (n1 == null) {
      hostInsert(fragmentStartAnchor, container, anchor);
      hostInsert(fragmentEndAnchor, container, anchor);
      mountChildren(
        n2.children || [],
        container,
        fragmentEndAnchor,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    } else {
      if (patchFlag > 0 && patchFlag & 64 && dynamicChildren && n1.dynamicChildren) {
        patchBlockChildren(
          n1.dynamicChildren,
          dynamicChildren,
          container,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds
        );
        if (n2.key != null || parentComponent && n2 === parentComponent.subTree) {
          traverseStaticChildren(
            n1,
            n2,
            true
          );
        }
      } else {
        patchChildren(
          n1,
          n2,
          container,
          fragmentEndAnchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      }
    }
  };
  const processComponent = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    n2.slotScopeIds = slotScopeIds;
    if (n1 == null) {
      if (n2.shapeFlag & 512) {
        parentComponent.ctx.activate(
          n2,
          container,
          anchor,
          namespace,
          optimized
        );
      } else {
        mountComponent(
          n2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          optimized
        );
      }
    } else {
      updateComponent(n1, n2, optimized);
    }
  };
  const mountComponent = (initialVNode, container, anchor, parentComponent, parentSuspense, namespace, optimized) => {
    const instance = initialVNode.component = createComponentInstance(
      initialVNode,
      parentComponent,
      parentSuspense
    );
    if (isKeepAlive(initialVNode)) {
      instance.ctx.renderer = internals;
    }
    {
      setupComponent(instance, false, optimized);
    }
    if (instance.asyncDep) {
      parentSuspense && parentSuspense.registerDep(instance, setupRenderEffect, optimized);
      if (!initialVNode.el) {
        const placeholder = instance.subTree = createVNode(Comment);
        processCommentNode(null, placeholder, container, anchor);
      }
    } else {
      setupRenderEffect(
        instance,
        initialVNode,
        container,
        anchor,
        parentSuspense,
        namespace,
        optimized
      );
    }
  };
  const updateComponent = (n1, n2, optimized) => {
    const instance = n2.component = n1.component;
    if (shouldUpdateComponent(n1, n2, optimized)) {
      if (instance.asyncDep && !instance.asyncResolved) {
        updateComponentPreRender(instance, n2, optimized);
        return;
      } else {
        instance.next = n2;
        instance.update();
      }
    } else {
      n2.el = n1.el;
      instance.vnode = n2;
    }
  };
  const setupRenderEffect = (instance, initialVNode, container, anchor, parentSuspense, namespace, optimized) => {
    const componentUpdateFn = () => {
      if (!instance.isMounted) {
        let vnodeHook;
        const { el, props } = initialVNode;
        const { bm, m, parent, root, type: type2 } = instance;
        const isAsyncWrapperVNode = isAsyncWrapper(initialVNode);
        toggleRecurse(instance, false);
        if (bm) {
          invokeArrayFns(bm);
        }
        if (!isAsyncWrapperVNode && (vnodeHook = props && props.onVnodeBeforeMount)) {
          invokeVNodeHook(vnodeHook, parent, initialVNode);
        }
        toggleRecurse(instance, true);
        if (el && hydrateNode) {
          const hydrateSubTree = () => {
            instance.subTree = renderComponentRoot(instance);
            hydrateNode(
              el,
              instance.subTree,
              instance,
              parentSuspense,
              null
            );
          };
          if (isAsyncWrapperVNode && type2.__asyncHydrate) {
            type2.__asyncHydrate(
              el,
              instance,
              hydrateSubTree
            );
          } else {
            hydrateSubTree();
          }
        } else {
          if (root.ce) {
            root.ce._injectChildStyle(type2);
          }
          const subTree = instance.subTree = renderComponentRoot(instance);
          patch(
            null,
            subTree,
            container,
            anchor,
            instance,
            parentSuspense,
            namespace
          );
          initialVNode.el = subTree.el;
        }
        if (m) {
          queuePostRenderEffect(m, parentSuspense);
        }
        if (!isAsyncWrapperVNode && (vnodeHook = props && props.onVnodeMounted)) {
          const scopedInitialVNode = initialVNode;
          queuePostRenderEffect(
            () => invokeVNodeHook(vnodeHook, parent, scopedInitialVNode),
            parentSuspense
          );
        }
        if (initialVNode.shapeFlag & 256 || parent && isAsyncWrapper(parent.vnode) && parent.vnode.shapeFlag & 256) {
          instance.a && queuePostRenderEffect(instance.a, parentSuspense);
        }
        instance.isMounted = true;
        initialVNode = container = anchor = null;
      } else {
        let { next, bu, u: u2, parent, vnode } = instance;
        {
          const nonHydratedAsyncRoot = locateNonHydratedAsyncRoot(instance);
          if (nonHydratedAsyncRoot) {
            if (next) {
              next.el = vnode.el;
              updateComponentPreRender(instance, next, optimized);
            }
            nonHydratedAsyncRoot.asyncDep.then(() => {
              if (!instance.isUnmounted) {
                componentUpdateFn();
              }
            });
            return;
          }
        }
        let originNext = next;
        let vnodeHook;
        toggleRecurse(instance, false);
        if (next) {
          next.el = vnode.el;
          updateComponentPreRender(instance, next, optimized);
        } else {
          next = vnode;
        }
        if (bu) {
          invokeArrayFns(bu);
        }
        if (vnodeHook = next.props && next.props.onVnodeBeforeUpdate) {
          invokeVNodeHook(vnodeHook, parent, next, vnode);
        }
        toggleRecurse(instance, true);
        const nextTree = renderComponentRoot(instance);
        const prevTree = instance.subTree;
        instance.subTree = nextTree;
        patch(
          prevTree,
          nextTree,
          hostParentNode(prevTree.el),
          getNextHostNode(prevTree),
          instance,
          parentSuspense,
          namespace
        );
        next.el = nextTree.el;
        if (originNext === null) {
          updateHOCHostEl(instance, nextTree.el);
        }
        if (u2) {
          queuePostRenderEffect(u2, parentSuspense);
        }
        if (vnodeHook = next.props && next.props.onVnodeUpdated) {
          queuePostRenderEffect(
            () => invokeVNodeHook(vnodeHook, parent, next, vnode),
            parentSuspense
          );
        }
      }
    };
    instance.scope.on();
    const effect = instance.effect = new ReactiveEffect(componentUpdateFn);
    instance.scope.off();
    const update = instance.update = effect.run.bind(effect);
    const job = instance.job = effect.runIfDirty.bind(effect);
    job.i = instance;
    job.id = instance.uid;
    effect.scheduler = () => queueJob(job);
    toggleRecurse(instance, true);
    update();
  };
  const updateComponentPreRender = (instance, nextVNode, optimized) => {
    nextVNode.component = instance;
    const prevProps = instance.vnode.props;
    instance.vnode = nextVNode;
    instance.next = null;
    updateProps(instance, nextVNode.props, prevProps, optimized);
    updateSlots(instance, nextVNode.children, optimized);
    pauseTracking();
    flushPreFlushCbs(instance);
    resetTracking();
  };
  const patchChildren = (n1, n2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized = false) => {
    const c1 = n1 && n1.children;
    const prevShapeFlag = n1 ? n1.shapeFlag : 0;
    const c2 = n2.children;
    const { patchFlag, shapeFlag } = n2;
    if (patchFlag > 0) {
      if (patchFlag & 128) {
        patchKeyedChildren(
          c1,
          c2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
        return;
      } else if (patchFlag & 256) {
        patchUnkeyedChildren(
          c1,
          c2,
          container,
          anchor,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
        return;
      }
    }
    if (shapeFlag & 8) {
      if (prevShapeFlag & 16) {
        unmountChildren(c1, parentComponent, parentSuspense);
      }
      if (c2 !== c1) {
        hostSetElementText(container, c2);
      }
    } else {
      if (prevShapeFlag & 16) {
        if (shapeFlag & 16) {
          patchKeyedChildren(
            c1,
            c2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else {
          unmountChildren(c1, parentComponent, parentSuspense, true);
        }
      } else {
        if (prevShapeFlag & 8) {
          hostSetElementText(container, "");
        }
        if (shapeFlag & 16) {
          mountChildren(
            c2,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        }
      }
    }
  };
  const patchUnkeyedChildren = (c1, c2, container, anchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    c1 = c1 || EMPTY_ARR;
    c2 = c2 || EMPTY_ARR;
    const oldLength = c1.length;
    const newLength = c2.length;
    const commonLength = Math.min(oldLength, newLength);
    let i2;
    for (i2 = 0; i2 < commonLength; i2++) {
      const nextChild = c2[i2] = optimized ? cloneIfMounted(c2[i2]) : normalizeVNode(c2[i2]);
      patch(
        c1[i2],
        nextChild,
        container,
        null,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized
      );
    }
    if (oldLength > newLength) {
      unmountChildren(
        c1,
        parentComponent,
        parentSuspense,
        true,
        false,
        commonLength
      );
    } else {
      mountChildren(
        c2,
        container,
        anchor,
        parentComponent,
        parentSuspense,
        namespace,
        slotScopeIds,
        optimized,
        commonLength
      );
    }
  };
  const patchKeyedChildren = (c1, c2, container, parentAnchor, parentComponent, parentSuspense, namespace, slotScopeIds, optimized) => {
    let i2 = 0;
    const l2 = c2.length;
    let e1 = c1.length - 1;
    let e2 = l2 - 1;
    while (i2 <= e1 && i2 <= e2) {
      const n1 = c1[i2];
      const n2 = c2[i2] = optimized ? cloneIfMounted(c2[i2]) : normalizeVNode(c2[i2]);
      if (isSameVNodeType(n1, n2)) {
        patch(
          n1,
          n2,
          container,
          null,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      } else {
        break;
      }
      i2++;
    }
    while (i2 <= e1 && i2 <= e2) {
      const n1 = c1[e1];
      const n2 = c2[e2] = optimized ? cloneIfMounted(c2[e2]) : normalizeVNode(c2[e2]);
      if (isSameVNodeType(n1, n2)) {
        patch(
          n1,
          n2,
          container,
          null,
          parentComponent,
          parentSuspense,
          namespace,
          slotScopeIds,
          optimized
        );
      } else {
        break;
      }
      e1--;
      e2--;
    }
    if (i2 > e1) {
      if (i2 <= e2) {
        const nextPos = e2 + 1;
        const anchor = nextPos < l2 ? c2[nextPos].el : parentAnchor;
        while (i2 <= e2) {
          patch(
            null,
            c2[i2] = optimized ? cloneIfMounted(c2[i2]) : normalizeVNode(c2[i2]),
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
          i2++;
        }
      }
    } else if (i2 > e2) {
      while (i2 <= e1) {
        unmount(c1[i2], parentComponent, parentSuspense, true);
        i2++;
      }
    } else {
      const s1 = i2;
      const s2 = i2;
      const keyToNewIndexMap = /* @__PURE__ */ new Map();
      for (i2 = s2; i2 <= e2; i2++) {
        const nextChild = c2[i2] = optimized ? cloneIfMounted(c2[i2]) : normalizeVNode(c2[i2]);
        if (nextChild.key != null) {
          keyToNewIndexMap.set(nextChild.key, i2);
        }
      }
      let j2;
      let patched = 0;
      const toBePatched = e2 - s2 + 1;
      let moved = false;
      let maxNewIndexSoFar = 0;
      const newIndexToOldIndexMap = new Array(toBePatched);
      for (i2 = 0; i2 < toBePatched; i2++)
        newIndexToOldIndexMap[i2] = 0;
      for (i2 = s1; i2 <= e1; i2++) {
        const prevChild = c1[i2];
        if (patched >= toBePatched) {
          unmount(prevChild, parentComponent, parentSuspense, true);
          continue;
        }
        let newIndex;
        if (prevChild.key != null) {
          newIndex = keyToNewIndexMap.get(prevChild.key);
        } else {
          for (j2 = s2; j2 <= e2; j2++) {
            if (newIndexToOldIndexMap[j2 - s2] === 0 && isSameVNodeType(prevChild, c2[j2])) {
              newIndex = j2;
              break;
            }
          }
        }
        if (newIndex === void 0) {
          unmount(prevChild, parentComponent, parentSuspense, true);
        } else {
          newIndexToOldIndexMap[newIndex - s2] = i2 + 1;
          if (newIndex >= maxNewIndexSoFar) {
            maxNewIndexSoFar = newIndex;
          } else {
            moved = true;
          }
          patch(
            prevChild,
            c2[newIndex],
            container,
            null,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
          patched++;
        }
      }
      const increasingNewIndexSequence = moved ? getSequence(newIndexToOldIndexMap) : EMPTY_ARR;
      j2 = increasingNewIndexSequence.length - 1;
      for (i2 = toBePatched - 1; i2 >= 0; i2--) {
        const nextIndex = s2 + i2;
        const nextChild = c2[nextIndex];
        const anchor = nextIndex + 1 < l2 ? c2[nextIndex + 1].el : parentAnchor;
        if (newIndexToOldIndexMap[i2] === 0) {
          patch(
            null,
            nextChild,
            container,
            anchor,
            parentComponent,
            parentSuspense,
            namespace,
            slotScopeIds,
            optimized
          );
        } else if (moved) {
          if (j2 < 0 || i2 !== increasingNewIndexSequence[j2]) {
            move(nextChild, container, anchor, 2);
          } else {
            j2--;
          }
        }
      }
    }
  };
  const move = (vnode, container, anchor, moveType, parentSuspense = null) => {
    const { el, type: type2, transition, children, shapeFlag } = vnode;
    if (shapeFlag & 6) {
      move(vnode.component.subTree, container, anchor, moveType);
      return;
    }
    if (shapeFlag & 128) {
      vnode.suspense.move(container, anchor, moveType);
      return;
    }
    if (shapeFlag & 64) {
      type2.move(vnode, container, anchor, internals);
      return;
    }
    if (type2 === Fragment) {
      hostInsert(el, container, anchor);
      for (let i2 = 0; i2 < children.length; i2++) {
        move(children[i2], container, anchor, moveType);
      }
      hostInsert(vnode.anchor, container, anchor);
      return;
    }
    if (type2 === Static) {
      moveStaticNode(vnode, container, anchor);
      return;
    }
    const needTransition2 = moveType !== 2 && shapeFlag & 1 && transition;
    if (needTransition2) {
      if (moveType === 0) {
        transition.beforeEnter(el);
        hostInsert(el, container, anchor);
        queuePostRenderEffect(() => transition.enter(el), parentSuspense);
      } else {
        const { leave, delayLeave, afterLeave } = transition;
        const remove22 = () => hostInsert(el, container, anchor);
        const performLeave = () => {
          leave(el, () => {
            remove22();
            afterLeave && afterLeave();
          });
        };
        if (delayLeave) {
          delayLeave(el, remove22, performLeave);
        } else {
          performLeave();
        }
      }
    } else {
      hostInsert(el, container, anchor);
    }
  };
  const unmount = (vnode, parentComponent, parentSuspense, doRemove = false, optimized = false) => {
    const {
      type: type2,
      props,
      ref: ref2,
      children,
      dynamicChildren,
      shapeFlag,
      patchFlag,
      dirs,
      cacheIndex
    } = vnode;
    if (patchFlag === -2) {
      optimized = false;
    }
    if (ref2 != null) {
      setRef(ref2, null, parentSuspense, vnode, true);
    }
    if (cacheIndex != null) {
      parentComponent.renderCache[cacheIndex] = void 0;
    }
    if (shapeFlag & 256) {
      parentComponent.ctx.deactivate(vnode);
      return;
    }
    const shouldInvokeDirs = shapeFlag & 1 && dirs;
    const shouldInvokeVnodeHook = !isAsyncWrapper(vnode);
    let vnodeHook;
    if (shouldInvokeVnodeHook && (vnodeHook = props && props.onVnodeBeforeUnmount)) {
      invokeVNodeHook(vnodeHook, parentComponent, vnode);
    }
    if (shapeFlag & 6) {
      unmountComponent(vnode.component, parentSuspense, doRemove);
    } else {
      if (shapeFlag & 128) {
        vnode.suspense.unmount(parentSuspense, doRemove);
        return;
      }
      if (shouldInvokeDirs) {
        invokeDirectiveHook(vnode, null, parentComponent, "beforeUnmount");
      }
      if (shapeFlag & 64) {
        vnode.type.remove(
          vnode,
          parentComponent,
          parentSuspense,
          internals,
          doRemove
        );
      } else if (dynamicChildren && !dynamicChildren.hasOnce && (type2 !== Fragment || patchFlag > 0 && patchFlag & 64)) {
        unmountChildren(
          dynamicChildren,
          parentComponent,
          parentSuspense,
          false,
          true
        );
      } else if (type2 === Fragment && patchFlag & (128 | 256) || !optimized && shapeFlag & 16) {
        unmountChildren(children, parentComponent, parentSuspense);
      }
      if (doRemove) {
        remove2(vnode);
      }
    }
    if (shouldInvokeVnodeHook && (vnodeHook = props && props.onVnodeUnmounted) || shouldInvokeDirs) {
      queuePostRenderEffect(() => {
        vnodeHook && invokeVNodeHook(vnodeHook, parentComponent, vnode);
        shouldInvokeDirs && invokeDirectiveHook(vnode, null, parentComponent, "unmounted");
      }, parentSuspense);
    }
  };
  const remove2 = (vnode) => {
    const { type: type2, el, anchor, transition } = vnode;
    if (type2 === Fragment) {
      {
        removeFragment(el, anchor);
      }
      return;
    }
    if (type2 === Static) {
      removeStaticNode(vnode);
      return;
    }
    const performRemove = () => {
      hostRemove(el);
      if (transition && !transition.persisted && transition.afterLeave) {
        transition.afterLeave();
      }
    };
    if (vnode.shapeFlag & 1 && transition && !transition.persisted) {
      const { leave, delayLeave } = transition;
      const performLeave = () => leave(el, performRemove);
      if (delayLeave) {
        delayLeave(vnode.el, performRemove, performLeave);
      } else {
        performLeave();
      }
    } else {
      performRemove();
    }
  };
  const removeFragment = (cur, end) => {
    let next;
    while (cur !== end) {
      next = hostNextSibling(cur);
      hostRemove(cur);
      cur = next;
    }
    hostRemove(end);
  };
  const unmountComponent = (instance, parentSuspense, doRemove) => {
    const { bum, scope, job, subTree, um, m, a: a2 } = instance;
    invalidateMount(m);
    invalidateMount(a2);
    if (bum) {
      invokeArrayFns(bum);
    }
    scope.stop();
    if (job) {
      job.flags |= 8;
      unmount(subTree, instance, parentSuspense, doRemove);
    }
    if (um) {
      queuePostRenderEffect(um, parentSuspense);
    }
    queuePostRenderEffect(() => {
      instance.isUnmounted = true;
    }, parentSuspense);
    if (parentSuspense && parentSuspense.pendingBranch && !parentSuspense.isUnmounted && instance.asyncDep && !instance.asyncResolved && instance.suspenseId === parentSuspense.pendingId) {
      parentSuspense.deps--;
      if (parentSuspense.deps === 0) {
        parentSuspense.resolve();
      }
    }
  };
  const unmountChildren = (children, parentComponent, parentSuspense, doRemove = false, optimized = false, start = 0) => {
    for (let i2 = start; i2 < children.length; i2++) {
      unmount(children[i2], parentComponent, parentSuspense, doRemove, optimized);
    }
  };
  const getNextHostNode = (vnode) => {
    if (vnode.shapeFlag & 6) {
      return getNextHostNode(vnode.component.subTree);
    }
    if (vnode.shapeFlag & 128) {
      return vnode.suspense.next();
    }
    const el = hostNextSibling(vnode.anchor || vnode.el);
    const teleportEnd = el && el[TeleportEndKey];
    return teleportEnd ? hostNextSibling(teleportEnd) : el;
  };
  let isFlushing = false;
  const render2 = (vnode, container, namespace) => {
    if (vnode == null) {
      if (container._vnode) {
        unmount(container._vnode, null, null, true);
      }
    } else {
      patch(
        container._vnode || null,
        vnode,
        container,
        null,
        null,
        null,
        namespace
      );
    }
    container._vnode = vnode;
    if (!isFlushing) {
      isFlushing = true;
      flushPreFlushCbs();
      flushPostFlushCbs();
      isFlushing = false;
    }
  };
  const internals = {
    p: patch,
    um: unmount,
    m: move,
    r: remove2,
    mt: mountComponent,
    mc: mountChildren,
    pc: patchChildren,
    pbc: patchBlockChildren,
    n: getNextHostNode,
    o: options
  };
  let hydrate;
  let hydrateNode;
  if (createHydrationFns) {
    [hydrate, hydrateNode] = createHydrationFns(
      internals
    );
  }
  return {
    render: render2,
    hydrate,
    createApp: createAppAPI(render2, hydrate)
  };
}
function resolveChildrenNamespace({ type: type2, props }, currentNamespace) {
  return currentNamespace === "svg" && type2 === "foreignObject" || currentNamespace === "mathml" && type2 === "annotation-xml" && props && props.encoding && props.encoding.includes("html") ? void 0 : currentNamespace;
}
function toggleRecurse({ effect, job }, allowed) {
  if (allowed) {
    effect.flags |= 32;
    job.flags |= 4;
  } else {
    effect.flags &= ~32;
    job.flags &= ~4;
  }
}
function needTransition(parentSuspense, transition) {
  return (!parentSuspense || parentSuspense && !parentSuspense.pendingBranch) && transition && !transition.persisted;
}
function traverseStaticChildren(n1, n2, shallow = false) {
  const ch1 = n1.children;
  const ch2 = n2.children;
  if (isArray(ch1) && isArray(ch2)) {
    for (let i2 = 0; i2 < ch1.length; i2++) {
      const c1 = ch1[i2];
      let c2 = ch2[i2];
      if (c2.shapeFlag & 1 && !c2.dynamicChildren) {
        if (c2.patchFlag <= 0 || c2.patchFlag === 32) {
          c2 = ch2[i2] = cloneIfMounted(ch2[i2]);
          c2.el = c1.el;
        }
        if (!shallow && c2.patchFlag !== -2)
          traverseStaticChildren(c1, c2);
      }
      if (c2.type === Text) {
        c2.el = c1.el;
      }
    }
  }
}
function getSequence(arr) {
  const p2 = arr.slice();
  const result = [0];
  let i2, j2, u2, v2, c;
  const len = arr.length;
  for (i2 = 0; i2 < len; i2++) {
    const arrI = arr[i2];
    if (arrI !== 0) {
      j2 = result[result.length - 1];
      if (arr[j2] < arrI) {
        p2[i2] = j2;
        result.push(i2);
        continue;
      }
      u2 = 0;
      v2 = result.length - 1;
      while (u2 < v2) {
        c = u2 + v2 >> 1;
        if (arr[result[c]] < arrI) {
          u2 = c + 1;
        } else {
          v2 = c;
        }
      }
      if (arrI < arr[result[u2]]) {
        if (u2 > 0) {
          p2[i2] = result[u2 - 1];
        }
        result[u2] = i2;
      }
    }
  }
  u2 = result.length;
  v2 = result[u2 - 1];
  while (u2-- > 0) {
    result[u2] = v2;
    v2 = p2[v2];
  }
  return result;
}
function locateNonHydratedAsyncRoot(instance) {
  const subComponent = instance.subTree.component;
  if (subComponent) {
    if (subComponent.asyncDep && !subComponent.asyncResolved) {
      return subComponent;
    } else {
      return locateNonHydratedAsyncRoot(subComponent);
    }
  }
}
function invalidateMount(hooks) {
  if (hooks) {
    for (let i2 = 0; i2 < hooks.length; i2++)
      hooks[i2].flags |= 8;
  }
}
const ssrContextKey = Symbol.for("v-scx");
const useSSRContext = () => {
  {
    const ctx = inject(ssrContextKey);
    return ctx;
  }
};
function watchEffect(effect, options) {
  return doWatch(effect, null, options);
}
function watchSyncEffect(effect, options) {
  return doWatch(
    effect,
    null,
    { flush: "sync" }
  );
}
function watch(source, cb, options) {
  return doWatch(source, cb, options);
}
function doWatch(source, cb, options = EMPTY_OBJ) {
  const { immediate, deep, flush, once } = options;
  const baseWatchOptions = extend({}, options);
  const runsImmediately = cb && immediate || !cb && flush !== "post";
  let ssrCleanup;
  if (isInSSRComponentSetup) {
    if (flush === "sync") {
      const ctx = useSSRContext();
      ssrCleanup = ctx.__watcherHandles || (ctx.__watcherHandles = []);
    } else if (!runsImmediately) {
      const watchStopHandle = () => {
      };
      watchStopHandle.stop = NOOP;
      watchStopHandle.resume = NOOP;
      watchStopHandle.pause = NOOP;
      return watchStopHandle;
    }
  }
  const instance = currentInstance;
  baseWatchOptions.call = (fn, type2, args) => callWithAsyncErrorHandling(fn, instance, type2, args);
  let isPre = false;
  if (flush === "post") {
    baseWatchOptions.scheduler = (job) => {
      queuePostRenderEffect(job, instance && instance.suspense);
    };
  } else if (flush !== "sync") {
    isPre = true;
    baseWatchOptions.scheduler = (job, isFirstRun) => {
      if (isFirstRun) {
        job();
      } else {
        queueJob(job);
      }
    };
  }
  baseWatchOptions.augmentJob = (job) => {
    if (cb) {
      job.flags |= 4;
    }
    if (isPre) {
      job.flags |= 2;
      if (instance) {
        job.id = instance.uid;
        job.i = instance;
      }
    }
  };
  const watchHandle = watch$1(source, cb, baseWatchOptions);
  if (isInSSRComponentSetup) {
    if (ssrCleanup) {
      ssrCleanup.push(watchHandle);
    } else if (runsImmediately) {
      watchHandle();
    }
  }
  return watchHandle;
}
function instanceWatch(source, value, options) {
  const publicThis = this.proxy;
  const getter = isString$1(source) ? source.includes(".") ? createPathGetter(publicThis, source) : () => publicThis[source] : source.bind(publicThis, publicThis);
  let cb;
  if (isFunction(value)) {
    cb = value;
  } else {
    cb = value.handler;
    options = value;
  }
  const reset = setCurrentInstance(this);
  const res = doWatch(getter, cb.bind(publicThis), options);
  reset();
  return res;
}
function createPathGetter(ctx, path) {
  const segments = path.split(".");
  return () => {
    let cur = ctx;
    for (let i2 = 0; i2 < segments.length && cur; i2++) {
      cur = cur[segments[i2]];
    }
    return cur;
  };
}
function useModel(props, name, options = EMPTY_OBJ) {
  const i2 = getCurrentInstance();
  const camelizedName = camelize(name);
  const hyphenatedName = hyphenate(name);
  const modifiers = getModelModifiers(props, camelizedName);
  const res = customRef((track2, trigger2) => {
    let localValue;
    let prevSetValue = EMPTY_OBJ;
    let prevEmittedValue;
    watchSyncEffect(() => {
      const propValue = props[camelizedName];
      if (hasChanged(localValue, propValue)) {
        localValue = propValue;
        trigger2();
      }
    });
    return {
      get() {
        track2();
        return options.get ? options.get(localValue) : localValue;
      },
      set(value) {
        const emittedValue = options.set ? options.set(value) : value;
        if (!hasChanged(emittedValue, localValue) && !(prevSetValue !== EMPTY_OBJ && hasChanged(value, prevSetValue))) {
          return;
        }
        const rawProps = i2.vnode.props;
        if (!(rawProps && (name in rawProps || camelizedName in rawProps || hyphenatedName in rawProps) && (`onUpdate:${name}` in rawProps || `onUpdate:${camelizedName}` in rawProps || `onUpdate:${hyphenatedName}` in rawProps))) {
          localValue = value;
          trigger2();
        }
        i2.emit(`update:${name}`, emittedValue);
        if (hasChanged(value, emittedValue) && hasChanged(value, prevSetValue) && !hasChanged(emittedValue, prevEmittedValue)) {
          trigger2();
        }
        prevSetValue = value;
        prevEmittedValue = emittedValue;
      }
    };
  });
  res[Symbol.iterator] = () => {
    let i22 = 0;
    return {
      next() {
        if (i22 < 2) {
          return { value: i22++ ? modifiers || EMPTY_OBJ : res, done: false };
        } else {
          return { done: true };
        }
      }
    };
  };
  return res;
}
const getModelModifiers = (props, modelName) => {
  return modelName === "modelValue" || modelName === "model-value" ? props.modelModifiers : props[`${modelName}Modifiers`] || props[`${camelize(modelName)}Modifiers`] || props[`${hyphenate(modelName)}Modifiers`];
};
function emit(instance, event, ...rawArgs) {
  if (instance.isUnmounted)
    return;
  const props = instance.vnode.props || EMPTY_OBJ;
  let args = rawArgs;
  const isModelListener2 = event.startsWith("update:");
  const modifiers = isModelListener2 && getModelModifiers(props, event.slice(7));
  if (modifiers) {
    if (modifiers.trim) {
      args = rawArgs.map((a2) => isString$1(a2) ? a2.trim() : a2);
    }
    if (modifiers.number) {
      args = rawArgs.map(looseToNumber);
    }
  }
  let handlerName;
  let handler = props[handlerName = toHandlerKey(event)] || props[handlerName = toHandlerKey(camelize(event))];
  if (!handler && isModelListener2) {
    handler = props[handlerName = toHandlerKey(hyphenate(event))];
  }
  if (handler) {
    callWithAsyncErrorHandling(
      handler,
      instance,
      6,
      args
    );
  }
  const onceHandler = props[handlerName + `Once`];
  if (onceHandler) {
    if (!instance.emitted) {
      instance.emitted = {};
    } else if (instance.emitted[handlerName]) {
      return;
    }
    instance.emitted[handlerName] = true;
    callWithAsyncErrorHandling(
      onceHandler,
      instance,
      6,
      args
    );
  }
}
function normalizeEmitsOptions(comp, appContext, asMixin = false) {
  const cache = appContext.emitsCache;
  const cached = cache.get(comp);
  if (cached !== void 0) {
    return cached;
  }
  const raw = comp.emits;
  let normalized = {};
  let hasExtends = false;
  if (!isFunction(comp)) {
    const extendEmits = (raw2) => {
      const normalizedFromExtend = normalizeEmitsOptions(raw2, appContext, true);
      if (normalizedFromExtend) {
        hasExtends = true;
        extend(normalized, normalizedFromExtend);
      }
    };
    if (!asMixin && appContext.mixins.length) {
      appContext.mixins.forEach(extendEmits);
    }
    if (comp.extends) {
      extendEmits(comp.extends);
    }
    if (comp.mixins) {
      comp.mixins.forEach(extendEmits);
    }
  }
  if (!raw && !hasExtends) {
    if (isObject(comp)) {
      cache.set(comp, null);
    }
    return null;
  }
  if (isArray(raw)) {
    raw.forEach((key) => normalized[key] = null);
  } else {
    extend(normalized, raw);
  }
  if (isObject(comp)) {
    cache.set(comp, normalized);
  }
  return normalized;
}
function isEmitListener(options, key) {
  if (!options || !isOn(key)) {
    return false;
  }
  key = key.slice(2).replace(/Once$/, "");
  return hasOwn(options, key[0].toLowerCase() + key.slice(1)) || hasOwn(options, hyphenate(key)) || hasOwn(options, key);
}
function markAttrsAccessed() {
}
function renderComponentRoot(instance) {
  const {
    type: Component,
    vnode,
    proxy,
    withProxy,
    propsOptions: [propsOptions],
    slots,
    attrs,
    emit: emit2,
    render: render2,
    renderCache,
    props,
    data,
    setupState,
    ctx,
    inheritAttrs
  } = instance;
  const prev = setCurrentRenderingInstance(instance);
  let result;
  let fallthroughAttrs;
  try {
    if (vnode.shapeFlag & 4) {
      const proxyToUse = withProxy || proxy;
      const thisProxy = false ? new Proxy(proxyToUse, {
        get(target, key, receiver) {
          warn$1(
            `Property '${String(
              key
            )}' was accessed via 'this'. Avoid using 'this' in templates.`
          );
          return Reflect.get(target, key, receiver);
        }
      }) : proxyToUse;
      result = normalizeVNode(
        render2.call(
          thisProxy,
          proxyToUse,
          renderCache,
          false ? shallowReadonly(props) : props,
          setupState,
          data,
          ctx
        )
      );
      fallthroughAttrs = attrs;
    } else {
      const render22 = Component;
      if (false)
        ;
      result = normalizeVNode(
        render22.length > 1 ? render22(
          false ? shallowReadonly(props) : props,
          false ? {
            get attrs() {
              markAttrsAccessed();
              return shallowReadonly(attrs);
            },
            slots,
            emit: emit2
          } : { attrs, slots, emit: emit2 }
        ) : render22(
          false ? shallowReadonly(props) : props,
          null
        )
      );
      fallthroughAttrs = Component.props ? attrs : getFunctionalFallthrough(attrs);
    }
  } catch (err2) {
    blockStack.length = 0;
    handleError(err2, instance, 1);
    result = createVNode(Comment);
  }
  let root = result;
  if (fallthroughAttrs && inheritAttrs !== false) {
    const keys = Object.keys(fallthroughAttrs);
    const { shapeFlag } = root;
    if (keys.length) {
      if (shapeFlag & (1 | 6)) {
        if (propsOptions && keys.some(isModelListener)) {
          fallthroughAttrs = filterModelListeners(
            fallthroughAttrs,
            propsOptions
          );
        }
        root = cloneVNode(root, fallthroughAttrs, false, true);
      }
    }
  }
  if (vnode.dirs) {
    root = cloneVNode(root, null, false, true);
    root.dirs = root.dirs ? root.dirs.concat(vnode.dirs) : vnode.dirs;
  }
  if (vnode.transition) {
    setTransitionHooks(root, vnode.transition);
  }
  {
    result = root;
  }
  setCurrentRenderingInstance(prev);
  return result;
}
const getFunctionalFallthrough = (attrs) => {
  let res;
  for (const key in attrs) {
    if (key === "class" || key === "style" || isOn(key)) {
      (res || (res = {}))[key] = attrs[key];
    }
  }
  return res;
};
const filterModelListeners = (attrs, props) => {
  const res = {};
  for (const key in attrs) {
    if (!isModelListener(key) || !(key.slice(9) in props)) {
      res[key] = attrs[key];
    }
  }
  return res;
};
function shouldUpdateComponent(prevVNode, nextVNode, optimized) {
  const { props: prevProps, children: prevChildren, component } = prevVNode;
  const { props: nextProps, children: nextChildren, patchFlag } = nextVNode;
  const emits = component.emitsOptions;
  if (nextVNode.dirs || nextVNode.transition) {
    return true;
  }
  if (optimized && patchFlag >= 0) {
    if (patchFlag & 1024) {
      return true;
    }
    if (patchFlag & 16) {
      if (!prevProps) {
        return !!nextProps;
      }
      return hasPropsChanged(prevProps, nextProps, emits);
    } else if (patchFlag & 8) {
      const dynamicProps = nextVNode.dynamicProps;
      for (let i2 = 0; i2 < dynamicProps.length; i2++) {
        const key = dynamicProps[i2];
        if (nextProps[key] !== prevProps[key] && !isEmitListener(emits, key)) {
          return true;
        }
      }
    }
  } else {
    if (prevChildren || nextChildren) {
      if (!nextChildren || !nextChildren.$stable) {
        return true;
      }
    }
    if (prevProps === nextProps) {
      return false;
    }
    if (!prevProps) {
      return !!nextProps;
    }
    if (!nextProps) {
      return true;
    }
    return hasPropsChanged(prevProps, nextProps, emits);
  }
  return false;
}
function hasPropsChanged(prevProps, nextProps, emitsOptions) {
  const nextKeys = Object.keys(nextProps);
  if (nextKeys.length !== Object.keys(prevProps).length) {
    return true;
  }
  for (let i2 = 0; i2 < nextKeys.length; i2++) {
    const key = nextKeys[i2];
    if (nextProps[key] !== prevProps[key] && !isEmitListener(emitsOptions, key)) {
      return true;
    }
  }
  return false;
}
function updateHOCHostEl({ vnode, parent }, el) {
  while (parent) {
    const root = parent.subTree;
    if (root.suspense && root.suspense.activeBranch === vnode) {
      root.el = vnode.el;
    }
    if (root === vnode) {
      (vnode = parent.vnode).el = el;
      parent = parent.parent;
    } else {
      break;
    }
  }
}
const isSuspense = (type2) => type2.__isSuspense;
function queueEffectWithSuspense(fn, suspense) {
  if (suspense && suspense.pendingBranch) {
    if (isArray(fn)) {
      suspense.effects.push(...fn);
    } else {
      suspense.effects.push(fn);
    }
  } else {
    queuePostFlushCb(fn);
  }
}
const Fragment = Symbol.for("v-fgt");
const Text = Symbol.for("v-txt");
const Comment = Symbol.for("v-cmt");
const Static = Symbol.for("v-stc");
const blockStack = [];
let currentBlock = null;
function openBlock(disableTracking = false) {
  blockStack.push(currentBlock = disableTracking ? null : []);
}
function closeBlock() {
  blockStack.pop();
  currentBlock = blockStack[blockStack.length - 1] || null;
}
let isBlockTreeEnabled = 1;
function setBlockTracking(value, inVOnce = false) {
  isBlockTreeEnabled += value;
  if (value < 0 && currentBlock && inVOnce) {
    currentBlock.hasOnce = true;
  }
}
function setupBlock(vnode) {
  vnode.dynamicChildren = isBlockTreeEnabled > 0 ? currentBlock || EMPTY_ARR : null;
  closeBlock();
  if (isBlockTreeEnabled > 0 && currentBlock) {
    currentBlock.push(vnode);
  }
  return vnode;
}
function createElementBlock(type2, props, children, patchFlag, dynamicProps, shapeFlag) {
  return setupBlock(
    createBaseVNode(
      type2,
      props,
      children,
      patchFlag,
      dynamicProps,
      shapeFlag,
      true
    )
  );
}
function createBlock(type2, props, children, patchFlag, dynamicProps) {
  return setupBlock(
    createVNode(
      type2,
      props,
      children,
      patchFlag,
      dynamicProps,
      true
    )
  );
}
function isVNode(value) {
  return value ? value.__v_isVNode === true : false;
}
function isSameVNodeType(n1, n2) {
  return n1.type === n2.type && n1.key === n2.key;
}
const normalizeKey = ({ key }) => key != null ? key : null;
const normalizeRef = ({
  ref: ref2,
  ref_key,
  ref_for
}) => {
  if (typeof ref2 === "number") {
    ref2 = "" + ref2;
  }
  return ref2 != null ? isString$1(ref2) || isRef(ref2) || isFunction(ref2) ? { i: currentRenderingInstance, r: ref2, k: ref_key, f: !!ref_for } : ref2 : null;
};
function createBaseVNode(type2, props = null, children = null, patchFlag = 0, dynamicProps = null, shapeFlag = type2 === Fragment ? 0 : 1, isBlockNode = false, needFullChildrenNormalization = false) {
  const vnode = {
    __v_isVNode: true,
    __v_skip: true,
    type: type2,
    props,
    key: props && normalizeKey(props),
    ref: props && normalizeRef(props),
    scopeId: currentScopeId,
    slotScopeIds: null,
    children,
    component: null,
    suspense: null,
    ssContent: null,
    ssFallback: null,
    dirs: null,
    transition: null,
    el: null,
    anchor: null,
    target: null,
    targetStart: null,
    targetAnchor: null,
    staticCount: 0,
    shapeFlag,
    patchFlag,
    dynamicProps,
    dynamicChildren: null,
    appContext: null,
    ctx: currentRenderingInstance
  };
  if (needFullChildrenNormalization) {
    normalizeChildren(vnode, children);
    if (shapeFlag & 128) {
      type2.normalize(vnode);
    }
  } else if (children) {
    vnode.shapeFlag |= isString$1(children) ? 8 : 16;
  }
  if (isBlockTreeEnabled > 0 && !isBlockNode && currentBlock && (vnode.patchFlag > 0 || shapeFlag & 6) && vnode.patchFlag !== 32) {
    currentBlock.push(vnode);
  }
  return vnode;
}
const createVNode = _createVNode;
function _createVNode(type2, props = null, children = null, patchFlag = 0, dynamicProps = null, isBlockNode = false) {
  if (!type2 || type2 === NULL_DYNAMIC_COMPONENT) {
    type2 = Comment;
  }
  if (isVNode(type2)) {
    const cloned = cloneVNode(
      type2,
      props,
      true
    );
    if (children) {
      normalizeChildren(cloned, children);
    }
    if (isBlockTreeEnabled > 0 && !isBlockNode && currentBlock) {
      if (cloned.shapeFlag & 6) {
        currentBlock[currentBlock.indexOf(type2)] = cloned;
      } else {
        currentBlock.push(cloned);
      }
    }
    cloned.patchFlag = -2;
    return cloned;
  }
  if (isClassComponent(type2)) {
    type2 = type2.__vccOpts;
  }
  if (props) {
    props = guardReactiveProps(props);
    let { class: klass, style } = props;
    if (klass && !isString$1(klass)) {
      props.class = normalizeClass(klass);
    }
    if (isObject(style)) {
      if (isProxy(style) && !isArray(style)) {
        style = extend({}, style);
      }
      props.style = normalizeStyle(style);
    }
  }
  const shapeFlag = isString$1(type2) ? 1 : isSuspense(type2) ? 128 : isTeleport(type2) ? 64 : isObject(type2) ? 4 : isFunction(type2) ? 2 : 0;
  return createBaseVNode(
    type2,
    props,
    children,
    patchFlag,
    dynamicProps,
    shapeFlag,
    isBlockNode,
    true
  );
}
function guardReactiveProps(props) {
  if (!props)
    return null;
  return isProxy(props) || isInternalObject(props) ? extend({}, props) : props;
}
function cloneVNode(vnode, extraProps, mergeRef = false, cloneTransition = false) {
  const { props, ref: ref2, patchFlag, children, transition } = vnode;
  const mergedProps = extraProps ? mergeProps(props || {}, extraProps) : props;
  const cloned = {
    __v_isVNode: true,
    __v_skip: true,
    type: vnode.type,
    props: mergedProps,
    key: mergedProps && normalizeKey(mergedProps),
    ref: extraProps && extraProps.ref ? mergeRef && ref2 ? isArray(ref2) ? ref2.concat(normalizeRef(extraProps)) : [ref2, normalizeRef(extraProps)] : normalizeRef(extraProps) : ref2,
    scopeId: vnode.scopeId,
    slotScopeIds: vnode.slotScopeIds,
    children,
    target: vnode.target,
    targetStart: vnode.targetStart,
    targetAnchor: vnode.targetAnchor,
    staticCount: vnode.staticCount,
    shapeFlag: vnode.shapeFlag,
    patchFlag: extraProps && vnode.type !== Fragment ? patchFlag === -1 ? 16 : patchFlag | 16 : patchFlag,
    dynamicProps: vnode.dynamicProps,
    dynamicChildren: vnode.dynamicChildren,
    appContext: vnode.appContext,
    dirs: vnode.dirs,
    transition,
    component: vnode.component,
    suspense: vnode.suspense,
    ssContent: vnode.ssContent && cloneVNode(vnode.ssContent),
    ssFallback: vnode.ssFallback && cloneVNode(vnode.ssFallback),
    el: vnode.el,
    anchor: vnode.anchor,
    ctx: vnode.ctx,
    ce: vnode.ce
  };
  if (transition && cloneTransition) {
    setTransitionHooks(
      cloned,
      transition.clone(cloned)
    );
  }
  return cloned;
}
function createTextVNode(text = " ", flag = 0) {
  return createVNode(Text, null, text, flag);
}
function createStaticVNode(content, numberOfNodes) {
  const vnode = createVNode(Static, null, content);
  vnode.staticCount = numberOfNodes;
  return vnode;
}
function createCommentVNode(text = "", asBlock = false) {
  return asBlock ? (openBlock(), createBlock(Comment, null, text)) : createVNode(Comment, null, text);
}
function normalizeVNode(child) {
  if (child == null || typeof child === "boolean") {
    return createVNode(Comment);
  } else if (isArray(child)) {
    return createVNode(
      Fragment,
      null,
      child.slice()
    );
  } else if (isVNode(child)) {
    return cloneIfMounted(child);
  } else {
    return createVNode(Text, null, String(child));
  }
}
function cloneIfMounted(child) {
  return child.el === null && child.patchFlag !== -1 || child.memo ? child : cloneVNode(child);
}
function normalizeChildren(vnode, children) {
  let type2 = 0;
  const { shapeFlag } = vnode;
  if (children == null) {
    children = null;
  } else if (isArray(children)) {
    type2 = 16;
  } else if (typeof children === "object") {
    if (shapeFlag & (1 | 64)) {
      const slot = children.default;
      if (slot) {
        slot._c && (slot._d = false);
        normalizeChildren(vnode, slot());
        slot._c && (slot._d = true);
      }
      return;
    } else {
      type2 = 32;
      const slotFlag = children._;
      if (!slotFlag && !isInternalObject(children)) {
        children._ctx = currentRenderingInstance;
      } else if (slotFlag === 3 && currentRenderingInstance) {
        if (currentRenderingInstance.slots._ === 1) {
          children._ = 1;
        } else {
          children._ = 2;
          vnode.patchFlag |= 1024;
        }
      }
    }
  } else if (isFunction(children)) {
    children = { default: children, _ctx: currentRenderingInstance };
    type2 = 32;
  } else {
    children = String(children);
    if (shapeFlag & 64) {
      type2 = 16;
      children = [createTextVNode(children)];
    } else {
      type2 = 8;
    }
  }
  vnode.children = children;
  vnode.shapeFlag |= type2;
}
function mergeProps(...args) {
  const ret = {};
  for (let i2 = 0; i2 < args.length; i2++) {
    const toMerge = args[i2];
    for (const key in toMerge) {
      if (key === "class") {
        if (ret.class !== toMerge.class) {
          ret.class = normalizeClass([ret.class, toMerge.class]);
        }
      } else if (key === "style") {
        ret.style = normalizeStyle([ret.style, toMerge.style]);
      } else if (isOn(key)) {
        const existing = ret[key];
        const incoming = toMerge[key];
        if (incoming && existing !== incoming && !(isArray(existing) && existing.includes(incoming))) {
          ret[key] = existing ? [].concat(existing, incoming) : incoming;
        }
      } else if (key !== "") {
        ret[key] = toMerge[key];
      }
    }
  }
  return ret;
}
function invokeVNodeHook(hook, instance, vnode, prevVNode = null) {
  callWithAsyncErrorHandling(hook, instance, 7, [
    vnode,
    prevVNode
  ]);
}
const emptyAppContext = createAppContext();
let uid = 0;
function createComponentInstance(vnode, parent, suspense) {
  const type2 = vnode.type;
  const appContext = (parent ? parent.appContext : vnode.appContext) || emptyAppContext;
  const instance = {
    uid: uid++,
    vnode,
    type: type2,
    parent,
    appContext,
    root: null,
    next: null,
    subTree: null,
    effect: null,
    update: null,
    job: null,
    scope: new EffectScope(
      true
    ),
    render: null,
    proxy: null,
    exposed: null,
    exposeProxy: null,
    withProxy: null,
    provides: parent ? parent.provides : Object.create(appContext.provides),
    ids: parent ? parent.ids : ["", 0, 0],
    accessCache: null,
    renderCache: [],
    components: null,
    directives: null,
    propsOptions: normalizePropsOptions(type2, appContext),
    emitsOptions: normalizeEmitsOptions(type2, appContext),
    emit: null,
    emitted: null,
    propsDefaults: EMPTY_OBJ,
    inheritAttrs: type2.inheritAttrs,
    ctx: EMPTY_OBJ,
    data: EMPTY_OBJ,
    props: EMPTY_OBJ,
    attrs: EMPTY_OBJ,
    slots: EMPTY_OBJ,
    refs: EMPTY_OBJ,
    setupState: EMPTY_OBJ,
    setupContext: null,
    suspense,
    suspenseId: suspense ? suspense.pendingId : 0,
    asyncDep: null,
    asyncResolved: false,
    isMounted: false,
    isUnmounted: false,
    isDeactivated: false,
    bc: null,
    c: null,
    bm: null,
    m: null,
    bu: null,
    u: null,
    um: null,
    bum: null,
    da: null,
    a: null,
    rtg: null,
    rtc: null,
    ec: null,
    sp: null
  };
  {
    instance.ctx = { _: instance };
  }
  instance.root = parent ? parent.root : instance;
  instance.emit = emit.bind(null, instance);
  if (vnode.ce) {
    vnode.ce(instance);
  }
  return instance;
}
let currentInstance = null;
const getCurrentInstance = () => currentInstance || currentRenderingInstance;
let internalSetCurrentInstance;
let setInSSRSetupState;
{
  const g = getGlobalThis();
  const registerGlobalSetter = (key, setter) => {
    let setters;
    if (!(setters = g[key]))
      setters = g[key] = [];
    setters.push(setter);
    return (v2) => {
      if (setters.length > 1)
        setters.forEach((set) => set(v2));
      else
        setters[0](v2);
    };
  };
  internalSetCurrentInstance = registerGlobalSetter(
    `__VUE_INSTANCE_SETTERS__`,
    (v2) => currentInstance = v2
  );
  setInSSRSetupState = registerGlobalSetter(
    `__VUE_SSR_SETTERS__`,
    (v2) => isInSSRComponentSetup = v2
  );
}
const setCurrentInstance = (instance) => {
  const prev = currentInstance;
  internalSetCurrentInstance(instance);
  instance.scope.on();
  return () => {
    instance.scope.off();
    internalSetCurrentInstance(prev);
  };
};
const unsetCurrentInstance = () => {
  currentInstance && currentInstance.scope.off();
  internalSetCurrentInstance(null);
};
function isStatefulComponent(instance) {
  return instance.vnode.shapeFlag & 4;
}
let isInSSRComponentSetup = false;
function setupComponent(instance, isSSR = false, optimized = false) {
  isSSR && setInSSRSetupState(isSSR);
  const { props, children } = instance.vnode;
  const isStateful = isStatefulComponent(instance);
  initProps(instance, props, isStateful, isSSR);
  initSlots(instance, children, optimized);
  const setupResult = isStateful ? setupStatefulComponent(instance, isSSR) : void 0;
  isSSR && setInSSRSetupState(false);
  return setupResult;
}
function setupStatefulComponent(instance, isSSR) {
  const Component = instance.type;
  instance.accessCache = /* @__PURE__ */ Object.create(null);
  instance.proxy = new Proxy(instance.ctx, PublicInstanceProxyHandlers);
  const { setup } = Component;
  if (setup) {
    pauseTracking();
    const setupContext = instance.setupContext = setup.length > 1 ? createSetupContext(instance) : null;
    const reset = setCurrentInstance(instance);
    const setupResult = callWithErrorHandling(
      setup,
      instance,
      0,
      [
        instance.props,
        setupContext
      ]
    );
    const isAsyncSetup = isPromise(setupResult);
    resetTracking();
    reset();
    if ((isAsyncSetup || instance.sp) && !isAsyncWrapper(instance)) {
      markAsyncBoundary(instance);
    }
    if (isAsyncSetup) {
      setupResult.then(unsetCurrentInstance, unsetCurrentInstance);
      if (isSSR) {
        return setupResult.then((resolvedResult) => {
          handleSetupResult(instance, resolvedResult, isSSR);
        }).catch((e) => {
          handleError(e, instance, 0);
        });
      } else {
        instance.asyncDep = setupResult;
      }
    } else {
      handleSetupResult(instance, setupResult, isSSR);
    }
  } else {
    finishComponentSetup(instance, isSSR);
  }
}
function handleSetupResult(instance, setupResult, isSSR) {
  if (isFunction(setupResult)) {
    if (instance.type.__ssrInlineRender) {
      instance.ssrRender = setupResult;
    } else {
      instance.render = setupResult;
    }
  } else if (isObject(setupResult)) {
    instance.setupState = proxyRefs(setupResult);
  } else
    ;
  finishComponentSetup(instance, isSSR);
}
let compile;
function finishComponentSetup(instance, isSSR, skipOptions) {
  const Component = instance.type;
  if (!instance.render) {
    if (!isSSR && compile && !Component.render) {
      const template = Component.template || resolveMergedOptions(instance).template;
      if (template) {
        const { isCustomElement, compilerOptions } = instance.appContext.config;
        const { delimiters, compilerOptions: componentCompilerOptions } = Component;
        const finalCompilerOptions = extend(
          extend(
            {
              isCustomElement,
              delimiters
            },
            compilerOptions
          ),
          componentCompilerOptions
        );
        Component.render = compile(template, finalCompilerOptions);
      }
    }
    instance.render = Component.render || NOOP;
  }
  {
    const reset = setCurrentInstance(instance);
    pauseTracking();
    try {
      applyOptions(instance);
    } finally {
      resetTracking();
      reset();
    }
  }
}
const attrsProxyHandlers = {
  get(target, key) {
    track(target, "get", "");
    return target[key];
  }
};
function createSetupContext(instance) {
  const expose = (exposed) => {
    instance.exposed = exposed || {};
  };
  {
    return {
      attrs: new Proxy(instance.attrs, attrsProxyHandlers),
      slots: instance.slots,
      emit: instance.emit,
      expose
    };
  }
}
function getComponentPublicInstance(instance) {
  if (instance.exposed) {
    return instance.exposeProxy || (instance.exposeProxy = new Proxy(proxyRefs(markRaw(instance.exposed)), {
      get(target, key) {
        if (key in target) {
          return target[key];
        } else if (key in publicPropertiesMap) {
          return publicPropertiesMap[key](instance);
        }
      },
      has(target, key) {
        return key in target || key in publicPropertiesMap;
      }
    }));
  } else {
    return instance.proxy;
  }
}
const classifyRE = /(?:^|[-_])(\w)/g;
const classify = (str) => str.replace(classifyRE, (c) => c.toUpperCase()).replace(/[-_]/g, "");
function getComponentName(Component, includeInferred = true) {
  return isFunction(Component) ? Component.displayName || Component.name : Component.name || includeInferred && Component.__name;
}
function formatComponentName(instance, Component, isRoot = false) {
  let name = getComponentName(Component);
  if (!name && Component.__file) {
    const match = Component.__file.match(/([^/\\]+)\.\w+$/);
    if (match) {
      name = match[1];
    }
  }
  if (!name && instance && instance.parent) {
    const inferFromRegistry = (registry) => {
      for (const key in registry) {
        if (registry[key] === Component) {
          return key;
        }
      }
    };
    name = inferFromRegistry(
      instance.components || instance.parent.type.components
    ) || inferFromRegistry(instance.appContext.components);
  }
  return name ? classify(name) : isRoot ? `App` : `Anonymous`;
}
function isClassComponent(value) {
  return isFunction(value) && "__vccOpts" in value;
}
const computed = (getterOrOptions, debugOptions) => {
  const c = computed$1(getterOrOptions, debugOptions, isInSSRComponentSetup);
  return c;
};
function h(type2, propsOrChildren, children) {
  const l = arguments.length;
  if (l === 2) {
    if (isObject(propsOrChildren) && !isArray(propsOrChildren)) {
      if (isVNode(propsOrChildren)) {
        return createVNode(type2, null, [propsOrChildren]);
      }
      return createVNode(type2, propsOrChildren);
    } else {
      return createVNode(type2, null, propsOrChildren);
    }
  } else {
    if (l > 3) {
      children = Array.prototype.slice.call(arguments, 2);
    } else if (l === 3 && isVNode(children)) {
      children = [children];
    }
    return createVNode(type2, propsOrChildren, children);
  }
}
const version = "3.5.13";
NOOP;
/**
* @vue/runtime-dom v3.5.13
* (c) 2018-present Yuxi (Evan) You and Vue contributors
* @license MIT
**/
let policy = void 0;
const tt = typeof window !== "undefined" && window.trustedTypes;
if (tt) {
  try {
    policy = /* @__PURE__ */ tt.createPolicy("vue", {
      createHTML: (val) => val
    });
  } catch (e) {
  }
}
const unsafeToTrustedHTML = policy ? (val) => policy.createHTML(val) : (val) => val;
const svgNS = "http://www.w3.org/2000/svg";
const mathmlNS = "http://www.w3.org/1998/Math/MathML";
const doc = typeof document !== "undefined" ? document : null;
const templateContainer = doc && /* @__PURE__ */ doc.createElement("template");
const nodeOps = {
  insert: (child, parent, anchor) => {
    parent.insertBefore(child, anchor || null);
  },
  remove: (child) => {
    const parent = child.parentNode;
    if (parent) {
      parent.removeChild(child);
    }
  },
  createElement: (tag, namespace, is, props) => {
    const el = namespace === "svg" ? doc.createElementNS(svgNS, tag) : namespace === "mathml" ? doc.createElementNS(mathmlNS, tag) : is ? doc.createElement(tag, { is }) : doc.createElement(tag);
    if (tag === "select" && props && props.multiple != null) {
      el.setAttribute("multiple", props.multiple);
    }
    return el;
  },
  createText: (text) => doc.createTextNode(text),
  createComment: (text) => doc.createComment(text),
  setText: (node, text) => {
    node.nodeValue = text;
  },
  setElementText: (el, text) => {
    el.textContent = text;
  },
  parentNode: (node) => node.parentNode,
  nextSibling: (node) => node.nextSibling,
  querySelector: (selector) => doc.querySelector(selector),
  setScopeId(el, id) {
    el.setAttribute(id, "");
  },
  insertStaticContent(content, parent, anchor, namespace, start, end) {
    const before = anchor ? anchor.previousSibling : parent.lastChild;
    if (start && (start === end || start.nextSibling)) {
      while (true) {
        parent.insertBefore(start.cloneNode(true), anchor);
        if (start === end || !(start = start.nextSibling))
          break;
      }
    } else {
      templateContainer.innerHTML = unsafeToTrustedHTML(
        namespace === "svg" ? `<svg>${content}</svg>` : namespace === "mathml" ? `<math>${content}</math>` : content
      );
      const template = templateContainer.content;
      if (namespace === "svg" || namespace === "mathml") {
        const wrapper = template.firstChild;
        while (wrapper.firstChild) {
          template.appendChild(wrapper.firstChild);
        }
        template.removeChild(wrapper);
      }
      parent.insertBefore(template, anchor);
    }
    return [
      before ? before.nextSibling : parent.firstChild,
      anchor ? anchor.previousSibling : parent.lastChild
    ];
  }
};
const TRANSITION = "transition";
const ANIMATION = "animation";
const vtcKey = Symbol("_vtc");
const DOMTransitionPropsValidators = {
  name: String,
  type: String,
  css: {
    type: Boolean,
    default: true
  },
  duration: [String, Number, Object],
  enterFromClass: String,
  enterActiveClass: String,
  enterToClass: String,
  appearFromClass: String,
  appearActiveClass: String,
  appearToClass: String,
  leaveFromClass: String,
  leaveActiveClass: String,
  leaveToClass: String
};
const TransitionPropsValidators = /* @__PURE__ */ extend(
  {},
  BaseTransitionPropsValidators,
  DOMTransitionPropsValidators
);
const decorate$1 = (t2) => {
  t2.displayName = "Transition";
  t2.props = TransitionPropsValidators;
  return t2;
};
const Transition = /* @__PURE__ */ decorate$1(
  (props, { slots }) => h(BaseTransition, resolveTransitionProps(props), slots)
);
const callHook = (hook, args = []) => {
  if (isArray(hook)) {
    hook.forEach((h2) => h2(...args));
  } else if (hook) {
    hook(...args);
  }
};
const hasExplicitCallback = (hook) => {
  return hook ? isArray(hook) ? hook.some((h2) => h2.length > 1) : hook.length > 1 : false;
};
function resolveTransitionProps(rawProps) {
  const baseProps = {};
  for (const key in rawProps) {
    if (!(key in DOMTransitionPropsValidators)) {
      baseProps[key] = rawProps[key];
    }
  }
  if (rawProps.css === false) {
    return baseProps;
  }
  const {
    name = "v",
    type: type2,
    duration,
    enterFromClass = `${name}-enter-from`,
    enterActiveClass = `${name}-enter-active`,
    enterToClass = `${name}-enter-to`,
    appearFromClass = enterFromClass,
    appearActiveClass = enterActiveClass,
    appearToClass = enterToClass,
    leaveFromClass = `${name}-leave-from`,
    leaveActiveClass = `${name}-leave-active`,
    leaveToClass = `${name}-leave-to`
  } = rawProps;
  const durations = normalizeDuration(duration);
  const enterDuration = durations && durations[0];
  const leaveDuration = durations && durations[1];
  const {
    onBeforeEnter,
    onEnter,
    onEnterCancelled,
    onLeave,
    onLeaveCancelled,
    onBeforeAppear = onBeforeEnter,
    onAppear = onEnter,
    onAppearCancelled = onEnterCancelled
  } = baseProps;
  const finishEnter = (el, isAppear, done, isCancelled) => {
    el._enterCancelled = isCancelled;
    removeTransitionClass(el, isAppear ? appearToClass : enterToClass);
    removeTransitionClass(el, isAppear ? appearActiveClass : enterActiveClass);
    done && done();
  };
  const finishLeave = (el, done) => {
    el._isLeaving = false;
    removeTransitionClass(el, leaveFromClass);
    removeTransitionClass(el, leaveToClass);
    removeTransitionClass(el, leaveActiveClass);
    done && done();
  };
  const makeEnterHook = (isAppear) => {
    return (el, done) => {
      const hook = isAppear ? onAppear : onEnter;
      const resolve2 = () => finishEnter(el, isAppear, done);
      callHook(hook, [el, resolve2]);
      nextFrame(() => {
        removeTransitionClass(el, isAppear ? appearFromClass : enterFromClass);
        addTransitionClass(el, isAppear ? appearToClass : enterToClass);
        if (!hasExplicitCallback(hook)) {
          whenTransitionEnds(el, type2, enterDuration, resolve2);
        }
      });
    };
  };
  return extend(baseProps, {
    onBeforeEnter(el) {
      callHook(onBeforeEnter, [el]);
      addTransitionClass(el, enterFromClass);
      addTransitionClass(el, enterActiveClass);
    },
    onBeforeAppear(el) {
      callHook(onBeforeAppear, [el]);
      addTransitionClass(el, appearFromClass);
      addTransitionClass(el, appearActiveClass);
    },
    onEnter: makeEnterHook(false),
    onAppear: makeEnterHook(true),
    onLeave(el, done) {
      el._isLeaving = true;
      const resolve2 = () => finishLeave(el, done);
      addTransitionClass(el, leaveFromClass);
      if (!el._enterCancelled) {
        forceReflow();
        addTransitionClass(el, leaveActiveClass);
      } else {
        addTransitionClass(el, leaveActiveClass);
        forceReflow();
      }
      nextFrame(() => {
        if (!el._isLeaving) {
          return;
        }
        removeTransitionClass(el, leaveFromClass);
        addTransitionClass(el, leaveToClass);
        if (!hasExplicitCallback(onLeave)) {
          whenTransitionEnds(el, type2, leaveDuration, resolve2);
        }
      });
      callHook(onLeave, [el, resolve2]);
    },
    onEnterCancelled(el) {
      finishEnter(el, false, void 0, true);
      callHook(onEnterCancelled, [el]);
    },
    onAppearCancelled(el) {
      finishEnter(el, true, void 0, true);
      callHook(onAppearCancelled, [el]);
    },
    onLeaveCancelled(el) {
      finishLeave(el);
      callHook(onLeaveCancelled, [el]);
    }
  });
}
function normalizeDuration(duration) {
  if (duration == null) {
    return null;
  } else if (isObject(duration)) {
    return [NumberOf(duration.enter), NumberOf(duration.leave)];
  } else {
    const n = NumberOf(duration);
    return [n, n];
  }
}
function NumberOf(val) {
  const res = toNumber(val);
  return res;
}
function addTransitionClass(el, cls) {
  cls.split(/\s+/).forEach((c) => c && el.classList.add(c));
  (el[vtcKey] || (el[vtcKey] = /* @__PURE__ */ new Set())).add(cls);
}
function removeTransitionClass(el, cls) {
  cls.split(/\s+/).forEach((c) => c && el.classList.remove(c));
  const _vtc = el[vtcKey];
  if (_vtc) {
    _vtc.delete(cls);
    if (!_vtc.size) {
      el[vtcKey] = void 0;
    }
  }
}
function nextFrame(cb) {
  requestAnimationFrame(() => {
    requestAnimationFrame(cb);
  });
}
let endId = 0;
function whenTransitionEnds(el, expectedType, explicitTimeout, resolve2) {
  const id = el._endId = ++endId;
  const resolveIfNotStale = () => {
    if (id === el._endId) {
      resolve2();
    }
  };
  if (explicitTimeout != null) {
    return setTimeout(resolveIfNotStale, explicitTimeout);
  }
  const { type: type2, timeout, propCount } = getTransitionInfo(el, expectedType);
  if (!type2) {
    return resolve2();
  }
  const endEvent = type2 + "end";
  let ended = 0;
  const end = () => {
    el.removeEventListener(endEvent, onEnd);
    resolveIfNotStale();
  };
  const onEnd = (e) => {
    if (e.target === el && ++ended >= propCount) {
      end();
    }
  };
  setTimeout(() => {
    if (ended < propCount) {
      end();
    }
  }, timeout + 1);
  el.addEventListener(endEvent, onEnd);
}
function getTransitionInfo(el, expectedType) {
  const styles = window.getComputedStyle(el);
  const getStyleProperties = (key) => (styles[key] || "").split(", ");
  const transitionDelays = getStyleProperties(`${TRANSITION}Delay`);
  const transitionDurations = getStyleProperties(`${TRANSITION}Duration`);
  const transitionTimeout = getTimeout(transitionDelays, transitionDurations);
  const animationDelays = getStyleProperties(`${ANIMATION}Delay`);
  const animationDurations = getStyleProperties(`${ANIMATION}Duration`);
  const animationTimeout = getTimeout(animationDelays, animationDurations);
  let type2 = null;
  let timeout = 0;
  let propCount = 0;
  if (expectedType === TRANSITION) {
    if (transitionTimeout > 0) {
      type2 = TRANSITION;
      timeout = transitionTimeout;
      propCount = transitionDurations.length;
    }
  } else if (expectedType === ANIMATION) {
    if (animationTimeout > 0) {
      type2 = ANIMATION;
      timeout = animationTimeout;
      propCount = animationDurations.length;
    }
  } else {
    timeout = Math.max(transitionTimeout, animationTimeout);
    type2 = timeout > 0 ? transitionTimeout > animationTimeout ? TRANSITION : ANIMATION : null;
    propCount = type2 ? type2 === TRANSITION ? transitionDurations.length : animationDurations.length : 0;
  }
  const hasTransform = type2 === TRANSITION && /\b(transform|all)(,|$)/.test(
    getStyleProperties(`${TRANSITION}Property`).toString()
  );
  return {
    type: type2,
    timeout,
    propCount,
    hasTransform
  };
}
function getTimeout(delays, durations) {
  while (delays.length < durations.length) {
    delays = delays.concat(delays);
  }
  return Math.max(...durations.map((d2, i2) => toMs(d2) + toMs(delays[i2])));
}
function toMs(s2) {
  if (s2 === "auto")
    return 0;
  return Number(s2.slice(0, -1).replace(",", ".")) * 1e3;
}
function forceReflow() {
  return document.body.offsetHeight;
}
function patchClass(el, value, isSVG) {
  const transitionClasses = el[vtcKey];
  if (transitionClasses) {
    value = (value ? [value, ...transitionClasses] : [...transitionClasses]).join(" ");
  }
  if (value == null) {
    el.removeAttribute("class");
  } else if (isSVG) {
    el.setAttribute("class", value);
  } else {
    el.className = value;
  }
}
const vShowOriginalDisplay = Symbol("_vod");
const vShowHidden = Symbol("_vsh");
const vShow = {
  beforeMount(el, { value }, { transition }) {
    el[vShowOriginalDisplay] = el.style.display === "none" ? "" : el.style.display;
    if (transition && value) {
      transition.beforeEnter(el);
    } else {
      setDisplay(el, value);
    }
  },
  mounted(el, { value }, { transition }) {
    if (transition && value) {
      transition.enter(el);
    }
  },
  updated(el, { value, oldValue }, { transition }) {
    if (!value === !oldValue)
      return;
    if (transition) {
      if (value) {
        transition.beforeEnter(el);
        setDisplay(el, true);
        transition.enter(el);
      } else {
        transition.leave(el, () => {
          setDisplay(el, false);
        });
      }
    } else {
      setDisplay(el, value);
    }
  },
  beforeUnmount(el, { value }) {
    setDisplay(el, value);
  }
};
function setDisplay(el, value) {
  el.style.display = value ? el[vShowOriginalDisplay] : "none";
  el[vShowHidden] = !value;
}
const CSS_VAR_TEXT = Symbol("");
const displayRE = /(^|;)\s*display\s*:/;
function patchStyle(el, prev, next) {
  const style = el.style;
  const isCssString = isString$1(next);
  let hasControlledDisplay = false;
  if (next && !isCssString) {
    if (prev) {
      if (!isString$1(prev)) {
        for (const key in prev) {
          if (next[key] == null) {
            setStyle(style, key, "");
          }
        }
      } else {
        for (const prevStyle of prev.split(";")) {
          const key = prevStyle.slice(0, prevStyle.indexOf(":")).trim();
          if (next[key] == null) {
            setStyle(style, key, "");
          }
        }
      }
    }
    for (const key in next) {
      if (key === "display") {
        hasControlledDisplay = true;
      }
      setStyle(style, key, next[key]);
    }
  } else {
    if (isCssString) {
      if (prev !== next) {
        const cssVarText = style[CSS_VAR_TEXT];
        if (cssVarText) {
          next += ";" + cssVarText;
        }
        style.cssText = next;
        hasControlledDisplay = displayRE.test(next);
      }
    } else if (prev) {
      el.removeAttribute("style");
    }
  }
  if (vShowOriginalDisplay in el) {
    el[vShowOriginalDisplay] = hasControlledDisplay ? style.display : "";
    if (el[vShowHidden]) {
      style.display = "none";
    }
  }
}
const importantRE = /\s*!important$/;
function setStyle(style, name, val) {
  if (isArray(val)) {
    val.forEach((v2) => setStyle(style, name, v2));
  } else {
    if (val == null)
      val = "";
    if (name.startsWith("--")) {
      style.setProperty(name, val);
    } else {
      const prefixed = autoPrefix(style, name);
      if (importantRE.test(val)) {
        style.setProperty(
          hyphenate(prefixed),
          val.replace(importantRE, ""),
          "important"
        );
      } else {
        style[prefixed] = val;
      }
    }
  }
}
const prefixes = ["Webkit", "Moz", "ms"];
const prefixCache = {};
function autoPrefix(style, rawName) {
  const cached = prefixCache[rawName];
  if (cached) {
    return cached;
  }
  let name = camelize(rawName);
  if (name !== "filter" && name in style) {
    return prefixCache[rawName] = name;
  }
  name = capitalize(name);
  for (let i2 = 0; i2 < prefixes.length; i2++) {
    const prefixed = prefixes[i2] + name;
    if (prefixed in style) {
      return prefixCache[rawName] = prefixed;
    }
  }
  return rawName;
}
const xlinkNS = "http://www.w3.org/1999/xlink";
function patchAttr(el, key, value, isSVG, instance, isBoolean = isSpecialBooleanAttr(key)) {
  if (isSVG && key.startsWith("xlink:")) {
    if (value == null) {
      el.removeAttributeNS(xlinkNS, key.slice(6, key.length));
    } else {
      el.setAttributeNS(xlinkNS, key, value);
    }
  } else {
    if (value == null || isBoolean && !includeBooleanAttr(value)) {
      el.removeAttribute(key);
    } else {
      el.setAttribute(
        key,
        isBoolean ? "" : isSymbol$1(value) ? String(value) : value
      );
    }
  }
}
function patchDOMProp(el, key, value, parentComponent, attrName) {
  if (key === "innerHTML" || key === "textContent") {
    if (value != null) {
      el[key] = key === "innerHTML" ? unsafeToTrustedHTML(value) : value;
    }
    return;
  }
  const tag = el.tagName;
  if (key === "value" && tag !== "PROGRESS" && !tag.includes("-")) {
    const oldValue = tag === "OPTION" ? el.getAttribute("value") || "" : el.value;
    const newValue = value == null ? el.type === "checkbox" ? "on" : "" : String(value);
    if (oldValue !== newValue || !("_value" in el)) {
      el.value = newValue;
    }
    if (value == null) {
      el.removeAttribute(key);
    }
    el._value = value;
    return;
  }
  let needRemove = false;
  if (value === "" || value == null) {
    const type2 = typeof el[key];
    if (type2 === "boolean") {
      value = includeBooleanAttr(value);
    } else if (value == null && type2 === "string") {
      value = "";
      needRemove = true;
    } else if (type2 === "number") {
      value = 0;
      needRemove = true;
    }
  }
  try {
    el[key] = value;
  } catch (e) {
  }
  needRemove && el.removeAttribute(attrName || key);
}
function addEventListener(el, event, handler, options) {
  el.addEventListener(event, handler, options);
}
function removeEventListener(el, event, handler, options) {
  el.removeEventListener(event, handler, options);
}
const veiKey = Symbol("_vei");
function patchEvent(el, rawName, prevValue, nextValue, instance = null) {
  const invokers = el[veiKey] || (el[veiKey] = {});
  const existingInvoker = invokers[rawName];
  if (nextValue && existingInvoker) {
    existingInvoker.value = nextValue;
  } else {
    const [name, options] = parseName(rawName);
    if (nextValue) {
      const invoker = invokers[rawName] = createInvoker(
        nextValue,
        instance
      );
      addEventListener(el, name, invoker, options);
    } else if (existingInvoker) {
      removeEventListener(el, name, existingInvoker, options);
      invokers[rawName] = void 0;
    }
  }
}
const optionsModifierRE = /(?:Once|Passive|Capture)$/;
function parseName(name) {
  let options;
  if (optionsModifierRE.test(name)) {
    options = {};
    let m;
    while (m = name.match(optionsModifierRE)) {
      name = name.slice(0, name.length - m[0].length);
      options[m[0].toLowerCase()] = true;
    }
  }
  const event = name[2] === ":" ? name.slice(3) : hyphenate(name.slice(2));
  return [event, options];
}
let cachedNow = 0;
const p$1 = /* @__PURE__ */ Promise.resolve();
const getNow = () => cachedNow || (p$1.then(() => cachedNow = 0), cachedNow = Date.now());
function createInvoker(initialValue, instance) {
  const invoker = (e) => {
    if (!e._vts) {
      e._vts = Date.now();
    } else if (e._vts <= invoker.attached) {
      return;
    }
    callWithAsyncErrorHandling(
      patchStopImmediatePropagation(e, invoker.value),
      instance,
      5,
      [e]
    );
  };
  invoker.value = initialValue;
  invoker.attached = getNow();
  return invoker;
}
function patchStopImmediatePropagation(e, value) {
  if (isArray(value)) {
    const originalStop = e.stopImmediatePropagation;
    e.stopImmediatePropagation = () => {
      originalStop.call(e);
      e._stopped = true;
    };
    return value.map(
      (fn) => (e2) => !e2._stopped && fn && fn(e2)
    );
  } else {
    return value;
  }
}
const isNativeOn = (key) => key.charCodeAt(0) === 111 && key.charCodeAt(1) === 110 && key.charCodeAt(2) > 96 && key.charCodeAt(2) < 123;
const patchProp = (el, key, prevValue, nextValue, namespace, parentComponent) => {
  const isSVG = namespace === "svg";
  if (key === "class") {
    patchClass(el, nextValue, isSVG);
  } else if (key === "style") {
    patchStyle(el, prevValue, nextValue);
  } else if (isOn(key)) {
    if (!isModelListener(key)) {
      patchEvent(el, key, prevValue, nextValue, parentComponent);
    }
  } else if (key[0] === "." ? (key = key.slice(1), true) : key[0] === "^" ? (key = key.slice(1), false) : shouldSetAsProp(el, key, nextValue, isSVG)) {
    patchDOMProp(el, key, nextValue);
    if (!el.tagName.includes("-") && (key === "value" || key === "checked" || key === "selected")) {
      patchAttr(el, key, nextValue, isSVG, parentComponent, key !== "value");
    }
  } else if (el._isVueCE && (/[A-Z]/.test(key) || !isString$1(nextValue))) {
    patchDOMProp(el, camelize(key), nextValue, parentComponent, key);
  } else {
    if (key === "true-value") {
      el._trueValue = nextValue;
    } else if (key === "false-value") {
      el._falseValue = nextValue;
    }
    patchAttr(el, key, nextValue, isSVG);
  }
};
function shouldSetAsProp(el, key, value, isSVG) {
  if (isSVG) {
    if (key === "innerHTML" || key === "textContent") {
      return true;
    }
    if (key in el && isNativeOn(key) && isFunction(value)) {
      return true;
    }
    return false;
  }
  if (key === "spellcheck" || key === "draggable" || key === "translate") {
    return false;
  }
  if (key === "form") {
    return false;
  }
  if (key === "list" && el.tagName === "INPUT") {
    return false;
  }
  if (key === "type" && el.tagName === "TEXTAREA") {
    return false;
  }
  if (key === "width" || key === "height") {
    const tag = el.tagName;
    if (tag === "IMG" || tag === "VIDEO" || tag === "CANVAS" || tag === "SOURCE") {
      return false;
    }
  }
  if (isNativeOn(key) && isString$1(value)) {
    return false;
  }
  return key in el;
}
const positionMap = /* @__PURE__ */ new WeakMap();
const newPositionMap = /* @__PURE__ */ new WeakMap();
const moveCbKey = Symbol("_moveCb");
const enterCbKey = Symbol("_enterCb");
const decorate = (t2) => {
  delete t2.props.mode;
  return t2;
};
const TransitionGroupImpl = /* @__PURE__ */ decorate({
  name: "TransitionGroup",
  props: /* @__PURE__ */ extend({}, TransitionPropsValidators, {
    tag: String,
    moveClass: String
  }),
  setup(props, { slots }) {
    const instance = getCurrentInstance();
    const state = useTransitionState();
    let prevChildren;
    let children;
    onUpdated(() => {
      if (!prevChildren.length) {
        return;
      }
      const moveClass = props.moveClass || `${props.name || "v"}-move`;
      if (!hasCSSTransform(
        prevChildren[0].el,
        instance.vnode.el,
        moveClass
      )) {
        return;
      }
      prevChildren.forEach(callPendingCbs);
      prevChildren.forEach(recordPosition);
      const movedChildren = prevChildren.filter(applyTranslation);
      forceReflow();
      movedChildren.forEach((c) => {
        const el = c.el;
        const style = el.style;
        addTransitionClass(el, moveClass);
        style.transform = style.webkitTransform = style.transitionDuration = "";
        const cb = el[moveCbKey] = (e) => {
          if (e && e.target !== el) {
            return;
          }
          if (!e || /transform$/.test(e.propertyName)) {
            el.removeEventListener("transitionend", cb);
            el[moveCbKey] = null;
            removeTransitionClass(el, moveClass);
          }
        };
        el.addEventListener("transitionend", cb);
      });
    });
    return () => {
      const rawProps = toRaw(props);
      const cssTransitionProps = resolveTransitionProps(rawProps);
      let tag = rawProps.tag || Fragment;
      prevChildren = [];
      if (children) {
        for (let i2 = 0; i2 < children.length; i2++) {
          const child = children[i2];
          if (child.el && child.el instanceof Element) {
            prevChildren.push(child);
            setTransitionHooks(
              child,
              resolveTransitionHooks(
                child,
                cssTransitionProps,
                state,
                instance
              )
            );
            positionMap.set(
              child,
              child.el.getBoundingClientRect()
            );
          }
        }
      }
      children = slots.default ? getTransitionRawChildren(slots.default()) : [];
      for (let i2 = 0; i2 < children.length; i2++) {
        const child = children[i2];
        if (child.key != null) {
          setTransitionHooks(
            child,
            resolveTransitionHooks(child, cssTransitionProps, state, instance)
          );
        }
      }
      return createVNode(tag, null, children);
    };
  }
});
const TransitionGroup = TransitionGroupImpl;
function callPendingCbs(c) {
  const el = c.el;
  if (el[moveCbKey]) {
    el[moveCbKey]();
  }
  if (el[enterCbKey]) {
    el[enterCbKey]();
  }
}
function recordPosition(c) {
  newPositionMap.set(c, c.el.getBoundingClientRect());
}
function applyTranslation(c) {
  const oldPos = positionMap.get(c);
  const newPos = newPositionMap.get(c);
  const dx = oldPos.left - newPos.left;
  const dy = oldPos.top - newPos.top;
  if (dx || dy) {
    const s2 = c.el.style;
    s2.transform = s2.webkitTransform = `translate(${dx}px,${dy}px)`;
    s2.transitionDuration = "0s";
    return c;
  }
}
function hasCSSTransform(el, root, moveClass) {
  const clone = el.cloneNode();
  const _vtc = el[vtcKey];
  if (_vtc) {
    _vtc.forEach((cls) => {
      cls.split(/\s+/).forEach((c) => c && clone.classList.remove(c));
    });
  }
  moveClass.split(/\s+/).forEach((c) => c && clone.classList.add(c));
  clone.style.display = "none";
  const container = root.nodeType === 1 ? root : root.parentNode;
  container.appendChild(clone);
  const { hasTransform } = getTransitionInfo(clone);
  container.removeChild(clone);
  return hasTransform;
}
const getModelAssigner = (vnode) => {
  const fn = vnode.props["onUpdate:modelValue"] || false;
  return isArray(fn) ? (value) => invokeArrayFns(fn, value) : fn;
};
function onCompositionStart(e) {
  e.target.composing = true;
}
function onCompositionEnd(e) {
  const target = e.target;
  if (target.composing) {
    target.composing = false;
    target.dispatchEvent(new Event("input"));
  }
}
const assignKey = Symbol("_assign");
const vModelText = {
  created(el, { modifiers: { lazy, trim, number } }, vnode) {
    el[assignKey] = getModelAssigner(vnode);
    const castToNumber = number || vnode.props && vnode.props.type === "number";
    addEventListener(el, lazy ? "change" : "input", (e) => {
      if (e.target.composing)
        return;
      let domValue = el.value;
      if (trim) {
        domValue = domValue.trim();
      }
      if (castToNumber) {
        domValue = looseToNumber(domValue);
      }
      el[assignKey](domValue);
    });
    if (trim) {
      addEventListener(el, "change", () => {
        el.value = el.value.trim();
      });
    }
    if (!lazy) {
      addEventListener(el, "compositionstart", onCompositionStart);
      addEventListener(el, "compositionend", onCompositionEnd);
      addEventListener(el, "change", onCompositionEnd);
    }
  },
  mounted(el, { value }) {
    el.value = value == null ? "" : value;
  },
  beforeUpdate(el, { value, oldValue, modifiers: { lazy, trim, number } }, vnode) {
    el[assignKey] = getModelAssigner(vnode);
    if (el.composing)
      return;
    const elValue = (number || el.type === "number") && !/^0\d/.test(el.value) ? looseToNumber(el.value) : el.value;
    const newValue = value == null ? "" : value;
    if (elValue === newValue) {
      return;
    }
    if (document.activeElement === el && el.type !== "range") {
      if (lazy && value === oldValue) {
        return;
      }
      if (trim && el.value.trim() === newValue) {
        return;
      }
    }
    el.value = newValue;
  }
};
const vModelCheckbox = {
  deep: true,
  created(el, _2, vnode) {
    el[assignKey] = getModelAssigner(vnode);
    addEventListener(el, "change", () => {
      const modelValue = el._modelValue;
      const elementValue = getValue$1(el);
      const checked = el.checked;
      const assign = el[assignKey];
      if (isArray(modelValue)) {
        const index2 = looseIndexOf(modelValue, elementValue);
        const found = index2 !== -1;
        if (checked && !found) {
          assign(modelValue.concat(elementValue));
        } else if (!checked && found) {
          const filtered = [...modelValue];
          filtered.splice(index2, 1);
          assign(filtered);
        }
      } else if (isSet$1(modelValue)) {
        const cloned = new Set(modelValue);
        if (checked) {
          cloned.add(elementValue);
        } else {
          cloned.delete(elementValue);
        }
        assign(cloned);
      } else {
        assign(getCheckboxValue(el, checked));
      }
    });
  },
  mounted: setChecked,
  beforeUpdate(el, binding, vnode) {
    el[assignKey] = getModelAssigner(vnode);
    setChecked(el, binding, vnode);
  }
};
function setChecked(el, { value, oldValue }, vnode) {
  el._modelValue = value;
  let checked;
  if (isArray(value)) {
    checked = looseIndexOf(value, vnode.props.value) > -1;
  } else if (isSet$1(value)) {
    checked = value.has(vnode.props.value);
  } else {
    if (value === oldValue)
      return;
    checked = looseEqual(value, getCheckboxValue(el, true));
  }
  if (el.checked !== checked) {
    el.checked = checked;
  }
}
const vModelRadio = {
  created(el, { value }, vnode) {
    el.checked = looseEqual(value, vnode.props.value);
    el[assignKey] = getModelAssigner(vnode);
    addEventListener(el, "change", () => {
      el[assignKey](getValue$1(el));
    });
  },
  beforeUpdate(el, { value, oldValue }, vnode) {
    el[assignKey] = getModelAssigner(vnode);
    if (value !== oldValue) {
      el.checked = looseEqual(value, vnode.props.value);
    }
  }
};
const vModelSelect = {
  deep: true,
  created(el, { value, modifiers: { number } }, vnode) {
    const isSetModel = isSet$1(value);
    addEventListener(el, "change", () => {
      const selectedVal = Array.prototype.filter.call(el.options, (o2) => o2.selected).map(
        (o2) => number ? looseToNumber(getValue$1(o2)) : getValue$1(o2)
      );
      el[assignKey](
        el.multiple ? isSetModel ? new Set(selectedVal) : selectedVal : selectedVal[0]
      );
      el._assigning = true;
      nextTick(() => {
        el._assigning = false;
      });
    });
    el[assignKey] = getModelAssigner(vnode);
  },
  mounted(el, { value }) {
    setSelected(el, value);
  },
  beforeUpdate(el, _binding, vnode) {
    el[assignKey] = getModelAssigner(vnode);
  },
  updated(el, { value }) {
    if (!el._assigning) {
      setSelected(el, value);
    }
  }
};
function setSelected(el, value) {
  const isMultiple = el.multiple;
  const isArrayValue = isArray(value);
  if (isMultiple && !isArrayValue && !isSet$1(value)) {
    return;
  }
  for (let i2 = 0, l = el.options.length; i2 < l; i2++) {
    const option = el.options[i2];
    const optionValue = getValue$1(option);
    if (isMultiple) {
      if (isArrayValue) {
        const optionType = typeof optionValue;
        if (optionType === "string" || optionType === "number") {
          option.selected = value.some((v2) => String(v2) === String(optionValue));
        } else {
          option.selected = looseIndexOf(value, optionValue) > -1;
        }
      } else {
        option.selected = value.has(optionValue);
      }
    } else if (looseEqual(getValue$1(option), value)) {
      if (el.selectedIndex !== i2)
        el.selectedIndex = i2;
      return;
    }
  }
  if (!isMultiple && el.selectedIndex !== -1) {
    el.selectedIndex = -1;
  }
}
function getValue$1(el) {
  return "_value" in el ? el._value : el.value;
}
function getCheckboxValue(el, checked) {
  const key = checked ? "_trueValue" : "_falseValue";
  return key in el ? el[key] : checked;
}
const systemModifiers = ["ctrl", "shift", "alt", "meta"];
const modifierGuards = {
  stop: (e) => e.stopPropagation(),
  prevent: (e) => e.preventDefault(),
  self: (e) => e.target !== e.currentTarget,
  ctrl: (e) => !e.ctrlKey,
  shift: (e) => !e.shiftKey,
  alt: (e) => !e.altKey,
  meta: (e) => !e.metaKey,
  left: (e) => "button" in e && e.button !== 0,
  middle: (e) => "button" in e && e.button !== 1,
  right: (e) => "button" in e && e.button !== 2,
  exact: (e, modifiers) => systemModifiers.some((m) => e[`${m}Key`] && !modifiers.includes(m))
};
const withModifiers = (fn, modifiers) => {
  const cache = fn._withMods || (fn._withMods = {});
  const cacheKey = modifiers.join(".");
  return cache[cacheKey] || (cache[cacheKey] = (event, ...args) => {
    for (let i2 = 0; i2 < modifiers.length; i2++) {
      const guard = modifierGuards[modifiers[i2]];
      if (guard && guard(event, modifiers))
        return;
    }
    return fn(event, ...args);
  });
};
const keyNames = {
  esc: "escape",
  space: " ",
  up: "arrow-up",
  left: "arrow-left",
  right: "arrow-right",
  down: "arrow-down",
  delete: "backspace"
};
const withKeys = (fn, modifiers) => {
  const cache = fn._withKeys || (fn._withKeys = {});
  const cacheKey = modifiers.join(".");
  return cache[cacheKey] || (cache[cacheKey] = (event) => {
    if (!("key" in event)) {
      return;
    }
    const eventKey = hyphenate(event.key);
    if (modifiers.some(
      (k2) => k2 === eventKey || keyNames[k2] === eventKey
    )) {
      return fn(event);
    }
  });
};
const rendererOptions = /* @__PURE__ */ extend({ patchProp }, nodeOps);
let renderer;
function ensureRenderer() {
  return renderer || (renderer = createRenderer(rendererOptions));
}
const createApp = (...args) => {
  const app2 = ensureRenderer().createApp(...args);
  const { mount } = app2;
  app2.mount = (containerOrSelector) => {
    const container = normalizeContainer(containerOrSelector);
    if (!container)
      return;
    const component = app2._component;
    if (!isFunction(component) && !component.render && !component.template) {
      component.template = container.innerHTML;
    }
    if (container.nodeType === 1) {
      container.textContent = "";
    }
    const proxy = mount(container, false, resolveRootNamespace(container));
    if (container instanceof Element) {
      container.removeAttribute("v-cloak");
      container.setAttribute("data-v-app", "");
    }
    return proxy;
  };
  return app2;
};
function resolveRootNamespace(container) {
  if (container instanceof SVGElement) {
    return "svg";
  }
  if (typeof MathMLElement === "function" && container instanceof MathMLElement) {
    return "mathml";
  }
}
function normalizeContainer(container) {
  if (isString$1(container)) {
    const res = document.querySelector(container);
    return res;
  }
  return container;
}
const zfs = "";
const index$2 = "";
const index$1 = "";
var __defProp2 = Object.defineProperty;
var __defNormalProp2 = (obj, key, value) => key in obj ? __defProp2(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField2 = (obj, key, value) => __defNormalProp2(obj, typeof key !== "symbol" ? key + "" : key, value);
class ParsingError extends Error {
  constructor(...args) {
    super(...args);
    this.name = "ParsingError";
  }
}
class ProcessError extends Error {
  constructor(...args) {
    super(...args);
    this.name = "ProcessError";
  }
}
class NonZeroExit extends ProcessError {
  constructor(...args) {
    super(...args);
    this.name = "ProcessError (exited non-zero)";
  }
}
class UnknownHost extends ProcessError {
  constructor(...args) {
    super(...args);
    this.name = "ProcessError (unknown/untrusted host)";
  }
}
class NotFound extends ProcessError {
  constructor(...args) {
    super(...args);
    this.name = "ProcessError (not found)";
  }
}
class AuthenticationFailed extends ProcessError {
  constructor(...args) {
    super(...args);
    this.name = "ProcessError (authentication failed)";
  }
}
class ValueError extends Error {
  constructor(...args) {
    super(...args);
    this.name = "ValueError";
  }
}
class SilentError extends Error {
  constructor(...args) {
    super(...args);
    this.name = "SilentError";
  }
}
class CancelledByUser extends SilentError {
  constructor(...args) {
    super(...args);
    this.name = "CancelledByUser";
  }
}
const defaultErrorConfig$1 = {
  withStackTrace: false
};
const createNeverThrowError$1 = (message, result, config = defaultErrorConfig$1) => {
  const data = result.isOk() ? { type: "Ok", value: result.value } : { type: "Err", value: result.error };
  const maybeStack = config.withStackTrace ? new Error().stack : void 0;
  return {
    data,
    message,
    stack: maybeStack
  };
};
function __awaiter$1(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve2) {
      resolve2(value);
    });
  }
  return new (P || (P = Promise))(function(resolve2, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve2(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, [])).next());
  });
}
function __values$1(o2) {
  var s2 = typeof Symbol === "function" && Symbol.iterator, m = s2 && o2[s2], i2 = 0;
  if (m)
    return m.call(o2);
  if (o2 && typeof o2.length === "number")
    return {
      next: function() {
        if (o2 && i2 >= o2.length)
          o2 = void 0;
        return { value: o2 && o2[i2++], done: !o2 };
      }
    };
  throw new TypeError(s2 ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function __await$1(v2) {
  return this instanceof __await$1 ? (this.v = v2, this) : new __await$1(v2);
}
function __asyncGenerator$1(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g = generator.apply(thisArg, _arguments || []), i2, q = [];
  return i2 = {}, verb("next"), verb("throw"), verb("return"), i2[Symbol.asyncIterator] = function() {
    return this;
  }, i2;
  function verb(n) {
    if (g[n])
      i2[n] = function(v2) {
        return new Promise(function(a2, b2) {
          q.push([n, v2, a2, b2]) > 1 || resume(n, v2);
        });
      };
  }
  function resume(n, v2) {
    try {
      step(g[n](v2));
    } catch (e) {
      settle(q[0][3], e);
    }
  }
  function step(r2) {
    r2.value instanceof __await$1 ? Promise.resolve(r2.value.v).then(fulfill, reject) : settle(q[0][2], r2);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f2, v2) {
    if (f2(v2), q.shift(), q.length)
      resume(q[0][0], q[0][1]);
  }
}
function __asyncDelegator$1(o2) {
  var i2, p2;
  return i2 = {}, verb("next"), verb("throw", function(e) {
    throw e;
  }), verb("return"), i2[Symbol.iterator] = function() {
    return this;
  }, i2;
  function verb(n, f2) {
    i2[n] = o2[n] ? function(v2) {
      return (p2 = !p2) ? { value: __await$1(o2[n](v2)), done: n === "return" } : f2 ? f2(v2) : v2;
    } : f2;
  }
}
function __asyncValues$1(o2) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var m = o2[Symbol.asyncIterator], i2;
  return m ? m.call(o2) : (o2 = typeof __values$1 === "function" ? __values$1(o2) : o2[Symbol.iterator](), i2 = {}, verb("next"), verb("throw"), verb("return"), i2[Symbol.asyncIterator] = function() {
    return this;
  }, i2);
  function verb(n) {
    i2[n] = o2[n] && function(v2) {
      return new Promise(function(resolve2, reject) {
        v2 = o2[n](v2), settle(resolve2, reject, v2.done, v2.value);
      });
    };
  }
  function settle(resolve2, reject, d2, v2) {
    Promise.resolve(v2).then(function(v22) {
      resolve2({ value: v22, done: d2 });
    }, reject);
  }
}
class ResultAsync$1 {
  constructor(res) {
    this._promise = res;
  }
  static fromSafePromise(promise) {
    const newPromise = promise.then((value) => new Ok$1(value));
    return new ResultAsync$1(newPromise);
  }
  static fromPromise(promise, errorFn) {
    const newPromise = promise.then((value) => new Ok$1(value)).catch((e) => new Err$1(errorFn(e)));
    return new ResultAsync$1(newPromise);
  }
  static fromThrowable(fn, errorFn) {
    return (...args) => {
      return new ResultAsync$1((() => __awaiter$1(this, void 0, void 0, function* () {
        try {
          return new Ok$1(yield fn(...args));
        } catch (error) {
          return new Err$1(errorFn ? errorFn(error) : error);
        }
      }))());
    };
  }
  static combine(asyncResultList) {
    return combineResultAsyncList$1(asyncResultList);
  }
  static combineWithAllErrors(asyncResultList) {
    return combineResultAsyncListWithAllErrors$1(asyncResultList);
  }
  map(f2) {
    return new ResultAsync$1(this._promise.then((res) => __awaiter$1(this, void 0, void 0, function* () {
      if (res.isErr()) {
        return new Err$1(res.error);
      }
      return new Ok$1(yield f2(res.value));
    })));
  }
  mapErr(f2) {
    return new ResultAsync$1(this._promise.then((res) => __awaiter$1(this, void 0, void 0, function* () {
      if (res.isOk()) {
        return new Ok$1(res.value);
      }
      return new Err$1(yield f2(res.error));
    })));
  }
  andThen(f2) {
    return new ResultAsync$1(this._promise.then((res) => {
      if (res.isErr()) {
        return new Err$1(res.error);
      }
      const newValue = f2(res.value);
      return newValue instanceof ResultAsync$1 ? newValue._promise : newValue;
    }));
  }
  orElse(f2) {
    return new ResultAsync$1(this._promise.then((res) => __awaiter$1(this, void 0, void 0, function* () {
      if (res.isErr()) {
        return f2(res.error);
      }
      return new Ok$1(res.value);
    })));
  }
  match(ok2, _err) {
    return this._promise.then((res) => res.match(ok2, _err));
  }
  unwrapOr(t2) {
    return this._promise.then((res) => res.unwrapOr(t2));
  }
  safeUnwrap() {
    return __asyncGenerator$1(this, arguments, function* safeUnwrap_1() {
      return yield __await$1(yield __await$1(yield* __asyncDelegator$1(__asyncValues$1(yield __await$1(this._promise.then((res) => res.safeUnwrap()))))));
    });
  }
  then(successCallback, failureCallback) {
    return this._promise.then(successCallback, failureCallback);
  }
}
const okAsync$1 = (value) => new ResultAsync$1(Promise.resolve(new Ok$1(value)));
const errAsync$1 = (err2) => new ResultAsync$1(Promise.resolve(new Err$1(err2)));
ResultAsync$1.fromPromise;
ResultAsync$1.fromSafePromise;
ResultAsync$1.fromThrowable;
const appendValueToEndOfList$1 = (value) => (list) => [...list, value];
const combineResultList$1 = (resultList) => resultList.reduce((acc, result) => acc.isOk() ? result.isErr() ? err$1(result.error) : acc.map(appendValueToEndOfList$1(result.value)) : acc, ok$1([]));
const combineResultAsyncList$1 = (asyncResultList) => ResultAsync$1.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultList$1);
const combineResultListWithAllErrors$1 = (resultList) => resultList.reduce((acc, result) => result.isErr() ? acc.isErr() ? err$1([...acc.error, result.error]) : err$1([result.error]) : acc.isErr() ? acc : ok$1([...acc.value, result.value]), ok$1([]));
const combineResultAsyncListWithAllErrors$1 = (asyncResultList) => ResultAsync$1.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultListWithAllErrors$1);
var Result$1;
(function(Result2) {
  function fromThrowable(fn, errorFn) {
    return (...args) => {
      try {
        const result = fn(...args);
        return ok$1(result);
      } catch (e) {
        return err$1(errorFn ? errorFn(e) : e);
      }
    };
  }
  Result2.fromThrowable = fromThrowable;
  function combine(resultList) {
    return combineResultList$1(resultList);
  }
  Result2.combine = combine;
  function combineWithAllErrors(resultList) {
    return combineResultListWithAllErrors$1(resultList);
  }
  Result2.combineWithAllErrors = combineWithAllErrors;
})(Result$1 || (Result$1 = {}));
const ok$1 = (value) => new Ok$1(value);
const err$1 = (err2) => new Err$1(err2);
function safeTry(body) {
  const n = body().next();
  if (n instanceof Promise) {
    return n.then((r2) => r2.value);
  }
  return n.value;
}
class Ok$1 {
  constructor(value) {
    this.value = value;
  }
  isOk() {
    return true;
  }
  isErr() {
    return !this.isOk();
  }
  map(f2) {
    return ok$1(f2(this.value));
  }
  mapErr(_f) {
    return ok$1(this.value);
  }
  andThen(f2) {
    return f2(this.value);
  }
  orElse(_f) {
    return ok$1(this.value);
  }
  asyncAndThen(f2) {
    return f2(this.value);
  }
  asyncMap(f2) {
    return ResultAsync$1.fromSafePromise(f2(this.value));
  }
  unwrapOr(_v) {
    return this.value;
  }
  match(ok2, _err) {
    return ok2(this.value);
  }
  safeUnwrap() {
    const value = this.value;
    return function* () {
      return value;
    }();
  }
  _unsafeUnwrap(_2) {
    return this.value;
  }
  _unsafeUnwrapErr(config) {
    throw createNeverThrowError$1("Called `_unsafeUnwrapErr` on an Ok", this, config);
  }
}
class Err$1 {
  constructor(error) {
    this.error = error;
  }
  isOk() {
    return false;
  }
  isErr() {
    return !this.isOk();
  }
  map(_f) {
    return err$1(this.error);
  }
  mapErr(f2) {
    return err$1(f2(this.error));
  }
  andThen(_f) {
    return err$1(this.error);
  }
  orElse(f2) {
    return f2(this.error);
  }
  asyncAndThen(_f) {
    return errAsync$1(this.error);
  }
  asyncMap(_f) {
    return errAsync$1(this.error);
  }
  unwrapOr(v2) {
    return v2;
  }
  match(_ok, err2) {
    return err2(this.error);
  }
  safeUnwrap() {
    const error = this.error;
    return function* () {
      yield err$1(error);
      throw new Error("Do not use this generator out of `safeTry`");
    }();
  }
  _unsafeUnwrap(config) {
    throw createNeverThrowError$1("Called `_unsafeUnwrap` on an Err", this, config);
  }
  _unsafeUnwrapErr(_2) {
    return this.error;
  }
}
Result$1.fromThrowable;
var monet$1$1 = { exports: {} };
/**
 * Monet.js 0.9.3
 *
 * (c) 2012-2021 Chris Myers
 * @license Monet.js may be freely distributed under the MIT license.
 * For all details and documentation:
 * https://monet.github.io/monet.js/
 */
var monet$2 = monet$1$1.exports;
var hasRequiredMonet$1;
function requireMonet$1() {
  if (hasRequiredMonet$1)
    return monet$1$1.exports;
  hasRequiredMonet$1 = 1;
  (function(module) {
    (function(root, factory) {
      if (module.exports) {
        module.exports = factory(root);
      } else {
        root.Monet = factory(root);
      }
    })(typeof self !== "undefined" ? self : monet$2, function() {
      function assignImp(target, source) {
        for (var key in source) {
          if (source.hasOwnProperty(key) && source[key] !== void 0) {
            target[key] = source[key];
          }
        }
        return target;
      }
      var assign = isFunction2(Object.assign) ? Object.assign : assignImp;
      var Monet = {
        apply2,
        assign,
        compose,
        curry: curry(swap(curry), [])([]),
        idFunction,
        isFunction: isFunction2,
        noop,
        swap
      };
      var TYPE_KEY = "@@type";
      var LIB_NAME = "monet.js";
      var TYPES_NAMES = {
        Identity: "Identity",
        Maybe: "Maybe",
        Either: "Either",
        Validation: "Validation",
        List: "List",
        NEL: "NEL",
        IO: "IO",
        MonadT: "MonadT",
        Reader: "Reader",
        Free: "Free"
      };
      function setType(target, typeName) {
        target[TYPE_KEY] = LIB_NAME + "/" + typeName;
      }
      function isInstance(typeName) {
        return function(target) {
          return (target[TYPE_KEY] || target.constructor[TYPE_KEY]) === LIB_NAME + "/" + typeName;
        };
      }
      function isOfType(typeName) {
        return function(target) {
          var targetType = target[TYPE_KEY] || target.constructor && target.constructor[TYPE_KEY];
          return Boolean(targetType) && targetType.length >= typeName.length && targetType.indexOf(typeName) === targetType.length - typeName.length;
        };
      }
      function isNothing(value) {
        return value == null;
      }
      function isEmpty(value) {
        if (isNothing(value) || value === "") {
          return true;
        }
        if (Array.isArray(value) && value.length === 0) {
          return true;
        }
        if (typeof value === "object") {
          return Object.keys(value).length === 0;
        }
        return false;
      }
      function noop() {
      }
      function getArgs(args) {
        return Array.prototype.slice.call(args);
      }
      function curry(fn, args) {
        return function() {
          var args1 = args.concat(getArgs(arguments));
          return args1.length >= fn.length ? fn.apply(null, args1.slice(0, args1.length)) : curry(fn, args1);
        };
      }
      function compose(f2, g) {
        return function(x) {
          return f2(g(x));
        };
      }
      function isFunction2(f2) {
        return Boolean(f2 && f2.constructor && f2.call && f2.apply);
      }
      function idFunction(value) {
        return value;
      }
      function trueFunction() {
        return true;
      }
      function areEqual(a2, b2) {
        if (a2 === b2 || a2 !== a2 && b2 !== b2) {
          return true;
        }
        if (!a2 || !b2) {
          return false;
        }
        if (isFunction2(a2.equals) && isFunction2(b2.equals)) {
          return a2.equals(b2);
        }
        return false;
      }
      function equals(a2) {
        return function(b2) {
          return areEqual(a2, b2);
        };
      }
      function falseFunction() {
        return false;
      }
      function swap(f2) {
        return function(a2, b2) {
          return f2(b2, a2);
        };
      }
      function apply2(a1, a2, f2) {
        return a2.ap(a1.map(curry(f2, [])));
      }
      function listEquals(list1, list2) {
        var a2 = list1;
        var b2 = list2;
        while (!a2.isNil && !b2.isNil) {
          if (!equals(a2.head())(b2.head())) {
            return false;
          }
          a2 = a2.tail();
          b2 = b2.tail();
        }
        return a2.isNil && b2.isNil;
      }
      function listMapC(fn, l) {
        return l.isNil ? Return(l) : Suspend(function() {
          return listMapC(fn, l.tail());
        }).map(curry(cons, [])(fn(l.head())));
      }
      function listMap(fn, l) {
        return listMapC(fn, l).run();
      }
      function listFilter(list, fn) {
        return list.foldRight(Nil)(function(a2, acc) {
          return fn(a2) ? cons(a2, acc) : acc;
        });
      }
      function listFindC(l, fn) {
        if (l.isNil) {
          return Return(None());
        }
        var h2 = l.head();
        return fn(h2) ? Return(Some(h2)) : Suspend(function() {
          return listFindC(l.tail(), fn);
        });
      }
      function listFind(l, fn) {
        return listFindC(l, fn).run();
      }
      function listContainsC(l, val) {
        if (l.isNil) {
          return Return(false);
        }
        var h2 = l.head();
        return areEqual(h2, val) ? Return(true) : Suspend(function() {
          return listContainsC(l.tail(), val);
        });
      }
      function listContains(l, val) {
        return listContainsC(l, val).run();
      }
      function cons(head, tail) {
        return tail.cons(head);
      }
      function List() {
        switch (arguments.length) {
          case 0:
            return new List.fn.init();
          case 1:
            return new List.fn.init(arguments[0]);
          default:
            return new List.fn.init(arguments[0], arguments[1]);
        }
      }
      Monet.List = List;
      var listForEach = function(effectFn, l) {
        if (!l.isNil) {
          effectFn(l.head());
          listForEach(effectFn, l.tail());
        }
      };
      var foldLeft = function(fn, acc, list) {
        function fL(innerAcc, innerList) {
          return innerList.isNil ? Return(innerAcc) : Suspend(function() {
            return fL(fn(innerAcc, innerList.head()), innerList.tail());
          });
        }
        return fL(acc, list).run();
      };
      var foldRight = function(fn, list, acc) {
        function fR(innerList, innerAcc) {
          return innerList.isNil ? Return(innerAcc) : Suspend(function() {
            return fR(innerList.tail(), innerAcc);
          }).map(function(accumulated) {
            return fn(innerList.head(), accumulated);
          });
        }
        return fR(list, acc).run();
      };
      var append = function(self2, other) {
        function appendFree(listA, listB) {
          return listA.isNil ? Return(listB) : Suspend(function() {
            return appendFree(listA.tail(), listB).map(function(list) {
              return list.cons(listA.head());
            });
          });
        }
        return appendFree(self2, other).run();
      };
      var sequence = function(list, type2) {
        return list.foldRight(type2.of(Nil))(type2.map2(cons));
      };
      var sequenceValidation = function(list) {
        return list.foldLeft(Success(Nil))(function(acc, a2) {
          return acc.ap(a2.map(function(v2) {
            return function(t2) {
              return cons(v2, t2);
            };
          }));
        }).map(listReverse);
      };
      var listReverse = function(list) {
        return list.foldLeft(Nil)(swap(cons));
      };
      var listAp = function(list1, list2) {
        return list1.bind(function(x) {
          return list2.map(function(f2) {
            return f2(x);
          });
        });
      };
      var Nil;
      List.fn = List.prototype = {
        init: function() {
          var head = arguments[0];
          var tail = arguments[1];
          if (arguments.length === 0) {
            this.isNil = true;
            this.size_ = 0;
          } else {
            this.isNil = false;
            this.head_ = head;
            this.tail_ = tail || Nil;
            this.size_ = this.tail_.size() + 1;
          }
          setType(this, TYPES_NAMES.List);
        },
        of: function(value) {
          return new List(value);
        },
        size: function() {
          return this.size_;
        },
        equals: function(other) {
          return (List.isOfType(other) || NEL.isOfType(other)) && listEquals(this, other);
        },
        cons: function(head) {
          return List(head, this);
        },
        snoc: function(element) {
          return this.concat(List(element));
        },
        map: function(fn) {
          return listMap(fn, this);
        },
        toArray: function() {
          return foldLeft(function(acc, e) {
            acc.push(e);
            return acc;
          }, [], this);
        },
        toSet: function() {
          return new Set(this);
        },
        foldLeft: function(initialValue) {
          var self2 = this;
          return function(fn) {
            return foldLeft(fn, initialValue, self2);
          };
        },
        foldRight: function(initialValue) {
          var self2 = this;
          return function(fn) {
            return foldRight(fn, self2, initialValue);
          };
        },
        append: function(list2) {
          return append(this, list2);
        },
        filter: function(fn) {
          return listFilter(this, fn);
        },
        find: function(fn) {
          return listFind(this, fn);
        },
        flatten: function() {
          return foldRight(append, this, Nil);
        },
        flattenMaybe: function() {
          return this.flatMap(Maybe.toList);
        },
        reverse: function() {
          return listReverse(this);
        },
        bind: function(fn) {
          return this.map(fn).flatten();
        },
        forEach: function(effectFn) {
          listForEach(effectFn, this);
        },
        contains: function(val) {
          return listContains(this, val);
        },
        sequenceMaybe: function() {
          return sequence(this, Maybe);
        },
        sequenceValidation: function() {
          return sequenceValidation(this);
        },
        sequenceEither: function() {
          return sequence(this, Either);
        },
        sequenceIO: function() {
          return sequence(this, IO);
        },
        sequenceReader: function() {
          return sequence(this, Reader);
        },
        sequence: function(monadType) {
          return sequence(this, monadType);
        },
        head: function() {
          return this.head_;
        },
        headMaybe: function() {
          return this.isNil ? None() : Some(this.head_);
        },
        lookup: function(i2) {
          return this.isNil || i2 >= this.size() ? None() : Maybe.fromNull(this.toArray()[i2]);
        },
        nth: function(i2) {
          return this.isNil || i2 >= this.size() ? void 0 : this.toArray()[i2];
        },
        tail: function() {
          return this.isNil ? Nil : this.tail_;
        },
        tails: function() {
          return this.isNil ? List(Nil, Nil) : this.tail().tails().cons(this);
        },
        ap: function(list) {
          return listAp(this, list);
        },
        apTo: function(listWithValues) {
          return listAp(listWithValues, this);
        },
        isNEL: falseFunction,
        toString: function() {
          return this.isNil ? "Nil" : "List(" + this.toArray().join(", ") + ")";
        },
        inspect: function() {
          return this.toString();
        }
      };
      List.fn.init.prototype = List.fn;
      setType(List, TYPES_NAMES.List);
      setType(List.fn.init, TYPES_NAMES.List);
      List.isInstance = isInstance(TYPES_NAMES.List);
      List.isOfType = isOfType(TYPES_NAMES.List);
      List.prototype.empty = function() {
        return Nil;
      };
      List.fromArray = function(array) {
        return array.reduceRight(function(acc, next) {
          return acc.cons(next);
        }, Nil);
      };
      List.from = function(iterable) {
        return List.fromArray(Array.from(iterable));
      };
      List.of = function(a2) {
        return new List(a2, Nil);
      };
      List.prototype.each = List.prototype.forEach;
      Nil = Monet.Nil = new List.fn.init();
      function emptyNELError(head) {
        return new Error("Cannot create an empty Non-Empty List. Passed head is " + head + ".");
      }
      function NEL(head, tail) {
        if (isNothing(head)) {
          throw emptyNELError(head);
        }
        return new NEL.fn.init(head, tail);
      }
      Monet.NEL = Monet.NonEmptyList = NEL;
      NEL.of = function(a2) {
        return NEL(a2, Nil);
      };
      NEL.fn = NEL.prototype = {
        init: function(head, tail) {
          if (isNothing(head)) {
            throw emptyNELError(head);
          } else {
            this.isNil = false;
            this.head_ = head;
            this.tail_ = isNothing(tail) ? Nil : tail;
            this.size_ = this.tail_.size() + 1;
          }
          setType(this, TYPES_NAMES.NEL);
        },
        equals: function(other) {
          return List.isOfType(other) || NEL.isOfType(other) && listEquals(this, other);
        },
        cons: function(head) {
          return NEL(head, this.toList());
        },
        snoc: function(element) {
          return this.concat(NEL(element));
        },
        map: function(fn) {
          return NEL(fn(this.head_), listMap(fn, this.tail_));
        },
        bind: function(fn) {
          var p2 = fn(this.head_);
          if (!p2.isNEL()) {
            throw new Error("NEL.fn.bind: Passed function must return a NonEmptyList.");
          }
          var list = this.tail().foldLeft(Nil.snoc(p2.head()).append(p2.tail()))(function(acc, e) {
            var list2 = fn(e).toList();
            return acc.snoc(list2.head()).append(list2.tail());
          });
          return new NEL(list.head(), list.tail());
        },
        head: function() {
          return this.head_;
        },
        lookup: function(i2) {
          return i2 >= this.size() ? None() : Maybe.fromNull(this.toArray()[i2]);
        },
        nth: function(i2) {
          return i2 >= this.size() ? void 0 : this.toArray()[i2];
        },
        tail: function() {
          return this.tail_;
        },
        tails: function() {
          var listsOfNels = this.toList().tails().map(NEL.fromList).flattenMaybe();
          return NEL(listsOfNels.head(), listsOfNels.tail());
        },
        toList: function() {
          return List(this.head_, this.tail_);
        },
        reverse: function() {
          if (this.tail().isNil) {
            return this;
          }
          var reversedTail = this.tail().reverse();
          return NEL(reversedTail.head(), reversedTail.tail().append(List(this.head())));
        },
        foldLeft: function(initialValue) {
          return this.toList().foldLeft(initialValue);
        },
        foldRight: function(initialValue) {
          return this.toList().foldRight(initialValue);
        },
        reduceLeft: function(fn) {
          return this.tail().foldLeft(this.head())(fn);
        },
        filter: function(fn) {
          return listFilter(this.toList(), fn);
        },
        find: function(fn) {
          return listFind(this.toList(), fn);
        },
        flatten: function() {
          return foldRight(append, this.toList().map(function(l) {
            return l.isNEL() ? l.toList() : l;
          }), Nil);
        },
        flattenMaybe: function() {
          return this.toList().flatMap(Maybe.toList);
        },
        contains: function(val) {
          return listContains(this.toList(), val);
        },
        append: function(list2) {
          return NEL.fromList(this.toList().append(list2.toList())).some();
        },
        cobind: function(fn) {
          return this.cojoin().map(fn);
        },
        size: function() {
          return this.size_;
        },
        forEach: function(fn) {
          return this.toList().forEach(fn);
        },
        isNEL: trueFunction,
        toString: function() {
          return "NEL(" + this.toArray().join(", ") + ")";
        },
        inspect: function() {
          return this.toString();
        }
      };
      NEL.fromList = function(list) {
        return list.isNil ? None() : Some(NEL(list.head(), list.tail()));
      };
      NEL.fromArray = function(array) {
        return NEL.fromList(List.fromArray(array));
      };
      NEL.from = function(iterable) {
        return NEL.fromList(List.from(iterable));
      };
      NEL.fn.init.prototype = NEL.fn;
      setType(NEL, TYPES_NAMES.NEL);
      setType(NEL.fn.init, TYPES_NAMES.NEL);
      NEL.isInstance = isInstance(TYPES_NAMES.NEL);
      NEL.isOfType = isOfType(TYPES_NAMES.NEL);
      NEL.prototype.toArray = List.prototype.toArray;
      NEL.prototype.toSet = List.prototype.toSet;
      NEL.prototype.extract = NEL.prototype.copure = NEL.prototype.head;
      NEL.prototype.cojoin = NEL.prototype.tails;
      NEL.prototype.coflatMap = NEL.prototype.mapTails = NEL.prototype.cobind;
      NEL.prototype.ap = List.prototype.ap;
      NEL.prototype.apTo = List.prototype.apTo;
      var Maybe = Monet.Maybe = {};
      Maybe.fromFalsy = function(val) {
        return !val ? Maybe.None() : Maybe.Some(val);
      };
      Maybe.fromNull = function(val) {
        return isNothing(val) ? Maybe.None() : Maybe.Some(val);
      };
      Maybe.fromUndefined = function(val) {
        return val === void 0 ? Maybe.None() : Maybe.Some(val);
      };
      Maybe.fromEmpty = function(val) {
        return isEmpty(val) ? Maybe.None() : Maybe.Some(val);
      };
      Maybe.of = function(a2) {
        return Some(a2);
      };
      var Some = Maybe.Just = Maybe.Some = Maybe.some = Monet.Some = Monet.Just = function(val) {
        return new Maybe.fn.init(true, val);
      };
      var None = Maybe.Nothing = Maybe.None = Maybe.none = Monet.None = Monet.Nothing = function() {
        return new Maybe.fn.init(false, null);
      };
      Maybe.toList = function(maybe) {
        return maybe.toList();
      };
      Maybe.fn = Maybe.prototype = {
        init: function(isValue, val) {
          this.isValue = isValue;
          if (isValue && isNothing(val)) {
            throw new Error("Can not create Some with illegal value: " + val + ".");
          }
          this.val = val;
          setType(this, TYPES_NAMES.Maybe);
        },
        isSome: function() {
          return this.isValue;
        },
        isNone: function() {
          return !this.isSome();
        },
        bind: function(bindFn) {
          return this.isValue ? bindFn(this.val) : this;
        },
        some: function() {
          if (this.isValue) {
            return this.val;
          }
          throw new Error("Cannot call .some() on a None.");
        },
        orSome: function(otherValue) {
          return this.isValue ? this.val : otherValue;
        },
        orLazy: function(getOtherValue) {
          return this.cata(getOtherValue, idFunction);
        },
        orNull: function() {
          return this.orSome(null);
        },
        orUndefined: function() {
          return this.orSome(void 0);
        },
        orElse: function(maybe) {
          return this.catchMap(function() {
            return maybe;
          });
        },
        ap: function(maybeWithFunction) {
          var value = this.val;
          return this.isValue ? maybeWithFunction.map(function(fn) {
            return fn(value);
          }) : this;
        },
        apTo: function(maybeWithValue) {
          return maybeWithValue.ap(this);
        },
        equals: function(other) {
          return Maybe.isOfType(other) && this.cata(function() {
            return other.isNone();
          }, function(val) {
            return other.fold(false)(equals(val));
          });
        },
        toArray: function() {
          return this.map(function(val) {
            return [val];
          }).orLazy(function() {
            return [];
          });
        },
        toSet: function() {
          return new Set(this);
        },
        toList: function() {
          return this.map(List).orLazy(function() {
            return Nil;
          });
        },
        toEither: function(failVal) {
          return this.isSome() ? Right(this.val) : Left(failVal);
        },
        toValidation: function(failVal) {
          return this.isSome() ? Success(this.val) : Fail(failVal);
        },
        fold: function(defaultValue) {
          var self2 = this;
          return function(fn) {
            return self2.isSome() ? fn(self2.val) : defaultValue;
          };
        },
        foldLeft: function(initialValue) {
          return this.toList().foldLeft(initialValue);
        },
        foldRight: function(initialValue) {
          return this.toList().foldRight(initialValue);
        },
        cata: function(none, some) {
          return this.isSome() ? some(this.val) : none();
        },
        catchMap: function(fn) {
          return this.isSome() ? this : fn();
        },
        filter: function(fn) {
          var self2 = this;
          return self2.flatMap(function(a2) {
            return fn(a2) ? self2 : None();
          });
        },
        orNoneIf: function(bool) {
          return bool ? None() : this;
        },
        contains: function(val) {
          return this.isSome() ? areEqual(this.val, val) : false;
        },
        forEach: function(fn) {
          this.cata(noop, fn);
        },
        orElseRun: function(fn) {
          this.cata(fn, noop);
        },
        toString: function() {
          return this.isSome() ? "Just(" + this.val + ")" : "Nothing";
        },
        inspect: function() {
          return this.toString();
        }
      };
      Maybe.prototype.orJust = Maybe.prototype.getOrElse = Maybe.prototype.orSome;
      Maybe.prototype.just = Maybe.prototype.some;
      Maybe.prototype.isJust = Maybe.prototype.isSome;
      Maybe.prototype.isNothing = Maybe.prototype.isNone;
      Maybe.prototype.orNothingIf = Maybe.prototype.orNoneIf;
      Maybe.fn.init.prototype = Maybe.fn;
      setType(Maybe, TYPES_NAMES.Maybe);
      setType(Maybe.fn.init, TYPES_NAMES.Maybe);
      Maybe.isInstance = isInstance(TYPES_NAMES.Maybe);
      Maybe.isOfType = isOfType(TYPES_NAMES.Maybe);
      var Validation = Monet.Validation = {};
      var Success = Validation.Success = Validation.success = Monet.Success = function(val) {
        return new Validation.fn.init(val, true);
      };
      var Fail = Validation.Fail = Validation.fail = Monet.Fail = function(error) {
        return new Validation.fn.init(error, false);
      };
      Validation.of = function(v2) {
        return Success(v2);
      };
      Validation.fn = Validation.prototype = {
        init: function(val, success) {
          this.val = val;
          this.isSuccessValue = success;
          setType(this, TYPES_NAMES.Validation);
        },
        success: function() {
          if (this.isSuccess()) {
            return this.val;
          }
          throw new Error("Cannot call success() on a Fail.");
        },
        isSuccess: function() {
          return this.isSuccessValue;
        },
        isFail: function() {
          return !this.isSuccessValue;
        },
        fail: function() {
          if (this.isSuccess()) {
            throw new Error("Cannot call fail() on a Success.");
          }
          return this.val;
        },
        bind: function(fn) {
          return this.isSuccess() ? fn(this.val) : this;
        },
        ap: function(validationWithFn) {
          var value = this.val;
          return this.isSuccess() ? validationWithFn.map(function(fn) {
            return fn(value);
          }) : validationWithFn.isFail() ? Validation.Fail(Semigroup.append(value, validationWithFn.fail())) : this;
        },
        apTo: function(validationWithValue) {
          return validationWithValue.ap(this);
        },
        acc: function() {
          var x = function() {
            return x;
          };
          return this.isSuccessValue ? Validation.success(x) : this;
        },
        foldLeft: function(initialValue) {
          return this.toMaybe().toList().foldLeft(initialValue);
        },
        foldRight: function(initialValue) {
          return this.toMaybe().toList().foldRight(initialValue);
        },
        cata: function(fail, success) {
          return this.isSuccessValue ? success(this.val) : fail(this.val);
        },
        catchMap: function(fn) {
          return this.isSuccess() ? this : fn(this.val);
        },
        swap: function() {
          return this.isSuccess() ? Fail(this.val) : Success(this.val);
        },
        failMap: function(fn) {
          return this.isFail() ? Fail(fn(this.val)) : this;
        },
        bimap: function(fail, success) {
          return this.isSuccessValue ? this.map(success) : this.failMap(fail);
        },
        forEach: function(fn) {
          this.cata(noop, fn);
        },
        forEachFail: function(fn) {
          this.cata(fn, noop);
        },
        equals: function(other) {
          return Validation.isOfType(other) && this.cata(function(fail) {
            return other.cata(equals(fail), falseFunction);
          }, function(success) {
            return other.cata(falseFunction, equals(success));
          });
        },
        toMaybe: function() {
          return this.isSuccess() ? Some(this.val) : None();
        },
        toEither: function() {
          return (this.isSuccess() ? Right : Left)(this.val);
        },
        toString: function() {
          return (this.isSuccess() ? "Success(" : "Fail(") + this.val + ")";
        },
        inspect: function() {
          return this.toString();
        }
      };
      Validation.prototype.fold = Validation.prototype.cata;
      Validation.fn.init.prototype = Validation.fn;
      setType(Validation, TYPES_NAMES.Validation);
      setType(Validation.fn.init, TYPES_NAMES.Validation);
      Validation.isInstance = isInstance(TYPES_NAMES.Validation);
      Validation.isOfType = isOfType(TYPES_NAMES.Validation);
      var Semigroup = Monet.Semigroup = {
        append: function(a2, b2) {
          if (isFunction2(a2.concat)) {
            return a2.concat(b2);
          }
          throw new Error("Couldn't find a semigroup appender in the environment, please specify your own append function");
        }
      };
      var MonadT = Monet.monadTransformer = Monet.MonadT = Monet.monadT = function(monad) {
        return new MonadT.fn.init(monad);
      };
      MonadT.of = function(m) {
        return MonadT(m);
      };
      MonadT.fn = MonadT.prototype = {
        init: function(monad) {
          this.monad = monad;
          setType(Validation, TYPES_NAMES.MonadT);
        },
        map: function(fn) {
          return MonadT(this.monad.map(function(v2) {
            return v2.map(fn);
          }));
        },
        bind: function(fn) {
          return MonadT(this.monad.map(function(v2) {
            return v2.flatMap(fn);
          }));
        },
        ap: function(monadWithFn) {
          return MonadT(this.monad.flatMap(function(v2) {
            return monadWithFn.perform().map(function(v22) {
              return v2.ap(v22);
            });
          }));
        },
        perform: function() {
          return this.monad;
        }
      };
      MonadT.fn.init.prototype = MonadT.fn;
      var IO = Monet.IO = Monet.io = function(effectFn) {
        return new IO.fn.init(effectFn);
      };
      IO.of = function(a2) {
        return IO(function() {
          return a2;
        });
      };
      IO.fn = IO.prototype = {
        init: function(effectFn) {
          if (!isFunction2(effectFn)) {
            throw new Error("IO requires a function.");
          }
          this.effectFn = effectFn;
          setType(this, TYPES_NAMES.IO);
        },
        map: function(fn) {
          var self2 = this;
          return IO(function() {
            return fn(self2.effectFn());
          });
        },
        bind: function(fn) {
          var self2 = this;
          return IO(function() {
            return fn(self2.effectFn()).run();
          });
        },
        ap: function(ioWithFn) {
          var self2 = this;
          return ioWithFn.map(function(fn) {
            return fn(self2.effectFn());
          });
        },
        apTo: function(ioWithValue) {
          return ioWithValue.ap(this);
        },
        run: function() {
          return this.effectFn();
        }
      };
      IO.fn.init.prototype = IO.fn;
      setType(IO, TYPES_NAMES.IO);
      setType(IO.fn.init, TYPES_NAMES.IO);
      IO.isInstance = isInstance(TYPES_NAMES.IO);
      IO.isOfType = isOfType(TYPES_NAMES.IO);
      IO.prototype.perform = IO.prototype.performUnsafeIO = IO.prototype.run;
      var Either = Monet.Either = {};
      Either.of = function(a2) {
        return Right(a2);
      };
      Either.fromTry = function(fn) {
        try {
          return Either.right(fn());
        } catch (e) {
          return Either.left(e);
        }
      };
      Either.fromPromise = function(promise) {
        return promise.then(Either.Right, Either.Left);
      };
      var Right = Either.Right = Either.right = Monet.Right = function(val) {
        return new Either.fn.init(val, true);
      };
      var Left = Either.Left = Either.left = Monet.Left = function(val) {
        return new Either.fn.init(val, false);
      };
      Either.fn = Either.prototype = {
        init: function(val, isRightValue) {
          this.isRightValue = isRightValue;
          this.value = val;
          setType(this, TYPES_NAMES.Either);
        },
        bind: function(fn) {
          return this.isRightValue ? fn(this.value) : this;
        },
        ap: function(eitherWithFn) {
          var self2 = this;
          return this.isRightValue ? eitherWithFn.map(function(fn) {
            return fn(self2.value);
          }) : this;
        },
        apTo: function(eitherWithValue) {
          return eitherWithValue.ap(this);
        },
        leftMap: function(fn) {
          return this.isLeft() ? Left(fn(this.value)) : this;
        },
        isRight: function() {
          return this.isRightValue;
        },
        isLeft: function() {
          return !this.isRight();
        },
        right: function() {
          if (this.isRightValue) {
            return this.value;
          }
          throw new Error("Cannot call right() on a Left.");
        },
        left: function() {
          if (this.isRightValue) {
            throw new Error("Cannot call left() on a Right.");
          }
          return this.value;
        },
        foldLeft: function(initialValue) {
          return this.toMaybe().toList().foldLeft(initialValue);
        },
        foldRight: function(initialValue) {
          return this.toMaybe().toList().foldRight(initialValue);
        },
        cata: function(leftFn, rightFn) {
          return this.isRightValue ? rightFn(this.value) : leftFn(this.value);
        },
        catchMap: function(fn) {
          return this.isRight() ? this : fn(this.value);
        },
        swap: function() {
          return this.isRight() ? Left(this.value) : Right(this.value);
        },
        forEach: function(fn) {
          this.cata(noop, fn);
        },
        forEachLeft: function(fn) {
          this.cata(fn, noop);
        },
        equals: function(other) {
          return Either.isOfType(other) && this.cata(function(left) {
            return other.cata(equals(left), falseFunction);
          }, function(right) {
            return other.cata(falseFunction, equals(right));
          });
        },
        bimap: function(leftFn, rightFn) {
          return this.isRightValue ? this.map(rightFn) : this.leftMap(leftFn);
        },
        toMaybe: function() {
          return this.isRight() ? Some(this.value) : None();
        },
        toValidation: function() {
          return this.isRight() ? Success(this.value) : Fail(this.value);
        },
        toString: function() {
          return this.cata(function(left) {
            return "Left(" + left + ")";
          }, function(right) {
            return "Right(" + right + ")";
          });
        },
        toPromise: function() {
          return this.cata(function(left) {
            return Promise.reject(left);
          }, function(right) {
            return Promise.resolve(right);
          });
        },
        inspect: function() {
          return this.toString();
        }
      };
      Either.prototype.fold = Either.prototype.cata;
      Either.fn.init.prototype = Either.fn;
      setType(Either, TYPES_NAMES.Either);
      setType(Either.fn.init, TYPES_NAMES.Either);
      Either.isInstance = isInstance(TYPES_NAMES.Either);
      Either.isOfType = isOfType(TYPES_NAMES.Either);
      var Reader = Monet.Reader = function(fn) {
        return new Reader.fn.init(fn);
      };
      Reader.of = function(x) {
        return Reader(function(_2) {
          return x;
        });
      };
      Reader.ask = function() {
        return Reader(idFunction);
      };
      Reader.fn = Reader.prototype = {
        init: function(fn) {
          this.f = fn;
          setType(this, TYPES_NAMES.Reader);
        },
        run: function(config) {
          return this.f(config);
        },
        bind: function(fn) {
          var self2 = this;
          return Reader(function(config) {
            return fn(self2.run(config)).run(config);
          });
        },
        ap: function(readerWithFn) {
          var self2 = this;
          return readerWithFn.bind(function(fn) {
            return Reader(function(config) {
              return fn(self2.run(config));
            });
          });
        },
        apTo: function(readerWithValue) {
          return readerWithValue.ap(this);
        },
        map: function(fn) {
          var self2 = this;
          return Reader(function(config) {
            return fn(self2.run(config));
          });
        },
        local: function(fn) {
          var self2 = this;
          return Reader(function(c) {
            return self2.run(fn(c));
          });
        }
      };
      Reader.fn.init.prototype = Reader.fn;
      setType(Reader, TYPES_NAMES.Reader);
      setType(Reader.fn.init, TYPES_NAMES.Reader);
      Reader.isInstance = isInstance(TYPES_NAMES.Reader);
      Reader.isOfType = isOfType(TYPES_NAMES.Reader);
      var Free = Monet.Free = {};
      var Suspend = Free.Suspend = Monet.Suspend = function(functor) {
        return new Free.fn.init(functor, true);
      };
      var Return = Free.Return = Monet.Return = function(val) {
        return new Free.fn.init(val, false);
      };
      Free.of = function(a2) {
        return Return(a2);
      };
      Free.liftF = function(functor) {
        return isFunction2(functor) ? Suspend(compose(Return, functor)) : Suspend(functor.map(Return));
      };
      Free.fn = Free.prototype = {
        init: function(val, isSuspend) {
          this.isSuspend = isSuspend;
          if (isSuspend) {
            this.functor = val;
          } else {
            this.val = val;
          }
          setType(this, TYPES_NAMES.Free);
        },
        run: function() {
          return this.go(function(f2) {
            return f2();
          });
        },
        bind: function(fn) {
          return this.isSuspend ? isFunction2(this.functor) ? Suspend(compose(function(free) {
            return free.bind(fn);
          }, this.functor)) : Suspend(this.functor.map(function(free) {
            return free.bind(fn);
          })) : fn(this.val);
        },
        ap: function(ff) {
          return this.bind(function(x) {
            return ff.map(function(f2) {
              return f2(x);
            });
          });
        },
        apTo: function(f2) {
          return f2.ap(this);
        },
        resume: function() {
          return this.isSuspend ? Left(this.functor) : Right(this.val);
        },
        go1: function(f2) {
          function go2(t2) {
            return t2.resume().cata(function(functor) {
              return go2(f2(functor));
            }, idFunction);
          }
          return go2(this);
        },
        go: function(f2) {
          var result = this.resume();
          while (result.isLeft()) {
            var next = f2(result.left());
            result = next.resume();
          }
          return result.right();
        }
      };
      Free.fn.init.prototype = Free.fn;
      setType(Free, TYPES_NAMES.Free);
      setType(Free.fn.init, TYPES_NAMES.Free);
      Free.isInstance = isInstance(TYPES_NAMES.Free);
      Free.isOfType = isOfType(TYPES_NAMES.Free);
      function Identity2(a2) {
        return new Identity2.fn.init(a2);
      }
      Monet.Identity = Identity2;
      Identity2.of = function(a2) {
        return new Identity2(a2);
      };
      Identity2.fn = Identity2.prototype = {
        init: function(val) {
          this.val = val;
          setType(this, TYPES_NAMES.Identity);
        },
        bind: function(fn) {
          return fn(this.val);
        },
        get: function() {
          return this.val;
        },
        forEach: function(fn) {
          fn(this.val);
        },
        equals: function(other) {
          return Identity2.isOfType(other) && equals(this.get())(other.get());
        },
        contains: function(val) {
          return areEqual(this.val, val);
        },
        toString: function() {
          return "Identity(" + this.val + ")";
        },
        inspect: function() {
          return this.toString();
        },
        ap: function(applyWithFunction) {
          var value = this.val;
          return applyWithFunction.map(function(fn) {
            return fn(value);
          });
        },
        apTo: function(identityWithValue) {
          return identityWithValue.ap(this);
        },
        toArray: function() {
          return [this.get()];
        },
        toList: function() {
          return List(this.get(), Nil);
        },
        toSet: function() {
          return new Set(this);
        }
      };
      Identity2.fn.init.prototype = Identity2.fn;
      setType(Identity2, TYPES_NAMES.Identity);
      setType(Identity2.fn.init, TYPES_NAMES.Identity);
      Identity2.isInstance = isInstance(TYPES_NAMES.Identity);
      Identity2.isOfType = isOfType(TYPES_NAMES.Identity);
      function addFantasyLandAliases(type2) {
        ["equals", "map", "ap", "chain"].filter(function(method) {
          return isFunction2(type2.prototype[method]);
        }).forEach(function(method) {
          type2.prototype["fantasy-land/" + method] = type2.prototype[method];
        });
      }
      function addAliases(type2) {
        type2.prototype.flatMap = type2.prototype.chain = type2.prototype.bind;
        type2.pure = type2.unit = type2.of;
        type2.prototype.of = type2.of;
        if (isFunction2(type2.prototype.append)) {
          type2.prototype.concat = type2.prototype.append;
        }
        type2.prototype.point = type2.prototype.pure = type2.prototype.unit = type2.prototype.of;
      }
      function addFilterNot(type2) {
        if (isFunction2(type2.prototype.filter)) {
          type2.prototype.filterNot = function(fn) {
            return this.filter(function(a2) {
              return !fn(a2);
            });
          };
        }
      }
      function addMonadOps(type2) {
        type2.prototype.join = function() {
          return this.flatMap(idFunction);
        };
        type2.map2 = function(fn) {
          return function(ma, mb) {
            return ma.flatMap(function(a2) {
              return mb.map(function(b2) {
                return fn(a2, b2);
              });
            });
          };
        };
      }
      function addFunctorOps(type2) {
        if (!isFunction2(type2.prototype.map)) {
          type2.prototype.map = function(fn) {
            return this.bind(compose(this.of, fn));
          };
        }
      }
      function addApplicativeOps(type2) {
        type2.prototype.takeLeft = function(m) {
          return apply2(this, m, function(a2, b2) {
            return a2;
          });
        };
        type2.prototype.takeRight = function(m) {
          return apply2(this, m, function(a2, b2) {
            return b2;
          });
        };
      }
      function addCollectionPredicates(type2) {
        if (isFunction2(type2.prototype.toArray)) {
          type2.prototype.every = type2.prototype.forall = function(fn) {
            return this.toArray().every(fn);
          };
          type2.prototype.exists = function(fn) {
            return this.toArray().some(fn);
          };
        }
      }
      function makeIterable(type2) {
        if (isFunction2(type2.prototype.toArray)) {
          type2.prototype[Symbol.iterator] = function() {
            return this.toArray()[Symbol.iterator]();
          };
        }
      }
      function addToOperator(type2) {
        if (isFunction2(type2.prototype.toArray)) {
          type2.prototype.to = function(ctor) {
            return ctor(this);
          };
        }
      }
      function decorate2(type2) {
        addAliases(type2);
        addFilterNot(type2);
        addMonadOps(type2);
        addFunctorOps(type2);
        addApplicativeOps(type2);
        addCollectionPredicates(type2);
        addFantasyLandAliases(type2);
        makeIterable(type2);
        addToOperator(type2);
      }
      decorate2(MonadT);
      decorate2(Either);
      decorate2(Maybe);
      decorate2(IO);
      decorate2(NEL);
      decorate2(List);
      decorate2(Validation);
      decorate2(Reader);
      decorate2(Free);
      decorate2(Identity2);
      return Monet;
    });
  })(monet$1$1);
  return monet$1$1.exports;
}
var monetExports = requireMonet$1();
const utf8Decoder = new TextDecoder("utf-8", { fatal: false });
const utf8Encoder = new TextEncoder();
class Command {
  constructor(argv, opts = {}) {
    __publicField2(this, "argv");
    __publicField2(this, "spawnOptions");
    this.argv = argv;
    this.spawnOptions = {
      ...opts,
      binary: true,
      err: "message"
    };
  }
  getName() {
    var _a2;
    return (_a2 = this.argv[0]) != null ? _a2 : "";
  }
  toString() {
    return `Command(${JSON.stringify(this.argv)}, ${JSON.stringify(this.spawnOptions)})`;
  }
}
class BashCommand extends Command {
  constructor(script, args = [], opts = {}) {
    var _a2;
    const arg0 = (_a2 = opts.arg0) != null ? _a2 : "HoustonBashCommand";
    super(["/usr/bin/env", "bash", "-c", script, arg0, ...args], opts);
  }
}
class PythonCommand extends Command {
  constructor(script, args = [], opts = {}) {
    super(["/usr/bin/env", "python3", "-c", script, ...args], opts);
  }
}
class ProcessBase {
  constructor(server2, command) {
    __publicField2(this, "server");
    __publicField2(this, "command");
    this.server = server2;
    this.command = command;
  }
  prefixMessage(message) {
    const arg0Prefix = `${this.getName()}: `;
    message = message.startsWith(arg0Prefix) ? message.replace(arg0Prefix, "") : message;
    return monetExports.Maybe.fromUndefined(this.server.host).fold("")((host) => `${host}: `).concat(arg0Prefix, message);
  }
  getName() {
    return this.command.getName();
  }
  toString() {
    return `Process(${this.server}, ${this.command})`;
  }
}
class ExitedProcess extends ProcessBase {
  constructor(server2, command, exitStatus, stdout, stderr, killedBy) {
    super(server2, command);
    __publicField2(this, "exitStatus");
    __publicField2(this, "stdout");
    __publicField2(this, "stderr");
    __publicField2(this, "killedBy");
    this.exitStatus = exitStatus;
    this.stdout = stdout;
    this.stderr = stderr;
    this.killedBy = killedBy;
  }
  getStdout(binary = false) {
    if (binary) {
      return this.stdout;
    }
    return utf8Decoder.decode(this.stdout);
  }
  getStderr() {
    return this.stderr;
  }
  succeeded() {
    return this.exitStatus === 0;
  }
  failed() {
    return !this.succeeded();
  }
  logDebug(logger = console.log) {
    logger(`${this}:
stdout:
${this.getStdout()}
stderr:
${this.getStderr()}`);
  }
  toString() {
    const str = `Exited${super.toString()} (exited ${this.exitStatus})`;
    if (!this.killedBy)
      return str;
    return str + ` (killed by ${this.killedBy})`;
  }
}
class Process extends ProcessBase {
  constructor(server2, command, defer) {
    super(server2, command);
    __publicField2(this, "spawnHandle");
    if (defer !== true) {
      this.execute();
    }
  }
  execute() {
    this.spawnHandle = cockpit.spawn(this.command.argv, {
      ...this.command.spawnOptions,
      host: this.server.host
    });
    return this;
  }
  wait(failIfNonZero = true) {
    return ResultAsync$1.fromPromise(
      new Promise((resolve2, reject) => {
        if (this.spawnHandle === void 0) {
          return reject(new ProcessError(this.prefixMessage("Process never started!")));
        }
        this.spawnHandle.then((stdout, stderr) => {
          const exitStatus = 0;
          resolve2(new ExitedProcess(this.server, this.command, exitStatus, stdout, stderr));
        }).catch((ex, stdout) => {
          if (ex.problem !== null && ex.problem !== void 0 || ex.exit_status === null || ex.exit_status === void 0) {
            switch (ex.problem) {
              case "unknown-host":
                return reject(new UnknownHost(`${this.server.host}: ${ex.message}`));
              case "not-found":
                return reject(new NotFound(this.prefixMessage(ex.message)));
              case "authentication-failed":
                return reject(new AuthenticationFailed(`${this.server.host}: ${ex.message}`));
              default:
                return reject(
                  new ProcessError(`${this.prefixMessage(ex.message)} (${ex.problem})`)
                );
            }
          }
          const exitedProcess = new ExitedProcess(
            this.server,
            this.command,
            ex.exit_status,
            stdout,
            ex.message
          );
          if (failIfNonZero && ex.exit_status !== 0) {
            exitedProcess.logDebug(console.error);
            return reject(
              new NonZeroExit(this.prefixMessage(`${ex.message} (${ex.exit_status})`))
            );
          }
          resolve2(exitedProcess);
        });
      }),
      (e) => {
        if (e instanceof ProcessError) {
          return e;
        }
        return new ProcessError(this.prefixMessage("Unknown error"), {
          cause: e
        });
      }
    );
  }
  write(data, stream = false) {
    if (this.spawnHandle === void 0) {
      return err$1(new ProcessError(this.prefixMessage("process not running!")));
    }
    if (typeof data === "string") {
      data = utf8Encoder.encode(data);
    }
    this.spawnHandle.input(data, stream);
    return ok$1(null);
  }
  terminate() {
    if (this.spawnHandle) {
      this.spawnHandle.close("terminated");
    }
    return this;
  }
  close() {
    if (this.spawnHandle) {
      this.spawnHandle.close();
    }
    return this;
  }
}
function useSpawn$6(argv = [], opts = {}, stderr = "message") {
  var _a2, _b;
  (_a2 = opts.superuser) != null ? _a2 : opts.superuser = "require";
  (_b = opts.err) != null ? _b : opts.err = stderr;
  let state;
  const proc = cockpit.spawn(argv, opts);
  const _promise = new Promise((resolve2, reject) => {
    proc.then((_stdout, _stderr) => {
      state.stdout = _stdout;
      state.stderr = _stderr;
      resolve2(state);
    }).catch((ex, _stdout) => {
      var _a3, _b2;
      state.stdout = _stdout;
      state.stderr = (_a3 = ex.message) != null ? _a3 : ex.problem;
      state.status = (_b2 = ex.exit_status) != null ? _b2 : void 0;
      reject(state);
    }).finally(() => {
      state.loading = false;
    });
  });
  state = {
    loading: true,
    argv: [...argv],
    proc: cockpit.spawn(argv, opts),
    stdout: void 0,
    stderr: void 0,
    status: void 0,
    _promise,
    promise: () => _promise,
    argvPretty: () => argv.map((token) => /\s/.test(token) ? `"${token}"` : token).join(" "),
    errorStringHTML(fullArgv = false) {
      return `<span class="font-mono text-sm whitespace-pre-wrap"><span class="font-semibold">${this.argv[0]}: </span><span>${errorString$6(this)} (${this.status})</span></span>` + (fullArgv ? `<span class="text-gray-500 font-mono text-sm whitespace-pre-wrap">${this.argvPretty()}</span>` : "");
    }
  };
  state.proc = proc;
  state._promise = _promise;
  if (opts.binary)
    return state;
  else
    return state;
}
function errorString$6(state) {
  var _a2, _b;
  if (typeof state === "string")
    return state;
  return (_b = (_a2 = state == null ? void 0 : state.stderr) != null ? _a2 : state == null ? void 0 : state.message) != null ? _b : JSON.stringify(state);
}
function errorStringHTML(state) {
  var _a3, _b, _c;
  var _a2;
  if (typeof state === "string")
    return `<span class="text-gray-500 font-mono text-sm whitespace-pre-wrap">${state}</span>`;
  return (_c = (_a2 = state.errorStringHTML) == null ? void 0 : _a2.call(state)) != null ? _c : `<span class="text-gray-500 font-mono text-sm whitespace-pre-wrap">${(_b = (_a3 = state == null ? void 0 : state.stderr) != null ? _a3 : state == null ? void 0 : state.message) != null ? _b : JSON.stringify(state)}</span>`;
}
function User(server2, login, uid2, gid, name, home, shell) {
  return {
    server: server2,
    login,
    uid: uid2,
    gid,
    name,
    home,
    shell
  };
}
function isLocalUser(user) {
  return [user.login, user.gid, user.name, user.home, user.shell].every(
    (prop) => prop !== void 0
  );
}
function Group(server2, name, gid, members) {
  return {
    server: server2,
    name,
    gid,
    members
  };
}
function isLocalGroup(group) {
  return [group.name, group.members].every((prop) => prop !== void 0);
}
const parseFileSystemType = (type2) => {
  switch (type2) {
    case "zfs":
      return "zfs";
    case "ceph":
      return "ceph";
    case "cifs":
      return "cifs";
    default:
      return "other";
  }
};
var RegexSnippets;
((RegexSnippets2) => {
  RegexSnippets2.newlineSplitter = /[\r\n]+/;
  RegexSnippets2.keyValueSplitter = /=(.*)/;
})(RegexSnippets || (RegexSnippets = {}));
function KeyValueSyntax(opts = {}) {
  let {
    indent = "",
    commentRegex = /^\s*[#;]/,
    trailingNewline = true,
    duplicateKey = "overwrite"
  } = opts;
  if (typeof indent === "number") {
    indent = " ".repeat(indent);
  }
  return {
    apply: (text) => Result$1.combine(
      text.split(RegexSnippets.newlineSplitter).map((line, lineIndex) => {
        if (commentRegex.test(line) || line.trim() === "") {
          return ok$1(null);
        }
        const [key, value] = line.split(RegexSnippets.keyValueSplitter).map((s2) => s2.trim());
        if (key === void 0 || value === void 0 || key === "") {
          return err$1(
            new ParsingError(`Invalid key = value format at line ${lineIndex}:
${line}`)
          );
        }
        return ok$1({ key, value });
      })
    ).andThen((keyValuePairs) => {
      const data = opts.duplicateKey === "append" ? {} : {};
      for (const [index2, { key, value }] of keyValuePairs.filter((kv) => kv !== null).entries()) {
        const currentValue = data[key];
        if (duplicateKey === "append") {
          if (currentValue === void 0) {
            data[key] = value;
          } else if (typeof currentValue === "string") {
            data[key] = [currentValue, value];
          } else if (Array.isArray(currentValue)) {
            data[key] = [...currentValue, value];
          }
        } else if (currentValue === void 0 || duplicateKey === "overwrite") {
          data[key] = value;
        } else if (duplicateKey === "error") {
          return err$1(new ParsingError(`Duplicate key '${key}' at line ${index2}`));
        }
      }
      return ok$1(data);
    }),
    unapply: (data) => ok$1(
      Object.entries(data).map(([key, values]) => [values].flat().map((value) => `${indent}${key} = ${value}`)).flat().join("\n") + (trailingNewline ? "\n" : "")
    )
  };
}
const Identity = (value) => ({
  flatten: () => value,
  flatMap: (func) => func(value),
  map: (func) => Identity.of(func(value))
});
Identity.of = Identity;
var StringUtils;
((StringUtils2) => {
  function trim(text) {
    if (Array.isArray(text)) {
      return text.map((s2) => s2.trim());
    }
    return text.trim();
  }
  StringUtils2.trim = trim;
  function joinEscapedNewlines(lines) {
    return lines.reduce((lines2, line) => {
      const previousLine = lines2[lines2.length - 1];
      if (previousLine == null ? void 0 : previousLine.endsWith("\\")) {
        lines2[lines2.length - 1] = `${previousLine.slice(0, -1)}${line.trimStart()}`;
      } else {
        lines2.push(line);
      }
      return lines2;
    }, []);
  }
  StringUtils2.joinEscapedNewlines = joinEscapedNewlines;
  function splitBy(splitter) {
    return (text) => text.split(splitter);
  }
  StringUtils2.splitBy = splitBy;
  function filter(...filters) {
    return (a2) => a2.filter((e) => filters.every((f2) => f2(e)));
  }
  StringUtils2.filter = filter;
  function commentFilter(delimiter = "#") {
    return (s2) => s2.trimStart().startsWith(delimiter);
  }
  StringUtils2.commentFilter = commentFilter;
  function nonEmptyFilter() {
    return (s2) => !!s2.trim();
  }
  StringUtils2.nonEmptyFilter = nonEmptyFilter;
  function regexFilter(re, negate = false) {
    return (s2) => re.test(s2) != negate;
  }
  StringUtils2.regexFilter = regexFilter;
})(StringUtils || (StringUtils = {}));
class ModeOctet {
  constructor(octet) {
    __publicField2(this, "r");
    __publicField2(this, "w");
    __publicField2(this, "x");
    this.r = (octet & 4) !== 0;
    this.w = (octet & 2) !== 0;
    this.x = (octet & 1) !== 0;
  }
  toNumber() {
    return (this.r ? 4 : 0) | (this.w ? 2 : 0) | (this.x ? 1 : 0);
  }
  toString() {
    return `${this.r ? "r" : "-"}${this.w ? "w" : "-"}${this.x ? "x" : "-"}`;
  }
  toOctal() {
    return this.toNumber().toString(8);
  }
}
class Mode {
  constructor(mode) {
    __publicField2(this, "owner");
    __publicField2(this, "group");
    __publicField2(this, "other");
    this.owner = new ModeOctet(mode >> 6 & 7);
    this.group = new ModeOctet(mode >> 3 & 7);
    this.other = new ModeOctet(mode >> 0 & 7);
  }
  toNumber() {
    return this.owner.toNumber() << 6 | this.group.toNumber() << 3 | this.other.toNumber();
  }
  toString() {
    return `${this.owner.toString()}${this.group.toString()}${this.other.toString()} (0${this.toOctal()})`;
  }
  toOctal() {
    return this.toNumber().toString(8);
  }
}
class Ownership {
  constructor(userOrGroup, group) {
    __publicField2(this, "user");
    __publicField2(this, "group");
    if ("uid" in userOrGroup) {
      this.user = userOrGroup;
      this.group = group;
    } else {
      this.group = userOrGroup;
    }
  }
  toChownString() {
    var _a2, _b;
    return `${this.user ? (_a2 = this.user.login) != null ? _a2 : this.user.uid.toString() : ""}:${this.group ? (_b = this.group.name) != null ? _b : this.group.gid.toString() : ""}`;
  }
}
class Path {
  constructor(path) {
    __publicField2(this, "path");
    if (path instanceof Path) {
      this.path = path.path;
    } else if (typeof path === "string") {
      this.path = path.replace(/\/+/g, "/");
      if (this.path.length > 1) {
        this.path = this.path.replace(/\/$/, "");
      }
    } else {
      throw TypeError(`typeof path = ${typeof path} != Path|string`);
    }
  }
  isAbsolute() {
    return this.path[0] === "/";
  }
  isRelative() {
    return !this.isAbsolute();
  }
  parent() {
    const lastSeparatorIndex = this.path.lastIndexOf("/");
    if (lastSeparatorIndex === -1) {
      return new Path(this.path + "/..");
    }
    if (lastSeparatorIndex === 0) {
      return new Path("/");
    }
    return new Path(this.path.substring(0, lastSeparatorIndex));
  }
  basename() {
    return this.path.split("/").pop();
  }
  testOn(server2, testFlag, commandOptions) {
    return server2.execute(new Command(["test", testFlag, this.path], commandOptions), false).map((proc) => proc.exitStatus === 0);
  }
  isBlockOn(server2, commandOptions) {
    return this.testOn(server2, "-b", commandOptions);
  }
  isCharacterOn(server2, commandOptions) {
    return this.testOn(server2, "-c", commandOptions);
  }
  isDirectoryOn(server2, commandOptions) {
    return this.testOn(server2, "-d", commandOptions);
  }
  existsOn(server2, commandOptions) {
    return this.testOn(server2, "-e", commandOptions);
  }
  isFileOn(server2, commandOptions) {
    return this.testOn(server2, "-f", commandOptions);
  }
  isSymbolicLinkOn(server2, commandOptions) {
    return this.testOn(server2, "-L", commandOptions);
  }
  isPipeOn(server2, commandOptions) {
    return this.testOn(server2, "-p", commandOptions);
  }
  isSocketOn(server2, commandOptions) {
    return this.testOn(server2, "-S", commandOptions);
  }
  createOn(server2, type2, parents, commandOptions) {
    const createResult = (parents ? server2.execute(new Command(["mkdir", "-p", this.parent().path], commandOptions)).map(() => null) : okAsync$1(null)).map(() => new Command([type2 === "file" ? "touch" : "mkdir", this.path], commandOptions)).andThen((cmd) => server2.execute(cmd, true));
    return type2 === "file" ? createResult.map(() => new File(server2, this)) : createResult.map(() => new Directory(server2, this));
  }
  getFilesystemMountOn(server2, commandOptions) {
    return server2.execute(new Command(["df", "--output=source,target,fstype", this.path], commandOptions)).map((proc) => proc.getStdout().trim().split(RegexSnippets.newlineSplitter)[1]).andThen((tokens) => {
      var _a2;
      const [source, mountpoint, realType] = (_a2 = tokens == null ? void 0 : tokens.split(/\s+/g)) != null ? _a2 : [];
      if (source === void 0 || mountpoint === void 0 || realType === void 0) {
        return errAsync$1(new ParsingError(`Failed to parse filesystem mount:
${tokens}`));
      }
      return okAsync$1({
        filesystem: {
          source,
          type: parseFileSystemType(realType),
          realType
        },
        mountpoint
      });
    });
  }
  resolveOn(server2, mustExist = false, commandOptions) {
    return server2.execute(
      new Command(
        ["realpath", mustExist ? "--canonicalize-existing" : "--canonicalize-missing", this.path],
        commandOptions
      )
    ).map((proc) => new Path(proc.getStdout().trim()));
  }
  findLongestExistingStemOn(server2, commandOptions) {
    if (!this.isAbsolute()) {
      return errAsync$1(
        new ProcessError(`Path.findLongestExistingStemOn: Path not absolute: ${this.path}`)
      );
    }
    let path = this;
    return new ResultAsync$1(
      safeTry(async function* () {
        while (path.path !== "/") {
          if (yield* path.existsOn(server2, commandOptions).safeUnwrap()) {
            return ok$1(path);
          }
          path = path.parent();
        }
        return ok$1(path);
      })
    );
  }
  getModeOn(server2, commandOptions) {
    return server2.execute(new Command(["stat", "--printf", "%#a", "--", this.path], commandOptions)).map((proc) => parseInt(proc.getStdout().trim(), 8)).andThen((mode) => isNaN(mode) ? err$1(new ParsingError("Failed to parse mode")) : ok$1(mode)).map((mode) => new Mode(mode));
  }
  setModeOn(server2, mode, commandOptions) {
    mode = typeof mode === "number" ? new Mode(mode) : mode;
    return server2.execute(new Command(["chmod", "--", mode.toOctal(), this.path], commandOptions)).map(() => this);
  }
  getOwnershipOn(server2, commandOptions) {
    return server2.execute(new Command(["stat", "--printf", "%u:%g", "--", this.path], commandOptions)).andThen((proc) => {
      const ownershipString = proc.getStdout().trim();
      const [uid2, gid] = ownershipString.split(":").map((s2) => parseInt(s2));
      if (uid2 === void 0 || gid === void 0 || isNaN(uid2) || isNaN(gid)) {
        return err$1(new ParsingError(`Failed to parse ownership from ${ownershipString}`));
      }
      return ResultAsync$1.combine([server2.getUserByUid(uid2), server2.getGroupByGid(gid)]).map(
        ([user, group]) => new Ownership(user, group)
      );
    });
  }
  setOwnershipOn(server2, ownership, commandOptions) {
    return server2.execute(new Command(["chown", "--", ownership.toChownString(), this.path], commandOptions)).map(() => this);
  }
  getExtendedAttributesOn(server2, commandOptions) {
    const kvParser = KeyValueSyntax({ duplicateKey: "error" });
    return server2.execute(new Command(["getfattr", "--dump", "--match=-", "--", this.path], commandOptions)).map((proc) => proc.getStdout()).andThen(kvParser.apply);
  }
  setExtendedAttributesOn(server2, attributes, commandOptions) {
    return ResultAsync$1.combine(
      Object.entries(attributes).map(
        ([key, value]) => this.setExtendedAttributeOn(server2, key, value, commandOptions)
      )
    ).map(() => this);
  }
  getExtendedAttributeOn(server2, attributeName, commandOptions) {
    return server2.execute(
      new Command(
        [
          "getfattr",
          `--name=${attributeName}`,
          "--only-values",
          "--absolute-names",
          "--",
          this.path
        ],
        commandOptions
      ),
      false
    ).andThen(
      (proc) => proc.exitStatus === 0 ? ok$1(monetExports.Some(proc.getStdout().trim())) : proc.getStderr().trim().endsWith("No such attribute") ? ok$1(monetExports.None()) : err$1(new ProcessError(proc.getStderr().trim()))
    );
  }
  setExtendedAttributeOn(server2, attributeName, attributeValue, commandOptions) {
    return server2.execute(
      new Command(
        ["setfattr", `--name=${attributeName}`, `--value=${attributeValue}`, "--", this.path],
        commandOptions
      )
    ).map(() => this);
  }
  removeExtendedAttributeOn(server2, attributeName, commandOptions) {
    return server2.execute(
      new Command(["setfattr", `--remove=${attributeName}`, "--", this.path], commandOptions)
    ).map(() => this);
  }
}
class FileSystemNode extends Path {
  constructor(serverOrNode, path) {
    var __super = (...args) => {
      super(...args);
      __publicField2(this, "server");
      return this;
    };
    if (serverOrNode instanceof Server) {
      if (path === void 0) {
        throw TypeError("path undefined!");
      }
      __super(path);
      this.server = serverOrNode;
    } else {
      __super(serverOrNode.path);
      this.server = serverOrNode.server;
    }
  }
  parent() {
    return new FileSystemNode(this.server, super.parent());
  }
  isBlock(commandOptions) {
    return this.isBlockOn(this.server, commandOptions);
  }
  isCharacter(commandOptions) {
    return this.isCharacterOn(this.server, commandOptions);
  }
  isDirectory(commandOptions) {
    return this.isDirectoryOn(this.server, commandOptions);
  }
  exists(commandOptions) {
    return this.existsOn(this.server, commandOptions);
  }
  isFile(commandOptions) {
    return this.isFileOn(this.server, commandOptions);
  }
  isSymbolicLink(commandOptions) {
    return this.isSymbolicLinkOn(this.server, commandOptions);
  }
  isPipe(commandOptions) {
    return this.isPipeOn(this.server, commandOptions);
  }
  isSocket(commandOptions) {
    return this.isSocketOn(this.server, commandOptions);
  }
  getFilesystemMount(commandOptions) {
    return this.getFilesystemMountOn(this.server, commandOptions);
  }
  resolve(mustExist = false, commandOptions) {
    return this.resolveOn(this.server, mustExist, commandOptions).map(
      (path) => new FileSystemNode(this.server, path)
    );
  }
  findLongestExistingStem(commandOptions) {
    return this.findLongestExistingStemOn(this.server, commandOptions).map(
      (path) => new FileSystemNode(this.server, path)
    );
  }
  getMode(commandOptions) {
    return this.getModeOn(this.server, commandOptions);
  }
  setMode(mode, commandOptions) {
    return (mode instanceof FileSystemNode ? mode.getMode(commandOptions) : okAsync$1(mode)).andThen((mode2) => this.setModeOn(this.server, mode2, commandOptions));
  }
  getOwnership(commandOptions) {
    return this.getOwnershipOn(this.server, commandOptions);
  }
  setOwnership(ownership, commandOptions) {
    return (ownership instanceof FileSystemNode ? ownership.getOwnership(commandOptions) : okAsync$1(ownership)).andThen((ownership2) => this.setOwnershipOn(this.server, ownership2, commandOptions));
  }
  assertExists(expected = true, commandOptions) {
    return this.exists(commandOptions).andThen(
      (exists) => exists === expected ? ok$1(this) : err$1(new ProcessError(`assertExists(${expected}) failed: ${this.path}`))
    );
  }
  assertIsFile(commandOptions) {
    return this.isFile(commandOptions).andThen(
      (isFile) => isFile ? ok$1(new File(this)) : err$1(new ProcessError(`assertIsFile failed: ${this.path}`))
    );
  }
  assertIsDirectory(commandOptions) {
    return this.isDirectory(commandOptions).andThen(
      (isDirectory) => isDirectory ? ok$1(new Directory(this)) : err$1(new ProcessError(`assertIsDirectory failed: ${this.path}`))
    );
  }
  getExtendedAttributes(commandOptions) {
    return this.getExtendedAttributesOn(this.server, commandOptions);
  }
  setExtendedAttributes(attributes, commandOptions) {
    return this.setExtendedAttributesOn(this.server, attributes, commandOptions);
  }
  getExtendedAttribute(attributeName, commandOptions) {
    return this.getExtendedAttributeOn(this.server, attributeName, commandOptions);
  }
  setExtendedAttribute(attributeName, attributeValue, commandOptions) {
    return this.setExtendedAttributeOn(this.server, attributeName, attributeValue, commandOptions);
  }
  removeExtendedAttribute(attributeName, commandOptions) {
    return this.removeExtendedAttributeOn(this.server, attributeName, commandOptions);
  }
  move(newPath, commandOptions = {}) {
    const { existing, ...options } = {
      existing: "fail",
      ...commandOptions
    };
    const existingFlagsLUT = {
      fail: ["--no-clobber"],
      clobber: ["--force"],
      backup: ["--backup=numbered"]
    };
    return this.server.execute(
      new Command(
        ["mv", ...existingFlagsLUT[existing], "--no-target-directory", "--", this.path, newPath],
        options
      )
    ).map(() => new FileSystemNode(this.server, newPath));
  }
}
class File extends FileSystemNode {
  create(parents, commandOptions) {
    return this.createOn(this.server, "file", parents, commandOptions);
  }
  remove(commandOptions) {
    return this.server.execute(new Command(["rm", this.path], commandOptions), true).map(() => this);
  }
  read(commandOptions = {}) {
    const { binary, ...options } = commandOptions;
    const procResult = this.server.execute(new Command(["cat", this.path], options));
    if (binary) {
      return procResult.map((p2) => p2.getStdout(true));
    }
    return procResult.map((p2) => p2.getStdout(false));
  }
  write(content, commandOptions = {}) {
    const { append, ...options } = commandOptions;
    const proc = this.server.spawnProcess(
      new Command(
        [
          "dd",
          "status=none",
          `of=${this.path}`,
          ...append ? ["oflag=append", "conv=notrunc"] : []
        ],
        options
      )
    );
    proc.write(content, false);
    return proc.wait(true).map(() => this);
  }
  move(...args) {
    return super.move(...args).map((node) => new File(node));
  }
  replace(newContentOrReplacer, commandOptions = {}) {
    const { binary, backup, ...options } = commandOptions;
    return File.makeTemp(this.server, this.parent().path, options).andThen((tempFile) => {
      if (typeof newContentOrReplacer === "function") {
        if (binary) {
          return this.read({ ...options, binary: true }).map(newContentOrReplacer).andThen((newContent) => tempFile.write(newContent, options));
        }
        return this.read({ ...options, binary: false }).map(newContentOrReplacer).andThen((newContent) => tempFile.write(newContent, options));
      }
      return okAsync$1(newContentOrReplacer).andThen(
        (newContent) => tempFile.write(newContent, options)
      );
    }).andThen((tempFile) => tempFile.setOwnership(this, options)).andThen((tempFile) => tempFile.setMode(this, options)).andThen(
      (tempFile) => tempFile.move(this.path, {
        ...options,
        existing: backup ? "backup" : "clobber"
      })
    ).map(() => this);
  }
  static makeTemp(server2, directory, commandOptions) {
    return server2.execute(
      new Command(
        ["mktemp", ...directory === void 0 ? [] : [`--tmpdir=${directory}`]],
        commandOptions
      )
    ).map((proc) => new File(server2, proc.getStdout().trim()));
  }
}
class Directory extends FileSystemNode {
  create(parents, commandOptions) {
    return this.createOn(this.server, "directory", parents, commandOptions);
  }
  remove(commandOptions) {
    return this.server.execute(new Command(["rmdir", this.path], commandOptions), true).map(() => this);
  }
  getChildren(opts, commandOptions) {
    var _a2, _b, _c;
    (_a2 = opts.limit) != null ? _a2 : opts.limit = 50;
    return this.server.execute(
      new BashCommand(
        'find -H "$1" -mindepth 1 -maxdepth 1 -name "$2" -path "$3" -print0' + (opts.limit === "none" ? "" : ` | head -z -n ${opts.limit.toString()}`),
        [this.path, (_b = opts.nameFilter) != null ? _b : "*", (_c = opts.pathFilter) != null ? _c : "*"],
        commandOptions
      )
    ).map(
      (proc) => proc.getStdout().trim().split("\0").slice(0, -1).map((pathString) => new FileSystemNode(this.server, pathString))
    );
  }
  move(...args) {
    return super.move(...args).map((node) => new Directory(node));
  }
}
var Download;
((Download2) => {
  function url(url2, filename) {
    const a2 = document.createElement("a");
    a2.href = url2;
    a2.style.display = "none";
    a2.download = filename;
    a2.target = "_blank";
    document.body.appendChild(a2);
    const event = new MouseEvent("click", {
      view: window,
      bubbles: false,
      cancelable: true
    });
    a2.dispatchEvent(event);
    document.body.removeChild(a2);
  }
  Download2.url = url;
  function blobParts(content, filename, type2 = "application/octet-stream") {
    const f2 = new window.File(content, filename, {
      type: type2
    });
    file(f2);
  }
  Download2.blobParts = blobParts;
  function file(f2) {
    var _a2;
    const url2 = URL.createObjectURL(f2);
    if (Object.hasOwnProperty.call(window, "chrome")) {
      Download2.url(url2, f2.name);
    } else {
      (_a2 = window.open(url2, "_blank")) == null ? void 0 : _a2.focus();
    }
  }
  Download2.file = file;
  function text(content, filename) {
    return blobParts([content], filename, "text/plain");
  }
  Download2.text = text;
  function binary(content, filename) {
    return blobParts([content], filename, "application/octet-stream");
  }
  Download2.binary = binary;
})(Download || (Download = {}));
function MethodFunctor(_ctor, method, ...args) {
  return (obj) => obj[method](...args);
}
const IdentityFunctor = (o2) => o2;
function StringToBooleanCaster(opts = {}) {
  var _a2, _b, _c;
  const ignoreCase = (_a2 = opts.ignoreCase) != null ? _a2 : true;
  const truthyWords = ((_b = opts.truthyWords) != null ? _b : ["true", "yes", "1"]).map(
    ignoreCase ? MethodFunctor(String, "toLowerCase") : IdentityFunctor
  );
  const falsyWords = ((_c = opts.falsyWords) != null ? _c : ["false", "no", "0"]).map(
    ignoreCase ? MethodFunctor(String, "toLowerCase") : IdentityFunctor
  );
  const caster = (text) => monetExports.Maybe.fromNull(truthyWords.includes(text) ? true : falsyWords.includes(text) ? false : null);
  if (ignoreCase) {
    return (text) => caster(text.toLowerCase());
  }
  return caster;
}
const safeJsonParse = (...args) => Result$1.fromThrowable(
  (...args2) => JSON.parse(...args2),
  (e) => e instanceof SyntaxError ? e : new SyntaxError(`${e}`)
)(...args);
function convertToBytes(sizeString) {
  const regex = /([\d.]+)\s?(B|KiB|MiB|GiB|TiB|PiB|EiB)/i;
  const match = sizeString.match(regex);
  if (!match) {
    console.error(`Invalid size format: ${sizeString}`);
    return 0;
  }
  const size = parseFloat(match[1]);
  const unit = match[2].toUpperCase();
  const unitMultipliers = {
    "B": 1,
    "KIB": 1024,
    "MIB": 1024 ** 2,
    "GIB": 1024 ** 3,
    "TIB": 1024 ** 4,
    "PIB": 1024 ** 5,
    "EIB": 1024 ** 6
  };
  return size * (unitMultipliers[unit] || 1);
}
const DiskInfoPy = '#!/usr/bin/env python3\nimport os\nimport json\nimport sys\nimport re\n\ndef loadServerInfo():\n    json_path = "/etc/45drives/server_info/server_info.json"\n    server_info = {}\n    if os.path.exists(json_path):\n        f = open(json_path, "r")\n        server_info = json.load(f)\n        f.close()\n        return server_info\n    else:\n        print("/etc/45drives/server_info/server_info.json not found.")\n        sys.exit(1)\n\ndef getDiskInfo(path,server_info):\n    if not os.path.isfile(path):\n        if "Chassis Size" in server_info.keys() and server_info["Chassis Size"] in ["2UGW"]:\n            print(f"This program is intended to display disk information for servers with dedicated storage bays.",file=sys.stderr)\n            print(f"Use command line utilities such as lsblk to see disk information for Ceph Gateways.",file=sys.stderr)\n            sys.exit(1)\n        print(f"Error opening {path}. Run `dmap`.",file=sys.stderr)\n        sys.exit(1)\n    \n    c_lines = []\n    disks = []\n    with open("/etc/vdev_id.conf","r") as vdev_id:\n        c_lines = vdev_id.readlines()\n    \n    for line in c_lines:\n        regex = re.search("^alias\\s+(\\d+-\\d+)\\s+(\\S+)",line)\n        if regex != None:\n            disks.append({"dev-by-path":regex.group(2),"bay-id":regex.group(1)})\n        \n    for d in disks:\n        d["occupied"] = os.path.islink(d["dev-by-path"])\n        d["dev"] = os.path.realpath(d["dev-by-path"]) if d["occupied"] else ""\n        d["disk_type"] = disk_type(d["dev"])\n\n    return {"rows":disks}\n\ndef disk_type(device_path):\n	#get the value of "/sys/block/[device_name]/queue/rotational\n	#this check will return 1 if block device is a spinner, 0 if not\n	device_name = os.path.basename(device_path)\n	rotational_path = "/sys/block/" + device_name + "/queue/rotational"\n	if not os.path.isfile(rotational_path):\n		return ""\n	rotational = open(rotational_path, mode=\'r\')\n	is_rotational = bool(int(rotational.read(1)))\n	return ("HDD" if is_rotational else "SSD")\n\ndef main():\n    server_info = loadServerInfo()\n    diskInfo = getDiskInfo("/etc/vdev_id.conf",server_info)\n    print(json.dumps(diskInfo,indent=4))\n\n\nif __name__ == "__main__":\n    main()\n';
class Server {
  constructor(host) {
    __publicField2(this, "host");
    __publicField2(this, "hostname");
    __publicField2(this, "ipAddress");
    __publicField2(this, "localUsers");
    __publicField2(this, "localGroups");
    this.host = host;
  }
  isAccessible() {
    return this.execute(new Command(["true"]), true).map(() => true);
  }
  getServerInfo() {
    return new File(this, "/etc/45drives/server_info/server_info.json").read().andThen(safeJsonParse);
  }
  getDiskInfo() {
    return this.execute(new PythonCommand(DiskInfoPy, [], { superuser: "try" })).map((proc) => proc.getStdout()).andThen(safeJsonParse);
  }
  getLsDev() {
    return this.execute(new Command(["/opt/45drives/tools/lsdev", "--json"], { superuser: "try" })).map((proc) => proc.getStdout()).andThen(safeJsonParse);
  }
  getHostname(cache = true) {
    if (this.hostname === void 0 || cache === false) {
      return this.execute(new Command(["hostname"]), true).map(
        (proc) => this.hostname = proc.getStdout().trim()
      );
    }
    return okAsync$1(this.hostname);
  }
  getIpAddress(cache = true) {
    if (this.ipAddress === void 0 || cache === false) {
      const target = "1.1.1.1";
      return this.execute(new Command(["ip", "route", "get", target]), true).andThen((proc) => {
        const stdout = proc.getStdout();
        const match = stdout.match(/\bsrc\s+(?<ipAddress>\d{1,3}(?:\.\d{1,3}){3})\b/);
        if (match === null || match.groups === void 0) {
          return err$1(new ParsingError(`Malformed output from ${proc}`, { cause: stdout }));
        }
        this.ipAddress = match.groups["ipAddress"];
        return ok$1(this.ipAddress);
      });
    }
    return okAsync$1(this.ipAddress);
  }
  spawnProcess(command, defer = false) {
    return new Process(this, command, defer);
  }
  execute(command, failIfNonZero = true) {
    return this.spawnProcess(command).wait(failIfNonZero);
  }
  downloadCommandOutput(command, filename) {
    const query = window.btoa(
      JSON.stringify({
        ...command.spawnOptions,
        host: this.host,
        payload: "stream",
        binary: "raw",
        spawn: command.argv,
        external: {
          "content-disposition": 'attachment; filename="' + encodeURIComponent(filename) + '"',
          "content-type": "application/x-xz, application/octet-stream"
        }
      })
    );
    const prefix = new URL(cockpit.transport.uri("channel/" + cockpit.transport.csrf_token)).pathname;
    const url = prefix + "?" + query;
    Download.url(url, filename);
  }
  getLocalUsers(cache = true) {
    if (this.localUsers === void 0 || cache === false) {
      return this.execute(new Command(["getent", "-s", "files", "passwd"]), true).map((proc) => {
        this.localUsers = proc.getStdout().split("\n").map((line) => {
          const [login, _2, uidStr, gidStr, name, home, shell] = line.split(":");
          if (login === void 0 || uidStr === void 0 || gidStr === void 0 || name === void 0 || home === void 0 || shell === void 0) {
            return null;
          }
          const uid2 = parseInt(uidStr);
          const gid = parseInt(gidStr);
          if (isNaN(uid2) || isNaN(gid)) {
            return null;
          }
          return User(
            this,
            login,
            uid2,
            gid,
            name,
            new Directory(this, home),
            new File(this, shell)
          );
        }).filter((user) => user !== null);
        return this.localUsers;
      });
    }
    return okAsync$1(this.localUsers);
  }
  getLocalGroups(cache = true) {
    if (this.localGroups === void 0 || cache === false) {
      return this.execute(new Command(["getent", "-s", "files", "group"]), true).map((proc) => {
        this.localGroups = proc.getStdout().split("\n").map((line) => {
          const [name, _2, gidStr, membersStr] = line.split(":");
          if (name === void 0 || gidStr === void 0 || membersStr === void 0) {
            return null;
          }
          const gid = parseInt(gidStr);
          if (isNaN(gid)) {
            return null;
          }
          return Group(this, name, gid, membersStr.split(","));
        }).filter((group) => group !== null);
        return this.localGroups;
      });
    }
    return okAsync$1(this.localGroups);
  }
  getUserGroups(user) {
    if (!isLocalUser(user)) {
      return errAsync$1(new ValueError(`Can't get groups from non-local user ${user.uid}`));
    }
    return this.execute(new Command(["groups", user.login]), true).map(
      (proc) => proc.getStdout().replace(/^[^:]+:/, "").trim().split(/\s+/)
    ).andThen((userGroupNames) => {
      return this.getLocalGroups().map(
        (localGroups) => localGroups.filter((group) => group.name in userGroupNames)
      );
    });
  }
  getGroupMembers(group) {
    if (!isLocalGroup(group)) {
      return errAsync$1(new ValueError(`Can't get members of non-local group ${group.gid}`));
    }
    return this.getLocalUsers().map(
      (localUsers) => localUsers.filter((user) => user.login in group.members)
    );
  }
  getUserByLogin(login) {
    return this.getLocalUsers().map((localUsers) => localUsers.filter((user) => user.login === login)).andThen(
      (userMatches) => userMatches.length === 0 ? err$1(new ValueError(`User not found: ${login}`)) : ok$1(userMatches[0])
    );
  }
  getUserByUid(uid2) {
    return this.getLocalUsers().map((localUsers) => localUsers.filter((user) => user.uid === uid2)).andThen(
      (userMatches) => userMatches.length === 0 ? ok$1(User(this, void 0, uid2, void 0, void 0, void 0, void 0)) : ok$1(userMatches[0])
    );
  }
  getGroupByName(groupName) {
    return this.getLocalGroups().map((localGroups) => localGroups.filter((group) => group.name === groupName)).andThen(
      (groupMatches) => groupMatches.length === 0 ? err$1(new ValueError(`Group not found: ${groupName}`)) : ok$1(groupMatches[0])
    );
  }
  getGroupByGid(gid) {
    return this.getLocalGroups().map((localGroups) => localGroups.filter((group) => group.gid === gid)).andThen(
      (groupMatches) => groupMatches.length === 0 ? ok$1(Group(this, void 0, gid, void 0)) : ok$1(groupMatches[0])
    );
  }
  toString() {
    var _a2;
    return `Server(${(_a2 = this.host) != null ? _a2 : "localhost"})`;
  }
}
const server = new Server();
var _internal$1;
((_internal2) => {
  _internal2.pcsNodesParseAddrs = (commandOutput) => safeJsonParse(commandOutput).andThen((clusterConfig) => {
    var _a3;
    var _a2;
    const addrs = (_a3 = (_a2 = clusterConfig.nodes) == null ? void 0 : _a2.map((node) => {
      var _a22;
      return (_a22 = node.addrs[0]) == null ? void 0 : _a22.addr;
    }).filter((addr) => addr !== void 0)) != null ? _a3 : [];
    if (addrs.length === 0) {
      console.warn("pcs cluster config output:", clusterConfig);
      return err$1(new ParsingError("no nodes found in output"));
    }
    return ok$1(addrs);
  });
  _internal2.parseCorosyncConfNodeIps = (corosyncConf) => corosyncConf.split(RegexSnippets.newlineSplitter).filter((line) => /^\s*ring0_addr\s*:\s*.+$/.test(line)).map((ring0Addr) => ring0Addr.split(":")[1].trim());
})(_internal$1 || (_internal$1 = {}));
var Upload;
((Upload2) => {
  function file(accept) {
    return getUpload({ multiple: false, accept }).andThen(
      ([file2]) => file2 === void 0 ? err$1(new Error("No file given")) : ok$1(file2)
    );
  }
  Upload2.file = file;
  function files(accept) {
    return getUpload({ multiple: true, accept });
  }
  Upload2.files = files;
  function text(accept) {
    return file(accept).andThen((file2) => ResultAsync$1.fromSafePromise(file2.text()));
  }
  Upload2.text = text;
  function binary(accept) {
    return file(accept).andThen((file2) => ResultAsync$1.fromSafePromise(file2.arrayBuffer()));
  }
  Upload2.binary = binary;
  function getUpload(options = {}) {
    const promise = new Promise((resolve2, reject) => {
      fakeUploadClick(resolve2, reject, options);
    });
    return ResultAsync$1.fromPromise(
      promise,
      (e) => e instanceof CancelledByUser ? e : e instanceof Error ? e : new Error(`Error while uploading: ${e}`)
    );
  }
  function fakeUploadClick(resolver, rejecter, options) {
    var _a2, _b;
    const input = document.createElement("input");
    input.type = "file";
    input.style.display = "none";
    input.hidden = true;
    input.multiple = (_a2 = options.multiple) != null ? _a2 : input.multiple;
    input.accept = (_b = options.accept) != null ? _b : input.accept;
    input.addEventListener("change", ({ target }) => {
      if (target instanceof HTMLInputElement && target.files && target.files.length > 0) {
        resolver(target.files);
        document.body.removeChild(input);
      }
    });
    input.addEventListener("cancel", () => {
      rejecter(new CancelledByUser());
      document.body.removeChild(input);
    });
    document.body.appendChild(input);
    const event = new MouseEvent("click", {
      view: window,
      bubbles: false,
      cancelable: true
    });
    input.dispatchEvent(event);
  }
})(Upload || (Upload = {}));
function unwrap(result) {
  return Promise.resolve(result).then(
    (result2) => result2.match(
      (okValue) => Promise.resolve(okValue),
      (errValue) => Promise.reject(errValue)
    )
  );
}
var SambaShareConfig;
((SambaShareConfig2) => {
  SambaShareConfig2.defaults = (name = "") => ({
    name,
    description: "",
    path: "",
    guestOk: false,
    browseable: true,
    readOnly: true,
    inheritPermissions: false,
    advancedOptions: {}
  });
  SambaShareConfig2.makeNew = () => ({
    ...(0, SambaShareConfig2.defaults)(""),
    readOnly: false
  });
})(SambaShareConfig || (SambaShareConfig = {}));
var SambaGlobalConfig;
((SambaGlobalConfig2) => {
  SambaGlobalConfig2.defaults = () => ({
    serverString: "Samba %v",
    logLevel: 0,
    workgroup: "WORKGROUP",
    advancedOptions: {}
  });
})(SambaGlobalConfig || (SambaGlobalConfig = {}));
var SambaConfig;
((SambaConfig2) => {
  SambaConfig2.defaults = () => ({
    global: SambaGlobalConfig.defaults(),
    shares: []
  });
})(SambaConfig || (SambaConfig = {}));
StringToBooleanCaster({
  truthyWords: ["yes", "1", "true"],
  falsyWords: ["no", "0", "false"],
  ignoreCase: true
});
var VDev;
((VDev2) => {
  function diskType(vdev) {
    const allDisksAre = (type2) => vdev.disks.every((disk) => disk.type === type2);
    for (const type2 of ["HDD", "SSD", "NVMe"]) {
      if (allDisksAre(type2))
        return type2;
    }
    return "Hybrid";
  }
  VDev2.diskType = diskType;
})(VDev || (VDev = {}));
class ZFSManager {
  constructor(server2 = new Server()) {
    __publicField2(this, "commandOptions");
    __publicField2(this, "RAIDZResiliency", {
      "raidz1": 1,
      "raidz2": 2,
      "raidz3": 3
    });
    __publicField2(this, "OptimalRAIDZLevel", {
      4: "raidz1",
      8: "raidz2",
      20: "raidz2",
      30: "raidz3"
    });
    this.server = server2;
    this.commandOptions = { superuser: "try" };
  }
  formatVDevArgv(vdev) {
    const args = [];
    if (vdev.type !== "disk") {
      args.push(vdev.type);
    }
    if (vdev.isMirror) {
      if (!["log", "special", "dedup"].includes(vdev.type)) {
        throw new ValueError(`${vdev.type} vdev cannot be mirrored!`);
      }
      args.push("mirror");
    }
    const validDisks = vdev.disks.map((disk) => {
      var _a2;
      return disk.vdev_path && disk.vdev_path !== "N/A" ? disk.vdev_path : (_a2 = disk.sd_path) != null ? _a2 : "";
    }).filter((path) => path !== "N/A" && path !== "");
    if (validDisks.length === 0) {
      throw new ValueError(`VDev of type ${vdev.type} has no valid disks!`);
    }
    args.push(...validDisks);
    return args;
  }
  formatVDevsArgv(vdevs) {
    return vdevs.sort((a2, b2) => {
      if (a2.type === b2.type) {
        return 0;
      }
      if (a2.type === "disk") {
        return -1;
      }
      return 1;
    }).flatMap((vdev) => this.formatVDevArgv(vdev));
  }
  async createPool(pool2, options) {
    const argv = ["zpool", "create", pool2.name];
    const poolProps = [];
    if (options.sectorsize !== void 0)
      poolProps.push(`ashift=${options.sectorsize}`);
    if (options.autoexpand !== void 0)
      poolProps.push(`autoexpand=${options.autoexpand}`);
    if (options.autoreplace !== void 0)
      poolProps.push(`autoreplace=${options.autoreplace}`);
    if (options.autotrim !== void 0)
      poolProps.push(`autotrim=${options.autotrim}`);
    argv.push(...poolProps.flatMap((prop) => ["-o", prop]));
    const fsProps = [
      "aclinherit=passthrough",
      "acltype=posixacl",
      "casesensitivity=sensitive",
      "normalization=formD",
      "sharenfs=off",
      "sharesmb=off",
      "utf8only=on",
      "xattr=sa"
    ];
    if (options.compression !== void 0)
      fsProps.push(`compression=${options.compression}`);
    if (options.recordsize !== void 0)
      fsProps.push(`recordsize=${options.recordsize}`);
    if (options.dedup !== void 0)
      fsProps.push(`dedup=${options.dedup}`);
    argv.push(...fsProps.flatMap((prop) => ["-O", prop]));
    if (options.forceCreate)
      argv.push("-f");
    argv.push(...this.formatVDevsArgv(pool2.vdevs));
    console.log("****\ncmdstring:\n", ...argv, "\n****");
    try {
      const proc = await unwrap(this.server.execute(new Command(argv, this.commandOptions)));
      console.log("Command output:", proc.getStdout());
      return proc;
    } catch (error) {
      console.error("Error executing command:", error);
      throw error;
    }
  }
  async destroyPool(pool2, options = {}) {
    const poolName = typeof pool2 === "string" ? pool2 : pool2.name;
    const argv = ["zpool", "destroy"];
    if (options.force) {
      argv.push("-f");
    }
    argv.push(poolName);
    await unwrap(
      this.server.execute(new Command(argv, this.commandOptions))
    );
  }
  async getPools() {
    return [];
  }
  async getBaseDisks() {
    return unwrap(
      this.server.getDiskInfo().map(
        (diskInfoData) => diskInfoData.rows.map((disk) => ({
          path: disk["dev"]
        }))
      )
    );
  }
  async getFullDisks() {
    return Promise.all([
      unwrap(this.server.getLsDev()),
      unwrap(this.server.getDiskInfo())
    ]).then(([lsdevData, diskInfoData]) => {
      const lsdevRows = lsdevData.rows.flat();
      const diskInfoRows = diskInfoData.rows;
      return diskInfoRows.map((disk) => {
        const matchingDisk = lsdevRows.find((lsdev) => lsdev.dev === disk.dev);
        return {
          path: `/dev/disk/by-vdev/${disk["bay-id"]}`,
          name: (matchingDisk == null ? void 0 : matchingDisk["bay-id"]) || "Unknown",
          capacity: (matchingDisk == null ? void 0 : matchingDisk.capacity) || "Unknown",
          model: (matchingDisk == null ? void 0 : matchingDisk["model-name"]) || "Unknown",
          guid: (matchingDisk == null ? void 0 : matchingDisk.serial) || "Unknown",
          type: (matchingDisk == null ? void 0 : matchingDisk.disk_type) || "HDD",
          health: (matchingDisk == null ? void 0 : matchingDisk.health) || "Unknown",
          stats: {},
          phy_path: disk["dev-by-path"],
          sd_path: disk.dev,
          vdev_path: `/dev/disk/by-vdev/${disk["bay-id"]}`,
          serial: (matchingDisk == null ? void 0 : matchingDisk.serial) || "Unknown",
          temp: (matchingDisk == null ? void 0 : matchingDisk["temp-c"]) || "N/A",
          powerOnCount: (matchingDisk == null ? void 0 : matchingDisk["power-cycle-count"]) || "0",
          powerOnHours: (matchingDisk == null ? void 0 : matchingDisk["power-on-time"]) || 0,
          rotationRate: (matchingDisk == null ? void 0 : matchingDisk["rotation-rate"]) || 0
        };
      });
    }).catch((error) => {
      console.error("Error fetching full disks:", error);
      return [];
    });
  }
  async getDiskCapacity(path) {
    const { fetchLsdev } = Disks;
    return fetchLsdev().map((lsdevData) => {
      const lsdevRows = lsdevData.rows.flat();
      const disk = lsdevRows.find((lsdev) => lsdev["dev-by-path"] === path);
      return (disk == null ? void 0 : disk.capacity) || "Unknown";
    }).unwrapOr("Unknown");
  }
  async addVDevsToPool(pool2, vdevs, options) {
    const argv = ["zpool", "add"];
    if (options.force)
      argv.push("-f");
    argv.push(pool2.name);
    argv.push(...this.formatVDevsArgv(vdevs));
    console.log("****\ncmdstring:\n", ...argv, "\n****");
    try {
      const proc = await unwrap(this.server.execute(new Command(argv, this.commandOptions)));
      console.log("Command output:", proc.getStdout());
      return proc;
    } catch (error) {
      console.error("Error executing command:", error);
      throw error;
    }
  }
  async addDataset(parent, name, options) {
    const argv = ["zfs", "create"];
    const datasetProps = [];
    if (options.atime !== void 0)
      datasetProps.push(`atime=${options.atime}`);
    if (options.casesensitivity !== void 0)
      datasetProps.push(`casesensitivity=${options.casesensitivity}`);
    if (options.compression !== void 0)
      datasetProps.push(`compression=${options.compression}`);
    if (options.dedup !== void 0)
      datasetProps.push(`dedup=${options.dedup}`);
    if (options.dnodesize !== void 0)
      datasetProps.push(`dnodesize=${options.dnodesize}`);
    if (options.xattr !== void 0)
      datasetProps.push(`xattr=${options.xattr}`);
    if (options.recordsize !== void 0)
      datasetProps.push(`recordsize=${options.recordsize}`);
    if (options.readonly !== void 0)
      datasetProps.push(`readonly=${options.readonly}`);
    if (options.quota !== void 0) {
      datasetProps.push(`quota=${options.quota === "0" ? "none" : options.quota}`);
    }
    argv.push(...datasetProps.flatMap((prop) => ["-o", prop]));
    argv.push(`${parent}/${name}`);
    console.log("****\ncmdstring:\n", ...argv, "\n****");
    try {
      const proc = await unwrap(this.server.execute(new Command(argv, this.commandOptions)));
      console.log("Command output:", proc.getStdout());
      return proc;
    } catch (error) {
      console.error("Error executing command:", error);
      throw error;
    }
  }
  allDisksHaveSameCapacity(disks) {
    if (disks.length === 0)
      return false;
    const firstCapacity = convertToBytes(disks[0].capacity);
    return disks.every((disk) => convertToBytes(disk.capacity) === firstCapacity);
  }
}
var Disks;
((Disks2) => {
  function runCommandJson(command, options = {}) {
    return server.execute(new Command(command, options)).map((proc) => proc.getStdout()).andThen(safeJsonParse);
  }
  Disks2.runCommandJson = runCommandJson;
  function fetchLsdev() {
    return runCommandJson(["/opt/45drives/tools/lsdev", "--json"]);
  }
  Disks2.fetchLsdev = fetchLsdev;
})(Disks || (Disks = {}));
class BetterCockpitFile$1 {
  constructor(path, opts) {
    var _a2;
    __publicField2(this, "failIfDNE");
    __publicField2(this, "persistStat");
    __publicField2(this, "fileHandle");
    __publicField2(this, "hookedFileHandle");
    __publicField2(this, "path");
    __publicField2(this, "stat");
    const opts_ = { ...opts };
    this.failIfDNE = opts_.dne === "fail";
    delete opts_.dne;
    this.persistStat = (_a2 = opts_.persistStat) != null ? _a2 : false;
    delete opts_.persistStat;
    this.fileHandle = cockpit.file(path, opts_);
    this.hookedFileHandle = {
      ...this.fileHandle,
      read: this.read,
      replace: this.replace,
      close: this.close
    };
    this.path = path;
  }
  read() {
    if (this.failIfDNE)
      return new Promise((resolve2, reject) => {
        this.fileHandle.read().then((content, tag) => {
          if (content === null && tag === "-")
            reject(new Error("File does not exist: " + this.path));
          else
            resolve2(...[content, tag]);
        }).catch((error) => reject(error));
      });
    else
      return this.fileHandle.read();
  }
  replace(content) {
    if (this.persistStat)
      return new Promise(async (resolve2, reject) => {
        await this.getStat();
        this.fileHandle.replace(content).then(
          (content2) => this.setStat().then(() => resolve2(content2)).catch((error) => reject(error))
        ).catch((error) => reject(error));
      });
    else
      return this.fileHandle.replace(content);
  }
  watch(callback, opts) {
    return this.hookedFileHandle.watch(callback, opts);
  }
  close() {
    return this.fileHandle.close();
  }
  async getStat() {
    try {
      const statFields = (await useSpawn$6(["stat", this.path, "--format=%u:%g:%a"]).promise()).stdout.split(":").map((a2) => a2.trim());
      this.stat = { uid: statFields[0], gid: statFields[1], permissions: statFields[2] };
      return { ...this.stat };
    } catch (state) {
      throw new Error(errorString$6(state));
    }
  }
  async setStat(stat = {}) {
    const tmpStat = { ...this.stat, ...stat };
    let ownership = "";
    if (tmpStat.uid)
      ownership += tmpStat.uid;
    if (tmpStat.gid)
      ownership += ":" + tmpStat.gid;
    if (ownership) {
      try {
        await useSpawn$6(["chown", ownership, this.path]).promise();
      } catch (state) {
        throw new Error(errorString$6(state));
      }
    }
    if (tmpStat.permissions) {
      try {
        await useSpawn$6(["chmod", tmpStat.permissions, this.path]).promise();
      } catch (state) {
        throw new Error(errorString$6(state));
      }
    }
    this.stat = tmpStat;
  }
}
async function getFingerprint(pubKey) {
  let tmpFile, result;
  try {
    tmpFile = (await useSpawn$6(["mktemp"], { superuser: "try" }).promise()).stdout.trim();
    const ddState = useSpawn$6(["dd", `of=${tmpFile}`], { superuser: "try" });
    ddState.proc.input(pubKey);
    await ddState.promise();
    result = (await useSpawn$6(["ssh-keygen", "-l", "-f", tmpFile], { superuser: "try" }).promise()).stdout.split(" ")[1];
  } catch (state) {
    result = "Failed to get fingerprint: " + errorString$6(state);
  } finally {
    if (tmpFile)
      useSpawn$6(["rm", tmpFile], { superuser: "try" });
  }
  return result;
}
const SSHAuthorizedKeysSyntax = {
  parse: async (string) => {
    return (await Promise.all(string.split("\n").filter((line) => !/^(\s*|\s*#.*)$/.test(line)).map((line) => line.replace(/\s*#.*$/, "")).map(async (line) => {
      var _a3;
      var _a2;
      const obj = {
        pubKey: line,
        fingerprint: await getFingerprint(line)
      };
      const regexp = new RegExp([
        /^((?:\w+=(?:"[^"]*"|'[^']*'|(?:[^,\s]|\\\s)*),?)+)?/,
        /\s*/,
        /\b(\S+)\b/,
        /\s*/,
        /(\S+)/,
        /\s*/,
        /(\S*)$/
      ].map((r2) => r2.source).join(""));
      const regMatch = line.match(regexp);
      if (!regMatch) {
        console.error("regex match on key failed: " + line);
        return null;
      }
      obj.options = (_a3 = (_a2 = regMatch[1]) == null ? void 0 : _a2.split(new RegExp(`(?<!\\\\),(?=(?:[^\\"]*\\"[^\\"]*\\")*[^\\"]*$)(?=(?:[^\\']*\\'[^\\']*\\')*[^\\']*$)`, "g"))) != null ? _a3 : null;
      obj.algo = regMatch[2];
      obj.pubKey = regMatch[3];
      obj.comment = regMatch[4];
      return obj;
    }))).filter((obj) => obj !== null);
  },
  stringify: (objs) => {
    var _a2;
    return ((_a2 = objs.map((obj) => {
      var _a4;
      var _a3;
      return [
        (_a4 = (_a3 = obj.options) == null ? void 0 : _a3.join(",")) != null ? _a4 : null,
        obj.algo,
        obj.pubKey,
        obj.comment
      ].filter((field) => field !== null).join(" ");
    }).join("\n")) != null ? _a2 : "") + "\n";
  }
};
const index = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  BetterCockpitFile: BetterCockpitFile$1,
  SSHAuthorizedKeysSyntax,
  errorString: errorString$6,
  errorStringHTML,
  getFingerprint,
  useSpawn: useSpawn$6
}, Symbol.toStringTag, { value: "Module" }));
(_a = window.reportHoustonError) != null ? _a : window.reportHoustonError = (e, ctx = "") => {
  console.error(ctx, e);
  return e;
};
const _sfc_main$v = defineComponent({});
const _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const _hoisted_1$p = { class: "size-icon aspect-square animate-spin border-2 border-neutral-300 border-t-neutral-500 dark:border-neutral-500 dark:border-t-neutral-200 rounded-full" };
function _sfc_render$4(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$p);
}
const LoadingSpinner = /* @__PURE__ */ _export_sfc(_sfc_main$v, [["render", _sfc_render$4], ["__scopeId", "data-v-7754b6ec"]]);
const defaultErrorConfig = {
  withStackTrace: false
};
const createNeverThrowError = (message, result, config = defaultErrorConfig) => {
  const data = result.isOk() ? { type: "Ok", value: result.value } : { type: "Err", value: result.error };
  const maybeStack = config.withStackTrace ? new Error().stack : void 0;
  return {
    data,
    message,
    stack: maybeStack
  };
};
function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve2) {
      resolve2(value);
    });
  }
  return new (P || (P = Promise))(function(resolve2, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve2(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, [])).next());
  });
}
function __values(o2) {
  var s2 = typeof Symbol === "function" && Symbol.iterator, m = s2 && o2[s2], i2 = 0;
  if (m)
    return m.call(o2);
  if (o2 && typeof o2.length === "number")
    return {
      next: function() {
        if (o2 && i2 >= o2.length)
          o2 = void 0;
        return { value: o2 && o2[i2++], done: !o2 };
      }
    };
  throw new TypeError(s2 ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function __await(v2) {
  return this instanceof __await ? (this.v = v2, this) : new __await(v2);
}
function __asyncGenerator(thisArg, _arguments, generator) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var g = generator.apply(thisArg, _arguments || []), i2, q = [];
  return i2 = {}, verb("next"), verb("throw"), verb("return"), i2[Symbol.asyncIterator] = function() {
    return this;
  }, i2;
  function verb(n) {
    if (g[n])
      i2[n] = function(v2) {
        return new Promise(function(a2, b2) {
          q.push([n, v2, a2, b2]) > 1 || resume(n, v2);
        });
      };
  }
  function resume(n, v2) {
    try {
      step(g[n](v2));
    } catch (e) {
      settle(q[0][3], e);
    }
  }
  function step(r2) {
    r2.value instanceof __await ? Promise.resolve(r2.value.v).then(fulfill, reject) : settle(q[0][2], r2);
  }
  function fulfill(value) {
    resume("next", value);
  }
  function reject(value) {
    resume("throw", value);
  }
  function settle(f2, v2) {
    if (f2(v2), q.shift(), q.length)
      resume(q[0][0], q[0][1]);
  }
}
function __asyncDelegator(o2) {
  var i2, p2;
  return i2 = {}, verb("next"), verb("throw", function(e) {
    throw e;
  }), verb("return"), i2[Symbol.iterator] = function() {
    return this;
  }, i2;
  function verb(n, f2) {
    i2[n] = o2[n] ? function(v2) {
      return (p2 = !p2) ? { value: __await(o2[n](v2)), done: n === "return" } : f2 ? f2(v2) : v2;
    } : f2;
  }
}
function __asyncValues(o2) {
  if (!Symbol.asyncIterator)
    throw new TypeError("Symbol.asyncIterator is not defined.");
  var m = o2[Symbol.asyncIterator], i2;
  return m ? m.call(o2) : (o2 = typeof __values === "function" ? __values(o2) : o2[Symbol.iterator](), i2 = {}, verb("next"), verb("throw"), verb("return"), i2[Symbol.asyncIterator] = function() {
    return this;
  }, i2);
  function verb(n) {
    i2[n] = o2[n] && function(v2) {
      return new Promise(function(resolve2, reject) {
        v2 = o2[n](v2), settle(resolve2, reject, v2.done, v2.value);
      });
    };
  }
  function settle(resolve2, reject, d2, v2) {
    Promise.resolve(v2).then(function(v3) {
      resolve2({ value: v3, done: d2 });
    }, reject);
  }
}
class ResultAsync {
  constructor(res) {
    this._promise = res;
  }
  static fromSafePromise(promise) {
    const newPromise = promise.then((value) => new Ok(value));
    return new ResultAsync(newPromise);
  }
  static fromPromise(promise, errorFn) {
    const newPromise = promise.then((value) => new Ok(value)).catch((e) => new Err(errorFn(e)));
    return new ResultAsync(newPromise);
  }
  static fromThrowable(fn, errorFn) {
    return (...args) => {
      return new ResultAsync((() => __awaiter(this, void 0, void 0, function* () {
        try {
          return new Ok(yield fn(...args));
        } catch (error) {
          return new Err(errorFn ? errorFn(error) : error);
        }
      }))());
    };
  }
  static combine(asyncResultList) {
    return combineResultAsyncList(asyncResultList);
  }
  static combineWithAllErrors(asyncResultList) {
    return combineResultAsyncListWithAllErrors(asyncResultList);
  }
  map(f2) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, void 0, void 0, function* () {
      if (res.isErr()) {
        return new Err(res.error);
      }
      return new Ok(yield f2(res.value));
    })));
  }
  mapErr(f2) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, void 0, void 0, function* () {
      if (res.isOk()) {
        return new Ok(res.value);
      }
      return new Err(yield f2(res.error));
    })));
  }
  andThen(f2) {
    return new ResultAsync(this._promise.then((res) => {
      if (res.isErr()) {
        return new Err(res.error);
      }
      const newValue = f2(res.value);
      return newValue instanceof ResultAsync ? newValue._promise : newValue;
    }));
  }
  orElse(f2) {
    return new ResultAsync(this._promise.then((res) => __awaiter(this, void 0, void 0, function* () {
      if (res.isErr()) {
        return f2(res.error);
      }
      return new Ok(res.value);
    })));
  }
  match(ok2, _err) {
    return this._promise.then((res) => res.match(ok2, _err));
  }
  unwrapOr(t2) {
    return this._promise.then((res) => res.unwrapOr(t2));
  }
  safeUnwrap() {
    return __asyncGenerator(this, arguments, function* safeUnwrap_1() {
      return yield __await(yield __await(yield* __asyncDelegator(__asyncValues(yield __await(this._promise.then((res) => res.safeUnwrap()))))));
    });
  }
  then(successCallback, failureCallback) {
    return this._promise.then(successCallback, failureCallback);
  }
}
const okAsync = (value) => new ResultAsync(Promise.resolve(new Ok(value)));
const errAsync = (err2) => new ResultAsync(Promise.resolve(new Err(err2)));
ResultAsync.fromPromise;
ResultAsync.fromSafePromise;
ResultAsync.fromThrowable;
const appendValueToEndOfList = (value) => (list) => [...list, value];
const combineResultList = (resultList) => resultList.reduce((acc, result) => acc.isOk() ? result.isErr() ? err(result.error) : acc.map(appendValueToEndOfList(result.value)) : acc, ok([]));
const combineResultAsyncList = (asyncResultList) => ResultAsync.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultList);
const combineResultListWithAllErrors = (resultList) => resultList.reduce((acc, result) => result.isErr() ? acc.isErr() ? err([...acc.error, result.error]) : err([result.error]) : acc.isErr() ? acc : ok([...acc.value, result.value]), ok([]));
const combineResultAsyncListWithAllErrors = (asyncResultList) => ResultAsync.fromSafePromise(Promise.all(asyncResultList)).andThen(combineResultListWithAllErrors);
var Result;
(function(Result2) {
  function fromThrowable(fn, errorFn) {
    return (...args) => {
      try {
        const result = fn(...args);
        return ok(result);
      } catch (e) {
        return err(errorFn ? errorFn(e) : e);
      }
    };
  }
  Result2.fromThrowable = fromThrowable;
  function combine(resultList) {
    return combineResultList(resultList);
  }
  Result2.combine = combine;
  function combineWithAllErrors(resultList) {
    return combineResultListWithAllErrors(resultList);
  }
  Result2.combineWithAllErrors = combineWithAllErrors;
})(Result || (Result = {}));
const ok = (value) => new Ok(value);
const err = (err2) => new Err(err2);
class Ok {
  constructor(value) {
    this.value = value;
  }
  isOk() {
    return true;
  }
  isErr() {
    return !this.isOk();
  }
  map(f2) {
    return ok(f2(this.value));
  }
  mapErr(_f) {
    return ok(this.value);
  }
  andThen(f2) {
    return f2(this.value);
  }
  orElse(_f) {
    return ok(this.value);
  }
  asyncAndThen(f2) {
    return f2(this.value);
  }
  asyncMap(f2) {
    return ResultAsync.fromSafePromise(f2(this.value));
  }
  unwrapOr(_v) {
    return this.value;
  }
  match(ok2, _err) {
    return ok2(this.value);
  }
  safeUnwrap() {
    const value = this.value;
    return function* () {
      return value;
    }();
  }
  _unsafeUnwrap(_2) {
    return this.value;
  }
  _unsafeUnwrapErr(config) {
    throw createNeverThrowError("Called `_unsafeUnwrapErr` on an Ok", this, config);
  }
}
class Err {
  constructor(error) {
    this.error = error;
  }
  isOk() {
    return false;
  }
  isErr() {
    return !this.isOk();
  }
  map(_f) {
    return err(this.error);
  }
  mapErr(f2) {
    return err(f2(this.error));
  }
  andThen(_f) {
    return err(this.error);
  }
  orElse(f2) {
    return f2(this.error);
  }
  asyncAndThen(_f) {
    return errAsync(this.error);
  }
  asyncMap(_f) {
    return errAsync(this.error);
  }
  unwrapOr(v2) {
    return v2;
  }
  match(_ok, err2) {
    return err2(this.error);
  }
  safeUnwrap() {
    const error = this.error;
    return function* () {
      yield err(error);
      throw new Error("Do not use this generator out of `safeTry`");
    }();
  }
  _unsafeUnwrap(config) {
    throw createNeverThrowError("Called `_unsafeUnwrap` on an Err", this, config);
  }
  _unsafeUnwrapErr(_2) {
    return this.error;
  }
}
Result.fromThrowable;
const globalProcessingState = ref$1(0);
function useGlobalProcessingState() {
  return globalProcessingState;
}
const darkModeState = ref$1(false);
function isCockpitStyleValue(value) {
  return value !== null && ["auto", "dark", "light"].includes(value);
}
const setDarkMode = (style) => {
  var _a3;
  var _a2;
  style = (_a3 = style != null ? style : localStorage.getItem("shell:style")) != null ? _a3 : "auto";
  if (((_a2 = window.matchMedia) == null ? void 0 : _a2.call(window, "(prefers-color-scheme: dark)").matches) && style === "auto" || style === "dark") {
    darkModeState.value = true;
    document.documentElement.classList.add("dark");
  } else {
    darkModeState.value = false;
    document.documentElement.classList.remove("dark");
  }
};
window.addEventListener("storage", (event) => {
  if (event.key === "shell:style" && isCockpitStyleValue(event.newValue)) {
    setDarkMode(event.newValue);
  }
});
window.addEventListener("cockpit-style", (event) => {
  var _a2;
  const styleEvent = event;
  const style = (_a2 = styleEvent.detail) == null ? void 0 : _a2.style;
  if (style === void 0 || !isCockpitStyleValue(style)) {
    return;
  }
  setDarkMode(style);
});
window.matchMedia("(prefers-color-scheme: dark)").addEventListener("change", () => {
  setDarkMode();
});
setDarkMode();
function useDarkModeState() {
  return darkModeState;
}
const _hoisted_1$o = {
  viewBox: "0 0 927.2956 162.9455",
  version: "1.1"
};
const _hoisted_2$f = ["fill"];
const _hoisted_3$c = ["fill"];
const _hoisted_4$7 = ["fill"];
const _hoisted_5$5 = ["fill"];
const _hoisted_6$4 = ["fill"];
const _hoisted_7$4 = ["fill"];
const _hoisted_8$4 = ["fill"];
const _hoisted_9$3 = ["fill"];
const _hoisted_10$3 = ["fill"];
const _sfc_main$u = /* @__PURE__ */ defineComponent({
  __name: "Logo45Drives",
  setup(__props) {
    const darkMode = useDarkModeState();
    const colorFanAnd45 = computed(() => darkMode.value ? "#FFFFFF" : "#333333");
    const colorDrives = computed(() => darkMode.value ? "#DC2626" : "#981c20");
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("svg", _hoisted_1$o, [
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorFanAnd45.value,
          "fill-opacity": "1",
          d: "m 84.980446,60.092653 c -8.78957,-1.65104 -17.43357,2.98987 -21.35048,9.44463 0.16472,0.046 0.3218,0.10348 0.48267,0.13023 3.7407,0.64932 7.44883,1.4461 11.0995,2.49763 0.34284,0.0995 0.62631,0.0709 0.93853,-0.12258 1.1109,-0.68761 2.31567,-1.15112 3.61235,-1.33691 0.35626,-0.0498 0.54205,-0.20686 0.69911,-0.51716 1.59357,-3.12394 3.0684,-6.30344 4.34785,-9.57104 0.0652,-0.16855 0.11301,-0.34668 0.17047,-0.5248 m -15.11406,39.15754 c 0.0575,-0.27389 0.11108,-0.49607 0.1513,-0.72209 0.61675,-3.57787 1.38481,-7.12512 2.38844,-10.61491 0.15707,-0.54779 0.1111,-0.98831 -0.17621,-1.4729 -0.79295,-1.32734 -1.24881,-2.77152 -1.3235,-4.32296 -0.0173,-0.37733 -0.15898,-0.58418 -0.52099,-0.74315 -3.07606,-1.34842 -6.18852,-2.60298 -9.36992,-3.68132 -0.18962,-0.0632 -0.38306,-0.113 -0.57843,-0.17047 -1.7219,9.07304 2.82323,17.59447 9.42931,21.7278 m 32.947954,-14.54713 c 0.73932,-4.91289 0.0134,-9.50974 -2.36164,-13.76375 -1.980484,-3.54915 -4.706034,-6.43942 -8.421824,-8.44288 -0.0881,0.64354 -0.16856,1.19326 -0.24134,1.74297 -0.43286,3.29057 -0.99981,6.55818 -1.7085,9.79896 -0.0823,0.37541 -0.0478,0.67421 0.18388,0.99024 0.97684,1.335 1.63572,2.80982 1.87514,4.45512 0.0478,0.32369 0.20302,0.49991 0.49415,0.64929 3.14694,1.59551 6.33218,3.10098 9.626594,4.37085 0.15131,0.0593 0.30645,0.11109 0.55354,0.1992 M 77.843826,102.34732 c 2.11456,0.76615 8.17091,0.4616 11.91543,-1.15304 4.56813,-1.970887 8.06558,-5.091007 10.630234,-9.456117 -0.551614,-0.0843 -0.997904,-0.1628 -1.444184,-0.21834 -3.33463,-0.4233 -6.64054,-0.99408 -9.92346,-1.70276 -0.53246,-0.11492 -0.94236,-0.0556 -1.40394,0.249 -1.31394,0.86575 -2.69875,1.58591 -4.30382,1.7583 -0.47308,0.0497 -0.94235,0.13215 -1.42119,0.20111 -1.51887,3.39593 -2.9056,6.80908 -4.04907,10.321847 m 10.57085,-53.235397 c -5.29405,-1.1588 -10.5019,-0.91363 -15.61973,0.45584 -6.94124,1.85982 -12.5609,5.80545 -17.0524,11.39255 -1.63381,2.03028 -4.11802,6.24405 -4.18697,7.18641 0.14556,0.0134 0.29113,0.0249 0.43477,0.0383 1.64147,0.15706 3.28484,0.29687 4.92438,0.475 1.38863,0.15132 2.77536,0.3352 4.16017,0.53057 0.40031,0.0556 0.64929,-0.0344 0.88872,-0.38116 0.57077,-0.82361 1.18369,-1.61848 1.80235,-2.40761 2.85006,-3.63918 6.57733,-5.9874 10.93668,-7.3971 1.86173,-0.60142 3.78665,-0.82553 5.72691,-0.97109 1.37906,-0.10151 2.75429,-0.0613 4.12569,0.12066 0.36582,0.0479 0.73358,0.0939 1.09941,0.13983 1.10325,-3.02243 2.05134,-6.01997 2.76002,-9.18222 M 68.424116,111.3725 c 0.0365,-0.24517 0.0709,-0.42522 0.0881,-0.60908 0.16662,-1.7449 0.31602,-3.49362 0.50182,-5.23659 0.13024,-1.22391 0.29305,-2.44591 0.48267,-3.66217 0.0727,-0.47309 -0.004,-0.79869 -0.45011,-1.03236 -0.2739,-0.14367 -0.5114,-0.35818 -0.76424,-0.54588 -1.59739,-1.181777 -3.16798,-2.398027 -4.44745,-3.932227 -4.56046,-5.46643 -6.20958,-11.75263 -5.23849,-18.76475 0.0268,-0.20302 0.0421,-0.40796 0.067,-0.65697 -3.05882,-0.96342 -6.11381,-1.81385 -9.23201,-2.4344 -3.42274,16.10621 5.4894,30.957887 18.99267,36.874427 M 104.55727,85.317903 c 1.41929,0.67995 7.58673,2.53786 9.13625,2.74471 3.3423,-14.86317 -4.53364,-31.03834 -19.532804,-37.12726 -0.58993,3.21396 -1.18177,6.42984 -1.78702,9.72426 4.49342,2.31949 7.835724,5.81118 10.099674,10.33143 2.27544,4.53938 2.7447,9.3546 2.0839,14.32686 M 74.815616,113.38362 c 6.42411,1.58975 15.88023,0.97874 23.75425,-3.96096 6.046784,-3.7924 10.643644,-8.89301 13.357704,-15.562277 -3.26568,-0.60908 -6.45859,-1.20666 -9.72618,-1.81766 -1.59549,2.89219 -3.587474,5.49132 -6.249824,7.535 -2.66617,2.047527 -5.57751,3.610447 -8.87958,4.313397 -3.24078,0.68761 -6.51413,0.93469 -9.77598,0.26239 -0.54588,1.29096 -1.9958,6.7095 -2.48039,9.23011 M 49.619106,67.962863 c 2.13371,-4.92437 5.08718,-9.32779 9.22817,-12.88078 4.12762,-3.53766 8.80491,-6.05252 14.07214,-7.38369 5.24616,-1.32542 10.5517,-1.45568 15.84957,-0.34668 0.50374,-1.42503 1.5725,-8.76084 1.42311,-9.67446 -24.59509,-4.84969 -45.44182,11.26421 -50.91592,30.06343 3.39593,0.0727 6.79569,0.14556 10.34293,0.22218 m -11.62812,4.76349 c -1.80045,8.11728 -1.38097,20.72606 5.79586,32.020927 5.80736,9.14199 13.82696,15.5546 24.28289,18.82413 0.0134,-0.15899 0.0326,-0.29881 0.0364,-0.44055 0.0651,-3.15267 0.12449,-6.30535 0.20686,-9.45803 0.008,-0.31411 -0.11683,-0.44627 -0.36393,-0.56502 -0.69527,-0.33711 -1.38288,-0.68953 -2.07431,-1.03238 -3.55108,-1.76213 -6.72291,-4.03374 -9.43123,-6.94508 -2.20265,-2.36929 -4.09311,-4.95694 -5.59093,-7.826137 -2.26585,-4.33637 -3.56256,-8.93323 -3.82879,-13.8327 -0.14939,-2.72365 -0.0748,-5.4243 0.40796,-8.10963 0.0727,-0.40223 0.12452,-0.80829 0.19154,-1.24497 -3.23503,-0.62633 -6.42218,-1.109 -9.63231,-1.39056 m 35.09123,52.180057 c 24.03198,4.65814 44.970654,-10.66472 50.806754,-30.099837 -3.34423,-0.22983 -6.69035,-0.4616 -10.12458,-0.6991 -1.66061,3.60087 -3.50893,7.174917 -6.26704,10.187787 -2.76003,3.01476 -5.88781,5.56219 -9.496344,7.49286 -3.58172,1.91727 -7.36455,3.25228 -11.41361,3.76369 -4.04141,0.51139 -8.07132,0.53437 -12.05718,-0.35818 -0.4003,0.91938 -1.52271,8.48694 -1.448,9.71278 m 21.34282,-75.855777 c 0.0958,0.0536 0.22027,0.12832 0.34858,0.19154 0.86385,0.42137 1.72766,0.83893 2.5915,1.25838 3.882414,1.89238 7.228544,4.48194 10.084344,7.71698 3.61237,4.09121 6.19043,8.73977 7.62695,14.01466 0.64165,2.35014 0.91745,4.75392 1.07452,7.17301 0.15897,2.44591 0.067,4.88415 -0.35243,7.30326 -0.10151,0.59184 -0.19345,1.18368 -0.29496,1.81191 3.2427,0.65697 6.43559,1.20285 9.73576,1.46718 1.99963,-11.50938 0.34284,-22.33114 -5.88589,-32.19714 -5.76714,-9.13434 -13.80973,-15.53737 -24.215874,-18.78199 -0.23365,3.30015 -0.46925,6.62522 -0.7125,10.04221 m 0.72974,-12.04184 c 0.98068,0.362 1.95942,0.72016 2.93625,1.08408 9.705114,3.62194 17.201814,9.95411 22.725704,18.65367 2.08966,3.28866 3.70047,6.82249 4.88991,10.54211 0.57461,1.79278 1.03429,3.61429 1.35799,5.46452 0.45586,2.59531 0.65505,5.22317 0.74698,7.85296 0.10152,2.9075 -0.15897,5.79969 -0.67228,8.66506 -0.0498,0.27773 -0.0843,0.55737 -0.13217,0.87532 3.29442,0.25283 6.4988,0.3237 9.75299,0.24516 2.12606,-14.54711 -0.48841,-28.06188 -8.75508,-40.2014 -8.09813,-11.89245 -19.14591,-19.79521 -33.271664,-23.2256 0.14174,3.35186 0.27964,6.66351 0.42137,10.04412 m -57.83993,30.76445 c 0.19921,-0.54205 0.40798,-1.086 0.60335,-1.63572 1.53803,-4.33061 3.49744,-8.43905 6.27471,-12.13378 2.13945,-2.85005 4.51641,-5.47792 7.19982,-7.81848 3.50127,-3.05691 7.41052,-5.47984 11.66643,-7.34731 3.41509,-1.49973 6.93934,-2.66235 10.64556,-3.15267 2.2333,-0.29496 4.48576,-0.45395 6.73247,-0.62442 2.46698,-0.1877 4.92247,0.0268 7.36839,0.35243 0.86381,0.11301 1.72381,0.25858 2.62977,0.39648 0.23943,-3.24078 0.38499,-6.43942 0.24709,-9.63807 -12.28127,-2.17585 -28.90465,-0.15705 -42.62243,10.40038 -10.59575,8.15368 -17.73237,18.60195 -20.8544,31.7432 3.39975,-0.18195 6.7095,-0.36008 10.10924,-0.54204 m 88.456914,27.05441 c -3.49552,11.193337 -10.26822,19.919697 -20.31045,26.041177 -10.067104,6.13873 -20.994224,7.74953 -32.595524,5.88972 -0.23941,3.23504 -0.40031,6.45092 -0.31028,9.66488 33.225684,5.33235 58.539024,-18.70728 63.279534,-42.017167 -3.31164,0.13792 -6.62139,0.27773 -10.06328,0.42139 M 26.452896,72.216873 c -2.11074,11.97672 -0.28348,28.552207 10.26055,42.394497 8.16134,10.71449 18.69197,17.88942 31.91366,21.02868 -0.18194,-3.40549 -0.36199,-6.73629 -0.54395,-10.09584 -0.15706,-0.0632 -0.32753,-0.1379 -0.4999,-0.20111 -2.43443,-0.88297 -4.86884,-1.76787 -7.1826,-2.94007 -5.0527,-2.56083 -9.42547,-6.01805 -13.21595,-10.20886 -4.57961,-5.06611 -7.82997,-10.90029 -9.88133,-17.408667 -0.98449,-3.12394 -1.50356,-6.33215 -1.74298,-9.59017 -0.0995,-1.33309 -0.2394,-2.6681 -0.23557,-4.0031 0.008,-2.12796 0.10725,-4.25784 0.45009,-6.36665 0.11876,-0.7355 0.22219,-1.4729 0.33904,-2.26203 -3.24271,-0.26049 -6.42604,-0.37925 -9.66106,-0.34668 M 148.4496,89.673423 c 0.0308,-0.10338 0.0593,-0.16088 0.067,-0.22027 0.28346,-2.11455 0.46926,-4.23675 0.48458,-6.36663 0.0115,-1.58784 -0.0517,-3.17376 -0.11109,-4.75966 -0.0919,-2.5053 -0.2988,-5.00292 -0.66463,-7.48139 -0.85808,-5.79969 -2.57423,-11.34658 -4.89374,-16.71723 -3.79623,-8.79341 -9.41205,-16.26903 -16.45865,-22.70272 -2.57807,-2.35588 -5.28063,-4.56047 -8.19198,-6.49689 -4.25976,-2.8328 -8.81447,-5.091 -13.5952,-6.90101 -3.74069,-1.41545 -7.628864,-2.28694 -11.528534,-3.1182 -0.13025,-0.0268 -0.27198,-0.004 -0.38306,-0.004 0.46733,3.39593 0.9251,6.74012 1.3867,10.10732 0.49609,0.1379 0.99599,0.28731 1.49973,0.41947 3.17566,0.82743 6.284294,1.86938 9.268414,3.21971 7.94489,3.59513 14.7425,8.73784 20.36599,15.40712 6.26129,7.42584 10.37739,15.90512 12.38659,25.40721 0.66847,3.1546 0.91747,6.35706 1.0956,9.57103 0.18387,3.32698 0.0498,6.63862 -0.41947,9.93495 -0.0632,0.44437 -0.10918,0.89063 -0.16854,1.39055 3.35569,-0.1494 6.61946,-0.33328 9.86025,-0.68954 M 89.973726,14.392413 c -0.15322,-0.0383 -0.25281,-0.0785 -0.35433,-0.0881 -1.6836,-0.1379 -3.36912,-0.2988 -5.05654,-0.40222 -2.42293,-0.1494 -4.84394,-0.0173 -7.26303,0.13215 -2.45931,0.15132 -4.91482,0.36584 -7.34731,0.77381 -3.94181,0.66463 -7.7706,1.74871 -11.52661,3.1048 -10.32377,3.72918 -19.08078,9.78171 -26.49514,17.83386 -4.77498,5.18487 -8.75125,10.89838 -11.64345,17.34548 -0.9615,2.14519 -1.8962,4.29996 -2.63169,6.53327 -1.02663,3.11819 -1.76214,6.3111 -2.42293,9.52124 -0.0401,0.19345 -0.0689,0.38882 -0.10535,0.59759 3.42275,-0.42329 6.77079,-0.83701 10.15715,-1.25648 0.0652,-0.19154 0.14364,-0.40414 0.20685,-0.62249 0.22218,-0.78338 0.44436,-1.56676 0.65889,-2.35205 1.25647,-4.59494 3.03392,-8.97345 5.42236,-13.09722 1.62614,-2.8079 3.4917,-5.45109 5.55263,-7.95255 2.26394,-2.75046 4.76349,-5.26915 7.5101,-7.53693 9.30289,-7.67674 19.95418,-12.08015 31.97496,-13.16424 3.93031,-0.35434 7.84531,-0.2241 11.75646,0.24133 0.73742,0.0881 1.47866,0.15515 2.27545,0.23751 -0.0996,-3.34229 -0.31987,-6.60223 -0.66847,-9.84875 m 47.843704,79.83587 c -0.18388,0.64547 -0.38499,1.3235 -0.57078,2.00538 -1.17795,4.345937 -2.7313,8.542487 -4.91482,12.497687 -3.19672,5.79588 -7.20555,10.94627 -12.12037,15.3784 -4.83628,4.35935 -10.25097,7.81849 -16.25562,10.34101 -3.997354,1.67785 -8.117274,2.96306 -12.400024,3.65641 -3.89967,0.63208 -7.83189,0.90022 -11.78519,0.80636 -2.00538,-0.0478 -4.00118,-0.20111 -5.98548,-0.49224 -0.38307,-0.0575 -0.77189,-0.0843 -1.21816,-0.13216 0.0861,3.33464 0.26431,6.60032 0.62823,9.94453 17.33205,1.90387 33.170134,-1.98048 47.485514,-11.95756 14.68887,-10.94627 24.10476,-25.208 27.31489,-43.423047 -3.40741,0.45969 -6.76695,0.91363 -10.17819,1.37523 M 14.688796,72.871903 c -2.13563,16.2384 1.80042,36.866787 16.42035,53.068787 10.52871,11.66835 23.38841,19.02523 38.94303,21.76226 -0.42331,-3.42656 -0.83702,-6.77459 -1.2565,-10.16287 -0.50947,-0.13982 -1.02661,-0.29113 -1.55143,-0.4252 -6.4739,-1.65297 -12.49004,-4.30765 -18.01775,-8.08664 -7.96788,-5.44727 -14.21962,-12.42109 -18.7341,-20.94443 -4.54322,-8.575027 -6.62905,-17.749597 -6.59458,-27.427897 0.01,-2.55125 0.20686,-5.09101 0.57844,-7.61546 0.0344,-0.23557 0.0401,-0.47691 0.0632,-0.76231 -3.34996,0.0422 -6.60991,0.26433 -9.85068,0.59376 M 3.2234465,71.954453 c 0.19537,-0.0152 0.30072,-0.0134 0.40223,-0.0326 3.07415,-0.58419 6.14638,-1.1741 9.2205195,-1.75445 0.28539,-0.0536 0.4367,-0.1858 0.49033,-0.47311 0.12067,-0.6359 0.26241,-1.26796 0.39649,-1.90003 0.64929,-3.0818 1.40011,-6.13872 2.36354,-9.14008 0.79296,-2.4689 1.79086,-4.85926 2.94199,-7.17684 8.87002,-17.88942 22.75253,-30.03087 41.73752,-36.28832 3.25612,-1.07261 6.58309,-1.89621 9.98667,-2.32141 2.2563,-0.28348 4.52791,-0.45203 6.79568,-0.6474 3.63152,-0.31412 7.26112,-0.25283 10.88689,0.1379 0.4233,0.046 0.85042,0.067 1.32543,0.10339 -0.34476,-3.3346402 -0.82359,-6.5658402 -1.36947,-9.7740602 -16.60039,-1.51313 -38.52932,2.37312 -56.76542,17.5235902 -16.22307,13.47835 -25.6389695,30.76061 -28.4123995,51.74334 M 92.816176,12.909723 c 0.35818,0.0766 0.72402,0.15896 1.08985,0.23366 3.00519,0.62058 6.00847,1.25456 8.935134,2.18926 8.24945,2.63553 15.70593,6.75162 22.42307,12.20081 7.29752,5.92036 13.1451,13.04932 17.54467,21.35431 5.11401,9.65531 7.76295,19.95418 7.99279,30.87553 0.0594,2.84431 -0.10727,5.67905 -0.36775,8.50993 -0.0344,0.3869 -0.046,0.77574 -0.0727,1.22582 3.33846,-0.39456 6.59267,-0.80826 9.88899,-1.43076 1.2967,-21.17618 -4.14674,-40.21865 -17.60021,-56.72327 C 126.80811,11.909893 105.6281,4.4036228 90.617446,2.9422028 c 0.72784,3.29825 1.45376,6.59073 2.19884,9.9675202 M 70.347216,149.59911 c -1.04196,-0.2241 -2.08008,-0.44629 -3.1182,-0.67421 -3.32315,-0.73167 -6.61947,-1.55527 -9.8162,-2.74472 -5.49133,-2.04367 -10.61491,-4.78263 -15.42053,-8.1211 -4.70795,-3.2676 -8.93132,-7.08107 -12.68732,-11.40595 -4.57962,-5.27298 -8.29542,-11.09757 -11.10141,-17.49678 -1.97665,-4.50683 -3.50127,-9.159237 -4.48384,-13.987827 -0.56886,-2.78686 -0.88874,-5.60817 -1.08985,-8.44099 -0.12641,-1.79086 -0.22026,-3.58554 -0.2643,-5.38023 -0.0575,-2.3827 0.0882,-4.75966 0.34284,-7.12897 0.0401,-0.36583 0.0593,-0.73166 0.0862,-1.09749 -1.20668,-0.0401 -9.0385695,1.10707 -9.8104595,1.42119 -1.92301,23.00344 6.00465,47.495087 25.6102295,65.196817 12.42684,11.22015 26.98928,17.86453 43.67012,19.83542 -0.64548,-3.35953 -1.27946,-6.65394 -1.91727,-9.97516 m 4.43213,10.25481 c 18.74561,1.63955 42.951874,-3.33272 62.124584,-22.33114 13.16425,-13.04357 20.8161,-28.81269 23.03216,-47.242267 -3.36528,0.74508 -6.65968,1.47292 -9.99049,2.21033 -0.0518,0.20112 -0.11492,0.41947 -0.16472,0.63972 -0.38499,1.71042 -0.76231,3.42275 -1.15496,5.13125 -0.59951,2.608707 -1.35799,5.171447 -2.30801,7.670987 -1.1224,2.94966 -2.47272,5.79971 -3.99543,8.56548 -3.79432,6.88762 -8.59995,12.97653 -14.44369,18.23611 -5.15997,4.64283 -10.88115,8.45247 -17.18651,11.35806 -6.39345,2.94582 -13.049324,5.01824 -20.065274,5.79204 -3.77516,0.41563 -7.56565,0.71825 -11.37147,0.55929 -1.335,-0.0556 -2.66618,-0.15515 -3.99927,-0.24326 -0.59758,-0.0403 -1.19325,-0.10151 -1.87321,-0.15897 0.34859,3.33846 0.80637,6.59075 1.39629,9.81237 M 162.94896,81.492863 c -0.006,45.072167 -36.5086,81.544377 -81.655474,81.452447 C 36.481816,162.85531 -0.04212354,126.70485 3.6462668e-5,81.389443 0.04013646,36.133393 36.619716,-0.1013072 81.649746,2.1280257e-4 126.86173,0.1035928 162.93556,36.704173 162.94896,81.492863",
          id: "path2"
        }, null, 8, _hoisted_2$f),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorFanAnd45.value,
          "fill-opacity": "1",
          d: "m 237.2253,77.106913 c 0,-8.39843 0.76172,-21.21093 1.17579,-29.60937 h -0.83204 c -3.32812,7.46875 -7.07812,14.79297 -10.82421,22.33594 l -17.34766,28.85547 h 71.62109 V 122.00926 H 180.07296 V 100.8452 l 48.25781,-79.484377 h 37.4336 V 153.54832 H 237.2253 Z m 0,0",
          id: "path4"
        }, null, 8, _hoisted_3$c),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorFanAnd45.value,
          "fill-opacity": "1",
          d: "m 292.35421,137.45848 13.76953,-19.32813 c 7.91016,7.29688 17.28906,13.22266 28.54688,13.22266 13.51562,0 22.20312,-7.17188 22.20312,-20.73438 0,-13.218747 -8.51562,-20.441397 -20.75781,-20.441397 -7.66406,0 -11.65234,1.6914 -19.5625,6.75781 l -13.64453,-8.81641 3.625,-66.75781 h 74.96484 v 25.72266 h -48.55859 l -2.17578,24.79297 c 5.01562,-2.14063 9.2539,-3.03516 14.6875,-3.03516 22.82031,0 42.09375,12.90625 42.09375,41.019527 0,29.33594 -22.70313,46.18359 -48.48828,46.18359 -21.57422,0 -36.32032,-8.20312 -46.70313,-18.58593",
          id: "path6"
        }, null, 8, _hoisted_4$7),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 449.63155,139.60301 c 31.23438,0 46.81641,-19.57422 46.81641,-53.351557 0,-33.78125 -15.58203,-52.39063 -46.81641,-52.39063 H 434.4714 V 139.60301 Z M 417.46749,19.915513 h 33.42969 c 41.08594,0 63.11328,23.8789 63.11328,66.33594 0,42.453117 -22.02734,67.296867 -62.36719,67.296867 h -34.17578 z m 0,0",
          id: "path8"
        }, null, 8, _hoisted_5$5),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 542.74484,54.575663 h 13.83203 l 1.41406,18.02344 h 0.55859 c 6.89063,-12.55859 17.00391,-20.46875 28.14063,-20.46875 4.3789,0 7.45703,0.5586 10.5625,2.03906 l -3.125,14.69141 c -3.40625,-1.07422 -5.63672,-1.62891 -9.60156,-1.62891 -8.35938,0 -18.34375,6.02344 -25.03516,22.76563 v 63.550777 h -16.74609 z m 0,0",
          id: "path10"
        }, null, 8, _hoisted_6$4),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 615.01827,54.575663 h 16.7461 v 98.972657 h -16.7461 z m -3.0664,-31.16406 c 0,-6.57812 5.05859,-10.8164 11.5664,-10.8164 6.51563,0 11.57032,4.23828 11.57032,10.8164 0,6.32031 -5.05469,10.82031 -11.57032,10.82031 -6.50781,0 -11.5664,-4.5 -11.5664,-10.82031",
          id: "path12"
        }, null, 8, _hoisted_7$4),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 652.4753,54.575663 h 17.26172 l 18.71485,56.222657 c 2.95703,9.66797 6.17187,19.73828 9.13281,29.19141 h 0.8125 c 2.95703,-9.45313 6.17187,-19.52344 9.13281,-29.19141 l 18.71485,-56.222657 h 16.40625 l -35,98.972657 h -19.46875 z m 0,0",
          id: "path14"
        }, null, 8, _hoisted_8$4),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 824.45968,96.091293 c 0,-19.83203 -8.918,-30.61328 -24.3945,-30.61328 -13.918,0 -26.3516,11.16797 -28.3868,30.61328 z m -69.1875,8.097657 c 0,-32.210937 21.7109,-52.058597 44.4922,-52.058597 25.2422,0 39.4961,18.13281 39.4961,46.44141 0,3.535147 -0.3008,7.070307 -0.7813,9.515617 h -66.6523 c 1.1992,20.96485 14.0195,34.5586 32.8828,34.5586 9.4961,0 17.3008,-3.06641 24.6289,-7.91016 l 6,10.99219 c -8.6797,5.67578 -19.2226,10.26172 -32.6836,10.26172 -26.3789,0 -47.3828,-19.28907 -47.3828,-51.80078",
          id: "path16"
        }, null, 8, _hoisted_9$3),
        createBaseVNode("path", {
          "fill-rule": "nonzero",
          fill: colorDrives.value,
          "fill-opacity": "1",
          d: "m 854.26048,142.25145 8.2695,-11.03125 c 8.5938,6.92578 17.3281,11.72656 29.2149,11.72656 12.9921,0 19.4453,-6.92578 19.4453,-15.375 0,-10.1836 -11.6836,-14.6836 -22.6328,-18.75391 -13.8711,-5.07031 -29.5157,-11.894527 -29.5157,-28.589837 0,-15.83594 12.6836,-28.09375 34.1368,-28.09375 12.3203,0 23.1015,5.04297 30.7734,11.11719 l -8.0117,10.73437 c -6.8164,-5.03906 -13.8125,-8.80859 -22.5703,-8.80859 -12.4649,0 -18.2227,6.64453 -18.2227,14.1914 0,9.41016 10.7617,12.99219 21.9688,17.17188 14.2773,5.382807 30.1796,11.187497 30.1796,30.027337 0,16.05078 -12.75,29.42188 -36.1093,29.42188 -14.0586,0 -27.6211,-5.95703 -36.9258,-13.73828",
          id: "path18"
        }, null, 8, _hoisted_10$3)
      ]);
    };
  }
});
const _sfc_main$t = defineComponent({
  props: {
    moduleName: String
  },
  setup(props) {
    const globalProcessingState2 = useGlobalProcessingState();
    function home() {
      cockpit.location.go("/");
    }
    function vape(event) {
      if (!event.ctrlKey)
        return;
      function makeWide(string) {
        let bytesOut = [];
        let bytesIn = new TextEncoder().encode(string);
        if (bytesIn.indexOf(239) !== -1)
          return string;
        bytesIn.forEach((byte) => {
          if (/^[a-z]$/.test(String.fromCharCode(byte)))
            bytesOut.push(239, 189, byte + 32);
          else if (/^[A-Z0-9]$/.test(String.fromCharCode(byte)))
            bytesOut.push(239, 188, byte + 96);
          else if (String.fromCharCode(byte) === " ")
            bytesOut.push(226, 128, 131);
          else
            bytesOut.push(byte);
        });
        return new TextDecoder().decode(new Uint8Array(bytesOut));
      }
      setInterval(() => {
        let elems = document.querySelectorAll("#app *");
        for (let i2 = 0; i2 < elems.length; i2++) {
          const element = elems[i2];
          if (element.children.length > 0)
            continue;
          if (element.textContent) {
            element.textContent = makeWide(element.textContent);
            element.style.color = "#ff00fb";
          }
        }
      }, 500);
    }
    return {
      globalProcessingState: globalProcessingState2,
      home,
      vape
    };
  },
  components: {
    LoadingSpinner,
    Logo45Drives: _sfc_main$u
  }
});
const _hoisted_1$n = { class: "px-3 sm:px-5 flex items-center bg-plugin-header font-redhat font-normal shadow-lg z-10" };
const _hoisted_2$e = { class: "flex flex-row flex-wrap items-baseline basis-32 grow shrink-0 gap-x-4 content-between" };
const _hoisted_3$b = { class: "flex flex-row items-center my-5" };
const _hoisted_4$6 = { class: "flex basis-32 justify-end items-center grow shrink-0 gap-buttons" };
function _sfc_render$3(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_Logo45Drives = resolveComponent("Logo45Drives");
  const _component_LoadingSpinner = resolveComponent("LoadingSpinner");
  return openBlock(), createElementBlock("div", _hoisted_1$n, [
    createBaseVNode("div", _hoisted_2$e, [
      createBaseVNode("div", _hoisted_3$b, [
        createVNode(_component_Logo45Drives, { class: "h-6" })
      ]),
      renderSlot(_ctx.$slots, "header-left", {}, void 0, true)
    ]),
    createBaseVNode("h1", {
      class: "text-red-800 dark:text-white text-base sm:text-2xl cursor-pointer grow-0 text-center px-2",
      onClick: _cache[0] || (_cache[0] = (...args) => _ctx.home && _ctx.home(...args))
    }, toDisplayString(_ctx.moduleName), 1),
    createBaseVNode("div", _hoisted_4$6, [
      _ctx.globalProcessingState ? (openBlock(), createBlock(_component_LoadingSpinner, {
        key: 0,
        class: "self-center grow-0"
      })) : createCommentVNode("", true),
      _cache[1] || (_cache[1] = createBaseVNode("div", { class: "grow" }, null, -1)),
      renderSlot(_ctx.$slots, "header-right", {}, void 0, true)
    ])
  ]);
}
const HoustonHeader = /* @__PURE__ */ _export_sfc(_sfc_main$t, [["render", _sfc_render$3], ["__scopeId", "data-v-3f0fa9bb"]]);
function render$a(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M9 12.75 11.25 15 15 9.75M21 12a9 9 0 1 1-18 0 9 9 0 0 1 18 0Z"
    })
  ]);
}
function render$9(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M12 9v3.75m9-.75a9 9 0 1 1-18 0 9 9 0 0 1 18 0Zm-9 3.75h.008v.008H12v-.008Z"
    })
  ]);
}
function render$8(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "m11.25 11.25.041-.02a.75.75 0 0 1 1.063.852l-.708 2.836a.75.75 0 0 0 1.063.853l.041-.021M21 12a9 9 0 1 1-18 0 9 9 0 0 1 18 0Zm-9-3.75h.008v.008H12V8.25Z"
    })
  ]);
}
function render$7(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    fill: "none",
    viewBox: "0 0 24 24",
    "stroke-width": "1.5",
    stroke: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      d: "M15 12H9m12 0a9 9 0 1 1-18 0 9 9 0 0 1 18 0Z"
    })
  ]);
}
function render$3(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 20 20",
    fill: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "fill-rule": "evenodd",
      d: "M18 10a8 8 0 1 1-16 0 8 8 0 0 1 16 0Zm-8-5a.75.75 0 0 1 .75.75v4.5a.75.75 0 0 1-1.5 0v-4.5A.75.75 0 0 1 10 5Zm0 10a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z",
      "clip-rule": "evenodd"
    })
  ]);
}
function render$1(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 20 20",
    fill: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", {
      "fill-rule": "evenodd",
      d: "M18 10a8 8 0 1 1-16 0 8 8 0 0 1 16 0ZM8.94 6.94a.75.75 0 1 1-1.061-1.061 3 3 0 1 1 2.871 5.026v.345a.75.75 0 0 1-1.5 0v-.5c0-.72.57-1.172 1.081-1.287A1.5 1.5 0 1 0 8.94 6.94ZM10 15a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z",
      "clip-rule": "evenodd"
    })
  ]);
}
function render(_ctx, _cache) {
  return openBlock(), createElementBlock("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 20 20",
    fill: "currentColor",
    "aria-hidden": "true",
    "data-slot": "icon"
  }, [
    createBaseVNode("path", { d: "M6.28 5.22a.75.75 0 0 0-1.06 1.06L8.94 10l-3.72 3.72a.75.75 0 1 0 1.06 1.06L10 11.06l3.72 3.72a.75.75 0 1 0 1.06-1.06L11.06 10l3.72-3.72a.75.75 0 0 0-1.06-1.06L10 8.94 6.28 5.22Z" })
  ]);
}
const _ = cockpit.gettext;
class Notification {
  constructor(title, body, level = "info", timeout = 1e4) {
    __publicField(this, "title");
    __publicField(this, "body");
    __publicField(this, "level");
    __publicField(this, "timeout");
    __publicField(this, "actions");
    __publicField(this, "key");
    __publicField(this, "remove");
    __publicField(this, "removerTimeout");
    __publicField(this, "removerStartTime");
    __publicField(this, "timeLeftPercent");
    __publicField(this, "timeLeftUpdaterInterval");
    this.title = title;
    this.body = body;
    this.level = level;
    this.timeout = timeout;
    this.actions = [];
    this.key = Symbol();
    this.remove = () => {
    };
    this.timeLeftPercent = 0;
  }
  addAction(label, callback, removesNotification = true) {
    const action = reactive({
      key: Symbol(),
      label,
      callback: async () => {
        action.processing = true;
        await callback();
        action.processing = false;
        if (removesNotification) {
          this.remove();
        }
      },
      processing: false
    });
    this.actions.push(action);
    return this;
  }
  startRemoveTimeout() {
    if (this.timeout !== "never") {
      this.removerStartTime = Date.now();
      this.timeLeftUpdaterInterval = window.setInterval(() => {
        if (this.removerStartTime === void 0 || this.timeout === "never") {
          return;
        }
        this.timeLeftPercent = 100 - (Date.now() - this.removerStartTime) / this.timeout * 100;
      }, 1e3 / 60);
      this.removerTimeout = window.setTimeout(() => this.remove(), this.timeout);
    }
  }
  stopRemoveTimeout() {
    if (this.removerTimeout !== void 0) {
      this.removerStartTime = void 0;
      this.timeLeftPercent = 100;
      window.clearTimeout(this.removerTimeout);
      window.clearTimeout(this.timeLeftUpdaterInterval);
    }
  }
}
const notificationList = ref$1([]);
function pushNotification(notif) {
  notif = reactive(notif);
  notif.startRemoveTimeout();
  notif.remove = () => {
    notif.stopRemoveTimeout();
    notificationList.value = notificationList.value.filter((n) => n.key !== notif.key);
  };
  notificationList.value = [notif, ...notificationList.value];
  return notif;
}
function reportError(e, context = "") {
  if (Array.isArray(e)) {
    return e.map((e2) => reportError(e2));
  }
  console.error(context, e);
  if (!(e instanceof SilentError)) {
    pushNotification(
      new Notification(_(e.name), [context, e.message].join("\n").trim(), "error", 2e4)
    );
  }
  return e;
}
const _sfc_main$s = {
  setup() {
    return {
      notificationList,
      _: cockpit.gettext
    };
  },
  components: {
    InformationCircleIcon: render$8,
    ExclamationCircleIcon: render$9,
    MinusCircleIcon: render$7,
    CheckCircleIcon: render$a,
    XMarkIcon: render
  }
};
const _hoisted_1$m = ["onMouseenter", "onMouseleave"];
const _hoisted_2$d = { class: "flex items-start p-4" };
const _hoisted_3$a = {
  class: "flex-shrink-0",
  "aria-hidden": "true"
};
const _hoisted_4$5 = { class: "ml-3 w-0 flex-1 pt-0.5" };
const _hoisted_5$4 = { class: "text-sm font-medium" };
const _hoisted_6$3 = ["innerHTML"];
const _hoisted_7$3 = {
  key: 0,
  class: "mt-3 flex space-x-7"
};
const _hoisted_8$3 = ["onClick", "disabled"];
const _hoisted_9$2 = ["onClick"];
const _hoisted_10$2 = { class: "ml-4 flex-shrink-0 flex" };
const _hoisted_11$1 = ["onClick"];
const _hoisted_12$1 = { class: "flex justify-end" };
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_ExclamationCircleIcon = resolveComponent("ExclamationCircleIcon");
  const _component_CheckCircleIcon = resolveComponent("CheckCircleIcon");
  const _component_MinusCircleIcon = resolveComponent("MinusCircleIcon");
  const _component_InformationCircleIcon = resolveComponent("InformationCircleIcon");
  const _component_XMarkIcon = resolveComponent("XMarkIcon");
  return openBlock(), createBlock(Teleport, {
    to: "body",
    disabled: _ctx.$slots.default !== void 0
  }, [
    createBaseVNode("div", {
      class: normalizeClass(_ctx.$slots.default ? "relative" : "fixed z-20")
    }, [
      renderSlot(_ctx.$slots, "default", {}, void 0, true),
      createBaseVNode("div", {
        "aria-live": "assertive",
        class: normalizeClass(["inset-0 flex items-end px-4 py-6 pointer-events-none sm:p-6 sm:items-start z-20 overflow-y-auto", _ctx.$slots.default ? "absolute" : "fixed h-screen"])
      }, [
        createVNode(TransitionGroup, {
          tag: "div",
          class: "w-full flex flex-col-reverse items-center sm:items-end sm:flex-col space-y-content",
          "enter-active-class": "transition-all transform ease-out duration-300",
          "enter-from-class": "translate-y-8 opacity-0 scale-95 sm:translate-y-0 sm:translate-x-8",
          "enter-to-class": "translate-y-0 opacity-100 scale-100 sm:translate-x-0",
          "leave-active-class": "transition-all transform ease-in duration-100",
          "leave-from-class": "opacity-100 scale-100 sm:translate-x-0",
          "leave-to-class": "opacity-0 scale-95 sm:translate-x-8"
        }, {
          default: withCtx(() => [
            (openBlock(true), createElementBlock(Fragment, null, renderList($setup.notificationList, (notification) => {
              var _a2;
              return openBlock(), createElementBlock("div", {
                key: notification.key,
                class: "max-w-sm w-full shadow-lg pointer-events-auto overflow-hidden bg-default text-default",
                onMouseenter: ($event) => notification.stopRemoveTimeout(),
                onMouseleave: ($event) => notification.startRemoveTimeout()
              }, [
                createBaseVNode("div", null, [
                  createBaseVNode("div", _hoisted_2$d, [
                    createBaseVNode("div", _hoisted_3$a, [
                      notification.level === "error" ? (openBlock(), createBlock(_component_ExclamationCircleIcon, {
                        key: 0,
                        class: "icon-error size-icon-lg",
                        "aria-hidden": "true"
                      })) : notification.level === "warning" ? (openBlock(), createBlock(_component_ExclamationCircleIcon, {
                        key: 1,
                        class: "icon-warning size-icon-lg",
                        "aria-hidden": "true"
                      })) : notification.level === "success" ? (openBlock(), createBlock(_component_CheckCircleIcon, {
                        key: 2,
                        class: "icon-success size-icon-lg",
                        "aria-hidden": "true"
                      })) : notification.level === "denied" ? (openBlock(), createBlock(_component_MinusCircleIcon, {
                        key: 3,
                        class: "icon-error size-icon-lg",
                        "aria-hidden": "true"
                      })) : (openBlock(), createBlock(_component_InformationCircleIcon, {
                        key: 4,
                        class: "icon-info size-icon-lg"
                      }))
                    ]),
                    createBaseVNode("div", _hoisted_4$5, [
                      createBaseVNode("p", _hoisted_5$4, toDisplayString(notification.title), 1),
                      createBaseVNode("p", {
                        class: "mt-1 text-sm text-muted whitespace-pre-wrap",
                        innerHTML: notification.body
                      }, null, 8, _hoisted_6$3),
                      ((_a2 = notification.actions) == null ? void 0 : _a2.length) ? (openBlock(), createElementBlock("div", _hoisted_7$3, [
                        (openBlock(true), createElementBlock(Fragment, null, renderList(notification.actions, (action) => {
                          return openBlock(), createElementBlock("button", {
                            key: action.key,
                            onClick: ($event) => action.callback(),
                            class: normalizeClass(["rounded-md text-sm font-medium", action.processing ? "text-muted cursor-wait" : "text-primary"]),
                            disabled: action.processing
                          }, toDisplayString(action.label), 11, _hoisted_8$3);
                        }), 128)),
                        createBaseVNode("button", {
                          onClick: ($event) => notification.remove(),
                          type: "button",
                          class: "rounded-md text-sm font-medium text-secondary"
                        }, toDisplayString($setup._("Dismiss")), 9, _hoisted_9$2)
                      ])) : createCommentVNode("", true)
                    ]),
                    createBaseVNode("div", _hoisted_10$2, [
                      createBaseVNode("button", {
                        onClick: ($event) => notification.remove(),
                        class: "icon-default"
                      }, [
                        _cache[0] || (_cache[0] = createBaseVNode("span", { class: "sr-only" }, "Close", -1)),
                        createVNode(_component_XMarkIcon, {
                          class: "size-icon",
                          "aria-hidden": "true"
                        })
                      ], 8, _hoisted_11$1)
                    ])
                  ]),
                  createBaseVNode("div", _hoisted_12$1, [
                    notification.timeout !== "never" ? (openBlock(), createElementBlock("div", {
                      key: 0,
                      class: "border-t-4 border-default",
                      style: normalizeStyle({ width: `${notification.timeLeftPercent}%` })
                    }, null, 4)) : createCommentVNode("", true)
                  ])
                ])
              ], 40, _hoisted_1$m);
            }), 128))
          ]),
          _: 1
        })
      ], 2)
    ], 2)
  ], 8, ["disabled"]);
}
const NotificationView = /* @__PURE__ */ _export_sfc(_sfc_main$s, [["render", _sfc_render$2], ["__scopeId", "data-v-0f4d9f7a"]]);
const _hoisted_1$l = { class: "flex flex-row flex-nowrap items-stretch self-stretch gap-2" };
const _hoisted_2$c = ["onClick"];
const _sfc_main$r = /* @__PURE__ */ defineComponent({
  __name: "TabSelector",
  props: /* @__PURE__ */ mergeModels({
    labels: {}
  }, {
    "index": { required: true },
    "indexModifiers": {}
  }),
  emits: ["update:index"],
  setup(__props) {
    const index2 = useModel(__props, "index");
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$l, [
        (openBlock(true), createElementBlock(Fragment, null, renderList(_ctx.labels, (label, i2) => {
          return openBlock(), createElementBlock("button", {
            key: label,
            class: normalizeClass([
              "px-2 border-b-2 border-b-transparent hover:border-b-neutral-400 dark:hover:border-b-neutral-600 text-lg font-medium sm:pt-2",
              i2 === index2.value ? "!border-b-red-700 dark:!border-b-red-800" : "text-muted hover:text-default"
            ]),
            onClick: ($event) => index2.value = i2
          }, toDisplayString(label), 11, _hoisted_2$c);
        }), 128))
      ]);
    };
  }
});
const TabSelector = /* @__PURE__ */ _export_sfc(_sfc_main$r, [["__scopeId", "data-v-977a4031"]]);
const _sfc_main$q = /* @__PURE__ */ defineComponent({
  __name: "TabView",
  props: {
    currentComponent: {}
  },
  setup(__props) {
    return (_ctx, _cache) => {
      return openBlock(), createBlock(KeepAlive, null, [
        _ctx.currentComponent ? (openBlock(), createBlock(resolveDynamicComponent(_ctx.currentComponent), {
          key: _ctx.currentComponent.name
        })) : createCommentVNode("", true)
      ], 1024);
    };
  }
});
const TabView = /* @__PURE__ */ _export_sfc(_sfc_main$q, [["__scopeId", "data-v-64d7efde"]]);
function defineHoustonAppTabState(entries) {
  var _a2;
  const entries_ = Array.isArray(entries) ? computed(() => entries) : entries;
  const index_ = ref$1(parseInt((_a2 = cockpit.localStorage.getItem("HoustonHeaderTabIndex")) != null ? _a2 : "") || 0);
  const index2 = computed({
    get: () => Math.min(Math.max(0, index_.value), Math.max(0, entries_.value.length - 1)),
    set: (value) => {
      index_.value = Math.min(Math.max(0, value), Math.max(0, entries_.value.length - 1));
      cockpit.localStorage.setItem("HoustonHeaderTabIndex", index_.value.toString());
    }
  });
  const currentComponent = computed(() => {
    var _a3;
    return (_a3 = entries_.value[index2.value]) == null ? void 0 : _a3.component;
  });
  return {
    labels: computed(() => entries_.value.map(({ label }) => label)),
    index: index2,
    currentComponent
  };
}
const _hoisted_1$k = { class: "fixed z-10 text-default" };
const _hoisted_2$b = {
  key: 0,
  class: "fixed z-10 inset-0 bg-neutral-500/75 dark:bg-black/50 transition-opacity pointer"
};
const _hoisted_3$9 = { class: "max-w-full max-h-full overflow-auto whitespace-normal" };
const _sfc_main$p = /* @__PURE__ */ defineComponent({
  __name: "Modal",
  props: {
    show: { type: Boolean }
  },
  emits: ["clickOutside", "beforeEnter", "enter", "afterEnter", "enterCancelled", "beforeLeave", "leave", "afterLeave", "leaveCancelled"],
  setup(__props, { emit: __emit }) {
    const emit2 = __emit;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(Teleport, { to: "body" }, [
        createBaseVNode("div", _hoisted_1$k, [
          createVNode(Transition, {
            mode: "out-in",
            "enter-active-class": "ease-out duration-500",
            "enter-from-class": "opacity-0",
            "enter-to-class": "opacity-100",
            "leave-active-class": "ease-in duration-500",
            "leave-from-class": "opacity-100",
            "leave-to-class": "opacity-0"
          }, {
            default: withCtx(() => [
              _ctx.show ? (openBlock(), createElementBlock("div", _hoisted_2$b)) : createCommentVNode("", true)
            ]),
            _: 1
          }),
          createVNode(Transition, {
            mode: "out-in",
            "enter-active-class": "ease-out duration-300",
            "enter-from-class": "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-90",
            "enter-to-class": "opacity-100 translate-y-0 sm:scale-100",
            "leave-active-class": "ease-in duration-100",
            "leave-from-class": "opacity-100 translate-y-0 sm:scale-100",
            "leave-to-class": "opacity-0 translate-y-4 sm:translate-y-0 sm:scale-75",
            onBeforeEnter: _cache[1] || (_cache[1] = ($event) => emit2("beforeEnter")),
            onEnter: _cache[2] || (_cache[2] = ($event) => emit2("enter")),
            onAfterEnter: _cache[3] || (_cache[3] = ($event) => emit2("afterEnter")),
            onEnterCancelled: _cache[4] || (_cache[4] = ($event) => emit2("enterCancelled")),
            onBeforeLeave: _cache[5] || (_cache[5] = ($event) => emit2("beforeLeave")),
            onLeave: _cache[6] || (_cache[6] = ($event) => emit2("leave")),
            onAfterLeave: _cache[7] || (_cache[7] = ($event) => emit2("afterLeave")),
            onLeaveCancelled: _cache[8] || (_cache[8] = ($event) => emit2("leaveCancelled"))
          }, {
            default: withCtx(() => [
              _ctx.show ? (openBlock(), createElementBlock("div", {
                key: 0,
                class: "fixed overflow-hidden z-10 inset-0 flex items-end sm:items-center justify-center px-4 pb-20 pt-4 sm:pb-4",
                onClick: _cache[0] || (_cache[0] = withModifiers(($event) => emit2("clickOutside"), ["self"]))
              }, [
                createBaseVNode("div", _hoisted_3$9, [
                  renderSlot(_ctx.$slots, "default", {}, void 0, true)
                ])
              ])) : createCommentVNode("", true)
            ]),
            _: 3
          })
        ])
      ]);
    };
  }
});
const Modal = /* @__PURE__ */ _export_sfc(_sfc_main$p, [["__scopeId", "data-v-82577aee"]]);
const _hoisted_1$j = { class: "bg-default md:shadow-lg shadow-md divide-y divide-default flex flex-col" };
const _hoisted_2$a = {
  key: 0,
  class: "px-4 py-2 sm:px-6 sm:py-5 text-header"
};
const _hoisted_3$8 = {
  key: 1,
  class: "px-4 py-2 sm:px-6 sm:py-5"
};
const _sfc_main$o = /* @__PURE__ */ defineComponent({
  __name: "CardContainer",
  props: {
    noBodyPaddingOnMobile: { type: Boolean }
  },
  setup(__props) {
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$j, [
        _ctx.$slots.header ? (openBlock(), createElementBlock("div", _hoisted_2$a, [
          renderSlot(_ctx.$slots, "header", {}, void 0, true)
        ])) : createCommentVNode("", true),
        createBaseVNode("div", {
          class: normalizeClass(["flex-grow sm:px-6 sm:py-5", { "px-4 py-5": !_ctx.noBodyPaddingOnMobile }])
        }, [
          renderSlot(_ctx.$slots, "default", {}, void 0, true)
        ], 2),
        _ctx.$slots.footer ? (openBlock(), createElementBlock("div", _hoisted_3$8, [
          renderSlot(_ctx.$slots, "footer", {}, void 0, true)
        ])) : createCommentVNode("", true)
      ]);
    };
  }
});
const CardContainer = /* @__PURE__ */ _export_sfc(_sfc_main$o, [["__scopeId", "data-v-886b94ad"]]);
const _hoisted_1$i = { class: "flex flex-row items-center gap-2" };
const _hoisted_2$9 = { class: "grow overflow-x-auto whitespace-pre-wrap" };
const _hoisted_3$7 = { class: "button-group-row justify-end grow" };
const _sfc_main$n = /* @__PURE__ */ defineComponent({
  __name: "ModalConfirm",
  props: {
    clickOutsideCancels: { type: Boolean }
  },
  emits: ["confirm", "cancel"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const _2 = cockpit.gettext;
    class Confirmation {
      constructor(header, body, dangerous, confirmButtonText2, cancelButtonText2) {
        __publicField(this, "id");
        __publicField(this, "promise");
        __publicField(this, "resolve");
        this.header = header;
        this.body = body;
        this.dangerous = dangerous;
        this.confirmButtonText = confirmButtonText2;
        this.cancelButtonText = cancelButtonText2;
        this.promise = new Promise((r2) => {
          this.resolve = r2;
        });
        this.id = Symbol();
      }
    }
    const confirmationStack = ref$1([]);
    const pushConfirmation = (c) => {
      confirmationStack.value = [c, ...confirmationStack.value];
    };
    const popConfirmation = () => {
      confirmationStack.value = confirmationStack.value.slice(1);
    };
    const currentConfirmation = computed(
      () => confirmationStack.value.length > 0 ? confirmationStack.value[0] : void 0
    );
    const resolveCurrent = (value) => {
      if (currentConfirmation.value === void 0) {
        return;
      }
      currentConfirmation.value.resolve(value);
      popConfirmation();
    };
    const headerText = ref$1("");
    const bodyText = ref$1("");
    const isDangerous = ref$1(false);
    const confirmButtonText = ref$1("");
    const cancelButtonText = ref$1("");
    watchEffect(() => {
      if (currentConfirmation.value === void 0) {
        return;
      }
      headerText.value = currentConfirmation.value.header;
      bodyText.value = currentConfirmation.value.body;
      isDangerous.value = currentConfirmation.value.dangerous;
      confirmButtonText.value = currentConfirmation.value.confirmButtonText;
      cancelButtonText.value = currentConfirmation.value.cancelButtonText;
    });
    const confirm2 = (options) => {
      var _a2, _b, _c;
      const confirmation = new Confirmation(
        options.header,
        options.body,
        (_a2 = options.dangerous) != null ? _a2 : false,
        (_b = options.confirmButtonText) != null ? _b : _2("Confirm"),
        (_c = options.cancelButtonText) != null ? _c : _2("Cancel")
      );
      pushConfirmation(confirmation);
      return ResultAsync.fromSafePromise(confirmation.promise);
    };
    const assertConfirm2 = (options, resultIfConfirmed) => {
      return confirm2(options).andThen(
        (confirmed) => confirmed ? okAsync(resultIfConfirmed) : errAsync(new CancelledByUser(options.header))
      );
    };
    __expose({
      confirm: confirm2,
      assertConfirm: assertConfirm2
    });
    return (_ctx, _cache) => {
      return openBlock(), createBlock(Modal, {
        show: currentConfirmation.value !== void 0
      }, {
        default: withCtx(() => [
          createVNode(CardContainer, { class: "sm:min-w-96" }, {
            header: withCtx(() => [
              createTextVNode(toDisplayString(headerText.value), 1)
            ]),
            footer: withCtx(() => [
              createBaseVNode("div", _hoisted_3$7, [
                createBaseVNode("button", {
                  class: "btn btn-secondary",
                  onClick: _cache[0] || (_cache[0] = ($event) => resolveCurrent(false))
                }, toDisplayString(cancelButtonText.value), 1),
                createBaseVNode("button", {
                  class: normalizeClass(["btn", isDangerous.value ? "btn-danger" : "btn-primary"]),
                  onClick: _cache[1] || (_cache[1] = ($event) => resolveCurrent(true))
                }, toDisplayString(confirmButtonText.value), 3)
              ])
            ]),
            default: withCtx(() => [
              createBaseVNode("div", _hoisted_1$i, [
                isDangerous.value ? (openBlock(), createBlock(unref(render$3), {
                  key: 0,
                  class: "size-icon-xl icon-danger shrink-0"
                })) : createCommentVNode("", true),
                createBaseVNode("div", _hoisted_2$9, toDisplayString(bodyText.value), 1)
              ])
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["show"]);
    };
  }
});
let globalModalConfirmFuncsPromiseResolver;
new Promise(
  (resolve2) => globalModalConfirmFuncsPromiseResolver = resolve2
);
var _internal;
((_internal2) => {
  _internal2.provideGlobalModalFuncs = (funcs) => {
    globalModalConfirmFuncsPromiseResolver(funcs);
  };
})(_internal || (_internal = {}));
const _sfc_main$m = /* @__PURE__ */ defineComponent({
  __name: "DisclosureController",
  props: {
    "show": { default: false },
    "showModifiers": {}
  },
  emits: ["update:show"],
  setup(__props) {
    const show = useModel(__props, "show");
    const setShow = (value) => show.value = value;
    return (_ctx, _cache) => {
      return renderSlot(_ctx.$slots, "default", {
        show: show.value,
        setShow
      });
    };
  }
});
const _hoisted_1$h = { class: "grow-0 overflow-visible relative" };
const _hoisted_2$8 = { class: "absolute bottom-0 right-0 h-auto inline-flex flex-row justify-end gap-2 py-2 px-6" };
const _hoisted_3$6 = ["onClick"];
const _hoisted_4$4 = { class: "flex flex-col" };
const _hoisted_5$3 = ["href"];
const _hoisted_6$2 = ["href"];
const _hoisted_7$2 = { class: "button-group-row justify-end" };
const _hoisted_8$2 = ["onClick"];
const _sfc_main$l = /* @__PURE__ */ defineComponent({
  __name: "HoustonAppContainer",
  props: {
    moduleName: {},
    appVersion: {},
    sourceURL: {},
    issuesURL: {},
    tabs: {},
    noScroll: { type: Boolean }
  },
  setup(__props) {
    const props = __props;
    const {
      currentComponent,
      labels: tabLabels,
      index: tabIndex
    } = defineHoustonAppTabState(computed(() => {
      var _a2;
      return (_a2 = props.tabs) != null ? _a2 : [];
    }));
    const globalProcessingState2 = useGlobalProcessingState();
    const globalModalConfirm = ref$1(null);
    watchEffect(() => {
      if (globalModalConfirm.value !== null) {
        _internal.provideGlobalModalFuncs(globalModalConfirm.value);
      }
    });
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", {
        class: normalizeClass(["text-default flex flex-col h-full", { "!cursor-wait": unref(globalProcessingState2) !== 0 }])
      }, [
        createVNode(HoustonHeader, { moduleName: _ctx.moduleName }, createSlots({ _: 2 }, [
          _ctx.tabs ? {
            name: "header-left",
            fn: withCtx(() => [
              createVNode(unref(TabSelector), {
                labels: unref(tabLabels),
                index: unref(tabIndex),
                "onUpdate:index": _cache[0] || (_cache[0] = ($event) => isRef(tabIndex) ? tabIndex.value = $event : null)
              }, null, 8, ["labels", "index"])
            ]),
            key: "0"
          } : void 0
        ]), 1032, ["moduleName"]),
        createBaseVNode("div", {
          class: normalizeClass(["grow basis-0 flex flex-col items-stretch", _ctx.noScroll ? "" : "overflow-y-auto"])
        }, [
          createBaseVNode("div", {
            class: normalizeClass(["bg-well grow", _ctx.noScroll ? "" : "overflow-y-auto"]),
            style: { "scrollbar-gutter": "stable both-edges" }
          }, [
            renderSlot(_ctx.$slots, "default", {}, () => [
              _ctx.tabs ? (openBlock(), createBlock(unref(TabView), {
                key: 0,
                currentComponent: unref(currentComponent)
              }, null, 8, ["currentComponent"])) : createCommentVNode("", true)
            ], true)
          ], 2),
          createBaseVNode("div", _hoisted_1$h, [
            createBaseVNode("div", _hoisted_2$8, [
              renderSlot(_ctx.$slots, "bottomRightButtonIcons", {}, void 0, true),
              createVNode(_sfc_main$m, null, {
                default: withCtx(({ show, setShow }) => [
                  createBaseVNode("button", {
                    onClick: ($event) => setShow(true)
                  }, [
                    createVNode(unref(render$1), { class: "size-icon icon-default" })
                  ], 8, _hoisted_3$6),
                  createVNode(unref(Modal), {
                    onClickOutside: ($event) => setShow(false),
                    show
                  }, {
                    default: withCtx(() => [
                      createVNode(CardContainer, null, {
                        header: withCtx(() => [
                          createTextVNode(toDisplayString(`${_ctx.moduleName} ${_ctx.appVersion}`), 1)
                        ]),
                        footer: withCtx(() => [
                          createBaseVNode("div", _hoisted_7$2, [
                            createBaseVNode("button", {
                              onClick: ($event) => setShow(false),
                              class: "btn btn-primary"
                            }, "Close", 8, _hoisted_8$2)
                          ])
                        ]),
                        default: withCtx(() => [
                          createBaseVNode("div", _hoisted_4$4, [
                            _cache[1] || (_cache[1] = createBaseVNode("span", null, [
                              createTextVNode(" Created by "),
                              createBaseVNode("a", {
                                class: "text-link",
                                href: "https://www.45drives.com/?utm_source=Houston&utm_medium=UI&utm_campaign=OS-Link",
                                target: "_blank"
                              }, " 45Drives "),
                              createTextVNode(" for Houston UI (Cockpit) ")
                            ], -1)),
                            _ctx.sourceURL ? (openBlock(), createElementBlock("a", {
                              key: 0,
                              class: "text-link",
                              href: _ctx.sourceURL,
                              target: "_blank"
                            }, "Source Code", 8, _hoisted_5$3)) : createCommentVNode("", true),
                            _ctx.issuesURL ? (openBlock(), createElementBlock("a", {
                              key: 1,
                              class: "text-link",
                              href: _ctx.issuesURL,
                              target: "_blank"
                            }, "Issue Tracker", 8, _hoisted_6$2)) : createCommentVNode("", true)
                          ])
                        ]),
                        _: 2
                      }, 1024)
                    ]),
                    _: 2
                  }, 1032, ["onClickOutside", "show"])
                ]),
                _: 1
              })
            ])
          ])
        ], 2),
        createVNode(NotificationView),
        createVNode(unref(_sfc_main$n), {
          ref_key: "globalModalConfirm",
          ref: globalModalConfirm
        }, null, 512)
      ], 2);
    };
  }
});
const HoustonAppContainer = /* @__PURE__ */ _export_sfc(_sfc_main$l, [["__scopeId", "data-v-bc506818"]]);
const byteToHex = [];
for (let i2 = 0; i2 < 256; ++i2) {
  byteToHex.push((i2 + 256).toString(16).slice(1));
}
typeof crypto !== "undefined" && crypto.randomUUID && crypto.randomUUID.bind(crypto);
function d$1(u2, e, r2) {
  let i2 = ref$1(r2 == null ? void 0 : r2.value), f2 = computed(() => u2.value !== void 0);
  return [computed(() => f2.value ? u2.value : i2.value), function(t2) {
    return f2.value || (i2.value = t2), e == null ? void 0 : e(t2);
  }];
}
let t = Symbol("headlessui.useid"), i = 0;
function I() {
  return inject(t, () => `${++i}`)();
}
function o$1(e) {
  var l;
  if (e == null || e.value == null)
    return null;
  let n = (l = e.value.$el) != null ? l : e.value;
  return n instanceof Node ? n : null;
}
function u$2(r2, n, ...a2) {
  if (r2 in n) {
    let e = n[r2];
    return typeof e == "function" ? e(...a2) : e;
  }
  let t2 = new Error(`Tried to handle "${r2}" but there is no handler defined. Only defined handlers are: ${Object.keys(n).map((e) => `"${e}"`).join(", ")}.`);
  throw Error.captureStackTrace && Error.captureStackTrace(t2, u$2), t2;
}
function r(t2, e) {
  if (t2)
    return t2;
  let n = e != null ? e : "button";
  if (typeof n == "string" && n.toLowerCase() === "button")
    return "button";
}
function s(t2, e) {
  let n = ref$1(r(t2.value.type, t2.value.as));
  return onMounted(() => {
    n.value = r(t2.value.type, t2.value.as);
  }), watchEffect(() => {
    var u2;
    n.value || o$1(e) && o$1(e) instanceof HTMLButtonElement && !((u2 = o$1(e)) != null && u2.hasAttribute("type")) && (n.value = "button");
  }), n;
}
var N = ((o2) => (o2[o2.None = 0] = "None", o2[o2.RenderStrategy = 1] = "RenderStrategy", o2[o2.Static = 2] = "Static", o2))(N || {}), S = ((e) => (e[e.Unmount = 0] = "Unmount", e[e.Hidden = 1] = "Hidden", e))(S || {});
function A({ visible: r2 = true, features: t2 = 0, ourProps: e, theirProps: o2, ...i2 }) {
  var a2;
  let n = j(o2, e), l = Object.assign(i2, { props: n });
  if (r2 || t2 & 2 && n.static)
    return y(l);
  if (t2 & 1) {
    let d2 = (a2 = n.unmount) == null || a2 ? 0 : 1;
    return u$2(d2, { [0]() {
      return null;
    }, [1]() {
      return y({ ...i2, props: { ...n, hidden: true, style: { display: "none" } } });
    } });
  }
  return y(l);
}
function y({ props: r2, attrs: t2, slots: e, slot: o2, name: i2 }) {
  var m, h$1;
  let { as: n, ...l } = T(r2, ["unmount", "static"]), a2 = (m = e.default) == null ? void 0 : m.call(e, o2), d2 = {};
  if (o2) {
    let u2 = false, c = [];
    for (let [p2, f2] of Object.entries(o2))
      typeof f2 == "boolean" && (u2 = true), f2 === true && c.push(p2);
    u2 && (d2["data-headlessui-state"] = c.join(" "));
  }
  if (n === "template") {
    if (a2 = b(a2 != null ? a2 : []), Object.keys(l).length > 0 || Object.keys(t2).length > 0) {
      let [u2, ...c] = a2 != null ? a2 : [];
      if (!v(u2) || c.length > 0)
        throw new Error(['Passing props on "template"!', "", `The current component <${i2} /> is rendering a "template".`, "However we need to passthrough the following props:", Object.keys(l).concat(Object.keys(t2)).map((s2) => s2.trim()).filter((s2, g, R) => R.indexOf(s2) === g).sort((s2, g) => s2.localeCompare(g)).map((s2) => `  - ${s2}`).join(`
`), "", "You can apply a few solutions:", ['Add an `as="..."` prop, to ensure that we render an actual element instead of a "template".', "Render a single element as the child so that we can forward the props onto that element."].map((s2) => `  - ${s2}`).join(`
`)].join(`
`));
      let p2 = j((h$1 = u2.props) != null ? h$1 : {}, l, d2), f2 = cloneVNode(u2, p2, true);
      for (let s2 in p2)
        s2.startsWith("on") && (f2.props || (f2.props = {}), f2.props[s2] = p2[s2]);
      return f2;
    }
    return Array.isArray(a2) && a2.length === 1 ? a2[0] : a2;
  }
  return h(n, Object.assign({}, l, d2), { default: () => a2 });
}
function b(r2) {
  return r2.flatMap((t2) => t2.type === Fragment ? b(t2.children) : [t2]);
}
function j(...r2) {
  if (r2.length === 0)
    return {};
  if (r2.length === 1)
    return r2[0];
  let t2 = {}, e = {};
  for (let i2 of r2)
    for (let n in i2)
      n.startsWith("on") && typeof i2[n] == "function" ? (e[n] != null || (e[n] = []), e[n].push(i2[n])) : t2[n] = i2[n];
  if (t2.disabled || t2["aria-disabled"])
    return Object.assign(t2, Object.fromEntries(Object.keys(e).map((i2) => [i2, void 0])));
  for (let i2 in e)
    Object.assign(t2, { [i2](n, ...l) {
      let a2 = e[i2];
      for (let d2 of a2) {
        if (n instanceof Event && n.defaultPrevented)
          return;
        d2(n, ...l);
      }
    } });
  return t2;
}
function E$1(r2) {
  let t2 = Object.assign({}, r2);
  for (let e in t2)
    t2[e] === void 0 && delete t2[e];
  return t2;
}
function T(r2, t2 = []) {
  let e = Object.assign({}, r2);
  for (let o2 of t2)
    o2 in e && delete e[o2];
  return e;
}
function v(r2) {
  return r2 == null ? false : typeof r2.type == "string" || typeof r2.type == "object" || typeof r2.type == "function";
}
var u$1 = ((e) => (e[e.None = 1] = "None", e[e.Focusable = 2] = "Focusable", e[e.Hidden = 4] = "Hidden", e))(u$1 || {});
let f = defineComponent({ name: "Hidden", props: { as: { type: [Object, String], default: "div" }, features: { type: Number, default: 1 } }, setup(t2, { slots: n, attrs: i2 }) {
  return () => {
    var r2;
    let { features: e, ...d2 } = t2, o2 = { "aria-hidden": (e & 2) === 2 ? true : (r2 = d2["aria-hidden"]) != null ? r2 : void 0, hidden: (e & 4) === 4 ? true : void 0, style: { position: "fixed", top: 1, left: 1, width: 1, height: 0, padding: 0, margin: -1, overflow: "hidden", clip: "rect(0, 0, 0, 0)", whiteSpace: "nowrap", borderWidth: "0", ...(e & 4) === 4 && (e & 2) !== 2 && { display: "none" } } };
    return A({ ourProps: o2, theirProps: d2, slot: {}, attrs: i2, slots: n, name: "Hidden" });
  };
} });
var o = ((r2) => (r2.Space = " ", r2.Enter = "Enter", r2.Escape = "Escape", r2.Backspace = "Backspace", r2.Delete = "Delete", r2.ArrowLeft = "ArrowLeft", r2.ArrowUp = "ArrowUp", r2.ArrowRight = "ArrowRight", r2.ArrowDown = "ArrowDown", r2.Home = "Home", r2.End = "End", r2.PageUp = "PageUp", r2.PageDown = "PageDown", r2.Tab = "Tab", r2))(o || {});
function p(i2) {
  var t2, r2;
  let s2 = (t2 = i2 == null ? void 0 : i2.form) != null ? t2 : i2.closest("form");
  if (s2) {
    for (let n of s2.elements)
      if (n !== i2 && (n.tagName === "INPUT" && n.type === "submit" || n.tagName === "BUTTON" && n.type === "submit" || n.nodeName === "INPUT" && n.type === "image")) {
        n.click();
        return;
      }
    (r2 = s2.requestSubmit) == null || r2.call(s2);
  }
}
let u = Symbol("DescriptionContext");
function w() {
  let t2 = inject(u, null);
  if (t2 === null)
    throw new Error("Missing parent");
  return t2;
}
function k({ slot: t2 = ref$1({}), name: o2 = "Description", props: s2 = {} } = {}) {
  let e = ref$1([]);
  function r2(n) {
    return e.value.push(n), () => {
      let i2 = e.value.indexOf(n);
      i2 !== -1 && e.value.splice(i2, 1);
    };
  }
  return provide(u, { register: r2, slot: t2, name: o2, props: s2 }), computed(() => e.value.length > 0 ? e.value.join(" ") : void 0);
}
defineComponent({ name: "Description", props: { as: { type: [Object, String], default: "p" }, id: { type: String, default: null } }, setup(t2, { attrs: o2, slots: s2 }) {
  var n;
  let e = (n = t2.id) != null ? n : `headlessui-description-${I()}`, r2 = w();
  return onMounted(() => onUnmounted(r2.register(e))), () => {
    let { name: i2 = "Description", slot: l = ref$1({}), props: d2 = {} } = r2, { ...c } = t2, f2 = { ...Object.entries(d2).reduce((a2, [g, m]) => Object.assign(a2, { [g]: unref(m) }), {}), id: e };
    return A({ ourProps: f2, theirProps: c, slot: l.value, attrs: o2, slots: s2, name: i2 });
  };
} });
let a = Symbol("LabelContext");
function d() {
  let t2 = inject(a, null);
  if (t2 === null) {
    let n = new Error("You used a <Label /> component, but it is not inside a parent.");
    throw Error.captureStackTrace && Error.captureStackTrace(n, d), n;
  }
  return t2;
}
function E({ slot: t2 = {}, name: n = "Label", props: i2 = {} } = {}) {
  let e = ref$1([]);
  function o2(r2) {
    return e.value.push(r2), () => {
      let l = e.value.indexOf(r2);
      l !== -1 && e.value.splice(l, 1);
    };
  }
  return provide(a, { register: o2, slot: t2, name: n, props: i2 }), computed(() => e.value.length > 0 ? e.value.join(" ") : void 0);
}
defineComponent({ name: "Label", props: { as: { type: [Object, String], default: "label" }, passive: { type: [Boolean], default: false }, id: { type: String, default: null } }, setup(t2, { slots: n, attrs: i2 }) {
  var r2;
  let e = (r2 = t2.id) != null ? r2 : `headlessui-label-${I()}`, o2 = d();
  return onMounted(() => onUnmounted(o2.register(e))), () => {
    let { name: l = "Label", slot: p2 = {}, props: c = {} } = o2, { passive: f2, ...s2 } = t2, u2 = { ...Object.entries(c).reduce((b2, [g, m]) => Object.assign(b2, { [g]: unref(m) }), {}), id: e };
    return f2 && (delete u2.onClick, delete u2.htmlFor, delete s2.onClick), A({ ourProps: u2, theirProps: s2, slot: p2, attrs: i2, slots: n, name: l });
  };
} });
let C = Symbol("GroupContext");
defineComponent({ name: "SwitchGroup", props: { as: { type: [Object, String], default: "template" } }, setup(l, { slots: c, attrs: i2 }) {
  let r2 = ref$1(null), f2 = E({ name: "SwitchLabel", props: { htmlFor: computed(() => {
    var t2;
    return (t2 = r2.value) == null ? void 0 : t2.id;
  }), onClick(t2) {
    r2.value && (t2.currentTarget.tagName === "LABEL" && t2.preventDefault(), r2.value.click(), r2.value.focus({ preventScroll: true }));
  } } }), p2 = k({ name: "SwitchDescription" });
  return provide(C, { switchRef: r2, labelledby: f2, describedby: p2 }), () => A({ theirProps: l, ourProps: {}, slot: {}, slots: c, attrs: i2, name: "SwitchGroup" });
} });
defineComponent({ name: "Switch", emits: { "update:modelValue": (l) => true }, props: { as: { type: [Object, String], default: "button" }, modelValue: { type: Boolean, default: void 0 }, defaultChecked: { type: Boolean, optional: true }, form: { type: String, optional: true }, name: { type: String, optional: true }, value: { type: String, optional: true }, id: { type: String, default: null }, disabled: { type: Boolean, default: false }, tabIndex: { type: Number, default: 0 } }, inheritAttrs: false, setup(l, { emit: c, attrs: i2, slots: r2, expose: f$1 }) {
  var h$1;
  let p$12 = (h$1 = l.id) != null ? h$1 : `headlessui-switch-${I()}`, n = inject(C, null), [t2, s$1] = d$1(computed(() => l.modelValue), (e) => c("update:modelValue", e), computed(() => l.defaultChecked));
  function m() {
    s$1(!t2.value);
  }
  let E2 = ref$1(null), o$2 = n === null ? E2 : n.switchRef, L = s(computed(() => ({ as: l.as, type: i2.type })), o$2);
  f$1({ el: o$2, $el: o$2 });
  function D(e) {
    e.preventDefault(), m();
  }
  function R(e) {
    e.key === o.Space ? (e.preventDefault(), m()) : e.key === o.Enter && p(e.currentTarget);
  }
  function x(e) {
    e.preventDefault();
  }
  let d2 = computed(() => {
    var e, a2;
    return (a2 = (e = o$1(o$2)) == null ? void 0 : e.closest) == null ? void 0 : a2.call(e, "form");
  });
  return onMounted(() => {
    watch([d2], () => {
      if (!d2.value || l.defaultChecked === void 0)
        return;
      function e() {
        s$1(l.defaultChecked);
      }
      return d2.value.addEventListener("reset", e), () => {
        var a2;
        (a2 = d2.value) == null || a2.removeEventListener("reset", e);
      };
    }, { immediate: true });
  }), () => {
    let { name: e, value: a2, form: K2, tabIndex: y2, ...b2 } = l, T$1 = { checked: t2.value }, B = { id: p$12, ref: o$2, role: "switch", type: L.value, tabIndex: y2 === -1 ? 0 : y2, "aria-checked": t2.value, "aria-labelledby": n == null ? void 0 : n.labelledby.value, "aria-describedby": n == null ? void 0 : n.describedby.value, onClick: D, onKeyup: R, onKeypress: x };
    return h(Fragment, [e != null && t2.value != null ? h(f, E$1({ features: u$1.Hidden, as: "input", type: "checkbox", hidden: true, readOnly: true, checked: t2.value, form: K2, disabled: b2.disabled, name: e, value: a2 })) : null, A({ ourProps: B, theirProps: { ...i2, ...T(b2, ["modelValue", "defaultChecked"]) }, slot: T$1, attrs: i2, slots: r2, name: "Switch" })]);
  };
} });
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getAugmentedNamespace(n) {
  if (n.__esModule)
    return n;
  var f2 = n.default;
  if (typeof f2 == "function") {
    var a2 = function a3() {
      if (this instanceof a3) {
        return Reflect.construct(f2, arguments, this.constructor);
      }
      return f2.apply(this, arguments);
    };
    a2.prototype = f2.prototype;
  } else
    a2 = {};
  Object.defineProperty(a2, "__esModule", { value: true });
  Object.keys(n).forEach(function(k2) {
    var d2 = Object.getOwnPropertyDescriptor(n, k2);
    Object.defineProperty(a2, k2, d2.get ? d2 : {
      enumerable: true,
      get: function() {
        return n[k2];
      }
    });
  });
  return a2;
}
var monet$1 = { exports: {} };
/**
 * Monet.js 0.9.3
 *
 * (c) 2012-2021 Chris Myers
 * @license Monet.js may be freely distributed under the MIT license.
 * For all details and documentation:
 * https://monet.github.io/monet.js/
 */
var monet = monet$1.exports;
var hasRequiredMonet;
function requireMonet() {
  if (hasRequiredMonet)
    return monet$1.exports;
  hasRequiredMonet = 1;
  (function(module) {
    (function(root, factory) {
      if (module.exports) {
        module.exports = factory(root);
      } else {
        root.Monet = factory(root);
      }
    })(typeof self !== "undefined" ? self : monet, function() {
      function assignImp(target, source) {
        for (var key in source) {
          if (source.hasOwnProperty(key) && source[key] !== void 0) {
            target[key] = source[key];
          }
        }
        return target;
      }
      var assign = isFunction2(Object.assign) ? Object.assign : assignImp;
      var Monet = {
        apply2,
        assign,
        compose,
        curry: curry(swap(curry), [])([]),
        idFunction,
        isFunction: isFunction2,
        noop,
        swap
      };
      var TYPE_KEY = "@@type";
      var LIB_NAME = "monet.js";
      var TYPES_NAMES = {
        Identity: "Identity",
        Maybe: "Maybe",
        Either: "Either",
        Validation: "Validation",
        List: "List",
        NEL: "NEL",
        IO: "IO",
        MonadT: "MonadT",
        Reader: "Reader",
        Free: "Free"
      };
      function setType(target, typeName) {
        target[TYPE_KEY] = LIB_NAME + "/" + typeName;
      }
      function isInstance(typeName) {
        return function(target) {
          return (target[TYPE_KEY] || target.constructor[TYPE_KEY]) === LIB_NAME + "/" + typeName;
        };
      }
      function isOfType(typeName) {
        return function(target) {
          var targetType = target[TYPE_KEY] || target.constructor && target.constructor[TYPE_KEY];
          return Boolean(targetType) && targetType.length >= typeName.length && targetType.indexOf(typeName) === targetType.length - typeName.length;
        };
      }
      function isNothing(value) {
        return value == null;
      }
      function isEmpty(value) {
        if (isNothing(value) || value === "") {
          return true;
        }
        if (Array.isArray(value) && value.length === 0) {
          return true;
        }
        if (typeof value === "object") {
          return Object.keys(value).length === 0;
        }
        return false;
      }
      function noop() {
      }
      function getArgs(args) {
        return Array.prototype.slice.call(args);
      }
      function curry(fn, args) {
        return function() {
          var args1 = args.concat(getArgs(arguments));
          return args1.length >= fn.length ? fn.apply(null, args1.slice(0, args1.length)) : curry(fn, args1);
        };
      }
      function compose(f2, g) {
        return function(x) {
          return f2(g(x));
        };
      }
      function isFunction2(f2) {
        return Boolean(f2 && f2.constructor && f2.call && f2.apply);
      }
      function idFunction(value) {
        return value;
      }
      function trueFunction() {
        return true;
      }
      function areEqual(a2, b2) {
        if (a2 === b2 || a2 !== a2 && b2 !== b2) {
          return true;
        }
        if (!a2 || !b2) {
          return false;
        }
        if (isFunction2(a2.equals) && isFunction2(b2.equals)) {
          return a2.equals(b2);
        }
        return false;
      }
      function equals(a2) {
        return function(b2) {
          return areEqual(a2, b2);
        };
      }
      function falseFunction() {
        return false;
      }
      function swap(f2) {
        return function(a2, b2) {
          return f2(b2, a2);
        };
      }
      function apply2(a1, a2, f2) {
        return a2.ap(a1.map(curry(f2, [])));
      }
      function listEquals(list1, list2) {
        var a2 = list1;
        var b2 = list2;
        while (!a2.isNil && !b2.isNil) {
          if (!equals(a2.head())(b2.head())) {
            return false;
          }
          a2 = a2.tail();
          b2 = b2.tail();
        }
        return a2.isNil && b2.isNil;
      }
      function listMapC(fn, l) {
        return l.isNil ? Return(l) : Suspend(function() {
          return listMapC(fn, l.tail());
        }).map(curry(cons, [])(fn(l.head())));
      }
      function listMap(fn, l) {
        return listMapC(fn, l).run();
      }
      function listFilter(list, fn) {
        return list.foldRight(Nil)(function(a2, acc) {
          return fn(a2) ? cons(a2, acc) : acc;
        });
      }
      function listFindC(l, fn) {
        if (l.isNil) {
          return Return(None());
        }
        var h2 = l.head();
        return fn(h2) ? Return(Some(h2)) : Suspend(function() {
          return listFindC(l.tail(), fn);
        });
      }
      function listFind(l, fn) {
        return listFindC(l, fn).run();
      }
      function listContainsC(l, val) {
        if (l.isNil) {
          return Return(false);
        }
        var h2 = l.head();
        return areEqual(h2, val) ? Return(true) : Suspend(function() {
          return listContainsC(l.tail(), val);
        });
      }
      function listContains(l, val) {
        return listContainsC(l, val).run();
      }
      function cons(head, tail) {
        return tail.cons(head);
      }
      function List() {
        switch (arguments.length) {
          case 0:
            return new List.fn.init();
          case 1:
            return new List.fn.init(arguments[0]);
          default:
            return new List.fn.init(arguments[0], arguments[1]);
        }
      }
      Monet.List = List;
      var listForEach = function(effectFn, l) {
        if (!l.isNil) {
          effectFn(l.head());
          listForEach(effectFn, l.tail());
        }
      };
      var foldLeft = function(fn, acc, list) {
        function fL(innerAcc, innerList) {
          return innerList.isNil ? Return(innerAcc) : Suspend(function() {
            return fL(fn(innerAcc, innerList.head()), innerList.tail());
          });
        }
        return fL(acc, list).run();
      };
      var foldRight = function(fn, list, acc) {
        function fR(innerList, innerAcc) {
          return innerList.isNil ? Return(innerAcc) : Suspend(function() {
            return fR(innerList.tail(), innerAcc);
          }).map(function(accumulated) {
            return fn(innerList.head(), accumulated);
          });
        }
        return fR(list, acc).run();
      };
      var append = function(self2, other) {
        function appendFree(listA, listB) {
          return listA.isNil ? Return(listB) : Suspend(function() {
            return appendFree(listA.tail(), listB).map(function(list) {
              return list.cons(listA.head());
            });
          });
        }
        return appendFree(self2, other).run();
      };
      var sequence = function(list, type2) {
        return list.foldRight(type2.of(Nil))(type2.map2(cons));
      };
      var sequenceValidation = function(list) {
        return list.foldLeft(Success(Nil))(function(acc, a2) {
          return acc.ap(a2.map(function(v2) {
            return function(t2) {
              return cons(v2, t2);
            };
          }));
        }).map(listReverse);
      };
      var listReverse = function(list) {
        return list.foldLeft(Nil)(swap(cons));
      };
      var listAp = function(list1, list2) {
        return list1.bind(function(x) {
          return list2.map(function(f2) {
            return f2(x);
          });
        });
      };
      var Nil;
      List.fn = List.prototype = {
        init: function() {
          var head = arguments[0];
          var tail = arguments[1];
          if (arguments.length === 0) {
            this.isNil = true;
            this.size_ = 0;
          } else {
            this.isNil = false;
            this.head_ = head;
            this.tail_ = tail || Nil;
            this.size_ = this.tail_.size() + 1;
          }
          setType(this, TYPES_NAMES.List);
        },
        of: function(value) {
          return new List(value);
        },
        size: function() {
          return this.size_;
        },
        equals: function(other) {
          return (List.isOfType(other) || NEL.isOfType(other)) && listEquals(this, other);
        },
        cons: function(head) {
          return List(head, this);
        },
        snoc: function(element) {
          return this.concat(List(element));
        },
        map: function(fn) {
          return listMap(fn, this);
        },
        toArray: function() {
          return foldLeft(function(acc, e) {
            acc.push(e);
            return acc;
          }, [], this);
        },
        toSet: function() {
          return new Set(this);
        },
        foldLeft: function(initialValue) {
          var self2 = this;
          return function(fn) {
            return foldLeft(fn, initialValue, self2);
          };
        },
        foldRight: function(initialValue) {
          var self2 = this;
          return function(fn) {
            return foldRight(fn, self2, initialValue);
          };
        },
        append: function(list2) {
          return append(this, list2);
        },
        filter: function(fn) {
          return listFilter(this, fn);
        },
        find: function(fn) {
          return listFind(this, fn);
        },
        flatten: function() {
          return foldRight(append, this, Nil);
        },
        flattenMaybe: function() {
          return this.flatMap(Maybe.toList);
        },
        reverse: function() {
          return listReverse(this);
        },
        bind: function(fn) {
          return this.map(fn).flatten();
        },
        forEach: function(effectFn) {
          listForEach(effectFn, this);
        },
        contains: function(val) {
          return listContains(this, val);
        },
        sequenceMaybe: function() {
          return sequence(this, Maybe);
        },
        sequenceValidation: function() {
          return sequenceValidation(this);
        },
        sequenceEither: function() {
          return sequence(this, Either);
        },
        sequenceIO: function() {
          return sequence(this, IO);
        },
        sequenceReader: function() {
          return sequence(this, Reader);
        },
        sequence: function(monadType) {
          return sequence(this, monadType);
        },
        head: function() {
          return this.head_;
        },
        headMaybe: function() {
          return this.isNil ? None() : Some(this.head_);
        },
        lookup: function(i2) {
          return this.isNil || i2 >= this.size() ? None() : Maybe.fromNull(this.toArray()[i2]);
        },
        nth: function(i2) {
          return this.isNil || i2 >= this.size() ? void 0 : this.toArray()[i2];
        },
        tail: function() {
          return this.isNil ? Nil : this.tail_;
        },
        tails: function() {
          return this.isNil ? List(Nil, Nil) : this.tail().tails().cons(this);
        },
        ap: function(list) {
          return listAp(this, list);
        },
        apTo: function(listWithValues) {
          return listAp(listWithValues, this);
        },
        isNEL: falseFunction,
        toString: function() {
          return this.isNil ? "Nil" : "List(" + this.toArray().join(", ") + ")";
        },
        inspect: function() {
          return this.toString();
        }
      };
      List.fn.init.prototype = List.fn;
      setType(List, TYPES_NAMES.List);
      setType(List.fn.init, TYPES_NAMES.List);
      List.isInstance = isInstance(TYPES_NAMES.List);
      List.isOfType = isOfType(TYPES_NAMES.List);
      List.prototype.empty = function() {
        return Nil;
      };
      List.fromArray = function(array) {
        return array.reduceRight(function(acc, next) {
          return acc.cons(next);
        }, Nil);
      };
      List.from = function(iterable) {
        return List.fromArray(Array.from(iterable));
      };
      List.of = function(a2) {
        return new List(a2, Nil);
      };
      List.prototype.each = List.prototype.forEach;
      Nil = Monet.Nil = new List.fn.init();
      function emptyNELError(head) {
        return new Error("Cannot create an empty Non-Empty List. Passed head is " + head + ".");
      }
      function NEL(head, tail) {
        if (isNothing(head)) {
          throw emptyNELError(head);
        }
        return new NEL.fn.init(head, tail);
      }
      Monet.NEL = Monet.NonEmptyList = NEL;
      NEL.of = function(a2) {
        return NEL(a2, Nil);
      };
      NEL.fn = NEL.prototype = {
        init: function(head, tail) {
          if (isNothing(head)) {
            throw emptyNELError(head);
          } else {
            this.isNil = false;
            this.head_ = head;
            this.tail_ = isNothing(tail) ? Nil : tail;
            this.size_ = this.tail_.size() + 1;
          }
          setType(this, TYPES_NAMES.NEL);
        },
        equals: function(other) {
          return List.isOfType(other) || NEL.isOfType(other) && listEquals(this, other);
        },
        cons: function(head) {
          return NEL(head, this.toList());
        },
        snoc: function(element) {
          return this.concat(NEL(element));
        },
        map: function(fn) {
          return NEL(fn(this.head_), listMap(fn, this.tail_));
        },
        bind: function(fn) {
          var p2 = fn(this.head_);
          if (!p2.isNEL()) {
            throw new Error("NEL.fn.bind: Passed function must return a NonEmptyList.");
          }
          var list = this.tail().foldLeft(Nil.snoc(p2.head()).append(p2.tail()))(function(acc, e) {
            var list2 = fn(e).toList();
            return acc.snoc(list2.head()).append(list2.tail());
          });
          return new NEL(list.head(), list.tail());
        },
        head: function() {
          return this.head_;
        },
        lookup: function(i2) {
          return i2 >= this.size() ? None() : Maybe.fromNull(this.toArray()[i2]);
        },
        nth: function(i2) {
          return i2 >= this.size() ? void 0 : this.toArray()[i2];
        },
        tail: function() {
          return this.tail_;
        },
        tails: function() {
          var listsOfNels = this.toList().tails().map(NEL.fromList).flattenMaybe();
          return NEL(listsOfNels.head(), listsOfNels.tail());
        },
        toList: function() {
          return List(this.head_, this.tail_);
        },
        reverse: function() {
          if (this.tail().isNil) {
            return this;
          }
          var reversedTail = this.tail().reverse();
          return NEL(reversedTail.head(), reversedTail.tail().append(List(this.head())));
        },
        foldLeft: function(initialValue) {
          return this.toList().foldLeft(initialValue);
        },
        foldRight: function(initialValue) {
          return this.toList().foldRight(initialValue);
        },
        reduceLeft: function(fn) {
          return this.tail().foldLeft(this.head())(fn);
        },
        filter: function(fn) {
          return listFilter(this.toList(), fn);
        },
        find: function(fn) {
          return listFind(this.toList(), fn);
        },
        flatten: function() {
          return foldRight(append, this.toList().map(function(l) {
            return l.isNEL() ? l.toList() : l;
          }), Nil);
        },
        flattenMaybe: function() {
          return this.toList().flatMap(Maybe.toList);
        },
        contains: function(val) {
          return listContains(this.toList(), val);
        },
        append: function(list2) {
          return NEL.fromList(this.toList().append(list2.toList())).some();
        },
        cobind: function(fn) {
          return this.cojoin().map(fn);
        },
        size: function() {
          return this.size_;
        },
        forEach: function(fn) {
          return this.toList().forEach(fn);
        },
        isNEL: trueFunction,
        toString: function() {
          return "NEL(" + this.toArray().join(", ") + ")";
        },
        inspect: function() {
          return this.toString();
        }
      };
      NEL.fromList = function(list) {
        return list.isNil ? None() : Some(NEL(list.head(), list.tail()));
      };
      NEL.fromArray = function(array) {
        return NEL.fromList(List.fromArray(array));
      };
      NEL.from = function(iterable) {
        return NEL.fromList(List.from(iterable));
      };
      NEL.fn.init.prototype = NEL.fn;
      setType(NEL, TYPES_NAMES.NEL);
      setType(NEL.fn.init, TYPES_NAMES.NEL);
      NEL.isInstance = isInstance(TYPES_NAMES.NEL);
      NEL.isOfType = isOfType(TYPES_NAMES.NEL);
      NEL.prototype.toArray = List.prototype.toArray;
      NEL.prototype.toSet = List.prototype.toSet;
      NEL.prototype.extract = NEL.prototype.copure = NEL.prototype.head;
      NEL.prototype.cojoin = NEL.prototype.tails;
      NEL.prototype.coflatMap = NEL.prototype.mapTails = NEL.prototype.cobind;
      NEL.prototype.ap = List.prototype.ap;
      NEL.prototype.apTo = List.prototype.apTo;
      var Maybe = Monet.Maybe = {};
      Maybe.fromFalsy = function(val) {
        return !val ? Maybe.None() : Maybe.Some(val);
      };
      Maybe.fromNull = function(val) {
        return isNothing(val) ? Maybe.None() : Maybe.Some(val);
      };
      Maybe.fromUndefined = function(val) {
        return val === void 0 ? Maybe.None() : Maybe.Some(val);
      };
      Maybe.fromEmpty = function(val) {
        return isEmpty(val) ? Maybe.None() : Maybe.Some(val);
      };
      Maybe.of = function(a2) {
        return Some(a2);
      };
      var Some = Maybe.Just = Maybe.Some = Maybe.some = Monet.Some = Monet.Just = function(val) {
        return new Maybe.fn.init(true, val);
      };
      var None = Maybe.Nothing = Maybe.None = Maybe.none = Monet.None = Monet.Nothing = function() {
        return new Maybe.fn.init(false, null);
      };
      Maybe.toList = function(maybe) {
        return maybe.toList();
      };
      Maybe.fn = Maybe.prototype = {
        init: function(isValue, val) {
          this.isValue = isValue;
          if (isValue && isNothing(val)) {
            throw new Error("Can not create Some with illegal value: " + val + ".");
          }
          this.val = val;
          setType(this, TYPES_NAMES.Maybe);
        },
        isSome: function() {
          return this.isValue;
        },
        isNone: function() {
          return !this.isSome();
        },
        bind: function(bindFn) {
          return this.isValue ? bindFn(this.val) : this;
        },
        some: function() {
          if (this.isValue) {
            return this.val;
          }
          throw new Error("Cannot call .some() on a None.");
        },
        orSome: function(otherValue) {
          return this.isValue ? this.val : otherValue;
        },
        orLazy: function(getOtherValue) {
          return this.cata(getOtherValue, idFunction);
        },
        orNull: function() {
          return this.orSome(null);
        },
        orUndefined: function() {
          return this.orSome(void 0);
        },
        orElse: function(maybe) {
          return this.catchMap(function() {
            return maybe;
          });
        },
        ap: function(maybeWithFunction) {
          var value = this.val;
          return this.isValue ? maybeWithFunction.map(function(fn) {
            return fn(value);
          }) : this;
        },
        apTo: function(maybeWithValue) {
          return maybeWithValue.ap(this);
        },
        equals: function(other) {
          return Maybe.isOfType(other) && this.cata(function() {
            return other.isNone();
          }, function(val) {
            return other.fold(false)(equals(val));
          });
        },
        toArray: function() {
          return this.map(function(val) {
            return [val];
          }).orLazy(function() {
            return [];
          });
        },
        toSet: function() {
          return new Set(this);
        },
        toList: function() {
          return this.map(List).orLazy(function() {
            return Nil;
          });
        },
        toEither: function(failVal) {
          return this.isSome() ? Right(this.val) : Left(failVal);
        },
        toValidation: function(failVal) {
          return this.isSome() ? Success(this.val) : Fail(failVal);
        },
        fold: function(defaultValue) {
          var self2 = this;
          return function(fn) {
            return self2.isSome() ? fn(self2.val) : defaultValue;
          };
        },
        foldLeft: function(initialValue) {
          return this.toList().foldLeft(initialValue);
        },
        foldRight: function(initialValue) {
          return this.toList().foldRight(initialValue);
        },
        cata: function(none, some) {
          return this.isSome() ? some(this.val) : none();
        },
        catchMap: function(fn) {
          return this.isSome() ? this : fn();
        },
        filter: function(fn) {
          var self2 = this;
          return self2.flatMap(function(a2) {
            return fn(a2) ? self2 : None();
          });
        },
        orNoneIf: function(bool) {
          return bool ? None() : this;
        },
        contains: function(val) {
          return this.isSome() ? areEqual(this.val, val) : false;
        },
        forEach: function(fn) {
          this.cata(noop, fn);
        },
        orElseRun: function(fn) {
          this.cata(fn, noop);
        },
        toString: function() {
          return this.isSome() ? "Just(" + this.val + ")" : "Nothing";
        },
        inspect: function() {
          return this.toString();
        }
      };
      Maybe.prototype.orJust = Maybe.prototype.getOrElse = Maybe.prototype.orSome;
      Maybe.prototype.just = Maybe.prototype.some;
      Maybe.prototype.isJust = Maybe.prototype.isSome;
      Maybe.prototype.isNothing = Maybe.prototype.isNone;
      Maybe.prototype.orNothingIf = Maybe.prototype.orNoneIf;
      Maybe.fn.init.prototype = Maybe.fn;
      setType(Maybe, TYPES_NAMES.Maybe);
      setType(Maybe.fn.init, TYPES_NAMES.Maybe);
      Maybe.isInstance = isInstance(TYPES_NAMES.Maybe);
      Maybe.isOfType = isOfType(TYPES_NAMES.Maybe);
      var Validation = Monet.Validation = {};
      var Success = Validation.Success = Validation.success = Monet.Success = function(val) {
        return new Validation.fn.init(val, true);
      };
      var Fail = Validation.Fail = Validation.fail = Monet.Fail = function(error) {
        return new Validation.fn.init(error, false);
      };
      Validation.of = function(v2) {
        return Success(v2);
      };
      Validation.fn = Validation.prototype = {
        init: function(val, success) {
          this.val = val;
          this.isSuccessValue = success;
          setType(this, TYPES_NAMES.Validation);
        },
        success: function() {
          if (this.isSuccess()) {
            return this.val;
          }
          throw new Error("Cannot call success() on a Fail.");
        },
        isSuccess: function() {
          return this.isSuccessValue;
        },
        isFail: function() {
          return !this.isSuccessValue;
        },
        fail: function() {
          if (this.isSuccess()) {
            throw new Error("Cannot call fail() on a Success.");
          }
          return this.val;
        },
        bind: function(fn) {
          return this.isSuccess() ? fn(this.val) : this;
        },
        ap: function(validationWithFn) {
          var value = this.val;
          return this.isSuccess() ? validationWithFn.map(function(fn) {
            return fn(value);
          }) : validationWithFn.isFail() ? Validation.Fail(Semigroup.append(value, validationWithFn.fail())) : this;
        },
        apTo: function(validationWithValue) {
          return validationWithValue.ap(this);
        },
        acc: function() {
          var x = function() {
            return x;
          };
          return this.isSuccessValue ? Validation.success(x) : this;
        },
        foldLeft: function(initialValue) {
          return this.toMaybe().toList().foldLeft(initialValue);
        },
        foldRight: function(initialValue) {
          return this.toMaybe().toList().foldRight(initialValue);
        },
        cata: function(fail, success) {
          return this.isSuccessValue ? success(this.val) : fail(this.val);
        },
        catchMap: function(fn) {
          return this.isSuccess() ? this : fn(this.val);
        },
        swap: function() {
          return this.isSuccess() ? Fail(this.val) : Success(this.val);
        },
        failMap: function(fn) {
          return this.isFail() ? Fail(fn(this.val)) : this;
        },
        bimap: function(fail, success) {
          return this.isSuccessValue ? this.map(success) : this.failMap(fail);
        },
        forEach: function(fn) {
          this.cata(noop, fn);
        },
        forEachFail: function(fn) {
          this.cata(fn, noop);
        },
        equals: function(other) {
          return Validation.isOfType(other) && this.cata(function(fail) {
            return other.cata(equals(fail), falseFunction);
          }, function(success) {
            return other.cata(falseFunction, equals(success));
          });
        },
        toMaybe: function() {
          return this.isSuccess() ? Some(this.val) : None();
        },
        toEither: function() {
          return (this.isSuccess() ? Right : Left)(this.val);
        },
        toString: function() {
          return (this.isSuccess() ? "Success(" : "Fail(") + this.val + ")";
        },
        inspect: function() {
          return this.toString();
        }
      };
      Validation.prototype.fold = Validation.prototype.cata;
      Validation.fn.init.prototype = Validation.fn;
      setType(Validation, TYPES_NAMES.Validation);
      setType(Validation.fn.init, TYPES_NAMES.Validation);
      Validation.isInstance = isInstance(TYPES_NAMES.Validation);
      Validation.isOfType = isOfType(TYPES_NAMES.Validation);
      var Semigroup = Monet.Semigroup = {
        append: function(a2, b2) {
          if (isFunction2(a2.concat)) {
            return a2.concat(b2);
          }
          throw new Error("Couldn't find a semigroup appender in the environment, please specify your own append function");
        }
      };
      var MonadT = Monet.monadTransformer = Monet.MonadT = Monet.monadT = function(monad) {
        return new MonadT.fn.init(monad);
      };
      MonadT.of = function(m) {
        return MonadT(m);
      };
      MonadT.fn = MonadT.prototype = {
        init: function(monad) {
          this.monad = monad;
          setType(Validation, TYPES_NAMES.MonadT);
        },
        map: function(fn) {
          return MonadT(this.monad.map(function(v2) {
            return v2.map(fn);
          }));
        },
        bind: function(fn) {
          return MonadT(this.monad.map(function(v2) {
            return v2.flatMap(fn);
          }));
        },
        ap: function(monadWithFn) {
          return MonadT(this.monad.flatMap(function(v2) {
            return monadWithFn.perform().map(function(v22) {
              return v2.ap(v22);
            });
          }));
        },
        perform: function() {
          return this.monad;
        }
      };
      MonadT.fn.init.prototype = MonadT.fn;
      var IO = Monet.IO = Monet.io = function(effectFn) {
        return new IO.fn.init(effectFn);
      };
      IO.of = function(a2) {
        return IO(function() {
          return a2;
        });
      };
      IO.fn = IO.prototype = {
        init: function(effectFn) {
          if (!isFunction2(effectFn)) {
            throw new Error("IO requires a function.");
          }
          this.effectFn = effectFn;
          setType(this, TYPES_NAMES.IO);
        },
        map: function(fn) {
          var self2 = this;
          return IO(function() {
            return fn(self2.effectFn());
          });
        },
        bind: function(fn) {
          var self2 = this;
          return IO(function() {
            return fn(self2.effectFn()).run();
          });
        },
        ap: function(ioWithFn) {
          var self2 = this;
          return ioWithFn.map(function(fn) {
            return fn(self2.effectFn());
          });
        },
        apTo: function(ioWithValue) {
          return ioWithValue.ap(this);
        },
        run: function() {
          return this.effectFn();
        }
      };
      IO.fn.init.prototype = IO.fn;
      setType(IO, TYPES_NAMES.IO);
      setType(IO.fn.init, TYPES_NAMES.IO);
      IO.isInstance = isInstance(TYPES_NAMES.IO);
      IO.isOfType = isOfType(TYPES_NAMES.IO);
      IO.prototype.perform = IO.prototype.performUnsafeIO = IO.prototype.run;
      var Either = Monet.Either = {};
      Either.of = function(a2) {
        return Right(a2);
      };
      Either.fromTry = function(fn) {
        try {
          return Either.right(fn());
        } catch (e) {
          return Either.left(e);
        }
      };
      Either.fromPromise = function(promise) {
        return promise.then(Either.Right, Either.Left);
      };
      var Right = Either.Right = Either.right = Monet.Right = function(val) {
        return new Either.fn.init(val, true);
      };
      var Left = Either.Left = Either.left = Monet.Left = function(val) {
        return new Either.fn.init(val, false);
      };
      Either.fn = Either.prototype = {
        init: function(val, isRightValue) {
          this.isRightValue = isRightValue;
          this.value = val;
          setType(this, TYPES_NAMES.Either);
        },
        bind: function(fn) {
          return this.isRightValue ? fn(this.value) : this;
        },
        ap: function(eitherWithFn) {
          var self2 = this;
          return this.isRightValue ? eitherWithFn.map(function(fn) {
            return fn(self2.value);
          }) : this;
        },
        apTo: function(eitherWithValue) {
          return eitherWithValue.ap(this);
        },
        leftMap: function(fn) {
          return this.isLeft() ? Left(fn(this.value)) : this;
        },
        isRight: function() {
          return this.isRightValue;
        },
        isLeft: function() {
          return !this.isRight();
        },
        right: function() {
          if (this.isRightValue) {
            return this.value;
          }
          throw new Error("Cannot call right() on a Left.");
        },
        left: function() {
          if (this.isRightValue) {
            throw new Error("Cannot call left() on a Right.");
          }
          return this.value;
        },
        foldLeft: function(initialValue) {
          return this.toMaybe().toList().foldLeft(initialValue);
        },
        foldRight: function(initialValue) {
          return this.toMaybe().toList().foldRight(initialValue);
        },
        cata: function(leftFn, rightFn) {
          return this.isRightValue ? rightFn(this.value) : leftFn(this.value);
        },
        catchMap: function(fn) {
          return this.isRight() ? this : fn(this.value);
        },
        swap: function() {
          return this.isRight() ? Left(this.value) : Right(this.value);
        },
        forEach: function(fn) {
          this.cata(noop, fn);
        },
        forEachLeft: function(fn) {
          this.cata(fn, noop);
        },
        equals: function(other) {
          return Either.isOfType(other) && this.cata(function(left) {
            return other.cata(equals(left), falseFunction);
          }, function(right) {
            return other.cata(falseFunction, equals(right));
          });
        },
        bimap: function(leftFn, rightFn) {
          return this.isRightValue ? this.map(rightFn) : this.leftMap(leftFn);
        },
        toMaybe: function() {
          return this.isRight() ? Some(this.value) : None();
        },
        toValidation: function() {
          return this.isRight() ? Success(this.value) : Fail(this.value);
        },
        toString: function() {
          return this.cata(function(left) {
            return "Left(" + left + ")";
          }, function(right) {
            return "Right(" + right + ")";
          });
        },
        toPromise: function() {
          return this.cata(function(left) {
            return Promise.reject(left);
          }, function(right) {
            return Promise.resolve(right);
          });
        },
        inspect: function() {
          return this.toString();
        }
      };
      Either.prototype.fold = Either.prototype.cata;
      Either.fn.init.prototype = Either.fn;
      setType(Either, TYPES_NAMES.Either);
      setType(Either.fn.init, TYPES_NAMES.Either);
      Either.isInstance = isInstance(TYPES_NAMES.Either);
      Either.isOfType = isOfType(TYPES_NAMES.Either);
      var Reader = Monet.Reader = function(fn) {
        return new Reader.fn.init(fn);
      };
      Reader.of = function(x) {
        return Reader(function(_2) {
          return x;
        });
      };
      Reader.ask = function() {
        return Reader(idFunction);
      };
      Reader.fn = Reader.prototype = {
        init: function(fn) {
          this.f = fn;
          setType(this, TYPES_NAMES.Reader);
        },
        run: function(config) {
          return this.f(config);
        },
        bind: function(fn) {
          var self2 = this;
          return Reader(function(config) {
            return fn(self2.run(config)).run(config);
          });
        },
        ap: function(readerWithFn) {
          var self2 = this;
          return readerWithFn.bind(function(fn) {
            return Reader(function(config) {
              return fn(self2.run(config));
            });
          });
        },
        apTo: function(readerWithValue) {
          return readerWithValue.ap(this);
        },
        map: function(fn) {
          var self2 = this;
          return Reader(function(config) {
            return fn(self2.run(config));
          });
        },
        local: function(fn) {
          var self2 = this;
          return Reader(function(c) {
            return self2.run(fn(c));
          });
        }
      };
      Reader.fn.init.prototype = Reader.fn;
      setType(Reader, TYPES_NAMES.Reader);
      setType(Reader.fn.init, TYPES_NAMES.Reader);
      Reader.isInstance = isInstance(TYPES_NAMES.Reader);
      Reader.isOfType = isOfType(TYPES_NAMES.Reader);
      var Free = Monet.Free = {};
      var Suspend = Free.Suspend = Monet.Suspend = function(functor) {
        return new Free.fn.init(functor, true);
      };
      var Return = Free.Return = Monet.Return = function(val) {
        return new Free.fn.init(val, false);
      };
      Free.of = function(a2) {
        return Return(a2);
      };
      Free.liftF = function(functor) {
        return isFunction2(functor) ? Suspend(compose(Return, functor)) : Suspend(functor.map(Return));
      };
      Free.fn = Free.prototype = {
        init: function(val, isSuspend) {
          this.isSuspend = isSuspend;
          if (isSuspend) {
            this.functor = val;
          } else {
            this.val = val;
          }
          setType(this, TYPES_NAMES.Free);
        },
        run: function() {
          return this.go(function(f2) {
            return f2();
          });
        },
        bind: function(fn) {
          return this.isSuspend ? isFunction2(this.functor) ? Suspend(compose(function(free) {
            return free.bind(fn);
          }, this.functor)) : Suspend(this.functor.map(function(free) {
            return free.bind(fn);
          })) : fn(this.val);
        },
        ap: function(ff) {
          return this.bind(function(x) {
            return ff.map(function(f2) {
              return f2(x);
            });
          });
        },
        apTo: function(f2) {
          return f2.ap(this);
        },
        resume: function() {
          return this.isSuspend ? Left(this.functor) : Right(this.val);
        },
        go1: function(f2) {
          function go2(t2) {
            return t2.resume().cata(function(functor) {
              return go2(f2(functor));
            }, idFunction);
          }
          return go2(this);
        },
        go: function(f2) {
          var result = this.resume();
          while (result.isLeft()) {
            var next = f2(result.left());
            result = next.resume();
          }
          return result.right();
        }
      };
      Free.fn.init.prototype = Free.fn;
      setType(Free, TYPES_NAMES.Free);
      setType(Free.fn.init, TYPES_NAMES.Free);
      Free.isInstance = isInstance(TYPES_NAMES.Free);
      Free.isOfType = isOfType(TYPES_NAMES.Free);
      function Identity2(a2) {
        return new Identity2.fn.init(a2);
      }
      Monet.Identity = Identity2;
      Identity2.of = function(a2) {
        return new Identity2(a2);
      };
      Identity2.fn = Identity2.prototype = {
        init: function(val) {
          this.val = val;
          setType(this, TYPES_NAMES.Identity);
        },
        bind: function(fn) {
          return fn(this.val);
        },
        get: function() {
          return this.val;
        },
        forEach: function(fn) {
          fn(this.val);
        },
        equals: function(other) {
          return Identity2.isOfType(other) && equals(this.get())(other.get());
        },
        contains: function(val) {
          return areEqual(this.val, val);
        },
        toString: function() {
          return "Identity(" + this.val + ")";
        },
        inspect: function() {
          return this.toString();
        },
        ap: function(applyWithFunction) {
          var value = this.val;
          return applyWithFunction.map(function(fn) {
            return fn(value);
          });
        },
        apTo: function(identityWithValue) {
          return identityWithValue.ap(this);
        },
        toArray: function() {
          return [this.get()];
        },
        toList: function() {
          return List(this.get(), Nil);
        },
        toSet: function() {
          return new Set(this);
        }
      };
      Identity2.fn.init.prototype = Identity2.fn;
      setType(Identity2, TYPES_NAMES.Identity);
      setType(Identity2.fn.init, TYPES_NAMES.Identity);
      Identity2.isInstance = isInstance(TYPES_NAMES.Identity);
      Identity2.isOfType = isOfType(TYPES_NAMES.Identity);
      function addFantasyLandAliases(type2) {
        ["equals", "map", "ap", "chain"].filter(function(method) {
          return isFunction2(type2.prototype[method]);
        }).forEach(function(method) {
          type2.prototype["fantasy-land/" + method] = type2.prototype[method];
        });
      }
      function addAliases(type2) {
        type2.prototype.flatMap = type2.prototype.chain = type2.prototype.bind;
        type2.pure = type2.unit = type2.of;
        type2.prototype.of = type2.of;
        if (isFunction2(type2.prototype.append)) {
          type2.prototype.concat = type2.prototype.append;
        }
        type2.prototype.point = type2.prototype.pure = type2.prototype.unit = type2.prototype.of;
      }
      function addFilterNot(type2) {
        if (isFunction2(type2.prototype.filter)) {
          type2.prototype.filterNot = function(fn) {
            return this.filter(function(a2) {
              return !fn(a2);
            });
          };
        }
      }
      function addMonadOps(type2) {
        type2.prototype.join = function() {
          return this.flatMap(idFunction);
        };
        type2.map2 = function(fn) {
          return function(ma, mb) {
            return ma.flatMap(function(a2) {
              return mb.map(function(b2) {
                return fn(a2, b2);
              });
            });
          };
        };
      }
      function addFunctorOps(type2) {
        if (!isFunction2(type2.prototype.map)) {
          type2.prototype.map = function(fn) {
            return this.bind(compose(this.of, fn));
          };
        }
      }
      function addApplicativeOps(type2) {
        type2.prototype.takeLeft = function(m) {
          return apply2(this, m, function(a2, b2) {
            return a2;
          });
        };
        type2.prototype.takeRight = function(m) {
          return apply2(this, m, function(a2, b2) {
            return b2;
          });
        };
      }
      function addCollectionPredicates(type2) {
        if (isFunction2(type2.prototype.toArray)) {
          type2.prototype.every = type2.prototype.forall = function(fn) {
            return this.toArray().every(fn);
          };
          type2.prototype.exists = function(fn) {
            return this.toArray().some(fn);
          };
        }
      }
      function makeIterable(type2) {
        if (isFunction2(type2.prototype.toArray)) {
          type2.prototype[Symbol.iterator] = function() {
            return this.toArray()[Symbol.iterator]();
          };
        }
      }
      function addToOperator(type2) {
        if (isFunction2(type2.prototype.toArray)) {
          type2.prototype.to = function(ctor) {
            return ctor(this);
          };
        }
      }
      function decorate2(type2) {
        addAliases(type2);
        addFilterNot(type2);
        addMonadOps(type2);
        addFunctorOps(type2);
        addApplicativeOps(type2);
        addCollectionPredicates(type2);
        addFantasyLandAliases(type2);
        makeIterable(type2);
        addToOperator(type2);
      }
      decorate2(MonadT);
      decorate2(Either);
      decorate2(Maybe);
      decorate2(IO);
      decorate2(NEL);
      decorate2(List);
      decorate2(Validation);
      decorate2(Reader);
      decorate2(Free);
      decorate2(Identity2);
      return Monet;
    });
  })(monet$1);
  return monet$1.exports;
}
requireMonet();
var isArguments$1;
var hasRequiredIsArguments$1;
function requireIsArguments$1() {
  if (hasRequiredIsArguments$1)
    return isArguments$1;
  hasRequiredIsArguments$1 = 1;
  var toStr = Object.prototype.toString;
  isArguments$1 = function isArguments2(value) {
    var str = toStr.call(value);
    var isArgs = str === "[object Arguments]";
    if (!isArgs) {
      isArgs = str !== "[object Array]" && value !== null && typeof value === "object" && typeof value.length === "number" && value.length >= 0 && toStr.call(value.callee) === "[object Function]";
    }
    return isArgs;
  };
  return isArguments$1;
}
var implementation$4;
var hasRequiredImplementation$4;
function requireImplementation$4() {
  if (hasRequiredImplementation$4)
    return implementation$4;
  hasRequiredImplementation$4 = 1;
  var keysShim;
  if (!Object.keys) {
    var has = Object.prototype.hasOwnProperty;
    var toStr = Object.prototype.toString;
    var isArgs = requireIsArguments$1();
    var isEnumerable = Object.prototype.propertyIsEnumerable;
    var hasDontEnumBug = !isEnumerable.call({ toString: null }, "toString");
    var hasProtoEnumBug = isEnumerable.call(function() {
    }, "prototype");
    var dontEnums = [
      "toString",
      "toLocaleString",
      "valueOf",
      "hasOwnProperty",
      "isPrototypeOf",
      "propertyIsEnumerable",
      "constructor"
    ];
    var equalsConstructorPrototype = function(o2) {
      var ctor = o2.constructor;
      return ctor && ctor.prototype === o2;
    };
    var excludedKeys = {
      $applicationCache: true,
      $console: true,
      $external: true,
      $frame: true,
      $frameElement: true,
      $frames: true,
      $innerHeight: true,
      $innerWidth: true,
      $onmozfullscreenchange: true,
      $onmozfullscreenerror: true,
      $outerHeight: true,
      $outerWidth: true,
      $pageXOffset: true,
      $pageYOffset: true,
      $parent: true,
      $scrollLeft: true,
      $scrollTop: true,
      $scrollX: true,
      $scrollY: true,
      $self: true,
      $webkitIndexedDB: true,
      $webkitStorageInfo: true,
      $window: true
    };
    var hasAutomationEqualityBug = function() {
      if (typeof window === "undefined") {
        return false;
      }
      for (var k2 in window) {
        try {
          if (!excludedKeys["$" + k2] && has.call(window, k2) && window[k2] !== null && typeof window[k2] === "object") {
            try {
              equalsConstructorPrototype(window[k2]);
            } catch (e) {
              return true;
            }
          }
        } catch (e) {
          return true;
        }
      }
      return false;
    }();
    var equalsConstructorPrototypeIfNotBuggy = function(o2) {
      if (typeof window === "undefined" || !hasAutomationEqualityBug) {
        return equalsConstructorPrototype(o2);
      }
      try {
        return equalsConstructorPrototype(o2);
      } catch (e) {
        return false;
      }
    };
    keysShim = function keys(object) {
      var isObject2 = object !== null && typeof object === "object";
      var isFunction2 = toStr.call(object) === "[object Function]";
      var isArguments2 = isArgs(object);
      var isString2 = isObject2 && toStr.call(object) === "[object String]";
      var theKeys = [];
      if (!isObject2 && !isFunction2 && !isArguments2) {
        throw new TypeError("Object.keys called on a non-object");
      }
      var skipProto = hasProtoEnumBug && isFunction2;
      if (isString2 && object.length > 0 && !has.call(object, 0)) {
        for (var i2 = 0; i2 < object.length; ++i2) {
          theKeys.push(String(i2));
        }
      }
      if (isArguments2 && object.length > 0) {
        for (var j2 = 0; j2 < object.length; ++j2) {
          theKeys.push(String(j2));
        }
      } else {
        for (var name in object) {
          if (!(skipProto && name === "prototype") && has.call(object, name)) {
            theKeys.push(String(name));
          }
        }
      }
      if (hasDontEnumBug) {
        var skipConstructor = equalsConstructorPrototypeIfNotBuggy(object);
        for (var k2 = 0; k2 < dontEnums.length; ++k2) {
          if (!(skipConstructor && dontEnums[k2] === "constructor") && has.call(object, dontEnums[k2])) {
            theKeys.push(dontEnums[k2]);
          }
        }
      }
      return theKeys;
    };
  }
  implementation$4 = keysShim;
  return implementation$4;
}
var objectKeys;
var hasRequiredObjectKeys;
function requireObjectKeys() {
  if (hasRequiredObjectKeys)
    return objectKeys;
  hasRequiredObjectKeys = 1;
  var slice = Array.prototype.slice;
  var isArgs = requireIsArguments$1();
  var origKeys = Object.keys;
  var keysShim = origKeys ? function keys(o2) {
    return origKeys(o2);
  } : requireImplementation$4();
  var originalKeys = Object.keys;
  keysShim.shim = function shimObjectKeys() {
    if (Object.keys) {
      var keysWorksWithArguments = function() {
        var args = Object.keys(arguments);
        return args && args.length === arguments.length;
      }(1, 2);
      if (!keysWorksWithArguments) {
        Object.keys = function keys(object) {
          if (isArgs(object)) {
            return originalKeys(slice.call(object));
          }
          return originalKeys(object);
        };
      }
    } else {
      Object.keys = keysShim;
    }
    return Object.keys || keysShim;
  };
  objectKeys = keysShim;
  return objectKeys;
}
var esErrors;
var hasRequiredEsErrors;
function requireEsErrors() {
  if (hasRequiredEsErrors)
    return esErrors;
  hasRequiredEsErrors = 1;
  esErrors = Error;
  return esErrors;
}
var _eval;
var hasRequired_eval;
function require_eval() {
  if (hasRequired_eval)
    return _eval;
  hasRequired_eval = 1;
  _eval = EvalError;
  return _eval;
}
var range;
var hasRequiredRange;
function requireRange() {
  if (hasRequiredRange)
    return range;
  hasRequiredRange = 1;
  range = RangeError;
  return range;
}
var ref;
var hasRequiredRef;
function requireRef() {
  if (hasRequiredRef)
    return ref;
  hasRequiredRef = 1;
  ref = ReferenceError;
  return ref;
}
var syntax;
var hasRequiredSyntax;
function requireSyntax() {
  if (hasRequiredSyntax)
    return syntax;
  hasRequiredSyntax = 1;
  syntax = SyntaxError;
  return syntax;
}
var type;
var hasRequiredType;
function requireType() {
  if (hasRequiredType)
    return type;
  hasRequiredType = 1;
  type = TypeError;
  return type;
}
var uri;
var hasRequiredUri;
function requireUri() {
  if (hasRequiredUri)
    return uri;
  hasRequiredUri = 1;
  uri = URIError;
  return uri;
}
var shams$1;
var hasRequiredShams$1;
function requireShams$1() {
  if (hasRequiredShams$1)
    return shams$1;
  hasRequiredShams$1 = 1;
  shams$1 = function hasSymbols2() {
    if (typeof Symbol !== "function" || typeof Object.getOwnPropertySymbols !== "function") {
      return false;
    }
    if (typeof Symbol.iterator === "symbol") {
      return true;
    }
    var obj = {};
    var sym = Symbol("test");
    var symObj = Object(sym);
    if (typeof sym === "string") {
      return false;
    }
    if (Object.prototype.toString.call(sym) !== "[object Symbol]") {
      return false;
    }
    if (Object.prototype.toString.call(symObj) !== "[object Symbol]") {
      return false;
    }
    var symVal = 42;
    obj[sym] = symVal;
    for (sym in obj) {
      return false;
    }
    if (typeof Object.keys === "function" && Object.keys(obj).length !== 0) {
      return false;
    }
    if (typeof Object.getOwnPropertyNames === "function" && Object.getOwnPropertyNames(obj).length !== 0) {
      return false;
    }
    var syms = Object.getOwnPropertySymbols(obj);
    if (syms.length !== 1 || syms[0] !== sym) {
      return false;
    }
    if (!Object.prototype.propertyIsEnumerable.call(obj, sym)) {
      return false;
    }
    if (typeof Object.getOwnPropertyDescriptor === "function") {
      var descriptor = Object.getOwnPropertyDescriptor(obj, sym);
      if (descriptor.value !== symVal || descriptor.enumerable !== true) {
        return false;
      }
    }
    return true;
  };
  return shams$1;
}
var hasSymbols;
var hasRequiredHasSymbols;
function requireHasSymbols() {
  if (hasRequiredHasSymbols)
    return hasSymbols;
  hasRequiredHasSymbols = 1;
  var origSymbol = typeof Symbol !== "undefined" && Symbol;
  var hasSymbolSham = requireShams$1();
  hasSymbols = function hasNativeSymbols() {
    if (typeof origSymbol !== "function") {
      return false;
    }
    if (typeof Symbol !== "function") {
      return false;
    }
    if (typeof origSymbol("foo") !== "symbol") {
      return false;
    }
    if (typeof Symbol("bar") !== "symbol") {
      return false;
    }
    return hasSymbolSham();
  };
  return hasSymbols;
}
var hasProto;
var hasRequiredHasProto;
function requireHasProto() {
  if (hasRequiredHasProto)
    return hasProto;
  hasRequiredHasProto = 1;
  var test = {
    __proto__: null,
    foo: {}
  };
  var $Object = Object;
  hasProto = function hasProto2() {
    return { __proto__: test }.foo === test.foo && !(test instanceof $Object);
  };
  return hasProto;
}
var implementation$3;
var hasRequiredImplementation$3;
function requireImplementation$3() {
  if (hasRequiredImplementation$3)
    return implementation$3;
  hasRequiredImplementation$3 = 1;
  var ERROR_MESSAGE = "Function.prototype.bind called on incompatible ";
  var toStr = Object.prototype.toString;
  var max = Math.max;
  var funcType = "[object Function]";
  var concatty = function concatty2(a2, b2) {
    var arr = [];
    for (var i2 = 0; i2 < a2.length; i2 += 1) {
      arr[i2] = a2[i2];
    }
    for (var j2 = 0; j2 < b2.length; j2 += 1) {
      arr[j2 + a2.length] = b2[j2];
    }
    return arr;
  };
  var slicy = function slicy2(arrLike, offset) {
    var arr = [];
    for (var i2 = offset, j2 = 0; i2 < arrLike.length; i2 += 1, j2 += 1) {
      arr[j2] = arrLike[i2];
    }
    return arr;
  };
  var joiny = function(arr, joiner) {
    var str = "";
    for (var i2 = 0; i2 < arr.length; i2 += 1) {
      str += arr[i2];
      if (i2 + 1 < arr.length) {
        str += joiner;
      }
    }
    return str;
  };
  implementation$3 = function bind(that) {
    var target = this;
    if (typeof target !== "function" || toStr.apply(target) !== funcType) {
      throw new TypeError(ERROR_MESSAGE + target);
    }
    var args = slicy(arguments, 1);
    var bound;
    var binder = function() {
      if (this instanceof bound) {
        var result = target.apply(
          this,
          concatty(args, arguments)
        );
        if (Object(result) === result) {
          return result;
        }
        return this;
      }
      return target.apply(
        that,
        concatty(args, arguments)
      );
    };
    var boundLength = max(0, target.length - args.length);
    var boundArgs = [];
    for (var i2 = 0; i2 < boundLength; i2++) {
      boundArgs[i2] = "$" + i2;
    }
    bound = Function("binder", "return function (" + joiny(boundArgs, ",") + "){ return binder.apply(this,arguments); }")(binder);
    if (target.prototype) {
      var Empty = function Empty2() {
      };
      Empty.prototype = target.prototype;
      bound.prototype = new Empty();
      Empty.prototype = null;
    }
    return bound;
  };
  return implementation$3;
}
var functionBind;
var hasRequiredFunctionBind;
function requireFunctionBind() {
  if (hasRequiredFunctionBind)
    return functionBind;
  hasRequiredFunctionBind = 1;
  var implementation2 = requireImplementation$3();
  functionBind = Function.prototype.bind || implementation2;
  return functionBind;
}
var hasown;
var hasRequiredHasown;
function requireHasown() {
  if (hasRequiredHasown)
    return hasown;
  hasRequiredHasown = 1;
  var call = Function.prototype.call;
  var $hasOwn = Object.prototype.hasOwnProperty;
  var bind = requireFunctionBind();
  hasown = bind.call(call, $hasOwn);
  return hasown;
}
var getIntrinsic;
var hasRequiredGetIntrinsic;
function requireGetIntrinsic() {
  if (hasRequiredGetIntrinsic)
    return getIntrinsic;
  hasRequiredGetIntrinsic = 1;
  var undefined$1;
  var $Error = /* @__PURE__ */ requireEsErrors();
  var $EvalError = /* @__PURE__ */ require_eval();
  var $RangeError = /* @__PURE__ */ requireRange();
  var $ReferenceError = /* @__PURE__ */ requireRef();
  var $SyntaxError = /* @__PURE__ */ requireSyntax();
  var $TypeError = /* @__PURE__ */ requireType();
  var $URIError = /* @__PURE__ */ requireUri();
  var $Function = Function;
  var getEvalledConstructor = function(expressionSyntax) {
    try {
      return $Function('"use strict"; return (' + expressionSyntax + ").constructor;")();
    } catch (e) {
    }
  };
  var $gOPD = Object.getOwnPropertyDescriptor;
  if ($gOPD) {
    try {
      $gOPD({}, "");
    } catch (e) {
      $gOPD = null;
    }
  }
  var throwTypeError = function() {
    throw new $TypeError();
  };
  var ThrowTypeError = $gOPD ? function() {
    try {
      arguments.callee;
      return throwTypeError;
    } catch (calleeThrows) {
      try {
        return $gOPD(arguments, "callee").get;
      } catch (gOPDthrows) {
        return throwTypeError;
      }
    }
  }() : throwTypeError;
  var hasSymbols2 = requireHasSymbols()();
  var hasProto2 = /* @__PURE__ */ requireHasProto()();
  var getProto2 = Object.getPrototypeOf || (hasProto2 ? function(x) {
    return x.__proto__;
  } : null);
  var needsEval = {};
  var TypedArray = typeof Uint8Array === "undefined" || !getProto2 ? undefined$1 : getProto2(Uint8Array);
  var INTRINSICS = {
    __proto__: null,
    "%AggregateError%": typeof AggregateError === "undefined" ? undefined$1 : AggregateError,
    "%Array%": Array,
    "%ArrayBuffer%": typeof ArrayBuffer === "undefined" ? undefined$1 : ArrayBuffer,
    "%ArrayIteratorPrototype%": hasSymbols2 && getProto2 ? getProto2([][Symbol.iterator]()) : undefined$1,
    "%AsyncFromSyncIteratorPrototype%": undefined$1,
    "%AsyncFunction%": needsEval,
    "%AsyncGenerator%": needsEval,
    "%AsyncGeneratorFunction%": needsEval,
    "%AsyncIteratorPrototype%": needsEval,
    "%Atomics%": typeof Atomics === "undefined" ? undefined$1 : Atomics,
    "%BigInt%": typeof BigInt === "undefined" ? undefined$1 : BigInt,
    "%BigInt64Array%": typeof BigInt64Array === "undefined" ? undefined$1 : BigInt64Array,
    "%BigUint64Array%": typeof BigUint64Array === "undefined" ? undefined$1 : BigUint64Array,
    "%Boolean%": Boolean,
    "%DataView%": typeof DataView === "undefined" ? undefined$1 : DataView,
    "%Date%": Date,
    "%decodeURI%": decodeURI,
    "%decodeURIComponent%": decodeURIComponent,
    "%encodeURI%": encodeURI,
    "%encodeURIComponent%": encodeURIComponent,
    "%Error%": $Error,
    "%eval%": eval,
    "%EvalError%": $EvalError,
    "%Float32Array%": typeof Float32Array === "undefined" ? undefined$1 : Float32Array,
    "%Float64Array%": typeof Float64Array === "undefined" ? undefined$1 : Float64Array,
    "%FinalizationRegistry%": typeof FinalizationRegistry === "undefined" ? undefined$1 : FinalizationRegistry,
    "%Function%": $Function,
    "%GeneratorFunction%": needsEval,
    "%Int8Array%": typeof Int8Array === "undefined" ? undefined$1 : Int8Array,
    "%Int16Array%": typeof Int16Array === "undefined" ? undefined$1 : Int16Array,
    "%Int32Array%": typeof Int32Array === "undefined" ? undefined$1 : Int32Array,
    "%isFinite%": isFinite,
    "%isNaN%": isNaN,
    "%IteratorPrototype%": hasSymbols2 && getProto2 ? getProto2(getProto2([][Symbol.iterator]())) : undefined$1,
    "%JSON%": typeof JSON === "object" ? JSON : undefined$1,
    "%Map%": typeof Map === "undefined" ? undefined$1 : Map,
    "%MapIteratorPrototype%": typeof Map === "undefined" || !hasSymbols2 || !getProto2 ? undefined$1 : getProto2((/* @__PURE__ */ new Map())[Symbol.iterator]()),
    "%Math%": Math,
    "%Number%": Number,
    "%Object%": Object,
    "%parseFloat%": parseFloat,
    "%parseInt%": parseInt,
    "%Promise%": typeof Promise === "undefined" ? undefined$1 : Promise,
    "%Proxy%": typeof Proxy === "undefined" ? undefined$1 : Proxy,
    "%RangeError%": $RangeError,
    "%ReferenceError%": $ReferenceError,
    "%Reflect%": typeof Reflect === "undefined" ? undefined$1 : Reflect,
    "%RegExp%": RegExp,
    "%Set%": typeof Set === "undefined" ? undefined$1 : Set,
    "%SetIteratorPrototype%": typeof Set === "undefined" || !hasSymbols2 || !getProto2 ? undefined$1 : getProto2((/* @__PURE__ */ new Set())[Symbol.iterator]()),
    "%SharedArrayBuffer%": typeof SharedArrayBuffer === "undefined" ? undefined$1 : SharedArrayBuffer,
    "%String%": String,
    "%StringIteratorPrototype%": hasSymbols2 && getProto2 ? getProto2(""[Symbol.iterator]()) : undefined$1,
    "%Symbol%": hasSymbols2 ? Symbol : undefined$1,
    "%SyntaxError%": $SyntaxError,
    "%ThrowTypeError%": ThrowTypeError,
    "%TypedArray%": TypedArray,
    "%TypeError%": $TypeError,
    "%Uint8Array%": typeof Uint8Array === "undefined" ? undefined$1 : Uint8Array,
    "%Uint8ClampedArray%": typeof Uint8ClampedArray === "undefined" ? undefined$1 : Uint8ClampedArray,
    "%Uint16Array%": typeof Uint16Array === "undefined" ? undefined$1 : Uint16Array,
    "%Uint32Array%": typeof Uint32Array === "undefined" ? undefined$1 : Uint32Array,
    "%URIError%": $URIError,
    "%WeakMap%": typeof WeakMap === "undefined" ? undefined$1 : WeakMap,
    "%WeakRef%": typeof WeakRef === "undefined" ? undefined$1 : WeakRef,
    "%WeakSet%": typeof WeakSet === "undefined" ? undefined$1 : WeakSet
  };
  if (getProto2) {
    try {
      null.error;
    } catch (e) {
      var errorProto = getProto2(getProto2(e));
      INTRINSICS["%Error.prototype%"] = errorProto;
    }
  }
  var doEval = function doEval2(name) {
    var value;
    if (name === "%AsyncFunction%") {
      value = getEvalledConstructor("async function () {}");
    } else if (name === "%GeneratorFunction%") {
      value = getEvalledConstructor("function* () {}");
    } else if (name === "%AsyncGeneratorFunction%") {
      value = getEvalledConstructor("async function* () {}");
    } else if (name === "%AsyncGenerator%") {
      var fn = doEval2("%AsyncGeneratorFunction%");
      if (fn) {
        value = fn.prototype;
      }
    } else if (name === "%AsyncIteratorPrototype%") {
      var gen = doEval2("%AsyncGenerator%");
      if (gen && getProto2) {
        value = getProto2(gen.prototype);
      }
    }
    INTRINSICS[name] = value;
    return value;
  };
  var LEGACY_ALIASES = {
    __proto__: null,
    "%ArrayBufferPrototype%": ["ArrayBuffer", "prototype"],
    "%ArrayPrototype%": ["Array", "prototype"],
    "%ArrayProto_entries%": ["Array", "prototype", "entries"],
    "%ArrayProto_forEach%": ["Array", "prototype", "forEach"],
    "%ArrayProto_keys%": ["Array", "prototype", "keys"],
    "%ArrayProto_values%": ["Array", "prototype", "values"],
    "%AsyncFunctionPrototype%": ["AsyncFunction", "prototype"],
    "%AsyncGenerator%": ["AsyncGeneratorFunction", "prototype"],
    "%AsyncGeneratorPrototype%": ["AsyncGeneratorFunction", "prototype", "prototype"],
    "%BooleanPrototype%": ["Boolean", "prototype"],
    "%DataViewPrototype%": ["DataView", "prototype"],
    "%DatePrototype%": ["Date", "prototype"],
    "%ErrorPrototype%": ["Error", "prototype"],
    "%EvalErrorPrototype%": ["EvalError", "prototype"],
    "%Float32ArrayPrototype%": ["Float32Array", "prototype"],
    "%Float64ArrayPrototype%": ["Float64Array", "prototype"],
    "%FunctionPrototype%": ["Function", "prototype"],
    "%Generator%": ["GeneratorFunction", "prototype"],
    "%GeneratorPrototype%": ["GeneratorFunction", "prototype", "prototype"],
    "%Int8ArrayPrototype%": ["Int8Array", "prototype"],
    "%Int16ArrayPrototype%": ["Int16Array", "prototype"],
    "%Int32ArrayPrototype%": ["Int32Array", "prototype"],
    "%JSONParse%": ["JSON", "parse"],
    "%JSONStringify%": ["JSON", "stringify"],
    "%MapPrototype%": ["Map", "prototype"],
    "%NumberPrototype%": ["Number", "prototype"],
    "%ObjectPrototype%": ["Object", "prototype"],
    "%ObjProto_toString%": ["Object", "prototype", "toString"],
    "%ObjProto_valueOf%": ["Object", "prototype", "valueOf"],
    "%PromisePrototype%": ["Promise", "prototype"],
    "%PromiseProto_then%": ["Promise", "prototype", "then"],
    "%Promise_all%": ["Promise", "all"],
    "%Promise_reject%": ["Promise", "reject"],
    "%Promise_resolve%": ["Promise", "resolve"],
    "%RangeErrorPrototype%": ["RangeError", "prototype"],
    "%ReferenceErrorPrototype%": ["ReferenceError", "prototype"],
    "%RegExpPrototype%": ["RegExp", "prototype"],
    "%SetPrototype%": ["Set", "prototype"],
    "%SharedArrayBufferPrototype%": ["SharedArrayBuffer", "prototype"],
    "%StringPrototype%": ["String", "prototype"],
    "%SymbolPrototype%": ["Symbol", "prototype"],
    "%SyntaxErrorPrototype%": ["SyntaxError", "prototype"],
    "%TypedArrayPrototype%": ["TypedArray", "prototype"],
    "%TypeErrorPrototype%": ["TypeError", "prototype"],
    "%Uint8ArrayPrototype%": ["Uint8Array", "prototype"],
    "%Uint8ClampedArrayPrototype%": ["Uint8ClampedArray", "prototype"],
    "%Uint16ArrayPrototype%": ["Uint16Array", "prototype"],
    "%Uint32ArrayPrototype%": ["Uint32Array", "prototype"],
    "%URIErrorPrototype%": ["URIError", "prototype"],
    "%WeakMapPrototype%": ["WeakMap", "prototype"],
    "%WeakSetPrototype%": ["WeakSet", "prototype"]
  };
  var bind = requireFunctionBind();
  var hasOwn2 = /* @__PURE__ */ requireHasown();
  var $concat = bind.call(Function.call, Array.prototype.concat);
  var $spliceApply = bind.call(Function.apply, Array.prototype.splice);
  var $replace = bind.call(Function.call, String.prototype.replace);
  var $strSlice = bind.call(Function.call, String.prototype.slice);
  var $exec = bind.call(Function.call, RegExp.prototype.exec);
  var rePropName = /[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g;
  var reEscapeChar = /\\(\\)?/g;
  var stringToPath = function stringToPath2(string) {
    var first = $strSlice(string, 0, 1);
    var last = $strSlice(string, -1);
    if (first === "%" && last !== "%") {
      throw new $SyntaxError("invalid intrinsic syntax, expected closing `%`");
    } else if (last === "%" && first !== "%") {
      throw new $SyntaxError("invalid intrinsic syntax, expected opening `%`");
    }
    var result = [];
    $replace(string, rePropName, function(match, number, quote, subString) {
      result[result.length] = quote ? $replace(subString, reEscapeChar, "$1") : number || match;
    });
    return result;
  };
  var getBaseIntrinsic = function getBaseIntrinsic2(name, allowMissing) {
    var intrinsicName = name;
    var alias;
    if (hasOwn2(LEGACY_ALIASES, intrinsicName)) {
      alias = LEGACY_ALIASES[intrinsicName];
      intrinsicName = "%" + alias[0] + "%";
    }
    if (hasOwn2(INTRINSICS, intrinsicName)) {
      var value = INTRINSICS[intrinsicName];
      if (value === needsEval) {
        value = doEval(intrinsicName);
      }
      if (typeof value === "undefined" && !allowMissing) {
        throw new $TypeError("intrinsic " + name + " exists, but is not available. Please file an issue!");
      }
      return {
        alias,
        name: intrinsicName,
        value
      };
    }
    throw new $SyntaxError("intrinsic " + name + " does not exist!");
  };
  getIntrinsic = function GetIntrinsic(name, allowMissing) {
    if (typeof name !== "string" || name.length === 0) {
      throw new $TypeError("intrinsic name must be a non-empty string");
    }
    if (arguments.length > 1 && typeof allowMissing !== "boolean") {
      throw new $TypeError('"allowMissing" argument must be a boolean');
    }
    if ($exec(/^%?[^%]*%?$/, name) === null) {
      throw new $SyntaxError("`%` may not be present anywhere but at the beginning and end of the intrinsic name");
    }
    var parts = stringToPath(name);
    var intrinsicBaseName = parts.length > 0 ? parts[0] : "";
    var intrinsic = getBaseIntrinsic("%" + intrinsicBaseName + "%", allowMissing);
    var intrinsicRealName = intrinsic.name;
    var value = intrinsic.value;
    var skipFurtherCaching = false;
    var alias = intrinsic.alias;
    if (alias) {
      intrinsicBaseName = alias[0];
      $spliceApply(parts, $concat([0, 1], alias));
    }
    for (var i2 = 1, isOwn = true; i2 < parts.length; i2 += 1) {
      var part = parts[i2];
      var first = $strSlice(part, 0, 1);
      var last = $strSlice(part, -1);
      if ((first === '"' || first === "'" || first === "`" || (last === '"' || last === "'" || last === "`")) && first !== last) {
        throw new $SyntaxError("property names with quotes must have matching quotes");
      }
      if (part === "constructor" || !isOwn) {
        skipFurtherCaching = true;
      }
      intrinsicBaseName += "." + part;
      intrinsicRealName = "%" + intrinsicBaseName + "%";
      if (hasOwn2(INTRINSICS, intrinsicRealName)) {
        value = INTRINSICS[intrinsicRealName];
      } else if (value != null) {
        if (!(part in value)) {
          if (!allowMissing) {
            throw new $TypeError("base intrinsic for " + name + " exists, but the property is not available.");
          }
          return void 0;
        }
        if ($gOPD && i2 + 1 >= parts.length) {
          var desc = $gOPD(value, part);
          isOwn = !!desc;
          if (isOwn && "get" in desc && !("originalValue" in desc.get)) {
            value = desc.get;
          } else {
            value = value[part];
          }
        } else {
          isOwn = hasOwn2(value, part);
          value = value[part];
        }
        if (isOwn && !skipFurtherCaching) {
          INTRINSICS[intrinsicRealName] = value;
        }
      }
    }
    return value;
  };
  return getIntrinsic;
}
var esDefineProperty;
var hasRequiredEsDefineProperty;
function requireEsDefineProperty() {
  if (hasRequiredEsDefineProperty)
    return esDefineProperty;
  hasRequiredEsDefineProperty = 1;
  var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
  var $defineProperty = GetIntrinsic("%Object.defineProperty%", true) || false;
  if ($defineProperty) {
    try {
      $defineProperty({}, "a", { value: 1 });
    } catch (e) {
      $defineProperty = false;
    }
  }
  esDefineProperty = $defineProperty;
  return esDefineProperty;
}
var gopd;
var hasRequiredGopd;
function requireGopd() {
  if (hasRequiredGopd)
    return gopd;
  hasRequiredGopd = 1;
  var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
  var $gOPD = GetIntrinsic("%Object.getOwnPropertyDescriptor%", true);
  if ($gOPD) {
    try {
      $gOPD([], "length");
    } catch (e) {
      $gOPD = null;
    }
  }
  gopd = $gOPD;
  return gopd;
}
var defineDataProperty;
var hasRequiredDefineDataProperty;
function requireDefineDataProperty() {
  if (hasRequiredDefineDataProperty)
    return defineDataProperty;
  hasRequiredDefineDataProperty = 1;
  var $defineProperty = /* @__PURE__ */ requireEsDefineProperty();
  var $SyntaxError = /* @__PURE__ */ requireSyntax();
  var $TypeError = /* @__PURE__ */ requireType();
  var gopd2 = /* @__PURE__ */ requireGopd();
  defineDataProperty = function defineDataProperty2(obj, property, value) {
    if (!obj || typeof obj !== "object" && typeof obj !== "function") {
      throw new $TypeError("`obj` must be an object or a function`");
    }
    if (typeof property !== "string" && typeof property !== "symbol") {
      throw new $TypeError("`property` must be a string or a symbol`");
    }
    if (arguments.length > 3 && typeof arguments[3] !== "boolean" && arguments[3] !== null) {
      throw new $TypeError("`nonEnumerable`, if provided, must be a boolean or null");
    }
    if (arguments.length > 4 && typeof arguments[4] !== "boolean" && arguments[4] !== null) {
      throw new $TypeError("`nonWritable`, if provided, must be a boolean or null");
    }
    if (arguments.length > 5 && typeof arguments[5] !== "boolean" && arguments[5] !== null) {
      throw new $TypeError("`nonConfigurable`, if provided, must be a boolean or null");
    }
    if (arguments.length > 6 && typeof arguments[6] !== "boolean") {
      throw new $TypeError("`loose`, if provided, must be a boolean");
    }
    var nonEnumerable = arguments.length > 3 ? arguments[3] : null;
    var nonWritable = arguments.length > 4 ? arguments[4] : null;
    var nonConfigurable = arguments.length > 5 ? arguments[5] : null;
    var loose = arguments.length > 6 ? arguments[6] : false;
    var desc = !!gopd2 && gopd2(obj, property);
    if ($defineProperty) {
      $defineProperty(obj, property, {
        configurable: nonConfigurable === null && desc ? desc.configurable : !nonConfigurable,
        enumerable: nonEnumerable === null && desc ? desc.enumerable : !nonEnumerable,
        value,
        writable: nonWritable === null && desc ? desc.writable : !nonWritable
      });
    } else if (loose || !nonEnumerable && !nonWritable && !nonConfigurable) {
      obj[property] = value;
    } else {
      throw new $SyntaxError("This environment does not support defining a property as non-configurable, non-writable, or non-enumerable.");
    }
  };
  return defineDataProperty;
}
var hasPropertyDescriptors_1;
var hasRequiredHasPropertyDescriptors;
function requireHasPropertyDescriptors() {
  if (hasRequiredHasPropertyDescriptors)
    return hasPropertyDescriptors_1;
  hasRequiredHasPropertyDescriptors = 1;
  var $defineProperty = /* @__PURE__ */ requireEsDefineProperty();
  var hasPropertyDescriptors = function hasPropertyDescriptors2() {
    return !!$defineProperty;
  };
  hasPropertyDescriptors.hasArrayLengthDefineBug = function hasArrayLengthDefineBug() {
    if (!$defineProperty) {
      return null;
    }
    try {
      return $defineProperty([], "length", { value: 1 }).length !== 1;
    } catch (e) {
      return true;
    }
  };
  hasPropertyDescriptors_1 = hasPropertyDescriptors;
  return hasPropertyDescriptors_1;
}
var defineProperties_1;
var hasRequiredDefineProperties;
function requireDefineProperties() {
  if (hasRequiredDefineProperties)
    return defineProperties_1;
  hasRequiredDefineProperties = 1;
  var keys = requireObjectKeys();
  var hasSymbols2 = typeof Symbol === "function" && typeof Symbol("foo") === "symbol";
  var toStr = Object.prototype.toString;
  var concat = Array.prototype.concat;
  var defineDataProperty2 = /* @__PURE__ */ requireDefineDataProperty();
  var isFunction2 = function(fn) {
    return typeof fn === "function" && toStr.call(fn) === "[object Function]";
  };
  var supportsDescriptors = /* @__PURE__ */ requireHasPropertyDescriptors()();
  var defineProperty = function(object, name, value, predicate) {
    if (name in object) {
      if (predicate === true) {
        if (object[name] === value) {
          return;
        }
      } else if (!isFunction2(predicate) || !predicate()) {
        return;
      }
    }
    if (supportsDescriptors) {
      defineDataProperty2(object, name, value, true);
    } else {
      defineDataProperty2(object, name, value);
    }
  };
  var defineProperties = function(object, map) {
    var predicates = arguments.length > 2 ? arguments[2] : {};
    var props = keys(map);
    if (hasSymbols2) {
      props = concat.call(props, Object.getOwnPropertySymbols(map));
    }
    for (var i2 = 0; i2 < props.length; i2 += 1) {
      defineProperty(object, props[i2], map[props[i2]], predicates[props[i2]]);
    }
  };
  defineProperties.supportsDescriptors = !!supportsDescriptors;
  defineProperties_1 = defineProperties;
  return defineProperties_1;
}
var callBind = { exports: {} };
var setFunctionLength;
var hasRequiredSetFunctionLength;
function requireSetFunctionLength() {
  if (hasRequiredSetFunctionLength)
    return setFunctionLength;
  hasRequiredSetFunctionLength = 1;
  var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
  var define = /* @__PURE__ */ requireDefineDataProperty();
  var hasDescriptors = /* @__PURE__ */ requireHasPropertyDescriptors()();
  var gOPD = /* @__PURE__ */ requireGopd();
  var $TypeError = /* @__PURE__ */ requireType();
  var $floor = GetIntrinsic("%Math.floor%");
  setFunctionLength = function setFunctionLength2(fn, length) {
    if (typeof fn !== "function") {
      throw new $TypeError("`fn` is not a function");
    }
    if (typeof length !== "number" || length < 0 || length > 4294967295 || $floor(length) !== length) {
      throw new $TypeError("`length` must be a positive 32-bit integer");
    }
    var loose = arguments.length > 2 && !!arguments[2];
    var functionLengthIsConfigurable = true;
    var functionLengthIsWritable = true;
    if ("length" in fn && gOPD) {
      var desc = gOPD(fn, "length");
      if (desc && !desc.configurable) {
        functionLengthIsConfigurable = false;
      }
      if (desc && !desc.writable) {
        functionLengthIsWritable = false;
      }
    }
    if (functionLengthIsConfigurable || functionLengthIsWritable || !loose) {
      if (hasDescriptors) {
        define(
          fn,
          "length",
          length,
          true,
          true
        );
      } else {
        define(
          fn,
          "length",
          length
        );
      }
    }
    return fn;
  };
  return setFunctionLength;
}
var hasRequiredCallBind;
function requireCallBind() {
  if (hasRequiredCallBind)
    return callBind.exports;
  hasRequiredCallBind = 1;
  (function(module) {
    var bind = requireFunctionBind();
    var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
    var setFunctionLength2 = /* @__PURE__ */ requireSetFunctionLength();
    var $TypeError = /* @__PURE__ */ requireType();
    var $apply = GetIntrinsic("%Function.prototype.apply%");
    var $call = GetIntrinsic("%Function.prototype.call%");
    var $reflectApply = GetIntrinsic("%Reflect.apply%", true) || bind.call($call, $apply);
    var $defineProperty = /* @__PURE__ */ requireEsDefineProperty();
    var $max = GetIntrinsic("%Math.max%");
    module.exports = function callBind2(originalFunction) {
      if (typeof originalFunction !== "function") {
        throw new $TypeError("a function is required");
      }
      var func = $reflectApply(bind, $call, arguments);
      return setFunctionLength2(
        func,
        1 + $max(0, originalFunction.length - (arguments.length - 1)),
        true
      );
    };
    var applyBind = function applyBind2() {
      return $reflectApply(bind, $apply, arguments);
    };
    if ($defineProperty) {
      $defineProperty(module.exports, "apply", { value: applyBind });
    } else {
      module.exports.apply = applyBind;
    }
  })(callBind);
  return callBind.exports;
}
var callBound;
var hasRequiredCallBound;
function requireCallBound() {
  if (hasRequiredCallBound)
    return callBound;
  hasRequiredCallBound = 1;
  var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
  var callBind2 = requireCallBind();
  var $indexOf = callBind2(GetIntrinsic("String.prototype.indexOf"));
  callBound = function callBoundIntrinsic(name, allowMissing) {
    var intrinsic = GetIntrinsic(name, !!allowMissing);
    if (typeof intrinsic === "function" && $indexOf(name, ".prototype.") > -1) {
      return callBind2(intrinsic);
    }
    return intrinsic;
  };
  return callBound;
}
var implementation$2;
var hasRequiredImplementation$2;
function requireImplementation$2() {
  if (hasRequiredImplementation$2)
    return implementation$2;
  hasRequiredImplementation$2 = 1;
  var objectKeys2 = requireObjectKeys();
  var hasSymbols2 = requireShams$1()();
  var callBound2 = requireCallBound();
  var toObject = Object;
  var $push = callBound2("Array.prototype.push");
  var $propIsEnumerable = callBound2("Object.prototype.propertyIsEnumerable");
  var originalGetSymbols = hasSymbols2 ? Object.getOwnPropertySymbols : null;
  implementation$2 = function assign(target, source1) {
    if (target == null) {
      throw new TypeError("target must be an object");
    }
    var to = toObject(target);
    if (arguments.length === 1) {
      return to;
    }
    for (var s2 = 1; s2 < arguments.length; ++s2) {
      var from = toObject(arguments[s2]);
      var keys = objectKeys2(from);
      var getSymbols = hasSymbols2 && (Object.getOwnPropertySymbols || originalGetSymbols);
      if (getSymbols) {
        var syms = getSymbols(from);
        for (var j2 = 0; j2 < syms.length; ++j2) {
          var key = syms[j2];
          if ($propIsEnumerable(from, key)) {
            $push(keys, key);
          }
        }
      }
      for (var i2 = 0; i2 < keys.length; ++i2) {
        var nextKey = keys[i2];
        if ($propIsEnumerable(from, nextKey)) {
          var propValue = from[nextKey];
          to[nextKey] = propValue;
        }
      }
    }
    return to;
  };
  return implementation$2;
}
var polyfill$2;
var hasRequiredPolyfill$2;
function requirePolyfill$2() {
  if (hasRequiredPolyfill$2)
    return polyfill$2;
  hasRequiredPolyfill$2 = 1;
  var implementation2 = requireImplementation$2();
  var lacksProperEnumerationOrder = function() {
    if (!Object.assign) {
      return false;
    }
    var str = "abcdefghijklmnopqrst";
    var letters = str.split("");
    var map = {};
    for (var i2 = 0; i2 < letters.length; ++i2) {
      map[letters[i2]] = letters[i2];
    }
    var obj = Object.assign({}, map);
    var actual = "";
    for (var k2 in obj) {
      actual += k2;
    }
    return str !== actual;
  };
  var assignHasPendingExceptions = function() {
    if (!Object.assign || !Object.preventExtensions) {
      return false;
    }
    var thrower = Object.preventExtensions({ 1: 2 });
    try {
      Object.assign(thrower, "xy");
    } catch (e) {
      return thrower[1] === "y";
    }
    return false;
  };
  polyfill$2 = function getPolyfill() {
    if (!Object.assign) {
      return implementation2;
    }
    if (lacksProperEnumerationOrder()) {
      return implementation2;
    }
    if (assignHasPendingExceptions()) {
      return implementation2;
    }
    return Object.assign;
  };
  return polyfill$2;
}
var shim$2;
var hasRequiredShim$2;
function requireShim$2() {
  if (hasRequiredShim$2)
    return shim$2;
  hasRequiredShim$2 = 1;
  var define = requireDefineProperties();
  var getPolyfill = requirePolyfill$2();
  shim$2 = function shimAssign() {
    var polyfill22 = getPolyfill();
    define(
      Object,
      { assign: polyfill22 },
      { assign: function() {
        return Object.assign !== polyfill22;
      } }
    );
    return polyfill22;
  };
  return shim$2;
}
var object_assign;
var hasRequiredObject_assign;
function requireObject_assign() {
  if (hasRequiredObject_assign)
    return object_assign;
  hasRequiredObject_assign = 1;
  var defineProperties = requireDefineProperties();
  var callBind2 = requireCallBind();
  var implementation2 = requireImplementation$2();
  var getPolyfill = requirePolyfill$2();
  var shim2 = requireShim$2();
  var polyfill22 = callBind2.apply(getPolyfill());
  var bound = function assign(target, source1) {
    return polyfill22(Object, arguments);
  };
  defineProperties(bound, {
    getPolyfill,
    implementation: implementation2,
    shim: shim2
  });
  object_assign = bound;
  return object_assign;
}
var functionsHaveNames_1;
var hasRequiredFunctionsHaveNames;
function requireFunctionsHaveNames() {
  if (hasRequiredFunctionsHaveNames)
    return functionsHaveNames_1;
  hasRequiredFunctionsHaveNames = 1;
  var functionsHaveNames = function functionsHaveNames2() {
    return typeof function f2() {
    }.name === "string";
  };
  var gOPD = Object.getOwnPropertyDescriptor;
  if (gOPD) {
    try {
      gOPD([], "length");
    } catch (e) {
      gOPD = null;
    }
  }
  functionsHaveNames.functionsHaveConfigurableNames = function functionsHaveConfigurableNames() {
    if (!functionsHaveNames() || !gOPD) {
      return false;
    }
    var desc = gOPD(function() {
    }, "name");
    return !!desc && !!desc.configurable;
  };
  var $bind = Function.prototype.bind;
  functionsHaveNames.boundFunctionsHaveNames = function boundFunctionsHaveNames() {
    return functionsHaveNames() && typeof $bind === "function" && function f2() {
    }.bind().name !== "";
  };
  functionsHaveNames_1 = functionsHaveNames;
  return functionsHaveNames_1;
}
var setFunctionName;
var hasRequiredSetFunctionName;
function requireSetFunctionName() {
  if (hasRequiredSetFunctionName)
    return setFunctionName;
  hasRequiredSetFunctionName = 1;
  var define = /* @__PURE__ */ requireDefineDataProperty();
  var hasDescriptors = /* @__PURE__ */ requireHasPropertyDescriptors()();
  var functionsHaveConfigurableNames = requireFunctionsHaveNames().functionsHaveConfigurableNames();
  var $TypeError = /* @__PURE__ */ requireType();
  setFunctionName = function setFunctionName2(fn, name) {
    if (typeof fn !== "function") {
      throw new $TypeError("`fn` is not a function");
    }
    var loose = arguments.length > 2 && !!arguments[2];
    if (!loose || functionsHaveConfigurableNames) {
      if (hasDescriptors) {
        define(
          fn,
          "name",
          name,
          true,
          true
        );
      } else {
        define(
          fn,
          "name",
          name
        );
      }
    }
    return fn;
  };
  return setFunctionName;
}
var implementation$1;
var hasRequiredImplementation$1;
function requireImplementation$1() {
  if (hasRequiredImplementation$1)
    return implementation$1;
  hasRequiredImplementation$1 = 1;
  var setFunctionName2 = requireSetFunctionName();
  var $TypeError = /* @__PURE__ */ requireType();
  var $Object = Object;
  implementation$1 = setFunctionName2(function flags() {
    if (this == null || this !== $Object(this)) {
      throw new $TypeError("RegExp.prototype.flags getter called on non-object");
    }
    var result = "";
    if (this.hasIndices) {
      result += "d";
    }
    if (this.global) {
      result += "g";
    }
    if (this.ignoreCase) {
      result += "i";
    }
    if (this.multiline) {
      result += "m";
    }
    if (this.dotAll) {
      result += "s";
    }
    if (this.unicode) {
      result += "u";
    }
    if (this.unicodeSets) {
      result += "v";
    }
    if (this.sticky) {
      result += "y";
    }
    return result;
  }, "get flags", true);
  return implementation$1;
}
var polyfill$1;
var hasRequiredPolyfill$1;
function requirePolyfill$1() {
  if (hasRequiredPolyfill$1)
    return polyfill$1;
  hasRequiredPolyfill$1 = 1;
  var implementation2 = requireImplementation$1();
  var supportsDescriptors = requireDefineProperties().supportsDescriptors;
  var $gOPD = Object.getOwnPropertyDescriptor;
  polyfill$1 = function getPolyfill() {
    if (supportsDescriptors && /a/mig.flags === "gim") {
      var descriptor = $gOPD(RegExp.prototype, "flags");
      if (descriptor && typeof descriptor.get === "function" && typeof RegExp.prototype.dotAll === "boolean" && typeof RegExp.prototype.hasIndices === "boolean") {
        var calls = "";
        var o2 = {};
        Object.defineProperty(o2, "hasIndices", {
          get: function() {
            calls += "d";
          }
        });
        Object.defineProperty(o2, "sticky", {
          get: function() {
            calls += "y";
          }
        });
        if (calls === "dy") {
          return descriptor.get;
        }
      }
    }
    return implementation2;
  };
  return polyfill$1;
}
var shim$1;
var hasRequiredShim$1;
function requireShim$1() {
  if (hasRequiredShim$1)
    return shim$1;
  hasRequiredShim$1 = 1;
  var supportsDescriptors = requireDefineProperties().supportsDescriptors;
  var getPolyfill = requirePolyfill$1();
  var gOPD = Object.getOwnPropertyDescriptor;
  var defineProperty = Object.defineProperty;
  var TypeErr = TypeError;
  var getProto2 = Object.getPrototypeOf;
  var regex = /a/;
  shim$1 = function shimFlags() {
    if (!supportsDescriptors || !getProto2) {
      throw new TypeErr("RegExp.prototype.flags requires a true ES5 environment that supports property descriptors");
    }
    var polyfill22 = getPolyfill();
    var proto = getProto2(regex);
    var descriptor = gOPD(proto, "flags");
    if (!descriptor || descriptor.get !== polyfill22) {
      defineProperty(proto, "flags", {
        configurable: true,
        enumerable: false,
        get: polyfill22
      });
    }
    return polyfill22;
  };
  return shim$1;
}
var regexp_prototype_flags;
var hasRequiredRegexp_prototype_flags;
function requireRegexp_prototype_flags() {
  if (hasRequiredRegexp_prototype_flags)
    return regexp_prototype_flags;
  hasRequiredRegexp_prototype_flags = 1;
  var define = requireDefineProperties();
  var callBind2 = requireCallBind();
  var implementation2 = requireImplementation$1();
  var getPolyfill = requirePolyfill$1();
  var shim2 = requireShim$1();
  var flagsBound = callBind2(getPolyfill());
  define(flagsBound, {
    getPolyfill,
    implementation: implementation2,
    shim: shim2
  });
  regexp_prototype_flags = flagsBound;
  return regexp_prototype_flags;
}
var esGetIterator = { exports: {} };
var shams;
var hasRequiredShams;
function requireShams() {
  if (hasRequiredShams)
    return shams;
  hasRequiredShams = 1;
  var hasSymbols2 = requireShams$1();
  shams = function hasToStringTagShams() {
    return hasSymbols2() && !!Symbol.toStringTag;
  };
  return shams;
}
var isArguments;
var hasRequiredIsArguments;
function requireIsArguments() {
  if (hasRequiredIsArguments)
    return isArguments;
  hasRequiredIsArguments = 1;
  var hasToStringTag = requireShams()();
  var callBound2 = requireCallBound();
  var $toString = callBound2("Object.prototype.toString");
  var isStandardArguments = function isArguments2(value) {
    if (hasToStringTag && value && typeof value === "object" && Symbol.toStringTag in value) {
      return false;
    }
    return $toString(value) === "[object Arguments]";
  };
  var isLegacyArguments = function isArguments2(value) {
    if (isStandardArguments(value)) {
      return true;
    }
    return value !== null && typeof value === "object" && typeof value.length === "number" && value.length >= 0 && $toString(value) !== "[object Array]" && $toString(value.callee) === "[object Function]";
  };
  var supportsStandardArguments = function() {
    return isStandardArguments(arguments);
  }();
  isStandardArguments.isLegacyArguments = isLegacyArguments;
  isArguments = supportsStandardArguments ? isStandardArguments : isLegacyArguments;
  return isArguments;
}
const __viteBrowserExternal = {};
const __viteBrowserExternal$1 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: __viteBrowserExternal
}, Symbol.toStringTag, { value: "Module" }));
const require$$0 = /* @__PURE__ */ getAugmentedNamespace(__viteBrowserExternal$1);
var objectInspect;
var hasRequiredObjectInspect;
function requireObjectInspect() {
  if (hasRequiredObjectInspect)
    return objectInspect;
  hasRequiredObjectInspect = 1;
  var hasMap = typeof Map === "function" && Map.prototype;
  var mapSizeDescriptor = Object.getOwnPropertyDescriptor && hasMap ? Object.getOwnPropertyDescriptor(Map.prototype, "size") : null;
  var mapSize = hasMap && mapSizeDescriptor && typeof mapSizeDescriptor.get === "function" ? mapSizeDescriptor.get : null;
  var mapForEach = hasMap && Map.prototype.forEach;
  var hasSet = typeof Set === "function" && Set.prototype;
  var setSizeDescriptor = Object.getOwnPropertyDescriptor && hasSet ? Object.getOwnPropertyDescriptor(Set.prototype, "size") : null;
  var setSize = hasSet && setSizeDescriptor && typeof setSizeDescriptor.get === "function" ? setSizeDescriptor.get : null;
  var setForEach = hasSet && Set.prototype.forEach;
  var hasWeakMap = typeof WeakMap === "function" && WeakMap.prototype;
  var weakMapHas = hasWeakMap ? WeakMap.prototype.has : null;
  var hasWeakSet = typeof WeakSet === "function" && WeakSet.prototype;
  var weakSetHas = hasWeakSet ? WeakSet.prototype.has : null;
  var hasWeakRef = typeof WeakRef === "function" && WeakRef.prototype;
  var weakRefDeref = hasWeakRef ? WeakRef.prototype.deref : null;
  var booleanValueOf = Boolean.prototype.valueOf;
  var objectToString2 = Object.prototype.toString;
  var functionToString = Function.prototype.toString;
  var $match = String.prototype.match;
  var $slice = String.prototype.slice;
  var $replace = String.prototype.replace;
  var $toUpperCase = String.prototype.toUpperCase;
  var $toLowerCase = String.prototype.toLowerCase;
  var $test = RegExp.prototype.test;
  var $concat = Array.prototype.concat;
  var $join = Array.prototype.join;
  var $arrSlice = Array.prototype.slice;
  var $floor = Math.floor;
  var bigIntValueOf = typeof BigInt === "function" ? BigInt.prototype.valueOf : null;
  var gOPS = Object.getOwnPropertySymbols;
  var symToString = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? Symbol.prototype.toString : null;
  var hasShammedSymbols = typeof Symbol === "function" && typeof Symbol.iterator === "object";
  var toStringTag = typeof Symbol === "function" && Symbol.toStringTag && (typeof Symbol.toStringTag === hasShammedSymbols ? "object" : "symbol") ? Symbol.toStringTag : null;
  var isEnumerable = Object.prototype.propertyIsEnumerable;
  var gPO = (typeof Reflect === "function" ? Reflect.getPrototypeOf : Object.getPrototypeOf) || ([].__proto__ === Array.prototype ? function(O) {
    return O.__proto__;
  } : null);
  function addNumericSeparator(num, str) {
    if (num === Infinity || num === -Infinity || num !== num || num && num > -1e3 && num < 1e3 || $test.call(/e/, str)) {
      return str;
    }
    var sepRegex = /[0-9](?=(?:[0-9]{3})+(?![0-9]))/g;
    if (typeof num === "number") {
      var int = num < 0 ? -$floor(-num) : $floor(num);
      if (int !== num) {
        var intStr = String(int);
        var dec = $slice.call(str, intStr.length + 1);
        return $replace.call(intStr, sepRegex, "$&_") + "." + $replace.call($replace.call(dec, /([0-9]{3})/g, "$&_"), /_$/, "");
      }
    }
    return $replace.call(str, sepRegex, "$&_");
  }
  var utilInspect = require$$0;
  var inspectCustom = utilInspect.custom;
  var inspectSymbol = isSymbol2(inspectCustom) ? inspectCustom : null;
  objectInspect = function inspect_(obj, options, depth, seen2) {
    var opts = options || {};
    if (has(opts, "quoteStyle") && (opts.quoteStyle !== "single" && opts.quoteStyle !== "double")) {
      throw new TypeError('option "quoteStyle" must be "single" or "double"');
    }
    if (has(opts, "maxStringLength") && (typeof opts.maxStringLength === "number" ? opts.maxStringLength < 0 && opts.maxStringLength !== Infinity : opts.maxStringLength !== null)) {
      throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');
    }
    var customInspect = has(opts, "customInspect") ? opts.customInspect : true;
    if (typeof customInspect !== "boolean" && customInspect !== "symbol") {
      throw new TypeError("option \"customInspect\", if provided, must be `true`, `false`, or `'symbol'`");
    }
    if (has(opts, "indent") && opts.indent !== null && opts.indent !== "	" && !(parseInt(opts.indent, 10) === opts.indent && opts.indent > 0)) {
      throw new TypeError('option "indent" must be "\\t", an integer > 0, or `null`');
    }
    if (has(opts, "numericSeparator") && typeof opts.numericSeparator !== "boolean") {
      throw new TypeError('option "numericSeparator", if provided, must be `true` or `false`');
    }
    var numericSeparator = opts.numericSeparator;
    if (typeof obj === "undefined") {
      return "undefined";
    }
    if (obj === null) {
      return "null";
    }
    if (typeof obj === "boolean") {
      return obj ? "true" : "false";
    }
    if (typeof obj === "string") {
      return inspectString(obj, opts);
    }
    if (typeof obj === "number") {
      if (obj === 0) {
        return Infinity / obj > 0 ? "0" : "-0";
      }
      var str = String(obj);
      return numericSeparator ? addNumericSeparator(obj, str) : str;
    }
    if (typeof obj === "bigint") {
      var bigIntStr = String(obj) + "n";
      return numericSeparator ? addNumericSeparator(obj, bigIntStr) : bigIntStr;
    }
    var maxDepth = typeof opts.depth === "undefined" ? 5 : opts.depth;
    if (typeof depth === "undefined") {
      depth = 0;
    }
    if (depth >= maxDepth && maxDepth > 0 && typeof obj === "object") {
      return isArray2(obj) ? "[Array]" : "[Object]";
    }
    var indent = getIndent(opts, depth);
    if (typeof seen2 === "undefined") {
      seen2 = [];
    } else if (indexOf(seen2, obj) >= 0) {
      return "[Circular]";
    }
    function inspect(value, from, noIndent) {
      if (from) {
        seen2 = $arrSlice.call(seen2);
        seen2.push(from);
      }
      if (noIndent) {
        var newOpts = {
          depth: opts.depth
        };
        if (has(opts, "quoteStyle")) {
          newOpts.quoteStyle = opts.quoteStyle;
        }
        return inspect_(value, newOpts, depth + 1, seen2);
      }
      return inspect_(value, opts, depth + 1, seen2);
    }
    if (typeof obj === "function" && !isRegExp2(obj)) {
      var name = nameOf(obj);
      var keys = arrObjKeys(obj, inspect);
      return "[Function" + (name ? ": " + name : " (anonymous)") + "]" + (keys.length > 0 ? " { " + $join.call(keys, ", ") + " }" : "");
    }
    if (isSymbol2(obj)) {
      var symString = hasShammedSymbols ? $replace.call(String(obj), /^(Symbol\(.*\))_[^)]*$/, "$1") : symToString.call(obj);
      return typeof obj === "object" && !hasShammedSymbols ? markBoxed(symString) : symString;
    }
    if (isElement(obj)) {
      var s2 = "<" + $toLowerCase.call(String(obj.nodeName));
      var attrs = obj.attributes || [];
      for (var i2 = 0; i2 < attrs.length; i2++) {
        s2 += " " + attrs[i2].name + "=" + wrapQuotes(quote(attrs[i2].value), "double", opts);
      }
      s2 += ">";
      if (obj.childNodes && obj.childNodes.length) {
        s2 += "...";
      }
      s2 += "</" + $toLowerCase.call(String(obj.nodeName)) + ">";
      return s2;
    }
    if (isArray2(obj)) {
      if (obj.length === 0) {
        return "[]";
      }
      var xs = arrObjKeys(obj, inspect);
      if (indent && !singleLineValues(xs)) {
        return "[" + indentedJoin(xs, indent) + "]";
      }
      return "[ " + $join.call(xs, ", ") + " ]";
    }
    if (isError(obj)) {
      var parts = arrObjKeys(obj, inspect);
      if (!("cause" in Error.prototype) && "cause" in obj && !isEnumerable.call(obj, "cause")) {
        return "{ [" + String(obj) + "] " + $join.call($concat.call("[cause]: " + inspect(obj.cause), parts), ", ") + " }";
      }
      if (parts.length === 0) {
        return "[" + String(obj) + "]";
      }
      return "{ [" + String(obj) + "] " + $join.call(parts, ", ") + " }";
    }
    if (typeof obj === "object" && customInspect) {
      if (inspectSymbol && typeof obj[inspectSymbol] === "function" && utilInspect) {
        return utilInspect(obj, { depth: maxDepth - depth });
      } else if (customInspect !== "symbol" && typeof obj.inspect === "function") {
        return obj.inspect();
      }
    }
    if (isMap2(obj)) {
      var mapParts = [];
      if (mapForEach) {
        mapForEach.call(obj, function(value, key) {
          mapParts.push(inspect(key, obj, true) + " => " + inspect(value, obj));
        });
      }
      return collectionOf("Map", mapSize.call(obj), mapParts, indent);
    }
    if (isSet2(obj)) {
      var setParts = [];
      if (setForEach) {
        setForEach.call(obj, function(value) {
          setParts.push(inspect(value, obj));
        });
      }
      return collectionOf("Set", setSize.call(obj), setParts, indent);
    }
    if (isWeakMap(obj)) {
      return weakCollectionOf("WeakMap");
    }
    if (isWeakSet(obj)) {
      return weakCollectionOf("WeakSet");
    }
    if (isWeakRef(obj)) {
      return weakCollectionOf("WeakRef");
    }
    if (isNumber(obj)) {
      return markBoxed(inspect(Number(obj)));
    }
    if (isBigInt(obj)) {
      return markBoxed(inspect(bigIntValueOf.call(obj)));
    }
    if (isBoolean(obj)) {
      return markBoxed(booleanValueOf.call(obj));
    }
    if (isString2(obj)) {
      return markBoxed(inspect(String(obj)));
    }
    if (typeof window !== "undefined" && obj === window) {
      return "{ [object Window] }";
    }
    if (obj === commonjsGlobal) {
      return "{ [object globalThis] }";
    }
    if (!isDate2(obj) && !isRegExp2(obj)) {
      var ys = arrObjKeys(obj, inspect);
      var isPlainObject2 = gPO ? gPO(obj) === Object.prototype : obj instanceof Object || obj.constructor === Object;
      var protoTag = obj instanceof Object ? "" : "null prototype";
      var stringTag = !isPlainObject2 && toStringTag && Object(obj) === obj && toStringTag in obj ? $slice.call(toStr(obj), 8, -1) : protoTag ? "Object" : "";
      var constructorTag = isPlainObject2 || typeof obj.constructor !== "function" ? "" : obj.constructor.name ? obj.constructor.name + " " : "";
      var tag = constructorTag + (stringTag || protoTag ? "[" + $join.call($concat.call([], stringTag || [], protoTag || []), ": ") + "] " : "");
      if (ys.length === 0) {
        return tag + "{}";
      }
      if (indent) {
        return tag + "{" + indentedJoin(ys, indent) + "}";
      }
      return tag + "{ " + $join.call(ys, ", ") + " }";
    }
    return String(obj);
  };
  function wrapQuotes(s2, defaultStyle, opts) {
    var quoteChar = (opts.quoteStyle || defaultStyle) === "double" ? '"' : "'";
    return quoteChar + s2 + quoteChar;
  }
  function quote(s2) {
    return $replace.call(String(s2), /"/g, "&quot;");
  }
  function isArray2(obj) {
    return toStr(obj) === "[object Array]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
  }
  function isDate2(obj) {
    return toStr(obj) === "[object Date]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
  }
  function isRegExp2(obj) {
    return toStr(obj) === "[object RegExp]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
  }
  function isError(obj) {
    return toStr(obj) === "[object Error]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
  }
  function isString2(obj) {
    return toStr(obj) === "[object String]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
  }
  function isNumber(obj) {
    return toStr(obj) === "[object Number]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
  }
  function isBoolean(obj) {
    return toStr(obj) === "[object Boolean]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
  }
  function isSymbol2(obj) {
    if (hasShammedSymbols) {
      return obj && typeof obj === "object" && obj instanceof Symbol;
    }
    if (typeof obj === "symbol") {
      return true;
    }
    if (!obj || typeof obj !== "object" || !symToString) {
      return false;
    }
    try {
      symToString.call(obj);
      return true;
    } catch (e) {
    }
    return false;
  }
  function isBigInt(obj) {
    if (!obj || typeof obj !== "object" || !bigIntValueOf) {
      return false;
    }
    try {
      bigIntValueOf.call(obj);
      return true;
    } catch (e) {
    }
    return false;
  }
  var hasOwn2 = Object.prototype.hasOwnProperty || function(key) {
    return key in this;
  };
  function has(obj, key) {
    return hasOwn2.call(obj, key);
  }
  function toStr(obj) {
    return objectToString2.call(obj);
  }
  function nameOf(f2) {
    if (f2.name) {
      return f2.name;
    }
    var m = $match.call(functionToString.call(f2), /^function\s*([\w$]+)/);
    if (m) {
      return m[1];
    }
    return null;
  }
  function indexOf(xs, x) {
    if (xs.indexOf) {
      return xs.indexOf(x);
    }
    for (var i2 = 0, l = xs.length; i2 < l; i2++) {
      if (xs[i2] === x) {
        return i2;
      }
    }
    return -1;
  }
  function isMap2(x) {
    if (!mapSize || !x || typeof x !== "object") {
      return false;
    }
    try {
      mapSize.call(x);
      try {
        setSize.call(x);
      } catch (s2) {
        return true;
      }
      return x instanceof Map;
    } catch (e) {
    }
    return false;
  }
  function isWeakMap(x) {
    if (!weakMapHas || !x || typeof x !== "object") {
      return false;
    }
    try {
      weakMapHas.call(x, weakMapHas);
      try {
        weakSetHas.call(x, weakSetHas);
      } catch (s2) {
        return true;
      }
      return x instanceof WeakMap;
    } catch (e) {
    }
    return false;
  }
  function isWeakRef(x) {
    if (!weakRefDeref || !x || typeof x !== "object") {
      return false;
    }
    try {
      weakRefDeref.call(x);
      return true;
    } catch (e) {
    }
    return false;
  }
  function isSet2(x) {
    if (!setSize || !x || typeof x !== "object") {
      return false;
    }
    try {
      setSize.call(x);
      try {
        mapSize.call(x);
      } catch (m) {
        return true;
      }
      return x instanceof Set;
    } catch (e) {
    }
    return false;
  }
  function isWeakSet(x) {
    if (!weakSetHas || !x || typeof x !== "object") {
      return false;
    }
    try {
      weakSetHas.call(x, weakSetHas);
      try {
        weakMapHas.call(x, weakMapHas);
      } catch (s2) {
        return true;
      }
      return x instanceof WeakSet;
    } catch (e) {
    }
    return false;
  }
  function isElement(x) {
    if (!x || typeof x !== "object") {
      return false;
    }
    if (typeof HTMLElement !== "undefined" && x instanceof HTMLElement) {
      return true;
    }
    return typeof x.nodeName === "string" && typeof x.getAttribute === "function";
  }
  function inspectString(str, opts) {
    if (str.length > opts.maxStringLength) {
      var remaining = str.length - opts.maxStringLength;
      var trailer = "... " + remaining + " more character" + (remaining > 1 ? "s" : "");
      return inspectString($slice.call(str, 0, opts.maxStringLength), opts) + trailer;
    }
    var s2 = $replace.call($replace.call(str, /(['\\])/g, "\\$1"), /[\x00-\x1f]/g, lowbyte);
    return wrapQuotes(s2, "single", opts);
  }
  function lowbyte(c) {
    var n = c.charCodeAt(0);
    var x = {
      8: "b",
      9: "t",
      10: "n",
      12: "f",
      13: "r"
    }[n];
    if (x) {
      return "\\" + x;
    }
    return "\\x" + (n < 16 ? "0" : "") + $toUpperCase.call(n.toString(16));
  }
  function markBoxed(str) {
    return "Object(" + str + ")";
  }
  function weakCollectionOf(type2) {
    return type2 + " { ? }";
  }
  function collectionOf(type2, size, entries, indent) {
    var joinedEntries = indent ? indentedJoin(entries, indent) : $join.call(entries, ", ");
    return type2 + " (" + size + ") {" + joinedEntries + "}";
  }
  function singleLineValues(xs) {
    for (var i2 = 0; i2 < xs.length; i2++) {
      if (indexOf(xs[i2], "\n") >= 0) {
        return false;
      }
    }
    return true;
  }
  function getIndent(opts, depth) {
    var baseIndent;
    if (opts.indent === "	") {
      baseIndent = "	";
    } else if (typeof opts.indent === "number" && opts.indent > 0) {
      baseIndent = $join.call(Array(opts.indent + 1), " ");
    } else {
      return null;
    }
    return {
      base: baseIndent,
      prev: $join.call(Array(depth + 1), baseIndent)
    };
  }
  function indentedJoin(xs, indent) {
    if (xs.length === 0) {
      return "";
    }
    var lineJoiner = "\n" + indent.prev + indent.base;
    return lineJoiner + $join.call(xs, "," + lineJoiner) + "\n" + indent.prev;
  }
  function arrObjKeys(obj, inspect) {
    var isArr = isArray2(obj);
    var xs = [];
    if (isArr) {
      xs.length = obj.length;
      for (var i2 = 0; i2 < obj.length; i2++) {
        xs[i2] = has(obj, i2) ? inspect(obj[i2], obj) : "";
      }
    }
    var syms = typeof gOPS === "function" ? gOPS(obj) : [];
    var symMap;
    if (hasShammedSymbols) {
      symMap = {};
      for (var k2 = 0; k2 < syms.length; k2++) {
        symMap["$" + syms[k2]] = syms[k2];
      }
    }
    for (var key in obj) {
      if (!has(obj, key)) {
        continue;
      }
      if (isArr && String(Number(key)) === key && key < obj.length) {
        continue;
      }
      if (hasShammedSymbols && symMap["$" + key] instanceof Symbol) {
        continue;
      } else if ($test.call(/[^\w$]/, key)) {
        xs.push(inspect(key, obj) + ": " + inspect(obj[key], obj));
      } else {
        xs.push(key + ": " + inspect(obj[key], obj));
      }
    }
    if (typeof gOPS === "function") {
      for (var j2 = 0; j2 < syms.length; j2++) {
        if (isEnumerable.call(obj, syms[j2])) {
          xs.push("[" + inspect(syms[j2]) + "]: " + inspect(obj[syms[j2]], obj));
        }
      }
    }
    return xs;
  }
  return objectInspect;
}
var sideChannel;
var hasRequiredSideChannel;
function requireSideChannel() {
  if (hasRequiredSideChannel)
    return sideChannel;
  hasRequiredSideChannel = 1;
  var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
  var callBound2 = requireCallBound();
  var inspect = /* @__PURE__ */ requireObjectInspect();
  var $TypeError = /* @__PURE__ */ requireType();
  var $WeakMap = GetIntrinsic("%WeakMap%", true);
  var $Map = GetIntrinsic("%Map%", true);
  var $weakMapGet = callBound2("WeakMap.prototype.get", true);
  var $weakMapSet = callBound2("WeakMap.prototype.set", true);
  var $weakMapHas = callBound2("WeakMap.prototype.has", true);
  var $mapGet = callBound2("Map.prototype.get", true);
  var $mapSet = callBound2("Map.prototype.set", true);
  var $mapHas = callBound2("Map.prototype.has", true);
  var listGetNode = function(list, key) {
    var prev = list;
    var curr;
    for (; (curr = prev.next) !== null; prev = curr) {
      if (curr.key === key) {
        prev.next = curr.next;
        curr.next = list.next;
        list.next = curr;
        return curr;
      }
    }
  };
  var listGet = function(objects, key) {
    var node = listGetNode(objects, key);
    return node && node.value;
  };
  var listSet = function(objects, key, value) {
    var node = listGetNode(objects, key);
    if (node) {
      node.value = value;
    } else {
      objects.next = {
        key,
        next: objects.next,
        value
      };
    }
  };
  var listHas = function(objects, key) {
    return !!listGetNode(objects, key);
  };
  sideChannel = function getSideChannel() {
    var $wm;
    var $m;
    var $o;
    var channel = {
      assert: function(key) {
        if (!channel.has(key)) {
          throw new $TypeError("Side channel does not contain " + inspect(key));
        }
      },
      get: function(key) {
        if ($WeakMap && key && (typeof key === "object" || typeof key === "function")) {
          if ($wm) {
            return $weakMapGet($wm, key);
          }
        } else if ($Map) {
          if ($m) {
            return $mapGet($m, key);
          }
        } else {
          if ($o) {
            return listGet($o, key);
          }
        }
      },
      has: function(key) {
        if ($WeakMap && key && (typeof key === "object" || typeof key === "function")) {
          if ($wm) {
            return $weakMapHas($wm, key);
          }
        } else if ($Map) {
          if ($m) {
            return $mapHas($m, key);
          }
        } else {
          if ($o) {
            return listHas($o, key);
          }
        }
        return false;
      },
      set: function(key, value) {
        if ($WeakMap && key && (typeof key === "object" || typeof key === "function")) {
          if (!$wm) {
            $wm = new $WeakMap();
          }
          $weakMapSet($wm, key, value);
        } else if ($Map) {
          if (!$m) {
            $m = new $Map();
          }
          $mapSet($m, key, value);
        } else {
          if (!$o) {
            $o = { key: {}, next: null };
          }
          listSet($o, key, value);
        }
      }
    };
    return channel;
  };
  return sideChannel;
}
var internalSlot;
var hasRequiredInternalSlot;
function requireInternalSlot() {
  if (hasRequiredInternalSlot)
    return internalSlot;
  hasRequiredInternalSlot = 1;
  var hasOwn2 = /* @__PURE__ */ requireHasown();
  var channel = requireSideChannel()();
  var $TypeError = /* @__PURE__ */ requireType();
  var SLOT = {
    assert: function(O, slot) {
      if (!O || typeof O !== "object" && typeof O !== "function") {
        throw new $TypeError("`O` is not an object");
      }
      if (typeof slot !== "string") {
        throw new $TypeError("`slot` must be a string");
      }
      channel.assert(O);
      if (!SLOT.has(O, slot)) {
        throw new $TypeError("`" + slot + "` is not present on `O`");
      }
    },
    get: function(O, slot) {
      if (!O || typeof O !== "object" && typeof O !== "function") {
        throw new $TypeError("`O` is not an object");
      }
      if (typeof slot !== "string") {
        throw new $TypeError("`slot` must be a string");
      }
      var slots = channel.get(O);
      return slots && slots["$" + slot];
    },
    has: function(O, slot) {
      if (!O || typeof O !== "object" && typeof O !== "function") {
        throw new $TypeError("`O` is not an object");
      }
      if (typeof slot !== "string") {
        throw new $TypeError("`slot` must be a string");
      }
      var slots = channel.get(O);
      return !!slots && hasOwn2(slots, "$" + slot);
    },
    set: function(O, slot, V) {
      if (!O || typeof O !== "object" && typeof O !== "function") {
        throw new $TypeError("`O` is not an object");
      }
      if (typeof slot !== "string") {
        throw new $TypeError("`slot` must be a string");
      }
      var slots = channel.get(O);
      if (!slots) {
        slots = {};
        channel.set(O, slots);
      }
      slots["$" + slot] = V;
    }
  };
  if (Object.freeze) {
    Object.freeze(SLOT);
  }
  internalSlot = SLOT;
  return internalSlot;
}
var stopIterationIterator;
var hasRequiredStopIterationIterator;
function requireStopIterationIterator() {
  if (hasRequiredStopIterationIterator)
    return stopIterationIterator;
  hasRequiredStopIterationIterator = 1;
  var SLOT = requireInternalSlot();
  var $SyntaxError = SyntaxError;
  var $StopIteration = typeof StopIteration === "object" ? StopIteration : null;
  stopIterationIterator = function getStopIterationIterator(origIterator) {
    if (!$StopIteration) {
      throw new $SyntaxError("this environment lacks StopIteration");
    }
    SLOT.set(origIterator, "[[Done]]", false);
    var siIterator = {
      next: function next() {
        var iterator2 = SLOT.get(this, "[[Iterator]]");
        var done = SLOT.get(iterator2, "[[Done]]");
        try {
          return {
            done,
            value: done ? void 0 : iterator2.next()
          };
        } catch (e) {
          SLOT.set(iterator2, "[[Done]]", true);
          if (e !== $StopIteration) {
            throw e;
          }
          return {
            done: true,
            value: void 0
          };
        }
      }
    };
    SLOT.set(siIterator, "[[Iterator]]", origIterator);
    return siIterator;
  };
  return stopIterationIterator;
}
var isarray;
var hasRequiredIsarray;
function requireIsarray() {
  if (hasRequiredIsarray)
    return isarray;
  hasRequiredIsarray = 1;
  var toString = {}.toString;
  isarray = Array.isArray || function(arr) {
    return toString.call(arr) == "[object Array]";
  };
  return isarray;
}
var isString;
var hasRequiredIsString;
function requireIsString() {
  if (hasRequiredIsString)
    return isString;
  hasRequiredIsString = 1;
  var strValue = String.prototype.valueOf;
  var tryStringObject = function tryStringObject2(value) {
    try {
      strValue.call(value);
      return true;
    } catch (e) {
      return false;
    }
  };
  var toStr = Object.prototype.toString;
  var strClass = "[object String]";
  var hasToStringTag = requireShams()();
  isString = function isString2(value) {
    if (typeof value === "string") {
      return true;
    }
    if (typeof value !== "object") {
      return false;
    }
    return hasToStringTag ? tryStringObject(value) : toStr.call(value) === strClass;
  };
  return isString;
}
var isMap;
var hasRequiredIsMap;
function requireIsMap() {
  if (hasRequiredIsMap)
    return isMap;
  hasRequiredIsMap = 1;
  var $Map = typeof Map === "function" && Map.prototype ? Map : null;
  var $Set = typeof Set === "function" && Set.prototype ? Set : null;
  var exported;
  if (!$Map) {
    exported = function isMap2(x) {
      return false;
    };
  }
  var $mapHas = $Map ? Map.prototype.has : null;
  var $setHas = $Set ? Set.prototype.has : null;
  if (!exported && !$mapHas) {
    exported = function isMap2(x) {
      return false;
    };
  }
  isMap = exported || function isMap2(x) {
    if (!x || typeof x !== "object") {
      return false;
    }
    try {
      $mapHas.call(x);
      if ($setHas) {
        try {
          $setHas.call(x);
        } catch (e) {
          return true;
        }
      }
      return x instanceof $Map;
    } catch (e) {
    }
    return false;
  };
  return isMap;
}
var isSet;
var hasRequiredIsSet;
function requireIsSet() {
  if (hasRequiredIsSet)
    return isSet;
  hasRequiredIsSet = 1;
  var $Map = typeof Map === "function" && Map.prototype ? Map : null;
  var $Set = typeof Set === "function" && Set.prototype ? Set : null;
  var exported;
  if (!$Set) {
    exported = function isSet2(x) {
      return false;
    };
  }
  var $mapHas = $Map ? Map.prototype.has : null;
  var $setHas = $Set ? Set.prototype.has : null;
  if (!exported && !$setHas) {
    exported = function isSet2(x) {
      return false;
    };
  }
  isSet = exported || function isSet2(x) {
    if (!x || typeof x !== "object") {
      return false;
    }
    try {
      $setHas.call(x);
      if ($mapHas) {
        try {
          $mapHas.call(x);
        } catch (e) {
          return true;
        }
      }
      return x instanceof $Set;
    } catch (e) {
    }
    return false;
  };
  return isSet;
}
var hasRequiredEsGetIterator;
function requireEsGetIterator() {
  if (hasRequiredEsGetIterator)
    return esGetIterator.exports;
  hasRequiredEsGetIterator = 1;
  var isArguments2 = requireIsArguments();
  var getStopIterationIterator = requireStopIterationIterator();
  if (requireHasSymbols()() || requireShams$1()()) {
    var $iterator = Symbol.iterator;
    esGetIterator.exports = function getIterator(iterable) {
      if (iterable != null && typeof iterable[$iterator] !== "undefined") {
        return iterable[$iterator]();
      }
      if (isArguments2(iterable)) {
        return Array.prototype[$iterator].call(iterable);
      }
    };
  } else {
    var isArray2 = requireIsarray();
    var isString2 = requireIsString();
    var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
    var $Map = GetIntrinsic("%Map%", true);
    var $Set = GetIntrinsic("%Set%", true);
    var callBound2 = requireCallBound();
    var $arrayPush = callBound2("Array.prototype.push");
    var $charCodeAt = callBound2("String.prototype.charCodeAt");
    var $stringSlice = callBound2("String.prototype.slice");
    var advanceStringIndex = function advanceStringIndex2(S2, index2) {
      var length = S2.length;
      if (index2 + 1 >= length) {
        return index2 + 1;
      }
      var first = $charCodeAt(S2, index2);
      if (first < 55296 || first > 56319) {
        return index2 + 1;
      }
      var second = $charCodeAt(S2, index2 + 1);
      if (second < 56320 || second > 57343) {
        return index2 + 1;
      }
      return index2 + 2;
    };
    var getArrayIterator = function getArrayIterator2(arraylike) {
      var i2 = 0;
      return {
        next: function next() {
          var done = i2 >= arraylike.length;
          var value;
          if (!done) {
            value = arraylike[i2];
            i2 += 1;
          }
          return {
            done,
            value
          };
        }
      };
    };
    var getNonCollectionIterator = function getNonCollectionIterator2(iterable, noPrimordialCollections) {
      if (isArray2(iterable) || isArguments2(iterable)) {
        return getArrayIterator(iterable);
      }
      if (isString2(iterable)) {
        var i2 = 0;
        return {
          next: function next() {
            var nextIndex = advanceStringIndex(iterable, i2);
            var value = $stringSlice(iterable, i2, nextIndex);
            i2 = nextIndex;
            return {
              done: nextIndex > iterable.length,
              value
            };
          }
        };
      }
      if (noPrimordialCollections && typeof iterable["_es6-shim iterator_"] !== "undefined") {
        return iterable["_es6-shim iterator_"]();
      }
    };
    if (!$Map && !$Set) {
      esGetIterator.exports = function getIterator(iterable) {
        if (iterable != null) {
          return getNonCollectionIterator(iterable, true);
        }
      };
    } else {
      var isMap2 = /* @__PURE__ */ requireIsMap();
      var isSet2 = /* @__PURE__ */ requireIsSet();
      var $mapForEach = callBound2("Map.prototype.forEach", true);
      var $setForEach = callBound2("Set.prototype.forEach", true);
      if (typeof process === "undefined" || !process.versions || !process.versions.node) {
        var $mapIterator = callBound2("Map.prototype.iterator", true);
        var $setIterator = callBound2("Set.prototype.iterator", true);
      }
      var $mapAtAtIterator = callBound2("Map.prototype.@@iterator", true) || callBound2("Map.prototype._es6-shim iterator_", true);
      var $setAtAtIterator = callBound2("Set.prototype.@@iterator", true) || callBound2("Set.prototype._es6-shim iterator_", true);
      var getCollectionIterator = function getCollectionIterator2(iterable) {
        if (isMap2(iterable)) {
          if ($mapIterator) {
            return getStopIterationIterator($mapIterator(iterable));
          }
          if ($mapAtAtIterator) {
            return $mapAtAtIterator(iterable);
          }
          if ($mapForEach) {
            var entries = [];
            $mapForEach(iterable, function(v2, k2) {
              $arrayPush(entries, [k2, v2]);
            });
            return getArrayIterator(entries);
          }
        }
        if (isSet2(iterable)) {
          if ($setIterator) {
            return getStopIterationIterator($setIterator(iterable));
          }
          if ($setAtAtIterator) {
            return $setAtAtIterator(iterable);
          }
          if ($setForEach) {
            var values = [];
            $setForEach(iterable, function(v2) {
              $arrayPush(values, v2);
            });
            return getArrayIterator(values);
          }
        }
      };
      esGetIterator.exports = function getIterator(iterable) {
        return getCollectionIterator(iterable) || getNonCollectionIterator(iterable);
      };
    }
  }
  return esGetIterator.exports;
}
var implementation;
var hasRequiredImplementation;
function requireImplementation() {
  if (hasRequiredImplementation)
    return implementation;
  hasRequiredImplementation = 1;
  var numberIsNaN = function(value) {
    return value !== value;
  };
  implementation = function is(a2, b2) {
    if (a2 === 0 && b2 === 0) {
      return 1 / a2 === 1 / b2;
    }
    if (a2 === b2) {
      return true;
    }
    if (numberIsNaN(a2) && numberIsNaN(b2)) {
      return true;
    }
    return false;
  };
  return implementation;
}
var polyfill2;
var hasRequiredPolyfill;
function requirePolyfill() {
  if (hasRequiredPolyfill)
    return polyfill2;
  hasRequiredPolyfill = 1;
  var implementation2 = requireImplementation();
  polyfill2 = function getPolyfill() {
    return typeof Object.is === "function" ? Object.is : implementation2;
  };
  return polyfill2;
}
var shim;
var hasRequiredShim;
function requireShim() {
  if (hasRequiredShim)
    return shim;
  hasRequiredShim = 1;
  var getPolyfill = requirePolyfill();
  var define = requireDefineProperties();
  shim = function shimObjectIs() {
    var polyfill22 = getPolyfill();
    define(Object, { is: polyfill22 }, {
      is: function testObjectIs() {
        return Object.is !== polyfill22;
      }
    });
    return polyfill22;
  };
  return shim;
}
var objectIs;
var hasRequiredObjectIs;
function requireObjectIs() {
  if (hasRequiredObjectIs)
    return objectIs;
  hasRequiredObjectIs = 1;
  var define = requireDefineProperties();
  var callBind2 = requireCallBind();
  var implementation2 = requireImplementation();
  var getPolyfill = requirePolyfill();
  var shim2 = requireShim();
  var polyfill22 = callBind2(getPolyfill(), Object);
  define(polyfill22, {
    getPolyfill,
    implementation: implementation2,
    shim: shim2
  });
  objectIs = polyfill22;
  return objectIs;
}
var isArrayBuffer;
var hasRequiredIsArrayBuffer;
function requireIsArrayBuffer() {
  if (hasRequiredIsArrayBuffer)
    return isArrayBuffer;
  hasRequiredIsArrayBuffer = 1;
  var callBind2 = requireCallBind();
  var callBound2 = requireCallBound();
  var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
  var $ArrayBuffer = GetIntrinsic("%ArrayBuffer%", true);
  var $byteLength = callBound2("ArrayBuffer.prototype.byteLength", true);
  var $toString = callBound2("Object.prototype.toString");
  var abSlice = !!$ArrayBuffer && !$byteLength && new $ArrayBuffer(0).slice;
  var $abSlice = !!abSlice && callBind2(abSlice);
  isArrayBuffer = $byteLength || $abSlice ? function isArrayBuffer2(obj) {
    if (!obj || typeof obj !== "object") {
      return false;
    }
    try {
      if ($byteLength) {
        $byteLength(obj);
      } else {
        $abSlice(obj, 0);
      }
      return true;
    } catch (e) {
      return false;
    }
  } : $ArrayBuffer ? function isArrayBuffer2(obj) {
    return $toString(obj) === "[object ArrayBuffer]";
  } : function isArrayBuffer2(obj) {
    return false;
  };
  return isArrayBuffer;
}
var isDateObject;
var hasRequiredIsDateObject;
function requireIsDateObject() {
  if (hasRequiredIsDateObject)
    return isDateObject;
  hasRequiredIsDateObject = 1;
  var getDay = Date.prototype.getDay;
  var tryDateObject = function tryDateGetDayCall(value) {
    try {
      getDay.call(value);
      return true;
    } catch (e) {
      return false;
    }
  };
  var toStr = Object.prototype.toString;
  var dateClass = "[object Date]";
  var hasToStringTag = requireShams()();
  isDateObject = function isDateObject2(value) {
    if (typeof value !== "object" || value === null) {
      return false;
    }
    return hasToStringTag ? tryDateObject(value) : toStr.call(value) === dateClass;
  };
  return isDateObject;
}
var isRegex;
var hasRequiredIsRegex;
function requireIsRegex() {
  if (hasRequiredIsRegex)
    return isRegex;
  hasRequiredIsRegex = 1;
  var callBound2 = requireCallBound();
  var hasToStringTag = requireShams()();
  var has;
  var $exec;
  var isRegexMarker;
  var badStringifier;
  if (hasToStringTag) {
    has = callBound2("Object.prototype.hasOwnProperty");
    $exec = callBound2("RegExp.prototype.exec");
    isRegexMarker = {};
    var throwRegexMarker = function() {
      throw isRegexMarker;
    };
    badStringifier = {
      toString: throwRegexMarker,
      valueOf: throwRegexMarker
    };
    if (typeof Symbol.toPrimitive === "symbol") {
      badStringifier[Symbol.toPrimitive] = throwRegexMarker;
    }
  }
  var $toString = callBound2("Object.prototype.toString");
  var gOPD = Object.getOwnPropertyDescriptor;
  var regexClass = "[object RegExp]";
  isRegex = hasToStringTag ? function isRegex2(value) {
    if (!value || typeof value !== "object") {
      return false;
    }
    var descriptor = gOPD(value, "lastIndex");
    var hasLastIndexDataProperty = descriptor && has(descriptor, "value");
    if (!hasLastIndexDataProperty) {
      return false;
    }
    try {
      $exec(value, badStringifier);
    } catch (e) {
      return e === isRegexMarker;
    }
  } : function isRegex2(value) {
    if (!value || typeof value !== "object" && typeof value !== "function") {
      return false;
    }
    return $toString(value) === regexClass;
  };
  return isRegex;
}
var isSharedArrayBuffer;
var hasRequiredIsSharedArrayBuffer;
function requireIsSharedArrayBuffer() {
  if (hasRequiredIsSharedArrayBuffer)
    return isSharedArrayBuffer;
  hasRequiredIsSharedArrayBuffer = 1;
  var callBound2 = requireCallBound();
  var $byteLength = callBound2("SharedArrayBuffer.prototype.byteLength", true);
  isSharedArrayBuffer = $byteLength ? function isSharedArrayBuffer2(obj) {
    if (!obj || typeof obj !== "object") {
      return false;
    }
    try {
      $byteLength(obj);
      return true;
    } catch (e) {
      return false;
    }
  } : function isSharedArrayBuffer2(obj) {
    return false;
  };
  return isSharedArrayBuffer;
}
var isNumberObject;
var hasRequiredIsNumberObject;
function requireIsNumberObject() {
  if (hasRequiredIsNumberObject)
    return isNumberObject;
  hasRequiredIsNumberObject = 1;
  var numToStr = Number.prototype.toString;
  var tryNumberObject = function tryNumberObject2(value) {
    try {
      numToStr.call(value);
      return true;
    } catch (e) {
      return false;
    }
  };
  var toStr = Object.prototype.toString;
  var numClass = "[object Number]";
  var hasToStringTag = requireShams()();
  isNumberObject = function isNumberObject2(value) {
    if (typeof value === "number") {
      return true;
    }
    if (typeof value !== "object") {
      return false;
    }
    return hasToStringTag ? tryNumberObject(value) : toStr.call(value) === numClass;
  };
  return isNumberObject;
}
var isBooleanObject;
var hasRequiredIsBooleanObject;
function requireIsBooleanObject() {
  if (hasRequiredIsBooleanObject)
    return isBooleanObject;
  hasRequiredIsBooleanObject = 1;
  var callBound2 = requireCallBound();
  var $boolToStr = callBound2("Boolean.prototype.toString");
  var $toString = callBound2("Object.prototype.toString");
  var tryBooleanObject = function booleanBrandCheck(value) {
    try {
      $boolToStr(value);
      return true;
    } catch (e) {
      return false;
    }
  };
  var boolClass = "[object Boolean]";
  var hasToStringTag = requireShams()();
  isBooleanObject = function isBoolean(value) {
    if (typeof value === "boolean") {
      return true;
    }
    if (value === null || typeof value !== "object") {
      return false;
    }
    return hasToStringTag && Symbol.toStringTag in value ? tryBooleanObject(value) : $toString(value) === boolClass;
  };
  return isBooleanObject;
}
var isSymbol = { exports: {} };
var hasRequiredIsSymbol;
function requireIsSymbol() {
  if (hasRequiredIsSymbol)
    return isSymbol.exports;
  hasRequiredIsSymbol = 1;
  var toStr = Object.prototype.toString;
  var hasSymbols2 = requireHasSymbols()();
  if (hasSymbols2) {
    var symToStr = Symbol.prototype.toString;
    var symStringRegex = /^Symbol\(.*\)$/;
    var isSymbolObject = function isRealSymbolObject(value) {
      if (typeof value.valueOf() !== "symbol") {
        return false;
      }
      return symStringRegex.test(symToStr.call(value));
    };
    isSymbol.exports = function isSymbol2(value) {
      if (typeof value === "symbol") {
        return true;
      }
      if (toStr.call(value) !== "[object Symbol]") {
        return false;
      }
      try {
        return isSymbolObject(value);
      } catch (e) {
        return false;
      }
    };
  } else {
    isSymbol.exports = function isSymbol2(value) {
      return false;
    };
  }
  return isSymbol.exports;
}
var isBigint = { exports: {} };
var hasBigints;
var hasRequiredHasBigints;
function requireHasBigints() {
  if (hasRequiredHasBigints)
    return hasBigints;
  hasRequiredHasBigints = 1;
  var $BigInt = typeof BigInt !== "undefined" && BigInt;
  hasBigints = function hasNativeBigInts() {
    return typeof $BigInt === "function" && typeof BigInt === "function" && typeof $BigInt(42) === "bigint" && typeof BigInt(42) === "bigint";
  };
  return hasBigints;
}
var hasRequiredIsBigint;
function requireIsBigint() {
  if (hasRequiredIsBigint)
    return isBigint.exports;
  hasRequiredIsBigint = 1;
  var hasBigInts = requireHasBigints()();
  if (hasBigInts) {
    var bigIntValueOf = BigInt.prototype.valueOf;
    var tryBigInt = function tryBigIntObject(value) {
      try {
        bigIntValueOf.call(value);
        return true;
      } catch (e) {
      }
      return false;
    };
    isBigint.exports = function isBigInt(value) {
      if (value === null || typeof value === "undefined" || typeof value === "boolean" || typeof value === "string" || typeof value === "number" || typeof value === "symbol" || typeof value === "function") {
        return false;
      }
      if (typeof value === "bigint") {
        return true;
      }
      return tryBigInt(value);
    };
  } else {
    isBigint.exports = function isBigInt(value) {
      return false;
    };
  }
  return isBigint.exports;
}
var whichBoxedPrimitive;
var hasRequiredWhichBoxedPrimitive;
function requireWhichBoxedPrimitive() {
  if (hasRequiredWhichBoxedPrimitive)
    return whichBoxedPrimitive;
  hasRequiredWhichBoxedPrimitive = 1;
  var isString2 = requireIsString();
  var isNumber = requireIsNumberObject();
  var isBoolean = requireIsBooleanObject();
  var isSymbol2 = requireIsSymbol();
  var isBigInt = requireIsBigint();
  whichBoxedPrimitive = function whichBoxedPrimitive2(value) {
    if (value == null || typeof value !== "object" && typeof value !== "function") {
      return null;
    }
    if (isString2(value)) {
      return "String";
    }
    if (isNumber(value)) {
      return "Number";
    }
    if (isBoolean(value)) {
      return "Boolean";
    }
    if (isSymbol2(value)) {
      return "Symbol";
    }
    if (isBigInt(value)) {
      return "BigInt";
    }
  };
  return whichBoxedPrimitive;
}
var isWeakmap;
var hasRequiredIsWeakmap;
function requireIsWeakmap() {
  if (hasRequiredIsWeakmap)
    return isWeakmap;
  hasRequiredIsWeakmap = 1;
  var $WeakMap = typeof WeakMap === "function" && WeakMap.prototype ? WeakMap : null;
  var $WeakSet = typeof WeakSet === "function" && WeakSet.prototype ? WeakSet : null;
  var exported;
  if (!$WeakMap) {
    exported = function isWeakMap(x) {
      return false;
    };
  }
  var $mapHas = $WeakMap ? $WeakMap.prototype.has : null;
  var $setHas = $WeakSet ? $WeakSet.prototype.has : null;
  if (!exported && !$mapHas) {
    exported = function isWeakMap(x) {
      return false;
    };
  }
  isWeakmap = exported || function isWeakMap(x) {
    if (!x || typeof x !== "object") {
      return false;
    }
    try {
      $mapHas.call(x, $mapHas);
      if ($setHas) {
        try {
          $setHas.call(x, $setHas);
        } catch (e) {
          return true;
        }
      }
      return x instanceof $WeakMap;
    } catch (e) {
    }
    return false;
  };
  return isWeakmap;
}
var isWeakset = { exports: {} };
var hasRequiredIsWeakset;
function requireIsWeakset() {
  if (hasRequiredIsWeakset)
    return isWeakset.exports;
  hasRequiredIsWeakset = 1;
  var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
  var callBound2 = requireCallBound();
  var $WeakSet = GetIntrinsic("%WeakSet%", true);
  var $setHas = callBound2("WeakSet.prototype.has", true);
  if ($setHas) {
    var $mapHas = callBound2("WeakMap.prototype.has", true);
    isWeakset.exports = function isWeakSet(x) {
      if (!x || typeof x !== "object") {
        return false;
      }
      try {
        $setHas(x, $setHas);
        if ($mapHas) {
          try {
            $mapHas(x, $mapHas);
          } catch (e) {
            return true;
          }
        }
        return x instanceof $WeakSet;
      } catch (e) {
      }
      return false;
    };
  } else {
    isWeakset.exports = function isWeakSet(x) {
      return false;
    };
  }
  return isWeakset.exports;
}
var whichCollection;
var hasRequiredWhichCollection;
function requireWhichCollection() {
  if (hasRequiredWhichCollection)
    return whichCollection;
  hasRequiredWhichCollection = 1;
  var isMap2 = /* @__PURE__ */ requireIsMap();
  var isSet2 = /* @__PURE__ */ requireIsSet();
  var isWeakMap = requireIsWeakmap();
  var isWeakSet = /* @__PURE__ */ requireIsWeakset();
  whichCollection = function whichCollection2(value) {
    if (value && typeof value === "object") {
      if (isMap2(value)) {
        return "Map";
      }
      if (isSet2(value)) {
        return "Set";
      }
      if (isWeakMap(value)) {
        return "WeakMap";
      }
      if (isWeakSet(value)) {
        return "WeakSet";
      }
    }
    return false;
  };
  return whichCollection;
}
var isCallable;
var hasRequiredIsCallable;
function requireIsCallable() {
  if (hasRequiredIsCallable)
    return isCallable;
  hasRequiredIsCallable = 1;
  var fnToStr = Function.prototype.toString;
  var reflectApply = typeof Reflect === "object" && Reflect !== null && Reflect.apply;
  var badArrayLike;
  var isCallableMarker;
  if (typeof reflectApply === "function" && typeof Object.defineProperty === "function") {
    try {
      badArrayLike = Object.defineProperty({}, "length", {
        get: function() {
          throw isCallableMarker;
        }
      });
      isCallableMarker = {};
      reflectApply(function() {
        throw 42;
      }, null, badArrayLike);
    } catch (_2) {
      if (_2 !== isCallableMarker) {
        reflectApply = null;
      }
    }
  } else {
    reflectApply = null;
  }
  var constructorRegex = /^\s*class\b/;
  var isES6ClassFn = function isES6ClassFunction(value) {
    try {
      var fnStr = fnToStr.call(value);
      return constructorRegex.test(fnStr);
    } catch (e) {
      return false;
    }
  };
  var tryFunctionObject = function tryFunctionToStr(value) {
    try {
      if (isES6ClassFn(value)) {
        return false;
      }
      fnToStr.call(value);
      return true;
    } catch (e) {
      return false;
    }
  };
  var toStr = Object.prototype.toString;
  var objectClass = "[object Object]";
  var fnClass = "[object Function]";
  var genClass = "[object GeneratorFunction]";
  var ddaClass = "[object HTMLAllCollection]";
  var ddaClass2 = "[object HTML document.all class]";
  var ddaClass3 = "[object HTMLCollection]";
  var hasToStringTag = typeof Symbol === "function" && !!Symbol.toStringTag;
  var isIE68 = !(0 in [,]);
  var isDDA = function isDocumentDotAll() {
    return false;
  };
  if (typeof document === "object") {
    var all = document.all;
    if (toStr.call(all) === toStr.call(document.all)) {
      isDDA = function isDocumentDotAll(value) {
        if ((isIE68 || !value) && (typeof value === "undefined" || typeof value === "object")) {
          try {
            var str = toStr.call(value);
            return (str === ddaClass || str === ddaClass2 || str === ddaClass3 || str === objectClass) && value("") == null;
          } catch (e) {
          }
        }
        return false;
      };
    }
  }
  isCallable = reflectApply ? function isCallable2(value) {
    if (isDDA(value)) {
      return true;
    }
    if (!value) {
      return false;
    }
    if (typeof value !== "function" && typeof value !== "object") {
      return false;
    }
    try {
      reflectApply(value, null, badArrayLike);
    } catch (e) {
      if (e !== isCallableMarker) {
        return false;
      }
    }
    return !isES6ClassFn(value) && tryFunctionObject(value);
  } : function isCallable2(value) {
    if (isDDA(value)) {
      return true;
    }
    if (!value) {
      return false;
    }
    if (typeof value !== "function" && typeof value !== "object") {
      return false;
    }
    if (hasToStringTag) {
      return tryFunctionObject(value);
    }
    if (isES6ClassFn(value)) {
      return false;
    }
    var strClass = toStr.call(value);
    if (strClass !== fnClass && strClass !== genClass && !/^\[object HTML/.test(strClass)) {
      return false;
    }
    return tryFunctionObject(value);
  };
  return isCallable;
}
var forEach_1;
var hasRequiredForEach;
function requireForEach() {
  if (hasRequiredForEach)
    return forEach_1;
  hasRequiredForEach = 1;
  var isCallable2 = requireIsCallable();
  var toStr = Object.prototype.toString;
  var hasOwnProperty2 = Object.prototype.hasOwnProperty;
  var forEachArray = function forEachArray2(array, iterator2, receiver) {
    for (var i2 = 0, len = array.length; i2 < len; i2++) {
      if (hasOwnProperty2.call(array, i2)) {
        if (receiver == null) {
          iterator2(array[i2], i2, array);
        } else {
          iterator2.call(receiver, array[i2], i2, array);
        }
      }
    }
  };
  var forEachString = function forEachString2(string, iterator2, receiver) {
    for (var i2 = 0, len = string.length; i2 < len; i2++) {
      if (receiver == null) {
        iterator2(string.charAt(i2), i2, string);
      } else {
        iterator2.call(receiver, string.charAt(i2), i2, string);
      }
    }
  };
  var forEachObject = function forEachObject2(object, iterator2, receiver) {
    for (var k2 in object) {
      if (hasOwnProperty2.call(object, k2)) {
        if (receiver == null) {
          iterator2(object[k2], k2, object);
        } else {
          iterator2.call(receiver, object[k2], k2, object);
        }
      }
    }
  };
  var forEach = function forEach2(list, iterator2, thisArg) {
    if (!isCallable2(iterator2)) {
      throw new TypeError("iterator must be a function");
    }
    var receiver;
    if (arguments.length >= 3) {
      receiver = thisArg;
    }
    if (toStr.call(list) === "[object Array]") {
      forEachArray(list, iterator2, receiver);
    } else if (typeof list === "string") {
      forEachString(list, iterator2, receiver);
    } else {
      forEachObject(list, iterator2, receiver);
    }
  };
  forEach_1 = forEach;
  return forEach_1;
}
var possibleTypedArrayNames;
var hasRequiredPossibleTypedArrayNames;
function requirePossibleTypedArrayNames() {
  if (hasRequiredPossibleTypedArrayNames)
    return possibleTypedArrayNames;
  hasRequiredPossibleTypedArrayNames = 1;
  possibleTypedArrayNames = [
    "Float32Array",
    "Float64Array",
    "Int8Array",
    "Int16Array",
    "Int32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "Uint16Array",
    "Uint32Array",
    "BigInt64Array",
    "BigUint64Array"
  ];
  return possibleTypedArrayNames;
}
var availableTypedArrays;
var hasRequiredAvailableTypedArrays;
function requireAvailableTypedArrays() {
  if (hasRequiredAvailableTypedArrays)
    return availableTypedArrays;
  hasRequiredAvailableTypedArrays = 1;
  var possibleNames = /* @__PURE__ */ requirePossibleTypedArrayNames();
  var g = typeof globalThis === "undefined" ? commonjsGlobal : globalThis;
  availableTypedArrays = function availableTypedArrays2() {
    var out = [];
    for (var i2 = 0; i2 < possibleNames.length; i2++) {
      if (typeof g[possibleNames[i2]] === "function") {
        out[out.length] = possibleNames[i2];
      }
    }
    return out;
  };
  return availableTypedArrays;
}
var whichTypedArray;
var hasRequiredWhichTypedArray;
function requireWhichTypedArray() {
  if (hasRequiredWhichTypedArray)
    return whichTypedArray;
  hasRequiredWhichTypedArray = 1;
  var forEach = requireForEach();
  var availableTypedArrays2 = /* @__PURE__ */ requireAvailableTypedArrays();
  var callBind2 = requireCallBind();
  var callBound2 = requireCallBound();
  var gOPD = /* @__PURE__ */ requireGopd();
  var $toString = callBound2("Object.prototype.toString");
  var hasToStringTag = requireShams()();
  var g = typeof globalThis === "undefined" ? commonjsGlobal : globalThis;
  var typedArrays = availableTypedArrays2();
  var $slice = callBound2("String.prototype.slice");
  var getPrototypeOf = Object.getPrototypeOf;
  var $indexOf = callBound2("Array.prototype.indexOf", true) || function indexOf(array, value) {
    for (var i2 = 0; i2 < array.length; i2 += 1) {
      if (array[i2] === value) {
        return i2;
      }
    }
    return -1;
  };
  var cache = { __proto__: null };
  if (hasToStringTag && gOPD && getPrototypeOf) {
    forEach(typedArrays, function(typedArray) {
      var arr = new g[typedArray]();
      if (Symbol.toStringTag in arr) {
        var proto = getPrototypeOf(arr);
        var descriptor = gOPD(proto, Symbol.toStringTag);
        if (!descriptor) {
          var superProto = getPrototypeOf(proto);
          descriptor = gOPD(superProto, Symbol.toStringTag);
        }
        cache["$" + typedArray] = callBind2(descriptor.get);
      }
    });
  } else {
    forEach(typedArrays, function(typedArray) {
      var arr = new g[typedArray]();
      var fn = arr.slice || arr.set;
      if (fn) {
        cache["$" + typedArray] = callBind2(fn);
      }
    });
  }
  var tryTypedArrays = function tryAllTypedArrays(value) {
    var found = false;
    forEach(
      cache,
      function(getter, typedArray) {
        if (!found) {
          try {
            if ("$" + getter(value) === typedArray) {
              found = $slice(typedArray, 1);
            }
          } catch (e) {
          }
        }
      }
    );
    return found;
  };
  var trySlices = function tryAllSlices(value) {
    var found = false;
    forEach(
      cache,
      function(getter, name) {
        if (!found) {
          try {
            getter(value);
            found = $slice(name, 1);
          } catch (e) {
          }
        }
      }
    );
    return found;
  };
  whichTypedArray = function whichTypedArray2(value) {
    if (!value || typeof value !== "object") {
      return false;
    }
    if (!hasToStringTag) {
      var tag = $slice($toString(value), 8, -1);
      if ($indexOf(typedArrays, tag) > -1) {
        return tag;
      }
      if (tag !== "Object") {
        return false;
      }
      return trySlices(value);
    }
    if (!gOPD) {
      return null;
    }
    return tryTypedArrays(value);
  };
  return whichTypedArray;
}
var arrayBufferByteLength;
var hasRequiredArrayBufferByteLength;
function requireArrayBufferByteLength() {
  if (hasRequiredArrayBufferByteLength)
    return arrayBufferByteLength;
  hasRequiredArrayBufferByteLength = 1;
  var callBound2 = requireCallBound();
  var $byteLength = callBound2("ArrayBuffer.prototype.byteLength", true);
  var isArrayBuffer2 = /* @__PURE__ */ requireIsArrayBuffer();
  arrayBufferByteLength = function byteLength(ab) {
    if (!isArrayBuffer2(ab)) {
      return NaN;
    }
    return $byteLength ? $byteLength(ab) : ab.byteLength;
  };
  return arrayBufferByteLength;
}
var deepEqual$1;
var hasRequiredDeepEqual;
function requireDeepEqual() {
  if (hasRequiredDeepEqual)
    return deepEqual$1;
  hasRequiredDeepEqual = 1;
  var assign = requireObject_assign();
  var callBound2 = requireCallBound();
  var flags = requireRegexp_prototype_flags();
  var GetIntrinsic = /* @__PURE__ */ requireGetIntrinsic();
  var getIterator = requireEsGetIterator();
  var getSideChannel = requireSideChannel();
  var is = requireObjectIs();
  var isArguments2 = requireIsArguments();
  var isArray2 = requireIsarray();
  var isArrayBuffer2 = /* @__PURE__ */ requireIsArrayBuffer();
  var isDate2 = requireIsDateObject();
  var isRegex2 = requireIsRegex();
  var isSharedArrayBuffer2 = /* @__PURE__ */ requireIsSharedArrayBuffer();
  var objectKeys2 = requireObjectKeys();
  var whichBoxedPrimitive2 = requireWhichBoxedPrimitive();
  var whichCollection2 = /* @__PURE__ */ requireWhichCollection();
  var whichTypedArray2 = /* @__PURE__ */ requireWhichTypedArray();
  var byteLength = /* @__PURE__ */ requireArrayBufferByteLength();
  var sabByteLength = callBound2("SharedArrayBuffer.prototype.byteLength", true);
  var $getTime = callBound2("Date.prototype.getTime");
  var gPO = Object.getPrototypeOf;
  var $objToString = callBound2("Object.prototype.toString");
  var $Set = GetIntrinsic("%Set%", true);
  var $mapHas = callBound2("Map.prototype.has", true);
  var $mapGet = callBound2("Map.prototype.get", true);
  var $mapSize = callBound2("Map.prototype.size", true);
  var $setAdd = callBound2("Set.prototype.add", true);
  var $setDelete = callBound2("Set.prototype.delete", true);
  var $setHas = callBound2("Set.prototype.has", true);
  var $setSize = callBound2("Set.prototype.size", true);
  function setHasEqualElement(set, val1, opts, channel) {
    var i2 = getIterator(set);
    var result;
    while ((result = i2.next()) && !result.done) {
      if (internalDeepEqual(val1, result.value, opts, channel)) {
        $setDelete(set, result.value);
        return true;
      }
    }
    return false;
  }
  function findLooseMatchingPrimitives(prim) {
    if (typeof prim === "undefined") {
      return null;
    }
    if (typeof prim === "object") {
      return void 0;
    }
    if (typeof prim === "symbol") {
      return false;
    }
    if (typeof prim === "string" || typeof prim === "number") {
      return +prim === +prim;
    }
    return true;
  }
  function mapMightHaveLoosePrim(a2, b2, prim, item, opts, channel) {
    var altValue = findLooseMatchingPrimitives(prim);
    if (altValue != null) {
      return altValue;
    }
    var curB = $mapGet(b2, altValue);
    var looseOpts = assign({}, opts, { strict: false });
    if (typeof curB === "undefined" && !$mapHas(b2, altValue) || !internalDeepEqual(item, curB, looseOpts, channel)) {
      return false;
    }
    return !$mapHas(a2, altValue) && internalDeepEqual(item, curB, looseOpts, channel);
  }
  function setMightHaveLoosePrim(a2, b2, prim) {
    var altValue = findLooseMatchingPrimitives(prim);
    if (altValue != null) {
      return altValue;
    }
    return $setHas(b2, altValue) && !$setHas(a2, altValue);
  }
  function mapHasEqualEntry(set, map, key1, item1, opts, channel) {
    var i2 = getIterator(set);
    var result;
    var key2;
    while ((result = i2.next()) && !result.done) {
      key2 = result.value;
      if (internalDeepEqual(key1, key2, opts, channel) && internalDeepEqual(item1, $mapGet(map, key2), opts, channel)) {
        $setDelete(set, key2);
        return true;
      }
    }
    return false;
  }
  function internalDeepEqual(actual, expected, options, channel) {
    var opts = options || {};
    if (opts.strict ? is(actual, expected) : actual === expected) {
      return true;
    }
    var actualBoxed = whichBoxedPrimitive2(actual);
    var expectedBoxed = whichBoxedPrimitive2(expected);
    if (actualBoxed !== expectedBoxed) {
      return false;
    }
    if (!actual || !expected || typeof actual !== "object" && typeof expected !== "object") {
      return opts.strict ? is(actual, expected) : actual == expected;
    }
    var hasActual = channel.has(actual);
    var hasExpected = channel.has(expected);
    var sentinel;
    if (hasActual && hasExpected) {
      if (channel.get(actual) === channel.get(expected)) {
        return true;
      }
    } else {
      sentinel = {};
    }
    if (!hasActual) {
      channel.set(actual, sentinel);
    }
    if (!hasExpected) {
      channel.set(expected, sentinel);
    }
    return objEquiv(actual, expected, opts, channel);
  }
  function isBuffer(x) {
    if (!x || typeof x !== "object" || typeof x.length !== "number") {
      return false;
    }
    if (typeof x.copy !== "function" || typeof x.slice !== "function") {
      return false;
    }
    if (x.length > 0 && typeof x[0] !== "number") {
      return false;
    }
    return !!(x.constructor && x.constructor.isBuffer && x.constructor.isBuffer(x));
  }
  function setEquiv(a2, b2, opts, channel) {
    if ($setSize(a2) !== $setSize(b2)) {
      return false;
    }
    var iA = getIterator(a2);
    var iB = getIterator(b2);
    var resultA;
    var resultB;
    var set;
    while ((resultA = iA.next()) && !resultA.done) {
      if (resultA.value && typeof resultA.value === "object") {
        if (!set) {
          set = new $Set();
        }
        $setAdd(set, resultA.value);
      } else if (!$setHas(b2, resultA.value)) {
        if (opts.strict) {
          return false;
        }
        if (!setMightHaveLoosePrim(a2, b2, resultA.value)) {
          return false;
        }
        if (!set) {
          set = new $Set();
        }
        $setAdd(set, resultA.value);
      }
    }
    if (set) {
      while ((resultB = iB.next()) && !resultB.done) {
        if (resultB.value && typeof resultB.value === "object") {
          if (!setHasEqualElement(set, resultB.value, opts.strict, channel)) {
            return false;
          }
        } else if (!opts.strict && !$setHas(a2, resultB.value) && !setHasEqualElement(set, resultB.value, opts.strict, channel)) {
          return false;
        }
      }
      return $setSize(set) === 0;
    }
    return true;
  }
  function mapEquiv(a2, b2, opts, channel) {
    if ($mapSize(a2) !== $mapSize(b2)) {
      return false;
    }
    var iA = getIterator(a2);
    var iB = getIterator(b2);
    var resultA;
    var resultB;
    var set;
    var key;
    var item1;
    var item2;
    while ((resultA = iA.next()) && !resultA.done) {
      key = resultA.value[0];
      item1 = resultA.value[1];
      if (key && typeof key === "object") {
        if (!set) {
          set = new $Set();
        }
        $setAdd(set, key);
      } else {
        item2 = $mapGet(b2, key);
        if (typeof item2 === "undefined" && !$mapHas(b2, key) || !internalDeepEqual(item1, item2, opts, channel)) {
          if (opts.strict) {
            return false;
          }
          if (!mapMightHaveLoosePrim(a2, b2, key, item1, opts, channel)) {
            return false;
          }
          if (!set) {
            set = new $Set();
          }
          $setAdd(set, key);
        }
      }
    }
    if (set) {
      while ((resultB = iB.next()) && !resultB.done) {
        key = resultB.value[0];
        item2 = resultB.value[1];
        if (key && typeof key === "object") {
          if (!mapHasEqualEntry(set, a2, key, item2, opts, channel)) {
            return false;
          }
        } else if (!opts.strict && (!a2.has(key) || !internalDeepEqual($mapGet(a2, key), item2, opts, channel)) && !mapHasEqualEntry(set, a2, key, item2, assign({}, opts, { strict: false }), channel)) {
          return false;
        }
      }
      return $setSize(set) === 0;
    }
    return true;
  }
  function objEquiv(a2, b2, opts, channel) {
    var i2, key;
    if (typeof a2 !== typeof b2) {
      return false;
    }
    if (a2 == null || b2 == null) {
      return false;
    }
    if ($objToString(a2) !== $objToString(b2)) {
      return false;
    }
    if (isArguments2(a2) !== isArguments2(b2)) {
      return false;
    }
    var aIsArray = isArray2(a2);
    var bIsArray = isArray2(b2);
    if (aIsArray !== bIsArray) {
      return false;
    }
    var aIsError = a2 instanceof Error;
    var bIsError = b2 instanceof Error;
    if (aIsError !== bIsError) {
      return false;
    }
    if (aIsError || bIsError) {
      if (a2.name !== b2.name || a2.message !== b2.message) {
        return false;
      }
    }
    var aIsRegex = isRegex2(a2);
    var bIsRegex = isRegex2(b2);
    if (aIsRegex !== bIsRegex) {
      return false;
    }
    if ((aIsRegex || bIsRegex) && (a2.source !== b2.source || flags(a2) !== flags(b2))) {
      return false;
    }
    var aIsDate = isDate2(a2);
    var bIsDate = isDate2(b2);
    if (aIsDate !== bIsDate) {
      return false;
    }
    if (aIsDate || bIsDate) {
      if ($getTime(a2) !== $getTime(b2)) {
        return false;
      }
    }
    if (opts.strict && gPO && gPO(a2) !== gPO(b2)) {
      return false;
    }
    var aWhich = whichTypedArray2(a2);
    var bWhich = whichTypedArray2(b2);
    if (aWhich !== bWhich) {
      return false;
    }
    if (aWhich || bWhich) {
      if (a2.length !== b2.length) {
        return false;
      }
      for (i2 = 0; i2 < a2.length; i2++) {
        if (a2[i2] !== b2[i2]) {
          return false;
        }
      }
      return true;
    }
    var aIsBuffer = isBuffer(a2);
    var bIsBuffer = isBuffer(b2);
    if (aIsBuffer !== bIsBuffer) {
      return false;
    }
    if (aIsBuffer || bIsBuffer) {
      if (a2.length !== b2.length) {
        return false;
      }
      for (i2 = 0; i2 < a2.length; i2++) {
        if (a2[i2] !== b2[i2]) {
          return false;
        }
      }
      return true;
    }
    var aIsArrayBuffer = isArrayBuffer2(a2);
    var bIsArrayBuffer = isArrayBuffer2(b2);
    if (aIsArrayBuffer !== bIsArrayBuffer) {
      return false;
    }
    if (aIsArrayBuffer || bIsArrayBuffer) {
      if (byteLength(a2) !== byteLength(b2)) {
        return false;
      }
      return typeof Uint8Array === "function" && internalDeepEqual(new Uint8Array(a2), new Uint8Array(b2), opts, channel);
    }
    var aIsSAB = isSharedArrayBuffer2(a2);
    var bIsSAB = isSharedArrayBuffer2(b2);
    if (aIsSAB !== bIsSAB) {
      return false;
    }
    if (aIsSAB || bIsSAB) {
      if (sabByteLength(a2) !== sabByteLength(b2)) {
        return false;
      }
      return typeof Uint8Array === "function" && internalDeepEqual(new Uint8Array(a2), new Uint8Array(b2), opts, channel);
    }
    if (typeof a2 !== typeof b2) {
      return false;
    }
    var ka = objectKeys2(a2);
    var kb = objectKeys2(b2);
    if (ka.length !== kb.length) {
      return false;
    }
    ka.sort();
    kb.sort();
    for (i2 = ka.length - 1; i2 >= 0; i2--) {
      if (ka[i2] != kb[i2]) {
        return false;
      }
    }
    for (i2 = ka.length - 1; i2 >= 0; i2--) {
      key = ka[i2];
      if (!internalDeepEqual(a2[key], b2[key], opts, channel)) {
        return false;
      }
    }
    var aCollection = whichCollection2(a2);
    var bCollection = whichCollection2(b2);
    if (aCollection !== bCollection) {
      return false;
    }
    if (aCollection === "Set" || bCollection === "Set") {
      return setEquiv(a2, b2, opts, channel);
    }
    if (aCollection === "Map") {
      return mapEquiv(a2, b2, opts, channel);
    }
    return true;
  }
  deepEqual$1 = function deepEqual2(a2, b2, opts) {
    return internalDeepEqual(a2, b2, opts, getSideChannel());
  };
  return deepEqual$1;
}
requireDeepEqual();
window.onerror = (event) => {
  if (typeof event === "string") {
    reportError(new Error(event));
  } else {
    const errorEvent = event;
    reportError(
      new Error(
        `${errorEvent.filename}:${errorEvent.lineno}:${errorEvent.colno}: ${errorEvent.message}`
      )
    );
  }
  return false;
};
window.reportHoustonError = reportError;
const _hoisted_1$2 = { class: "bg-default" };
const _hoisted_2$1 = { class: "border-b border-default" };
const _hoisted_3$1 = {
  class: "-mb-px flex justify-center",
  "aria-label": "Tabs"
};
const _hoisted_4$1 = ["onClick", "aria-current"];
const _sfc_main$2 = /* @__PURE__ */ defineComponent({
  __name: "Navigation",
  props: {
    show: { type: Boolean },
    navigationItems: {},
    currentNavigationItem: {},
    navigationCallback: {}
  },
  setup(__props) {
    const props = __props;
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$2, [
        createBaseVNode("div", null, [
          createBaseVNode("div", _hoisted_2$1, [
            createBaseVNode("nav", _hoisted_3$1, [
              (openBlock(true), createElementBlock(Fragment, null, renderList(props.navigationItems, (item) => {
                return openBlock(), createElementBlock("a", {
                  key: item.name,
                  onClick: withModifiers(($event) => _ctx.navigationCallback(item), ["prevent"]),
                  class: normalizeClass([item.current ? "border-default text-default" : "border-transparent text-secondary hover:border-default hover:text-default", "whitespace-nowrap border-b-4 py-4 px-4 text-sm font-medium"]),
                  "aria-current": item.current ? "page" : void 0
                }, toDisplayString(item.name), 11, _hoisted_4$1);
              }), 128))
            ])
          ])
        ])
      ]);
    };
  }
});
const scriptRel = "modulepreload";
const assetsURL = function(dep, importerUrl) {
  return new URL(dep, importerUrl).href;
};
const seen = {};
const __vitePreload = function preload(baseModule, deps, importerUrl) {
  if (!deps || deps.length === 0) {
    return baseModule();
  }
  const links = document.getElementsByTagName("link");
  return Promise.all(deps.map((dep) => {
    dep = assetsURL(dep, importerUrl);
    if (dep in seen)
      return;
    seen[dep] = true;
    const isCss = dep.endsWith(".css");
    const cssSelector = isCss ? '[rel="stylesheet"]' : "";
    const isBaseRelative = !!importerUrl;
    if (isBaseRelative) {
      for (let i2 = links.length - 1; i2 >= 0; i2--) {
        const link2 = links[i2];
        if (link2.href === dep && (!isCss || link2.rel === "stylesheet")) {
          return;
        }
      }
    } else if (document.querySelector(`link[href="${dep}"]${cssSelector}`)) {
      return;
    }
    const link = document.createElement("link");
    link.rel = isCss ? "stylesheet" : scriptRel;
    if (!isCss) {
      link.as = "script";
      link.crossOrigin = "";
    }
    link.href = dep;
    document.head.appendChild(link);
    if (isCss) {
      return new Promise((res, rej) => {
        link.addEventListener("load", res);
        link.addEventListener("error", () => rej(new Error(`Unable to preload CSS for ${dep}`)));
      });
    }
  })).then(() => baseModule());
};
const test_ssh_script = `import subprocess
import argparse

def test_passwordless_ssh(target):
    try:
        # Attempt to run a command on the remote host without providing a password
        test_cmd = ['ssh', target, 'echo Success']

        process_test = subprocess.Popen(
            test_cmd,
            stdout=subprocess.PIPE,
            stderr=subprocess.PIPE,  
        )

        stdout, stderr = process_test.communicate()

        if process_test.returncode != 0:
            # raise Exception(f"Error: {stderr.decode('utf-8')}")
            return False
        else:
            print(stdout)
            return True

    
    except subprocess.CalledProcessError as e:
        # If there is an error, notify the user and return False
        print(f"Error: {e.stderr}")
        print("Passwordless SSH connection failed.")
        return False

def main():
    parser = argparse.ArgumentParser(description='Test passwordless SSH connection')
  
    parser.add_argument('sshTarget', type=str, help='ssh target')
    
    args = parser.parse_args()

    ssh_target = args.sshTarget
    
    result = test_passwordless_ssh(ssh_target)
    print(result)

if __name__ == "__main__":
    main()`;
const { errorString: errorString$5, useSpawn: useSpawn$5 } = index;
function isBoolOnOff(bool) {
  if (bool) {
    return "on";
  } else {
    return "off";
  }
}
function isBoolCompression(bool) {
  if (bool) {
    return "lz4";
  } else {
    return "off";
  }
}
function onOffToBool(state) {
  if (state == "on") {
    return true;
  } else if (state == "off") {
    return false;
  }
}
function yesNoToBool(state) {
  if (state == "yes") {
    return true;
  } else if (state == "no") {
    return false;
  }
}
const upperCaseWord = (word) => {
  let lowerCaseWord = word.toLowerCase();
  let firstLetter = lowerCaseWord.charAt(0);
  let remainingLetters = lowerCaseWord.substring(1);
  let firstLetterCap = firstLetter.toUpperCase();
  return firstLetterCap + remainingLetters;
};
const convertBytesToSize = (bytes, precision = 2) => {
  if (bytes === 0) {
    return `0 B`;
  }
  const binarySizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB", "ZiB", "YiB"];
  const base = 1024;
  const i2 = Math.min(Math.floor(Math.log(bytes) / Math.log(base)), binarySizes.length - 1);
  const convertedSize = (bytes / Math.pow(base, i2)).toFixed(precision);
  return `${convertedSize} ${binarySizes[i2]}`;
};
const convertSizeToBytes = (size) => {
  const binarySizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB", "ZiB", "YiB"];
  const base = 1024;
  const decimalBase = 1e3;
  const match = size.trim().match(/(\d+\.?\d*)\s*([a-zA-Z]+)/i);
  if (!match) {
    throw new Error(`Invalid size format: "${size}"`);
  }
  const [value, unit] = match.slice(1);
  const normalizedUnit = unit.toLowerCase();
  const decimalSizes = ["b", "kb", "mb", "gb", "tb", "pb", "eb", "zb", "yb"];
  const index2 = binarySizes.findIndex((sizeUnit) => sizeUnit.toLowerCase() === normalizedUnit);
  if (index2 !== -1) {
    return parseFloat(value) * Math.pow(base, index2);
  }
  const decimalIndex = decimalSizes.findIndex((sizeUnit) => sizeUnit.toLowerCase() === normalizedUnit);
  if (decimalIndex !== -1) {
    const decimalBytes = parseFloat(value) * Math.pow(decimalBase, decimalIndex);
    const binaryBytes = decimalBytes * Math.pow(decimalBase / base, decimalIndex);
    return binaryBytes;
  }
  throw new Error(`Unrecognized unit: "${unit}"`);
};
const getSizeNumberFromString = (sizeString) => {
  const [value, unit] = sizeString.split(" ");
  const numericValue = parseFloat(value);
  return numericValue;
};
const getSizeUnitFromString = (sizeString) => {
  const [value, unit] = sizeString.split(" ");
  return unit;
};
const getQuotaRefreservUnit = (bytes) => {
  const sizes = ["kib", "mib", "gib", "tib"];
  const i2 = Math.floor(Math.log(bytes) / Math.log(1024));
  if (i2 === 0) {
    return `${bytes} Bytes`;
  }
  const convertedSize = (bytes / Math.pow(1024, i2)).toFixed(2);
  return `${convertedSize} ${sizes[i2 - 1]}`;
};
function getTimestampString() {
  const currentDateTime = new Date();
  const timestampString = currentDateTime.toLocaleString("en-US", {
    hour: "numeric",
    minute: "numeric",
    second: "numeric",
    day: "2-digit",
    month: "2-digit",
    year: "numeric"
  });
  return timestampString;
}
function getSnapshotTimestamp() {
  const currentDateTime = new Date();
  const year = currentDateTime.getFullYear();
  const month = String(currentDateTime.getMonth() + 1).padStart(2, "0");
  const day = String(currentDateTime.getDate()).padStart(2, "0");
  const hour = String(currentDateTime.getHours()).padStart(2, "0");
  const minute = String(currentDateTime.getMinutes()).padStart(2, "0");
  const second = String(currentDateTime.getSeconds()).padStart(2, "0");
  const timestamp = `${year}.${month}.${day}-${hour}.${minute}.${second}`;
  return timestamp;
}
function getRawTimestampFromString(timestampString) {
  if (timestampString === void 0 || timestampString === null) {
    return null;
  }
  const rawTimestamp = new Date(timestampString).getTime() / 1e3;
  return rawTimestamp;
}
function convertRawTimestampToString(rawTimestamp) {
  const date = new Date(rawTimestamp * 1e3);
  const timestamp = date.toISOString().replace(/T|Z/g, " ").trim();
  return timestamp.substring(0, 19);
}
function convertTimestampToLocal(timestamp) {
  const hasSpace = timestamp.includes(" ");
  const utcTimestamp = hasSpace ? timestamp.replace(" ", "T") + "Z" : timestamp;
  const localTimestamp = new Date(utcTimestamp).toLocaleString("en-US", {
    year: "numeric",
    month: "2-digit",
    day: "2-digit",
    hour: "2-digit",
    minute: "2-digit",
    second: "2-digit",
    hour12: false
  });
  const rearrangedTimestamp = localTimestamp.replace(/\//g, "-").replace(",", "");
  const [date, time] = rearrangedTimestamp.split(" ");
  const [month, day, year] = date.split("-");
  const rearrangedDate = `${year}-${month}-${day}`;
  const finalTimestamp = `${rearrangedDate} ${time}`;
  return finalTimestamp;
}
function convertTimestampFormat(timestamp) {
  const parsedTimestamp = new Date(timestamp);
  const year = parsedTimestamp.getFullYear();
  const month = (parsedTimestamp.getMonth() + 1).toString().padStart(2, "0");
  const day = parsedTimestamp.getDate().toString().padStart(2, "0");
  const hours = parsedTimestamp.getHours().toString().padStart(2, "0");
  const minutes = parsedTimestamp.getMinutes().toString().padStart(2, "0");
  const seconds = parsedTimestamp.getSeconds().toString().padStart(2, "0");
  const customFormat = `${year}-${month}-${day} ${hours}:${minutes}:${seconds}`;
  return customFormat;
}
function getParentPath(datasetName) {
  const segments = datasetName.split("/");
  segments.pop();
  return segments.join("/");
}
function convertSecondsToString(seconds) {
  let result = "";
  const hours = Math.floor(seconds / 3600);
  const minutes = Math.floor(seconds % 3600 / 60);
  if (hours > 0) {
    result += `${hours} hour${hours > 1 ? "s" : ""} `;
  }
  if (minutes > 0) {
    result += `${minutes} minute${minutes > 1 ? "s" : ""} `;
  }
  if (hours === 0 && minutes === 0) {
    result += `${seconds} second${seconds > 1 ? "s" : ""} `;
  }
  return result.trim();
}
function addActivity(id, activities) {
  const activity = ref$1({
    isActive: false,
    isPaused: false,
    isCanceled: false,
    isFinished: false
  });
  activities.value.set(id, activity);
}
async function loadScanActivities(pools, scanActivities) {
  pools.value.forEach((pool) => {
    addActivity(pool.name, scanActivities);
  });
  console.log("scanActivities", scanActivities);
}
async function loadTrimActivities(pools, trimActivities) {
  pools.value.forEach((pool) => {
    addActivity(pool.name, trimActivities);
  });
  pools.value.forEach((pool) => {
    pool.vdevs.forEach((vDev) => {
      vDev.disks.forEach((disk) => {
        addActivity(disk.name, trimActivities);
      });
    });
  });
  console.log("trimActivities", trimActivities);
}
function getValue(type2, value) {
  if (type2 == "sector") {
    switch (value) {
      case "auto":
        return "Auto Detect";
      case "9":
        return "512 B";
      case "12":
        return "4 KiB";
      case "13":
        return "8 KiB";
      case "14":
        return "16 KiB";
      case "15":
        return "32 KiB";
      case "16":
        return "64 KiB";
      default:
        return "None";
    }
  } else if (type2 == "record") {
    switch (value) {
      case "512b":
        return "512 B";
      case "4kib":
        return "4 KiB";
      case "8kib":
        return "8 KiB";
      case "16kib":
        return "16 KiB";
      case "32kib":
        return "32 KiB";
      case "64kib":
        return "64 KiB";
      case "128kib":
        return "128 KiB";
      case "256kib":
        return "256 KiB";
      case "512kib":
        return "512 KiB";
      case "1mib":
        return "1 MiB";
      default:
        return "None";
    }
  } else if (type2 == "dnode") {
    switch (value) {
      case "1k":
        return "1 KiB";
      case "2k":
        return "2 KiB";
      case "4k":
        return "4 KiB";
      case "8k":
        return "8 KiB";
      case "16k":
        return "16 KiB";
      case "auto":
        return "Auto";
      case "legacy":
        return "Legacy";
      default:
        return "None";
    }
  } else if (type2 == "compression") {
    switch (value) {
      case "on":
        return "On";
      case "off":
        return "Off";
      case "gzip":
        return "GZIP";
      case "lz4":
        return "LZ4";
      case "lzjb":
        return "LZJB";
      case "zle":
        return "ZLE";
      default:
        return "None";
    }
  } else if (type2 == "dedup") {
    switch (value) {
      case "on":
        return "On";
      case "off":
        return "Off";
      case "edonr,verify":
        return "Edon-R + Verify";
      case "sha256":
        return "SHA-256";
      case "sha256,verify":
        return "SHA-256 + Verify";
      case "sha512":
        return "SHA-512";
      case "sha512,verify":
        return "SHA-512 + Verify";
      case "skein":
        return "Skein";
      case "skein,verify":
        return "Skein + Verify";
      case "verify":
        return "Verify";
      default:
        return "None";
    }
  }
}
function checkInheritance(type2, value, poolConfigOptions) {
  if (type2 == "compression") {
    if (value == "inherited") {
      return `${upperCaseWord(value)} (${poolConfigOptions.compression.toUpperCase()})`;
    } else {
      return getValue("compression", value);
    }
  } else if (type2 == "dedup") {
    if (value == "inherited") {
      return `${upperCaseWord(value)} (${upperCaseWord(poolConfigOptions.dedup)})`;
    } else {
      return getValue("dedup", value);
    }
  } else if (type2 == "record") {
    if (value == "inherited") {
      return `${upperCaseWord(value)} (${getValue("record", poolConfigOptions.recordsize.toString())})`;
    } else {
      return getValue("record", value);
    }
  } else if (type2 == "atime") {
    if (value == "inherited") {
      return `${upperCaseWord(value)} (On)`;
    } else {
      return upperCaseWord(value);
    }
  } else if (type2 == "case") {
    if (value == "inherited") {
      return `${upperCaseWord(value)} (Sensitive)`;
    } else {
      return upperCaseWord(value);
    }
  } else if (type2 == "dnode") {
    if (value == "inherited") {
      return `${upperCaseWord(value)} (Legacy)`;
    } else {
      return getValue("dnode", value);
    }
  } else if (type2 == "xattr") {
    if (value == "inherited") {
      return `${upperCaseWord(value)} (System Attribute)`;
    } else {
      return upperCaseWord(value);
    }
  }
}
async function testSSH(sshTarget) {
  try {
    console.log(`target: ${sshTarget}`);
    const state = useSpawn$5(["/usr/bin/env", "python3", "-c", test_ssh_script, sshTarget], { superuser: "try" });
    const output = await state.promise();
    console.log("testSSH output:", output);
    if (output.stdout.includes("True")) {
      return true;
    } else {
      return false;
    }
  } catch (error) {
    console.error(errorString$5(error));
    return false;
  }
}
function formatStatus(status) {
  switch (status) {
    case "ONLINE":
      return "text-green-600";
    case "DEGRADED":
      return "text-orange-600";
    case "FAULTED":
      return "text-red-600";
    case "SUSPENDED":
      return "text-red-600";
    case "OFFLINE":
      return "text-red-600";
    case "REMOVED":
      return "text-red-600";
    case "UNAVAIL":
      return "text-red-600";
    case "REPLACING":
      return "text-orange-600";
  }
}
function getCapacityColor(type2, capacity, refreservationPercent) {
  const availableSpace = refreservationPercent !== void 0 ? 100 - refreservationPercent : 100;
  const capacityPercentOfAvailable = capacity / availableSpace * 100;
  let colorString;
  if (capacityPercentOfAvailable <= 70) {
    colorString = `${type2}-green-600`;
  } else if (capacityPercentOfAvailable > 70 && capacityPercentOfAvailable <= 85) {
    colorString = `${type2}-orange-600`;
  } else if (capacityPercentOfAvailable > 85 && capacityPercentOfAvailable <= 100) {
    colorString = `${type2}-red-600`;
  } else {
    colorString = `${type2}-blue-600`;
  }
  return colorString;
}
function getFullDiskInfo(disks, diskName) {
  if (!diskName) {
    console.warn("getFullDiskInfo called with an empty diskName.");
    return void 0;
  }
  const pathPrefixes = {
    phy_path: "/dev/disk/by-path/",
    sd_path: "/dev/",
    id_path: "/dev/disk/by-id/",
    label_path: "/dev/disk/by-label/",
    part_label_path: "/dev/disk/by-partlabel/",
    part_uuid: "/dev/disk/by-partuuid/",
    uuid: "/dev/disk/by-uuid/"
  };
  console.log("Searching for disk with name:", diskName);
  const foundDisk = disks.find((disk) => {
    var _a2, _b, _c, _d, _e, _f, _g;
    if (((_a2 = disk.name) == null ? void 0 : _a2.trim()) === diskName.trim() || ((_b = disk.vdev_path) == null ? void 0 : _b.trim()) === diskName.trim()) {
      disk.path = (_f = (_e = (_c = disk.vdev_path) == null ? void 0 : _c.trim()) != null ? _e : (_d = disk.name) == null ? void 0 : _d.trim()) != null ? _f : "";
      return true;
    }
    for (const [key, prefix] of Object.entries(pathPrefixes)) {
      const diskPath = (_g = disk[key]) == null ? void 0 : _g.trim();
      if (diskPath && diskPath.replace(prefix, "") === diskName.trim()) {
        disk.path = diskPath;
        return true;
      }
    }
    return false;
  });
  if (foundDisk) {
    console.log("Found disk:", foundDisk);
  }
  return foundDisk;
}
function getDiskIDName(disks, diskIdentifier, selectedDiskName) {
  const phyPathPrefix = "/dev/disk/by-path/";
  const sdPathPrefix = "/dev/";
  const idPathPrefix = "/dev/disk/by-id/";
  const labelPathPrefix = "/dev/disk/by-label/";
  const partLabelPathPrefix = "/dev/disk/by-partlabel/";
  const partUUIDPrefix = "/dev/disk/by-partuuid/";
  const uuidPrefix = "/dev/disk/by-uuid/";
  const newDisk = ref$1();
  const diskName = ref$1("");
  const diskPath = ref$1("");
  newDisk.value = disks.find((disk) => {
    var _a2;
    return ((_a2 = disk.name) == null ? void 0 : _a2.trim()) === selectedDiskName.trim();
  });
  switch (diskIdentifier) {
    case "vdev_path":
      diskPath.value = newDisk.value.vdev_path;
      diskName.value = selectedDiskName;
      break;
    case "phy_path":
      diskPath.value = newDisk.value.phy_path;
      diskName.value = diskPath.value.replace(phyPathPrefix, "");
      break;
    case "sd_path":
      diskPath.value = newDisk.value.sd_path;
      diskName.value = diskPath.value.replace(sdPathPrefix, "");
      break;
    case "id_path":
      diskPath.value = newDisk.value.id_path;
      diskName.value = diskPath.value.replace(idPathPrefix, "");
      break;
    case "label_path":
      diskPath.value = newDisk.value.label_path;
      diskName.value = diskPath.value.replace(labelPathPrefix, "");
      break;
    case "part_label_path":
      diskPath.value = newDisk.value.part_label_path;
      diskName.value = diskPath.value.replace(partLabelPathPrefix, "");
      break;
    case "part_uuid":
      diskPath.value = newDisk.value.part_uuid;
      diskName.value = diskPath.value.replace(partUUIDPrefix, "");
      break;
    case "uuid":
      diskPath.value = newDisk.value.uuid;
      diskName.value = diskPath.value.replace(uuidPrefix, "");
      break;
    default:
      console.log("Error with selectedDiskNames/diskIdentifier");
      break;
  }
  return diskName.value;
}
function findDiskByPath(disks, path) {
  const partitionSuffixRegex = /-part[0-9]+$/;
  const basePath = path.match(partitionSuffixRegex) ? path.replace(partitionSuffixRegex, "") : path;
  return disks.find((disk) => {
    const sdPath = disk.sd_path ? cleanDiskPath$1(disk.sd_path) : null;
    const phyPath = disk.phy_path ? cleanDiskPath$1(disk.phy_path) : null;
    const vdevPath = disk.vdev_path ? cleanDiskPath$1(disk.vdev_path) : null;
    return [sdPath, phyPath, vdevPath].some((diskPath) => diskPath === path || diskPath === basePath);
  });
}
function cleanDiskPath$1(path) {
  return path.replace(/-part[0-9]+$/, "");
}
function truncateName(name, threshold) {
  return name.length > threshold ? name.slice(0, threshold) + "..." : name;
}
async function isPoolUpgradable(poolName) {
  try {
    const state = useSpawn$5(["zpool", "status", poolName], { superuser: "try" });
    const output = await state.promise();
    const lines = output.stdout.split("\n");
    const statusPattern = /The pool is formatted using a legacy on-disk format/;
    const actionPattern = /Upgrade the pool using 'zpool upgrade'/;
    let statusFound = false;
    let actionFound = false;
    for (const line of lines) {
      if (statusPattern.test(line)) {
        statusFound = true;
      }
      if (actionPattern.test(line)) {
        actionFound = true;
      }
      if (statusFound && actionFound) {
        return true;
      }
    }
    return false;
  } catch (error) {
    console.error(errorString$5(error));
    return false;
  }
}
function isCapacityPatternInvalid(capacityStr) {
  return /^(\d+(\.\d+)?)(\s*[KMGTP]{1})$/i.test(capacityStr);
}
function formatCapacityString(capacityStr) {
  const match = capacityStr.match(/^(\d+(\.\d+)?)(\s*[KMGTP])?$/i);
  if (!match) {
    throw new Error("Invalid capacity string format. Expected format like '32G', '500M', '9.01T', '1P'.");
  }
  const value = parseFloat(match[1]);
  const unit = match[3] ? match[3].trim().toUpperCase() : "G";
  const decimalUnit = `${unit}B`;
  return `${value} ${decimalUnit}`;
}
const get_pools_script = `import libzfs
import json
import logging
from logging.handlers import RotatingFileHandler

# Configure rotating log handler
log_file = '/var/log/cockpit_zfs_getpools.log'
handler = RotatingFileHandler(log_file, maxBytes=5 * 1024 * 1024, backupCount=3)  # 5MB max size, 3 backups
formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')
handler.setFormatter(formatter)

# Configure logger
logger = logging.getLogger('cockpit_zfs_getpools')
logger.setLevel(logging.DEBUG)
logger.addHandler(handler)

# Example usage of the logger in the script
def basic_typed_children(children):
    try:
        for i in range(0, len(children)):
            children[i]['properties']['creation']['parsed'] = str(children[i]['properties']['creation']['parsed'])

            if len(children[i]['children']) >= 1:
                children[i]['children'] = basic_typed_children(children[i]['children'])

        return children
    except Exception as e:
        logger.error(f"Exception in basic_typed_children: {str(e)}")
        return []

def main():
    try:
        logger.info("=" * 80)  # Separator line
        logger.info("Starting a new run of get-pools script")
        
        with libzfs.ZFS() as zfs:
            z_pools = []

            for p in zfs.pools:
                pool = p.asdict()

                root_dataset = pool.get('root_dataset')  # Check if 'root_dataset' exists
                if root_dataset is not None:
                    pool['root_dataset']['properties']['creation']['parsed'] = str(pool['root_dataset']['properties']['creation']['parsed'])

                    if 'scan' in pool:
                        pool['scan']['start_time'] = str(pool['scan']['start_time'])
                        pool['scan']['end_time'] = str(pool['scan']['end_time'])
                        pool['scan']['pause'] = str(pool['scan']['pause'])

                    pool['root_dataset']['children'] = basic_typed_children(pool['root_dataset']['children'])
                else:
                    pool['root_dataset'] = None  # Set 'root_dataset' to None if it doesn't exist

                pool_log_data = {
                    'name': pool['name'],
                    'status': pool['status']
                }
                
                logger.debug(f"Parsed pool data: {pool_log_data}")
                z_pools.append(pool)

            logger.info(f"Pools discovered: {len(z_pools)}")
            print(json.dumps(z_pools, indent=4))
            
    except Exception as e:
        logger.error(f"Exception in main: {str(e)}")

if __name__ == '__main__':
    main()
`;
const get_importable_pools_script = `import libzfs
import json
import logging
from logging.handlers import RotatingFileHandler

# Configure rotating log handler
log_file = '/var/log/cockpit_zfs_getimportablepools.log'
handler = RotatingFileHandler(log_file, maxBytes=5 * 1024 * 1024, backupCount=3)  # 5MB max size, 3 backups
formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')
handler.setFormatter(formatter)

# Configure logger
logger = logging.getLogger('cockpit_zfs_getimportablepools')
logger.setLevel(logging.DEBUG)
logger.addHandler(handler)

def main():
    try:
        logger.info("=" * 80)  # Separator line
        logger.info("Starting a new run of get-importable-pools script")
        
        z_pools = []
        
        with libzfs.ZFS() as zfs:
            try:
                importable_pools = zfs.find_import()
            except Exception as e:
                logger.error(f"Error during find_import(): {str(e)}")
                raise

            for p in importable_pools:
                try:
                    pool = p.asdict()
                    # Log minimal data for each pool
                    pool_log_data = {
                        'name': pool['name'],
                        'status': pool['status']
                    }
                    logger.debug(f"Found pool: {pool_log_data}")
                    
                    # Handle scan times, if present
                    if 'scan' in pool:
                        pool['scan']['start_time'] = str(pool['scan']['start_time'])
                        pool['scan']['end_time'] = str(pool['scan']['end_time'])

                    # Add parsed pool to the list
                    z_pools.append(pool)
                    
                except Exception as pool_error:
                    logger.error(f"Error processing pool: {str(pool_error)}")

        try:
            # Serialize and output the result
            output = json.dumps(z_pools, indent=4)
            print(output)  # Send JSON to stdout
            # logger.debug(f"Output JSON: {output}")
        except Exception as serialization_error:
            logger.error(f"Error serializing JSON: {str(serialization_error)}")
        
    except Exception as e:
        logger.error(f"Exception in main: {str(e)}")
        # return []
        
if __name__ == '__main__':
    main()`;
const get_importable_destroyed_pools_script = `import libzfs
import json
import logging
from logging.handlers import RotatingFileHandler

# Configure rotating log handler
log_file = '/var/log/cockpit_zfs_getimportabledestroyedpools.log'
handler = RotatingFileHandler(log_file, maxBytes=5 * 1024 * 1024, backupCount=3)  # 5MB max size, 3 backups
formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')
handler.setFormatter(formatter)

# Configure logger
logger = logging.getLogger('cockpit_zfs_getimportabledestroyedpools')
logger.setLevel(logging.DEBUG)
logger.addHandler(handler)

def main():
    try:
        logger.info("=" * 80)  # Separator line
        logger.info("Starting a new run of get-importable-destroyed-pools script")
        
        z_pools = []
        
        with libzfs.ZFS() as zfs:
            try:
                destroyed_importable_pools = zfs.find_import(destroyed='True', search_paths=['/dev', '/dev/disk/by-id', '/dev/disk/by-path', '/dev/disk/by-vdev'])
            except Exception as e:
                logger.error(f"Error during find_import(): {str(e)}")
                raise

            for p in destroyed_importable_pools:
                try:
                    pool = p.asdict()
                    # Log minimal data for each pool
                    pool_log_data = {
                        'name': pool['name'],
                        'status': pool['status']
                    }
                    logger.debug(f"Found pool: {pool_log_data}")
                    
                    # Handle scan times, if present
                    if 'scan' in pool:
                        pool['scan']['start_time'] = str(pool['scan']['start_time'])
                        pool['scan']['end_time'] = str(pool['scan']['end_time'])

                    # Add parsed pool to the list
                    z_pools.append(pool)
                    
                except Exception as pool_error:
                    logger.error(f"Error processing pool: {str(pool_error)}")

        try:
            # Serialize and output the result
            output = json.dumps(z_pools, indent=4)
            print(output)  # Send JSON to stdout
            # logger.debug(f"Output JSON: {output}")
        except Exception as serialization_error:
            logger.error(f"Error serializing JSON: {str(serialization_error)}")
        
    except Exception as e:
        logger.error(f"Exception in getting importable destroyed pools: {str(e)}")
        return []
        
if __name__ == '__main__':
    main()`;
const { errorString: errorString$4, useSpawn: useSpawn$4 } = index;
async function getPools() {
  try {
    const state = useSpawn$4(["/usr/bin/env", "python3", "-c", get_pools_script], { superuser: "try" });
    const pools = (await state.promise()).stdout;
    return pools;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return JSON.stringify({ error: errorMessage });
  }
}
async function setRefreservation(pool, refreservationPercent) {
  try {
    const sizeInBytes = convertSizeToBytes(pool.properties.size);
    const refreservationBytes = sizeInBytes / 100 * refreservationPercent;
    const cmdString = ["zfs", "set", "refreservation=" + refreservationBytes, pool.name];
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$4(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function destroyPool(pool, forceDestroy) {
  try {
    const cmdString = ["zpool", "destroy"];
    if (forceDestroy) {
      cmdString.push("-f");
    }
    cmdString.push(pool.name);
    console.log("Executing command:", cmdString.join(" "));
    const state = useSpawn$4(cmdString);
    const output = await state.promise();
    if (output.stderr) {
      console.warn("Destroy command warnings:", output.stderr);
    }
    console.log("Destroy command output:", output.stdout);
    return output.stdout;
  } catch (err2) {
    console.error("Error during destroyPool:", err2);
    const errorMessage = errorString$4(err2);
    if (err2.stderr && err2.stderr.includes("is busy")) {
      return { error: "Pool is busy. Please ensure no active processes are using it and try again." };
    }
    if (err2.stderr && err2.stderr.includes("cannot unmount")) {
      console.warn(`Unmount failed for pool: ${pool.name}. Retrying forced unmount...`);
      await useSpawn$4(["zfs", "unmount", "-f", pool.name]);
      return destroyPool(pool, true);
    }
    return { error: errorMessage };
  }
}
const properties$1 = [
  "failmode",
  "comment",
  "autoexpand",
  "autoreplace",
  "autotrim",
  "delegation",
  "listsnapshots"
];
async function configurePool(pool) {
  try {
    const hasProperties = hasChanges$1(pool);
    if (hasProperties) {
      for (const property of properties$1) {
        if (property in pool) {
          let cmdString = ["zpool", "set"];
          cmdString.push(`${property}=${pool[property]}`);
          cmdString.push(pool.name);
          console.log("****\ncmdstring:\n", ...cmdString, "\n****");
          const state = useSpawn$4(cmdString);
          const output = await state.promise();
          console.log(output);
          await new Promise((resolve2) => setTimeout(resolve2, 250));
        }
      }
    } else {
      console.log("There are no selected properties to change.");
    }
    return { success: true };
  } catch (error) {
    const errorMessage = errorString$4(error);
    console.error(errorMessage);
    return { success: false, error: errorMessage };
  }
}
function hasChanges$1(pool) {
  for (const property of properties$1) {
    if (property in pool) {
      return true;
    }
  }
  return false;
}
async function clearErrors(poolName, deviceName) {
  try {
    let cmdString = ["zpool", "clear"];
    cmdString.push(poolName);
    if (deviceName) {
      cmdString.push(deviceName);
    }
    const state = useSpawn$4(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function trimPool(pool, isSecure, action) {
  try {
    let cmdString = ["zpool", "trim"];
    if (isSecure) {
      cmdString.push("-d");
    }
    if (action === "pause") {
      cmdString.push("-s");
    }
    if (action === "stop") {
      cmdString.push("-c");
    }
    cmdString.push(pool.name);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$4(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function scrubPool(pool, action) {
  try {
    let cmdString = ["zpool", "scrub"];
    if (action === "pause") {
      cmdString.push("-p");
    }
    if (action === "stop") {
      cmdString.push("-s");
    }
    cmdString.push(pool.name);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$4(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function resilverPool(pool) {
  try {
    const state = useSpawn$4(["zpool", "resilver", pool.name]);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function exportPool(pool, force) {
  try {
    let cmdString = ["zpool", "export"];
    if (force) {
      cmdString.push("-f");
    }
    cmdString.push(pool.name);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$4(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function getImportablePools() {
  try {
    const state = useSpawn$4(["/usr/bin/env", "python3", "-c", get_importable_pools_script], { superuser: "try" });
    const pools = (await state.promise()).stdout;
    return pools;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return JSON.stringify({ error: errorMessage });
  }
}
async function getImportableDestroyedPools() {
  try {
    const state = useSpawn$4(["/usr/bin/env", "python3", "-c", get_importable_destroyed_pools_script], { superuser: "try" });
    const pools = (await state.promise()).stdout;
    return pools;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return JSON.stringify({ error: errorMessage });
  }
}
async function importPool(pool) {
  try {
    let cmdString = ["zpool", "import"];
    if (pool.isDestroyed) {
      cmdString.push("-Df");
    }
    if (pool.forceImport) {
      cmdString.push("-f");
    }
    if (pool.ignoreMissingLog) {
      cmdString.push("-m");
    }
    if (!pool.mountFileSystems) {
      cmdString.push("-N");
    }
    if (pool.recoveryMode) {
      cmdString.push("-F");
    }
    cmdString.push("-d");
    switch (pool.identifier) {
      case "vdev_path":
        cmdString.push("/dev/disk/by-vdev");
        break;
      case "phy_path":
        cmdString.push("/dev/disk/by-path");
        break;
      case "sd_path":
        cmdString.push("/dev");
        break;
      default:
        break;
    }
    if (pool.altRoot != "") {
      cmdString.push("-o", "altroot=" + pool.altRoot);
    }
    if (pool.readOnly) {
      cmdString.push("-o", "readonly=on");
    }
    cmdString.push(pool.poolGUID);
    if (pool.renamePool) {
      cmdString.push(pool.newPoolName);
    }
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$4(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function removeVDevFromPool(vdev, pool) {
  try {
    let cmdString = ["zpool", "remove"];
    cmdString.push(pool.name);
    cmdString.push(vdev.name);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$4(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function upgradePool(pool) {
  try {
    const state = useSpawn$4(["zpool", "upgrade", pool.name]);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$4(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
const script_py = `import subprocess
import json
import logging
from logging.handlers import RotatingFileHandler

# Configure rotating log handler
log_file = '/var/log/cockpit_zfs_getdisks.log'
handler = RotatingFileHandler(log_file, maxBytes=5 * 1024 * 1024, backupCount=3)  # 5MB max size, 3 backups
formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')
handler.setFormatter(formatter)

# Configure logger
logger = logging.getLogger('cockpit_zfs_getdisks')
logger.setLevel(logging.DEBUG)
logger.addHandler(handler)

# Example usage of the logger in the script
def get_lsdev_disks():
    try:
        result = subprocess.run(['lsdev', '-jdHmtTsfcp'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        if result.returncode != 0:
            logger.error(f"lsdev command failed: {result.stderr.decode()}")
            return None  # Return None if lsdev command fails

        logger.debug("lsdev command succeeded.")
        json_data = json.loads(result.stdout)

        disks = []
        for row in json_data['rows']:
            for disk in row:
                if not disk['occupied']:
                    continue

                device_path = disk['dev']
                partitions = int(disk['partitions'])

                disk_data = {
                    'vdev_path': f'/dev/disk/by-vdev/{disk["bay-id"]}',
                    'phy_path': disk['dev-by-path'],
                    'sd_path': device_path,
                    'name': disk['bay-id'],
                    'model': disk['model-name'],
                    'serial': disk['serial'],
                    'capacity': disk['capacity'],
                    'type': disk['disk_type'],
                    'usable': True,
                    'temp': disk['temp-c'],
                    'health': disk['health'],
                    'rotation_rate': disk['rotation-rate'],
                    'power_on_count': disk['power-cycle-count'],
                    'power_on_time': disk['power-on-time'],
                    'has_partitions': False if partitions == 0 else True
                }
                
                disk_log_data = {
                    'name': disk['bay-id'],
                    'type': disk['disk_type'],
                    'health': disk['health'],
                    'temp': disk['temp-c'],
                }
                
                logger.debug(f"Discovered disk: {disk_log_data}")
                disks.append(disk_data)
                
        logger.info(f"Disks discovered: {len(disks)}")
        return disks
    except Exception as e:
        logger.error(f"Exception in get_lsdev_disks: {str(e)}")
        return None

# def get_lsblk_disks(nvme_only=False):
#     """Get all disks (or only NVMe disks if nvme_only=True) using lsblk JSON output and udevadm."""
#     try:
#         # Run lsblk with JSON output
#         lsblk_result = subprocess.run(['lsblk', '-dnOpJ'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
#         if lsblk_result.returncode != 0:
#             logger.error(f"lsblk command failed: {lsblk_result.stderr.decode()}")
#             return []

#         logger.debug("lsblk command succeeded.")
#         lsblk_data = json.loads(lsblk_result.stdout.decode())
#         disks = []

#         for device in lsblk_data['blockdevices']:
#             # Skip if nvme_only is True and device is not NVMe
#             if nvme_only and 'nvme' not in device['name']:
#                 continue

#             # Collect additional information using smartctl if available
#             smartctl_data = get_smartctl_data(device['name'].split('/')[-1])  # Get only the device name, e.g., 'sda'

#             # Get additional details using udevadm
#             udevadm_result = subprocess.run(['udevadm', 'info', '--query=all', f'--name={device["name"]}'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
#             if udevadm_result.returncode != 0:
#                 logger.error(f"udevadm failed for {device['name']}: {udevadm_result.stderr.decode()}")
#                 continue

#             # logger.debug(f"udevadm output for {device['name']}: {udevadm_result.stdout.decode()}")
#             udevadm_output = udevadm_result.stdout.decode().split('\\n')
#             udev_info = {}
#             for line in udevadm_output:
#                 if '=' in line:
#                     key, value = line.split('=', 1)
#                     udev_info[key.strip()] = value.strip()

#             # Append the disk data to the list
#             disk_data = {
#                 'vdev_path': 'N/A',
#                 'phy_path': f'/dev/disk/by-path/{udev_info.get("E: ID_PATH", "unknown")}',
#                 'sd_path': device['name'],
#                 'name': device['name'].split('/')[-1],
#                 'model': device.get('model', udev_info.get('E: ID_MODEL', 'Unknown')),
#                 'serial': device.get('serial', udev_info.get('E: ID_SERIAL_SHORT', 'Unknown')),
#                 'capacity': device['size'],
#                 'type': 'NVMe' if 'nvme' in device['name'] else device['type'].capitalize(),
#                 'usable': device['ro'] == '0',
#                 'temp': f'{smartctl_data["temp"]}\u2103' if smartctl_data["temp"] is not None else 'Unknown',
#                 'health': "OK" if smartctl_data['health'] == 'PASSED' else "POOR",
#                 'rotation_rate': 0 if 'nvme' in device['name'] else (device['rota'] == '1'),
#                 'power_on_count': smartctl_data['power_cycle_count'],
#                 'power_on_time': smartctl_data['power_on_hours'],
#                 'has_partitions': 'E: ID_PART_TABLE_TYPE' in udev_info
#             }
            
#             disk_log_data = {
#                 'name': device['name'].split('/')[-1],
#                 'type': 'NVMe' if 'nvme' in device['name'] else device['type'].capitalize(),
#                 'temp': f'{smartctl_data["temp"]}\u2103' if smartctl_data["temp"] is not None else 'Unknown',
#                 'health': "OK" if smartctl_data['health'] == 'PASSED' else "POOR",
#             }
            
#             logger.debug(f"Discovered disk: {disk_log_data}")
#             disks.append(disk_data)

#         logger.info(f"Disks discovered: {len(disks)}")
#         return disks

#     except Exception as e:
#         logger.error(f"Exception in get_lsblk_disks: {str(e)}")
#         return []

def get_lsblk_disks(nvme_only=False):
    """Get all disks (or only NVMe disks if nvme_only=True) using lsblk JSON output and udevadm."""
    try:
        # Run lsblk with JSON output, including mountpoints
        lsblk_result = subprocess.run(['lsblk', '-dnOpJ', '-o', 'NAME,TYPE,SIZE,ROTA,SERIAL,MODEL,MOUNTPOINT'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        if lsblk_result.returncode != 0:
            logger.error(f"lsblk command failed: {lsblk_result.stderr.decode()}")
            return []

        logger.debug("lsblk command succeeded.")
        lsblk_data = json.loads(lsblk_result.stdout.decode())
        disks = []

        for device in lsblk_data['blockdevices']:
            # Skip if nvme_only is True and device is not NVMe
            if nvme_only and 'nvme' not in device['name']:
                continue

            # Check if this device is a boot drive (mounted at / or /boot)
            if 'children' in device:
                for partition in device['children']:
                    if partition.get('mountpoint') in ['/', '/boot']:
                        logger.info(f"Skipping boot drive: {device['name']}")
                        continue

            # Collect additional information using smartctl if available
            smartctl_data = get_smartctl_data(device['name'].split('/')[-1])  # Get only the device name, e.g., 'sda'

            # Get additional details using udevadm
            udevadm_result = subprocess.run(['udevadm', 'info', '--query=all', f'--name={device["name"]}'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            if udevadm_result.returncode != 0:
                logger.error(f"udevadm failed for {device['name']}: {udevadm_result.stderr.decode()}")
                continue

            udevadm_output = udevadm_result.stdout.decode().split('\\n')
            udev_info = {}
            for line in udevadm_output:
                if '=' in line:
                    key, value = line.split('=', 1)
                    udev_info[key.strip()] = value.strip()

            # Append the disk data to the list
            disk_data = {
                'vdev_path': 'N/A',
                'phy_path': f'/dev/disk/by-path/{udev_info.get("E: ID_PATH", "unknown")}',
                'sd_path': device['name'],
                'name': device['name'].split('/')[-1],
                'model': device.get('model', udev_info.get('E: ID_MODEL', 'Unknown')),
                'serial': device.get('serial', udev_info.get('E: ID_SERIAL_SHORT', 'Unknown')),
                'capacity': device['size'],
                'type': 'NVMe' if 'nvme' in device['name'] else device['type'].capitalize(),
                'usable': device['ro'] == '0',
                'temp': f'{smartctl_data["temp"]}\u2103' if smartctl_data["temp"] is not None else 'Unknown',
                'health': "OK" if smartctl_data['health'] == 'PASSED' else "POOR",
                'rotation_rate': 0 if 'nvme' in device['name'] else (device['rota'] == '1'),
                'power_on_count': smartctl_data['power_cycle_count'],
                'power_on_time': smartctl_data['power_on_hours'],
                'has_partitions': 'E: ID_PART_TABLE_TYPE' in udev_info
            }

            disk_log_data = {
                'name': device['name'].split('/')[-1],
                'type': 'NVMe' if 'nvme' in device['name'] else device['type'].capitalize(),
                'temp': f'{smartctl_data["temp"]}\u2103' if smartctl_data["temp"] is not None else 'Unknown',
                'health': "OK" if smartctl_data['health'] == 'PASSED' else "POOR",
            }

            logger.debug(f"Discovered disk: {disk_log_data}")
            disks.append(disk_data)

        logger.info(f"Disks discovered: {len(disks)}")
        return disks

    except Exception as e:
        logger.error(f"Exception in get_lsblk_disks: {str(e)}")
        return []


def get_smartctl_data(device):
    """Runs smartctl to get additional information like temperature, power-on time, and health status."""
    try:
        smartctl_result = subprocess.run(['smartctl', '-a', f'/dev/{device}'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        if smartctl_result.returncode != 0:
            logger.error(f"smartctl failed for {device}: {smartctl_result.stderr.decode()}")
            return {'temp': None, 'power_on_hours': None, 'power_cycle_count': None, 'health': None}

        output = smartctl_result.stdout.decode().split('\\n')
        logger.debug(f"smartctl command succeeded.")
        smart_info = {'temp': None, 'power_on_hours': None, 'power_cycle_count': None, 'health': None}

        for line in output:
            if 'Temperature' in line and 'Celsius' in line:
                smart_info['temp'] = int(line.split()[-2])  # Extract temperature
            elif 'Power On Hours' in line:
                smart_info['power_on_hours'] = int(line.split()[-1])  # Extract power-on hours
            elif 'Power Cycle Count' in line:
                smart_info['power_cycle_count'] = int(line.split()[-1])  # Extract power cycle count
            elif 'SMART overall-health' in line:
                smart_info['health'] = line.split(':')[-1].strip()

        return smart_info
    except Exception as e:
        logger.error(f"Exception in get_smartctl_data: {str(e)}")
        return {'temp': None, 'power_on_hours': None, 'power_cycle_count': None, 'health': None}

def main():
    try:
        logger.info("=" * 80)  # Separator line
        logger.info("Starting a new run of get-disks script")
        
        lsdev_disks = get_lsdev_disks()
        if lsdev_disks is not None:
            nvme_disks = get_lsblk_disks(nvme_only=True)
            all_disks = lsdev_disks + nvme_disks
        else:
            all_disks = get_lsblk_disks(nvme_only=False)

        logger.info(f"Total disks discovered: {len(all_disks)}")
        print(json.dumps(all_disks, indent=4))
    except Exception as e:
        logger.error(f"Exception in main: {str(e)}")

if __name__ == '__main__':
    main()`;
const { errorString: errorString$3, useSpawn: useSpawn$3 } = index;
async function getDisks() {
  try {
    const spawnState = useSpawn$3(["/usr/bin/env", "python3", "-c", script_py], { superuser: "try" });
    console.debug("Spawn state:", spawnState);
    if (!spawnState || !spawnState.promise) {
      throw new Error("Failed to initialize spawnState or promise is undefined");
    }
    const result = await spawnState.promise();
    return result.stdout;
  } catch (error) {
    console.error("Error in getDisks:", error.message);
    throw new Error(error.message);
  }
}
async function labelClear(disk) {
  try {
    const cmdString = ["zpool", "labelclear"];
    cmdString.push(disk.name);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$3(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$3(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function attachDisk(diskVDevPoolData) {
  try {
    let cmdString = ["zpool", "attach"];
    if (diskVDevPoolData.forceAttach) {
      cmdString.push("-f");
    }
    cmdString.push(diskVDevPoolData.poolName);
    cmdString.push(diskVDevPoolData.existingDiskName);
    cmdString.push(diskVDevPoolData.newDiskName);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$3(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$3(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function detachDisk(poolName, diskName) {
  try {
    let cmdString = ["zpool", "detach"];
    cmdString.push(poolName);
    cmdString.push(diskName);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$3(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$3(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function offlineDisk(poolName, diskName, forceFault, temporary) {
  try {
    let cmdString = ["zpool", "offline"];
    if (forceFault) {
      cmdString.push("-f");
    }
    if (temporary) {
      cmdString.push("-t");
    }
    cmdString.push(poolName);
    cmdString.push(diskName);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$3(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$3(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function onlineDisk(poolName, diskName, expand) {
  try {
    let cmdString = ["zpool", "online"];
    if (expand) {
      cmdString.push("-e");
    }
    cmdString.push(poolName);
    cmdString.push(diskName);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$3(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$3(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function replaceDisk(poolName, diskName, newDiskName, forceReplace) {
  try {
    let cmdString = ["zpool", "replace"];
    if (forceReplace) {
      cmdString.push("-f");
    }
    cmdString.push(poolName);
    cmdString.push(diskName);
    cmdString.push(newDiskName);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$3(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$3(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function trimDisk(poolName, diskName, isSecure, action) {
  try {
    let cmdString = ["zpool", "trim"];
    if (isSecure) {
      cmdString.push("-d");
    }
    if (action === "pause") {
      cmdString.push("-s");
    }
    if (action === "stop") {
      cmdString.push("-c");
    }
    cmdString.push(poolName);
    cmdString.push(diskName);
    console.log("****\ncmdstring:\n", ...cmdString, "\n****");
    const state = useSpawn$3(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$3(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
const get_datasets_script = "import libzfs\nimport json\n\ndef basic_typed_children(children):\n    for i in range(0, len(children)):\n        children[i]['properties']['creation']['parsed'] = str(children[i]['properties']['creation']['parsed'])\n\n        if len(children[i]['children']) >= 1:\n            children[i]['children'] = basic_typed_children(children[i]['children'])\n\n    return children\n\ndef main():\n    with libzfs.ZFS() as zfs:\n        z_datasets = []\n\n        for p in zfs.datasets:\n            dataset = p.asdict()\n\n            dataset['properties']['creation']['parsed'] = str(dataset['properties']['creation']['parsed'])\n\n            dataset['children'] = basic_typed_children(dataset['children'])\n\n            z_datasets.append(dataset)\n\n    print(json.dumps(z_datasets, indent=4))\nif __name__ == '__main__':\n    main()";
const create_encrypted_dataset_script = `# Python script for creating an encrypted ZFS dataset
import subprocess
import argparse
import tempfile
import os

def create_encrypted_dataset(atime, case, compress, dedup, dnode, xattr, record, readonly, quota, encryption, keyformat, keylocation, path, passphrase_file):
    try:
        # Create a secure temporary file to store the passphrase
        with tempfile.NamedTemporaryFile(mode='w+', delete=False) as temp_passphrase_file:
            temp_passphrase_file.write(passphrase_file)
            temp_passphrase_file_path = temp_passphrase_file.name

        try:
            # Construct the ZFS create command with provided arguments
            process = subprocess.Popen(
                ['zfs', 'create',
                '-o', atime,
                '-o', case,
                '-o', compress,
                '-o', dedup,
                '-o', dnode,
                '-o', xattr,
                '-o', record,
                '-o', quota,
                '-o', readonly,
                '-o', encryption,
                '-o', keyformat,
                '-o', keylocation,
                path],
                stdin=subprocess.PIPE,
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE,
            )

            # Provide the passphrase file as input to the process
            with open(temp_passphrase_file_path, 'rb') as f:
                stdout, stderr = process.communicate(input=f.read())

            if process.returncode != 0:
                raise Exception(f"Error: {stderr.decode('utf-8')}")
            else:
                print(stdout)

        finally:
            # Delete the temporary passphrase file after using it
            os.remove(temp_passphrase_file_path)

    except Exception as e:
        print(f"An error occurred: {e}")

def main():
    # Parse command-line arguments
    parser = argparse.ArgumentParser(description='Create and encrypt a ZFS Dataset')
    parser.add_argument('cmdString', type=str, help='zfs create')
    parser.add_argument('atime',type=str, help='access time')
    parser.add_argument('case',type=str, help='case sensitivity')
    parser.add_argument('compress',type=str, help='compression')
    parser.add_argument('dedup',type=str, help='deduplication')
    parser.add_argument('dnode',type=str, help='dnode size')
    parser.add_argument('xattr',type=str, help='extended attributes')
    parser.add_argument('record',type=str, help='record size')
    parser.add_argument('quota',type=str, help='quota')
    parser.add_argument('readonly',type=str, help='read only')
    parser.add_argument('encryption',type=str, help='encryption')
    parser.add_argument('keyformat',type=str, help='keyformat')
    parser.add_argument('keylocation',type=str, help='keylocation')
    parser.add_argument('path',type=str, help='path')
    parser.add_argument('passphrase',type=str, help='passphrase')

    args = parser.parse_args()

    # Extract values from command-line arguments
    cmdString = args.cmdString
    atime = args.atime
    case = args.case
    compress = args.compress
    dedup = args.dedup
    dnode = args.dnode
    xattr = args.xattr
    record = args.record
    quota = args.quota
    readonly = args.readonly
    encryption = args.encryption
    keyformat = args.keyformat
    keylocation = args.keylocation
    path = args.path
    passphrase = args.passphrase

    print(f"Executing command: {cmdString} create {atime} {case} {compress} {dedup} {dnode} {xattr} {record} {quota} {readonly} {encryption} {keyformat} {keylocation} {path}")

    # Call the function to create the encrypted dataset
    create_encrypted_dataset(atime, case, compress, dedup, dnode, xattr, record, quota, readonly, encryption, keyformat, keylocation, path, passphrase)

if __name__ == '__main__':
    main()

`;
const change_passphrase_script = `# Python script for changing encrypted dataset keys
import subprocess
import argparse
import tempfile
import os

def change_key(fileSystemName, passphrase):
    try:
        # Create a secure temporary file to store the passphrase
        with tempfile.NamedTemporaryFile(mode='w+', delete=False) as temp_passphrase_file:
            temp_passphrase_file.write(passphrase)
            temp_passphrase_file_path = temp_passphrase_file.name

        try:
            # Construct the ZFS change-key command with the provided file system name
            process = subprocess.Popen(
                ['zfs', 'change-key', fileSystemName],
                stdin=subprocess.PIPE,
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE,
            )

            # Provide the passphrase file as input to the process
            with open(temp_passphrase_file_path, 'rb') as f:
                # stdout, stderr = process.communicate(input=f.read())
            # if process.returncode != 0:
            #      raise Exception(f"Error: {stderr.decode('utf-8')}")
                
            # else:
            #     print(stdout)
                process.communicate(input=f.read())

            return process.returncode == 0

        finally:
            # Delete the temporary passphrase file after using it
            os.remove(temp_passphrase_file_path)

    except Exception as e:
        print(f"An error occurred: {e}")
        raise e

def main():
    # Parse command-line arguments
    parser = argparse.ArgumentParser(description='Change encryption key for ZFS Dataset')
    parser.add_argument('fileSystemName', type=str, help='fileSystemName')
    parser.add_argument('newPassphrase', type=str, help='newPassphrase')

    args = parser.parse_args()

    # Extract values from command-line arguments
    fileSystemName = args.fileSystemName
    newPassphrase = args.newPassphrase

    print(f"Executing command: zfs change-key {fileSystemName}")

    # Call function to change key
    change_key(fileSystemName, newPassphrase)

if __name__ == '__main__':
    main()`;
const unlock_dataset_script = `# Python script for unlocking encrypted datasets
import subprocess
import argparse
import tempfile
import os

def unlock_locked_dataset(name, passphrase_file):
    try :
        # Create a secure temporary file to store the passphrase
        with tempfile.NamedTemporaryFile(mode='w+', delete=False) as temp_passphrase_file:
            temp_passphrase_file.write(passphrase_file)
            temp_passphrase_file_path = temp_passphrase_file.name

        try:
            # Construct the ZFS create command with provided arguments
            process = subprocess.Popen(
                ['zfs', 'load-key',
                name],
                stdin=subprocess.PIPE,
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE,
            )

            # Provide the passphrase file as input to the process
            with open(temp_passphrase_file_path, 'rb') as f:
                stdout, stderr = process.communicate(input=f.read())

            if process.returncode != 0:
                # raise Exception(f"Error: {stderr.decode('utf-8')}")
                print(f"Error: {stderr}")
            else:
                print(stdout)

        finally:
            # Delete the temporary passphrase file after using it
            os.remove(temp_passphrase_file_path)

    except Exception as e:
        print(f"An error occurred: {e}")
        raise e


def main():
    # Parse command-line arguments
    parser = argparse.ArgumentParser(description='Unlock encrypted ZFS Dataset')
    parser.add_argument('name', type=str, help='dataset name')
    parser.add_argument('passphrase', type=str, help='passphrase')

    args = parser.parse_args()

    # Extract values from arguments
    name = args.name
    passphrase = args.passphrase

    print(f"Executing unlock command on {name}")

    # Call function to unlock dataset
    unlock_locked_dataset(name, passphrase)

if __name__ == '__main__':
    main()`;
const validate_passphrase_script = `# Python script for checking encryption passphrase is valid
import subprocess
import argparse
import tempfile
import os

def check_key(fileSystemName, passphrase):
    try:
        # Create a secure temporary file to store the passphrase
        with tempfile.NamedTemporaryFile(mode='w+', delete=False) as temp_passphrase_file:
            temp_passphrase_file.write(passphrase)
            temp_passphrase_file_path = temp_passphrase_file.name

        try:
            # Construct the ZFS change-key command with the provided file system name
            process = subprocess.Popen(
                ['zfs', 'load-key', '-n', fileSystemName],
                stdin=subprocess.PIPE,
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE,
            )

            # Provide the passphrase file as input to the process
            with open(temp_passphrase_file_path, 'rb') as f:
                process.communicate(input=f.read())
                # stdout, stderr = process.communicate(input=f.read())

            return process.returncode == 0
            # if process.returncode != 0:
            #     raise Exception(f"Error: {stderr.decode('utf-8')}")
            # else:
                # print(stdout)
                # return process.returncode

        finally:
            # Delete the temporary passphrase file after using it
            os.remove(temp_passphrase_file_path)

    except Exception as e:
        return str(False).lower()

def main():
    # Parse command-line arguments
    parser = argparse.ArgumentParser(description='Check encryption key validity for ZFS Dataset')
    parser.add_argument('fileSystemName', type=str, help='fileSystemName')
    parser.add_argument('passphrase', type=str, help='passphrase')

    args = parser.parse_args()

    # Extract values from command-line arguments
    fileSystemName = args.fileSystemName
    passphrase = args.passphrase

    # Call function to check key
    is_valid = check_key(fileSystemName, passphrase)
    print(str(is_valid).lower())  # Print 'true' or 'false'

if __name__ == '__main__':
    main()
`;
const { errorString: errorString$2, useSpawn: useSpawn$2 } = index;
async function getDatasets() {
  try {
    const state = useSpawn$2(["/usr/bin/env", "python3", "-c", get_datasets_script], { superuser: "try" });
    const datasets = (await state.promise()).stdout;
    return datasets;
  } catch (state) {
    console.error(errorString$2(state));
    return null;
  }
}
async function createEncryptedDataset(fileSystemData, passphrase) {
  try {
    let quota = "";
    if (Number(fileSystemData.quota) == 0) {
      quota = "quota=none";
    } else {
      quota = "quota=" + fileSystemData.quota;
    }
    let args = {
      cmd: "zfs",
      atime: "atime=" + fileSystemData.atime,
      case: "casesensitivity=" + fileSystemData.casesensitivity,
      compress: "compression=" + fileSystemData.compression,
      dedup: "dedup=" + fileSystemData.dedup,
      dnode: "dnodesize=" + fileSystemData.dnodesize,
      xattr: "xattr=" + fileSystemData.xattr,
      record: "recordsize=" + fileSystemData.recordsize,
      quota,
      readonly: "readonly=" + fileSystemData.readonly,
      encryption: "encryption=" + fileSystemData.encryption,
      keyformat: "keyformat=passphrase",
      keylocation: "keylocation=prompt",
      path: fileSystemData.parent + "/" + fileSystemData.name,
      passphrase
    };
    const state = useSpawn$2(["/usr/bin/env", "python3", "-c", create_encrypted_dataset_script, args.cmd, args.atime, args.case, args.compress, args.dedup, args.dnode, args.xattr, args.record, args.quota, args.readonly, args.encryption, args.keyformat, args.keylocation, args.path, args.passphrase], { superuser: "try" });
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$2(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function changePassphrase(fileSystemName, newPassphrase) {
  try {
    const state = useSpawn$2(["/usr/bin/env", "python3", "-c", change_passphrase_script, fileSystemName, newPassphrase], { superuser: "try" });
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$2(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function isPassphraseValid(fileSystemName, passphrase) {
  try {
    const state = useSpawn$2(["/usr/bin/env", "python3", "-c", validate_passphrase_script, fileSystemName, passphrase], { superuser: "try" });
    const output = await state.promise();
    console.log(`fileSystemName: ${fileSystemName}, pass: ${passphrase}, function call output: ${output.stdout}`);
    if (output.stdout.includes("true")) {
      return true;
    } else {
      return false;
    }
  } catch (state) {
    console.error(errorString$2(state));
    return false;
  }
}
async function configureDataset(fileSystemData) {
  try {
    let cmdString = ["zfs", "set"];
    const hasProperties = hasChanges(fileSystemData);
    if (hasProperties) {
      if (fileSystemData.readonly) {
        cmdString.push("readonly=" + fileSystemData.readonly);
      }
      if (fileSystemData.record) {
        cmdString.push("recordsize=" + fileSystemData.record);
      }
      if (fileSystemData.aclinherit) {
        cmdString.push("aclinherit=" + fileSystemData.aclinherit);
      }
      if (fileSystemData.acltype) {
        cmdString.push("acltype=" + fileSystemData.acltype);
      }
      if (fileSystemData.atime) {
        cmdString.push("atime=" + fileSystemData.atime);
      }
      if (fileSystemData.dedup) {
        cmdString.push("dedup=" + fileSystemData.dedup);
      }
      if (fileSystemData.compression) {
        cmdString.push("compression=" + fileSystemData.compression);
      }
      if (fileSystemData.checksum) {
        cmdString.push("checksum=" + fileSystemData.checksum);
      }
      if (fileSystemData.dnodesize) {
        cmdString.push("dnodesize=" + fileSystemData.dnodesize);
      }
      if (fileSystemData.xattr) {
        cmdString.push("xattr=" + fileSystemData.xattr);
      }
      if (fileSystemData.quota) {
        if (Number(fileSystemData.quota) == 0) {
          cmdString.push("quota=none");
        } else {
          cmdString.push("quota=" + fileSystemData.quota);
        }
      }
      if (fileSystemData.refreservation) {
        if (Number(fileSystemData.refreservation) == 0) {
          cmdString.push("refreservation=off");
        } else {
          cmdString.push("refreservation=" + fileSystemData.refreservation);
        }
      }
      if (fileSystemData.mountpoint) {
        cmdString.push("mountpoint=" + fileSystemData.mountpoint);
      }
      if (fileSystemData.canmount) {
        cmdString.push("canmount=" + fileSystemData.canmount);
      }
      cmdString.push(fileSystemData.name);
      console.log("configure cmdString:", cmdString);
      const state = useSpawn$2(cmdString);
      const output = await state.promise();
      console.log(output);
      return output.stdout;
    } else {
      console.log("There are no selected properties to change.");
    }
  } catch (state) {
    const errorMessage = errorString$2(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function destroyDataset(fileSystemData, forceDestroy, destroyChildren, destroyDependents) {
  try {
    let cmdString = ["zfs", "destroy"];
    if (destroyDependents) {
      cmdString.push("-R");
    }
    if (forceDestroy) {
      cmdString.push("-f");
    }
    if (destroyChildren) {
      cmdString.push("-r");
    }
    cmdString.push(fileSystemData.name);
    console.log("destroy cmdString:", cmdString);
    const state = useSpawn$2(cmdString);
    console.log("state: ", state);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$2(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function unmountFileSystem(fileSystemData, forceUnmount) {
  try {
    let cmdString = ["zfs", "unmount"];
    if (forceUnmount) {
      cmdString.push("-f");
    }
    cmdString.push(fileSystemData.name);
    console.log("***\ncmdString:", cmdString, "\n***");
    const state = useSpawn$2(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$2(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function mountFileSystem(fileSystemData, forceMount) {
  try {
    let cmdString = ["zfs", "mount"];
    if (forceMount) {
      cmdString.push("-f");
    }
    cmdString.push(fileSystemData.name);
    console.log("***\ncmdString:", cmdString, "\n***");
    const state = useSpawn$2(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$2(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function lockFileSystem(fileSystemData) {
  try {
    let cmdString = ["zfs", "unload-key"];
    cmdString.push(fileSystemData.name);
    console.log("***\ncmdString:", cmdString, "\n***");
    const state = useSpawn$2(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$2(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function unlockFileSystem(fileSystemData, passphrase) {
  try {
    const state = useSpawn$2(["/usr/bin/env", "python3", "-c", unlock_dataset_script, fileSystemData.name, passphrase], { superuser: "try" });
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$2(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function renameFileSystem(oldPath, newPath, forceUnmount, createParent) {
  try {
    let cmdString = ["zfs", "rename"];
    if (createParent) {
      cmdString.push("-p");
    }
    if (forceUnmount) {
      cmdString.push("-f");
    }
    cmdString.push(oldPath);
    cmdString.push(newPath);
    console.log("***\ncmdString:", cmdString, "\n***");
    const state = useSpawn$2(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$2(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
const properties = [
  "readonly",
  "mountpoint",
  "canmount",
  "atime",
  "quota",
  "record",
  "refreservation",
  "aclinherit",
  "acltype",
  "dedup",
  "compression",
  "checksum",
  "dnodesize",
  "xattr"
];
function hasChanges(fileSystemData) {
  for (const property of properties) {
    if (property in fileSystemData) {
      return true;
    }
  }
  return false;
}
const get_snapshots_script = `import libzfs
import json
import sys

def basic_typed_children(children):
    for i in range(len(children)):
        children[i]['properties']['creation']['parsed'] = str(children[i]['properties']['creation']['parsed'])
        
        if len(children[i]['children']) >= 1:
            children[i]['children'] = basic_typed_children(children[i]['children'])

    return children

def get_all_snapshots():
    with libzfs.ZFS() as zfs:
        z_datasets = {}

        for d in zfs.datasets:
            snaps = []

            for snap in d.snapshots:
                z_snap = snap.asdict()
                z_snap['properties']['creation']['parsed'] = str(z_snap['properties']['creation']['parsed'])
                snaps.append(z_snap)

            z_datasets[d.name] = snaps

    return json.dumps(z_datasets, indent=4)  # Return the JSON string

def get_snapshots_by_dataset(dataset_name):
    with libzfs.ZFS() as zfs:
        z_datasets = {}

        for d in zfs.datasets:
            if d.name == dataset_name:  # Use 'd.name' for checking the dataset name
                snaps = []

                for snap in d.snapshots:
                    z_snap = snap.asdict()
                    z_snap['properties']['creation']['parsed'] = str(z_snap['properties']['creation']['parsed'])
                    snaps.append(z_snap)

                z_datasets[d.name] = snaps
                break  # Stop after finding the desired dataset

    return json.dumps(z_datasets, indent=4)  # Return the JSON string

import libzfs
import json
import sys

def basic_typed_children(children):
    for i in range(len(children)):
        children[i]['properties']['creation']['parsed'] = str(children[i]['properties']['creation']['parsed'])
        
        if len(children[i]['children']) >= 1:
            children[i]['children'] = basic_typed_children(children[i]['children'])

    return children

def get_all_snapshots():
    with libzfs.ZFS() as zfs:
        z_datasets = {}

        for d in zfs.datasets:
            snaps = []

            for snap in d.snapshots:
                z_snap = snap.asdict()
                z_snap['properties']['creation']['parsed'] = str(z_snap['properties']['creation']['parsed'])
                snaps.append(z_snap)

            z_datasets[d.name] = snaps

    return json.dumps(z_datasets, indent=4)  # Return the JSON string

def get_snapshots_by_dataset(dataset_name):
    with libzfs.ZFS() as zfs:
        z_datasets = {}

        for d in zfs.datasets:
            if d.name == dataset_name:  # Use 'd.name' for checking the dataset name
                snaps = []

                for snap in d.snapshots:
                    z_snap = snap.asdict()
                    z_snap['properties']['creation']['parsed'] = str(z_snap['properties']['creation']['parsed'])
                    snaps.append(z_snap)

                z_datasets[d.name] = snaps
                break  # Stop after finding the desired dataset

    return json.dumps(z_datasets, indent=4)  # Return the JSON string

# Placeholder for the function to get snapshots by pool (implement as needed)
def get_snapshots_by_pool(pool_name):
    with libzfs.ZFS() as zfs:
        z_datasets = {}

        for d in zfs.datasets:
            if d.pool.name == pool_name:  # Check if the dataset belongs to the specified pool
                snaps = []

                for snap in d.snapshots:
                    z_snap = snap.asdict()
                    z_snap['properties']['creation']['parsed'] = str(z_snap['properties']['creation']['parsed'])
                    snaps.append(z_snap)

                z_datasets[d.name] = snaps  # Store snapshots for the dataset

    return json.dumps(z_datasets, indent=4)  # Return the JSON string


def main():
    if len(sys.argv) < 2:
        print("Usage: python3 your_script.py [all|dataset_name|pool_name]")
        return

    command = sys.argv[1]
    snapshots = None  # Initialize snapshots variable

    if command == 'all':
        snapshots = get_all_snapshots()
    elif command.startswith('dataset:'):
        dataset_name = command.split(':')[1]
        snapshots = get_snapshots_by_dataset(dataset_name)
    elif command.startswith('pool:'):
        pool_name = command.split(':')[1]
        snapshots = get_snapshots_by_pool(pool_name)
    else:
        print("Invalid command. Use 'all', 'dataset:<name>', or 'pool:<name>'.")
        return


if __name__ == '__main__':
    main()

def main():
    if len(sys.argv) < 2:
        print("Usage: python3 your_script.py [all|dataset_name|pool_name]")
        return

    command = sys.argv[1]
    snapshots = None  # Initialize snapshots variable

    if command == 'all':
        snapshots = get_all_snapshots()
    elif command.startswith('dataset:'):
        dataset_name = command.split(':')[1]
        snapshots = get_snapshots_by_dataset(dataset_name)
    elif command.startswith('pool:'):
        pool_name = command.split(':')[1]
        snapshots = get_snapshots_by_pool(pool_name)
    else:
        print("Invalid command. Use 'all', 'dataset:<name>', or 'pool:<name>'.")
        return

    if snapshots:  # Print the snapshots if they were retrieved
        print(snapshots)

if __name__ == '__main__':
    main()`;
const send_dataset_script = `# Python script for sending snapshots
import subprocess
import argparse
import re
import json
import os

def destroy_for_overwrite_local(recvName):
    destroy_cmd = ['zfs', 'destroy', f'{recvName}', '-R']

    process_destroy = subprocess.Popen(
        destroy_cmd,
        stdout=subprocess.PIPE,
        stderr=subprocess.PIPE,
    )

    print(f"Executing command: zfs destroy -R {recvName}")
    
    stdout, stderr = process_destroy.communicate()

    if process_destroy.returncode != 0:
        raise Exception(f"Error: {stderr.decode('utf-8')}")
    else:
        print(stdout)

def destroy_for_overwrite_remote(recvName, recvHostUser, recvHost, recvPort=22):
    ssh_cmd = ['ssh']

    if recvPort != '22':
        ssh_cmd.extend(['-p', recvPort])

    ssh_cmd.append(recvHostUser + '@' + recvHost)

    ssh_cmd.extend(['zfs', 'destroy', f'{recvName}', '-R'])

    process_destroy = subprocess.Popen(
        ssh_cmd,
        stdout=subprocess.PIPE,
        stderr=subprocess.PIPE,
    )

    print(f"Executing command: zfs destroy -R {recvName}")
    
    stdout, stderr = process_destroy.communicate()

    if process_destroy.returncode != 0:
        raise Exception(f"Error: {stderr.decode('utf-8')}")
    else:
        print(stdout)

def remove_remote_file(hostname, username, port=22):
    ssh_cmd = ['ssh', '-p', str(port), f'{username}@{hostname}', f'if [ -e full_output.json ]; then rm full_output.json; fi']
    
    process_remove = subprocess.Popen(
        ssh_cmd,
        stdout=subprocess.PIPE,
        stderr=subprocess.PIPE,
    )

    stdout, stderr = process_remove.communicate()

    if process_remove.returncode != 0:
        raise Exception(f"Error: {stderr.decode('utf-8')}")
    else:
        print(stdout)

def send_dataset(sendName, recvName, sendName2="", forceOverwrite=False, compressed=False, raw=False, recvHost="", recvPort=22, recvHostUser="", mBufferSize=1, mBufferUnit="G"):
    try:
        # Initialize variables 
        snapshot_name = sendName
        total_size = None
        update_size = None
        status = None
        output_data = []
        final_data = None

        # Delete progress file if exists from previous send
        file_path = "full_output.json"
        if os.path.exists(file_path):
            os.remove(file_path)

        # If remote send, delete progress file if exists 
        if recvHost != "":
            remove_remote_file(recvHost, recvHostUser, recvPort)
            # If force overwrite required  
            # if forceOverwrite == True:
            #     destroy_for_overwrite_remote(recvName, recvHostUser, recvHost, recvPort)

        # Initial local send command
        send_cmd = ['zfs', 'send', '-v']

        if compressed:
            send_cmd.append('-Lce')

        if raw:
            send_cmd.append('-w')

        if sendName2 != "":
            send_cmd.extend(['-i', sendName2])

        send_cmd.append(sendName)

        print(f"SEND_CMD: {send_cmd}")

        process_send = subprocess.Popen(
            send_cmd,
            stdout=subprocess.PIPE,
            stderr=subprocess.PIPE,
        )
        
        # If sending locally
        if recvHost == "":
            recv_cmd = ['zfs', 'recv', '-v']

            if forceOverwrite:
                recv_cmd.append('-F')
                # If force overwrite required  
                destroy_for_overwrite_local(recvName)

            recv_cmd.append(recvName)

            print(f"RECV_CMD: {recv_cmd}")

            process_recv = subprocess.Popen(
                recv_cmd,
                stdin=process_send.stdout,
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE,
                universal_newlines=True,
            )

            while process_send.poll() is None:
                output = process_send.stderr.readline()
                
                if output:
                    # Extract total size
                    pattern_total = r'estimated size is (\\d+(\\.\\d+)?[KMG])'
                    match_total = re.search(pattern_total, str(output))
                    if match_total:
                        total_size = match_total.group(1)

                    # Extract progress data
                    pattern_progress = r'(\\d+:\\d+\\d+)\\s+(\\d+(\\.\\d+)?[KMG])\\s+([\\w\\/@]+)'
                    match_progress = re.search(pattern_progress, str(output))
                    if match_progress:
                        update_size = match_progress.group(2)
                        snapshot_name = match_progress.group(4)
                        status = "ongoing"

                        # Create a data dictionary
                        data = {
                            "snapshot": snapshot_name,
                            "status": status,
                            "sent": update_size,
                            "totalSize": total_size,
                        }

                        output_data.append(data)
                        print(data)

                        with open(file_path, 'w') as json_file:
                            # Loop to append each line one at a time
                            json_file.write(json.dumps(data) + '\\n')
                            json_file.flush()

                        # current_directory = os.getcwd()
                        # print("Current Working Directory:", current_directory)
                        
                    if match_progress is False:
                        break
                
            while process_recv.poll() is None:
                recv_output = process_recv.stdout.readline()

                # Check for the "received" line structure
                if "received" in str(recv_output):
                    # Extract the final progress information
                    pattern_final_progress = r'received\\s+([\\d.]+[KMG]?)\\s+stream\\s+in\\s+(\\d+)\\s+seconds\\s+\\(([\\d.]+[KMG]?)\\/sec\\)'

                    match_final_progress = re.search(pattern_final_progress, str(recv_output))
                    if match_final_progress:
                        received_size = match_final_progress.group(1)
                        status = "finished"
                        
                        # Create the final data object
                        final_data = {
                            "snapshot": snapshot_name,
                            "status": status,
                            "sent": received_size,
                            "totalSize": total_size,
                        }

                        # Print the data for verification
                        print(final_data)
                        output_data.append(final_data)

                        with open(file_path, 'w') as json_file:
                            json_file.write(json.dumps(final_data) + '\\n')
                            json_file.flush()

            stdout, stderr = process_recv.communicate()

            if process_recv.returncode != 0:
                raise Exception(f"Error:{stderr}")
            else:
                print(stdout)

            # Print out entire JSON
            print(json.dumps(output_data, indent=2))

        # If sending remotely via SSH
        if recvHost != "":
            if forceOverwrite:
                destroy_for_overwrite_remote(recvName, recvHostUser, recvHost, recvPort)

            m_buff_cmd = ['mbuffer', '-s', '256k']
            m_buff_cmd.extend(['-m', mBufferSize + mBufferUnit])

            process_m_buff = subprocess.Popen(
                m_buff_cmd,
                stdin=process_send.stdout,
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE,
                universal_newlines=True,
            )

            ssh_cmd = ['ssh']

            if recvPort != '22':
                ssh_cmd.extend(['-p', recvPort])

            ssh_cmd.append(recvHostUser + '@' + recvHost)

            ssh_cmd.extend(['zfs', 'recv'])

            if forceOverwrite:
                ssh_cmd.append('-F')

            ssh_cmd.append('-v')

            ssh_cmd.append(recvName)

            print(f"SSH_CMD: {ssh_cmd}")

            process_ssh_recv = subprocess.Popen(
                ssh_cmd,
                stdin=process_m_buff.stdout,
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE,
                universal_newlines=True,
            )

            while process_send.poll() is None:
                output = process_send.stderr.readline()
                
                if output:
                    # Extract total size
                    pattern_total = r'estimated size is (\\d+(\\.\\d+)?[KMG])'
                    match_total = re.search(pattern_total, str(output))
                    if match_total:
                        total_size = match_total.group(1)

                    # Extract progress data
                    pattern_progress = r'(\\d+:\\d+\\d+)\\s+(\\d+(\\.\\d+)?[KMG])\\s+([\\w\\/@]+)'
                    match_progress = re.search(pattern_progress, str(output))
                    if match_progress:
                        update_size = match_progress.group(2)
                        snapshot_name = match_progress.group(4)
                        status = "ongoing"

                        # Create a data dictionary
                        data = {
                            "snapshot": snapshot_name,
                            "status": status,
                            "sent": update_size,
                            "totalSize": total_size,
                        }

                        output_data.append(data)
                        print(data)

                        with open(file_path, 'w') as json_file:
                            # Loop to append each line one at a time
                            json_file.write(json.dumps(data) + '\\n')
                            json_file.flush()

                        # current_directory = os.getcwd()
                        # print("Current Working Directory:", current_directory)
                        
                    if match_progress is False:
                        break
                
            while process_ssh_recv.poll() is None:
                ssh_output = process_ssh_recv.stdout.readline()

                if "received" in str(ssh_output):
                    # Extract the final progress information
                    pattern_final_progress = r'received\\s+([\\d.]+[KMG]?)\\s+stream\\s+in\\s+(\\d+)\\s+seconds\\s+\\(([\\d.]+[KMG]?)\\/sec\\)'

                    match_final_progress = re.search(pattern_final_progress, str(ssh_output))
                    if match_final_progress:
                        received_size = match_final_progress.group(1)
                        status = "finished"
                        
                        # Create the final data object
                        final_data = {
                            "snapshot": snapshot_name,
                            "status": status,
                            "sent": received_size,
                            "totalSize": total_size,
                        }

                        # Print the data for verification
                        print(final_data)
                        output_data.append(final_data)

                        # current_directory = os.getcwd()
                        # print("Current Working Directory:", current_directory)

                        with open(file_path, 'w') as json_file:
                            json_file.write(json.dumps(final_data) + '\\n')
                            json_file.flush()

            stdout, stderr = process_ssh_recv.communicate()

            if process_ssh_recv.returncode != 0:
                raise Exception(f"Error: {stderr}")
            else:
                print(stdout)

             # Print out entire JSON
            print(json.dumps(output_data, indent=2))
        

    except Exception as e:
        print(f"An error occurred: {e}")

def main() : 
    parser = argparse.ArgumentParser(description='Send ZFS Dataset')
    parser.add_argument('sendName', type=str, help='sending dataset name')
    parser.add_argument('recvName', type=str, help='receiving dataset name')
    parser.add_argument('sendName2', type=str, help='first snap for incremental send')
    parser.add_argument('forceOverwrite', type=str, default='False', help='forcefully overwrite existing dataset')
    parser.add_argument('compressed', type=str, default='False', help='sending dataset compression')
    parser.add_argument('raw', type=str, default='False', help='sending dataset raw')
    parser.add_argument('recvHost', type=str, help='receiving dataset host')
    parser.add_argument('recvPort', type=str, default='22', help='receiving dataset port')
    parser.add_argument('recvHostUser', type=str, help='receiving dataset host user')
    parser.add_argument('mBufferSize', type=str, default='1', help='mbuffer size')
    parser.add_argument('mBufferUnit', type=str, default="G", help='mbuffer unit')

    args = parser.parse_args()

    sendName = args.sendName
    recvName = args.recvName
    sendName2 = args.sendName2
    forceOverwrite = args.forceOverwrite.lower() == 'true'
    compressed = args.compressed.lower() == 'true'
    raw = args.raw.lower() == 'true'
    recvHost = args.recvHost
    recvPort = args.recvPort
    recvHostUser = args.recvHostUser
    mBufferSize = args.mBufferSize
    mBufferUnit = args.mBufferUnit

    if sendName2 != "":
        print(f"Sending incrementally to {recvName} from {sendName2} to {sendName}")
    else:
        print(f"Executing command: zfs send {sendName} | {recvName}")

    send_dataset(sendName, recvName, sendName2, forceOverwrite, compressed, raw, recvHost, recvPort, recvHostUser, mBufferSize, mBufferUnit)

if __name__ == '__main__':
    main()`;
const check_dataset_script = `# Python script for checking dataset
import subprocess
import argparse

def check_if_recv_dataset_exists(recvName, recvHost, recvPort, recvHostUser):
    # Construct the SSH command
    if recvPort == '22':
        ssh_cmd = ['ssh', f'{recvHostUser}@{recvHost}', f'zfs list -H -o name {recvName}']
    else:
        ssh_cmd = ['ssh', '-p', f'{recvPort}', f'{recvHostUser}@{recvHost}', f'zfs list -H -o name {recvName}']

    # Run the SSH command
    process_check_dataset = subprocess.Popen(
        ssh_cmd,
        stdout=subprocess.PIPE,
        stderr=subprocess.PIPE,
        universal_newlines=True,  # Ensures text mode for stdout and stderr
    )

    # Wait for the command to complete and capture the output
    stdout, stderr = process_check_dataset.communicate()

    # Check the return code
    if process_check_dataset.returncode != 0:
        # raise Exception(f"Error:{stderr}")
        return False
    else:
        # Check if the output matches the recvName
        # return stdout.strip() == recvName
        return bool(stdout.strip())

def main() :
    parser = argparse.ArgumentParser(description='Check ZFS Dataset')
    parser.add_argument('recvName', type=str, help='receiving dataset name')
    parser.add_argument('recvHost', type=str, help='receiving dataset host')
    parser.add_argument('recvPort', type=str, default='22', help='receiving dataset port')
    parser.add_argument('recvHostUser', type=str, help='receiving dataset host user')

    args = parser.parse_args()

    recvName = args.recvName
    recvHost = args.recvHost
    recvPort = args.recvPort
    recvHostUser = args.recvHostUser

    if recvPort == '22':
        print(f"ssh {recvHostUser}@{recvHost} 'zfs list -H -o name {recvName}'")
    else:
        print(f"ssh -p {recvPort} {recvHostUser}@{recvHost} 'zfs list -H -o name {recvName}'")

    exists = check_if_recv_dataset_exists(recvName, recvHost, recvPort, recvHostUser)

    print(str(exists))

if __name__ == '__main__':
    main()`;
const get_recent_snaps_script = `import subprocess
import json
import argparse

def get_snapshots_info(recvName, recvHost, recvPort, recvHostUser):
    if recvPort == '22':
        ssh_cmd = ['ssh', f'{recvHostUser}@{recvHost}', f'zfs list -H -o name,guid,creation -t snapshot {recvName}']
    else:
        ssh_cmd = ['ssh', '-p', f'{recvPort}', f'{recvHostUser}@{recvHost}', f'zfs list -H -o name,guid,creation -t snapshot {recvName}']

    process = subprocess.Popen(
        ssh_cmd, 
        stdout=subprocess.PIPE, 
        stderr=subprocess.PIPE,
        universal_newlines=True, 
    )

    stdout, stderr = process.communicate()

    if process.returncode != 0:
        # raise Exception(f"Error:{stderr}")
        return []

    # Parse the output and structure the data
    snapshots_info = []
    for line in stdout.splitlines():
        name, guid, creation_str = line.split('\\t')
        snapshot_data = {'name': name, 'guid': guid, 'creation': creation_str}
        snapshots_info.append(snapshot_data)

    # Sort the array by 'creation' timestamp in descending order
    snapshots_info.sort(key=lambda x: x['creation'], reverse=True)

    return snapshots_info

def main():
    parser = argparse.ArgumentParser(description='Send ZFS Dataset')
   
    parser.add_argument('recvName', type=str, help='receiving dataset name')
    parser.add_argument('recvHost', type=str, help='receiving dataset host')
    parser.add_argument('recvPort', type=str, default='22', help='receiving dataset port')
    parser.add_argument('recvHostUser', type=str, help='receiving dataset host user')

    args = parser.parse_args()

    recvName = args.recvName
    recvHost = args.recvHost
    recvPort = args.recvPort
    recvHostUser = args.recvHostUser

    snapshots_info = get_snapshots_info(recvName, recvHost, recvPort, recvHostUser)

    # Print the structured data
    print(json.dumps(snapshots_info, indent=2))

    return snapshots_info

if __name__ == '__main__':
    main()
`;
const check_remote_snaps_script = `import subprocess
import argparse

def check_if_recv_dataset_has_snapshots(recvName, recvHost, recvPort, recvHostUser):
    # Construct the SSH command
    if recvPort == '22':
        ssh_cmd = ['ssh', f'{recvHostUser}@{recvHost}', f'zfs list -H -o name -t snapshot {recvName}']
    else:
        ssh_cmd = ['ssh', '-p', f'{recvPort}', f'{recvHostUser}@{recvHost}', f'zfs list -H -o name -t snapshot {recvName}']

    # Run the SSH command
    process_check_snapshots = subprocess.Popen(
        ssh_cmd,
        stdout=subprocess.PIPE,
        stderr=subprocess.PIPE,
        universal_newlines=True,  # Ensures text mode for stdout and stderr
    )

    # Wait for the command to complete and capture the output
    stdout, stderr = process_check_snapshots.communicate()

    # Log stdout and stderr for debugging
    print("stdout:", stdout)
    print("stderr:", stderr)

    # Check the return code
    if process_check_snapshots.returncode != 0:
        # raise Exception(f"Error:{stderr}")
        return False
    else:
        # Check if the output contains snapshots
        return bool(stdout.strip())

def main() :
    parser = argparse.ArgumentParser(description='Check ZFS Datasets/Snapshots')
    parser.add_argument('recvName', type=str, help='receiving dataset name')
    parser.add_argument('recvHost', type=str, help='receiving dataset host')
    parser.add_argument('recvPort', type=str, default='22', help='receiving dataset port')
    parser.add_argument('recvHostUser', type=str, help='receiving dataset host user')

    args = parser.parse_args()

    recvName = args.recvName
    recvHost = args.recvHost
    recvPort = args.recvPort
    recvHostUser = args.recvHostUser

    if recvPort == '22':
        print(f"ssh {recvHostUser}@{recvHost} 'zfs list -H -o name -t snapshot {recvName}'")
    else:
        print(f"ssh -p {recvPort} {recvHostUser}@{recvHost} 'zfs list -H -o name -t snapshot {recvName}'")

    exists = check_if_recv_dataset_has_snapshots(recvName, recvHost, recvPort, recvHostUser)

    print(str(exists))

if __name__ == '__main__':
    main()`;
const { errorString: errorString$1, useSpawn: useSpawn$1 } = index;
async function getSnapshots() {
  try {
    const argument = `all`;
    const state = useSpawn$1(["/usr/bin/env", "python3", "-c", get_snapshots_script, argument], { superuser: "try" });
    const snapshots = (await state.promise()).stdout;
    return JSON.parse(snapshots);
  } catch (error) {
    console.error("Error fetching all snapshots:", error);
    return null;
  }
}
async function getSnapshotsOfDataset(datasetName) {
  try {
    const argument = `dataset:${datasetName}`;
    const command = ["/usr/bin/env", "python3", "-c", get_snapshots_script, argument];
    const state = useSpawn$1(command, { superuser: "try" });
    const snapshots = (await state.promise()).stdout;
    return JSON.parse(snapshots);
  } catch (error) {
    console.error(`Error fetching snapshots for dataset "${datasetName}":`, error);
    return null;
  }
}
async function getSnapshotsOfPool(poolName) {
  try {
    const argument = `pool:${poolName}`;
    const command = ["/usr/bin/env", "python3", "-c", get_snapshots_script, argument];
    const state = useSpawn$1(command, { superuser: "try" });
    const snapshots = (await state.promise()).stdout;
    return JSON.parse(snapshots);
  } catch (error) {
    console.error(`Error fetching snapshots for dataset "${poolName}":`, error);
    return null;
  }
}
async function createSnapshot(newSnap) {
  try {
    let cmdString = ["zfs", "snapshot"];
    if (newSnap.snapChildren) {
      cmdString.push("-r");
    }
    cmdString.push(newSnap.filesystem + "@" + newSnap.name);
    console.log("****create cmdString: *****\n", cmdString);
    const state = useSpawn$1(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$1(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function destroySnapshot(snapshotName, destroyChildrenSameName, destroyAllChildren) {
  try {
    let cmdString = ["zfs", "destroy"];
    if (destroyChildrenSameName) {
      cmdString.push("-r");
    }
    if (destroyAllChildren) {
      cmdString.push("-R");
    }
    cmdString.push(snapshotName);
    console.log("****destroy cmdString: *****\n", cmdString);
    const state = useSpawn$1(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$1(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function rollbackSnapshot(snapshot, destroyNewerSnaps, destroyAllNewer) {
  try {
    let cmdString = ["zfs", "rollback"];
    if (destroyNewerSnaps) {
      cmdString.push("-r");
    }
    if (destroyAllNewer) {
      cmdString.push("-R");
    }
    cmdString.push(snapshot.name);
    console.log("****rollback cmdString: *****\n", cmdString);
    const state = useSpawn$1(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$1(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function renameSnapshot(snapshotName, newName, renameChildren) {
  try {
    let cmdString = ["zfs", "rename"];
    if (renameChildren) {
      cmdString.push("-r");
    }
    cmdString.push(snapshotName);
    cmdString.push(newName);
    console.log("****rename cmdString: *****\n", cmdString);
    const state = useSpawn$1(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$1(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function cloneSnapshot(snapName, newParentFS, cloneName, createParent) {
  try {
    let cmdString = ["zfs", "clone"];
    if (createParent) {
      cmdString.push("-p");
    }
    cmdString.push(`${snapName}`);
    cmdString.push(`${newParentFS}/${cloneName}`);
    console.log("****clone cmdString: *****\n", cmdString);
    const state = useSpawn$1(cmdString);
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$1(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function sendSnapshot(sendingData) {
  try {
    console.log("sendingData (snapshots.ts - sendSnapshot):", sendingData);
    const state = useSpawn$1(["/usr/bin/env", "python3", "-c", send_dataset_script, sendingData.sendName, sendingData.recvName, sendingData.sendIncName, sendingData.sendOpts.forceOverwrite, sendingData.sendOpts.compressed, sendingData.sendOpts.raw, sendingData.recvHost, sendingData.recvPort, sendingData.recvHostUser, sendingData.mBufferConfig.size, sendingData.mBufferConfig.unit], { superuser: "try" });
    const output = await state.promise();
    console.log("sendSnapshot completed");
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$1(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function doesDatasetExist(sendingData) {
  try {
    console.log("sendingData (snapshots.ts - checkDataset - doesDatasetExist):", sendingData);
    const state = useSpawn$1(["/usr/bin/env", "python3", "-c", check_dataset_script, sendingData.recvName, sendingData.recvHost, sendingData.recvPort, sendingData.recvHostUser], { superuser: "try" });
    const output = await state.promise();
    console.log(output);
    if (output.stdout.includes("True")) {
      return true;
    } else {
      return false;
    }
  } catch (state) {
    const errorMessage = errorString$1(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function doesDatasetHaveSnaps(sendingData) {
  try {
    console.log("sendingData (snapshots.ts - checkDataset - doesDatasetHaveSnaps):", sendingData);
    const state = useSpawn$1(["/usr/bin/env", "python3", "-c", check_remote_snaps_script, sendingData.recvName, sendingData.recvHost, sendingData.recvPort, sendingData.recvHostUser], { superuser: "try" });
    const output = await state.promise();
    console.log(output);
    if (output.stdout.includes("True")) {
      return true;
    } else {
      return false;
    }
  } catch (state) {
    const errorMessage = errorString$1(state);
    console.error(errorMessage);
    return { error: errorMessage };
  }
}
async function getRecentSnaps(sendingData) {
  try {
    console.log("sendingData (snapshots.ts - getRecentSnaps):", sendingData);
    const state = useSpawn$1(["/usr/bin/env", "python3", "-c", get_recent_snaps_script, sendingData.recvName, sendingData.recvHost, sendingData.recvPort, sendingData.recvHostUser], { superuser: "try" });
    const output = await state.promise();
    console.log(output);
    return output.stdout;
  } catch (state) {
    const errorMessage = errorString$1(state);
    console.error(errorMessage);
    return JSON.stringify({ error: errorMessage });
  }
}
async function formatRecentSnaps(sendingData, snapSnips) {
  try {
    const rawJSON = await getRecentSnaps(sendingData);
    if (rawJSON) {
      const parsedJSON = JSON.parse(rawJSON);
      parsedJSON.forEach((snap) => {
        if (snap) {
          console.log("snap:", snap);
          const snapSnip = {
            name: snap.name,
            guid: snap.guid,
            creation: convertTimestampToLocal(convertTimestampFormat(snap.creation))
          };
          console.log("snapSnip after:", snapSnip);
          snapSnips.push(snapSnip);
        } else {
          console.log("no recent snaps");
        }
      });
    } else {
      console.error("No data received from getRecentSnaps");
    }
    console.log("formatted snapSnips:", snapSnips);
  } catch (error) {
    console.error("An error occurred getting snapSnips:", error);
  }
}
const get_scan_script = "import libzfs\nimport json\n\ndef main():\n\n    with libzfs.ZFS() as zfs:\n        z_pools = {}\n\n        for p in zfs.pools:\n            pool = p.asdict()\n            if 'scan' in pool:\n                pool['scan']['start_time'] = str(pool['scan']['start_time'])\n                pool['scan']['end_time'] = str(pool['scan']['end_time'])\n                pool['scan']['pause'] = str(pool['scan']['pause'])\n                pool['scan']['name'] = pool['name']\n\n                z_pools[pool['name']] = pool['scan']\n                \n    print(json.dumps(z_pools, indent=4))\n    \nif __name__ == '__main__':\n    main()";
const get_disk_stats_script = "import libzfs\nimport json\n\ndef get_disks(group):\n    disks = []\n    for vdev in group:\n\n        if vdev['type'] == 'disk':\n            disks.append({\n                'name': vdev['name'],\n                'stats':vdev['stats'],\n                'guid': vdev['guid'],\n                'status': vdev['status'],\n            })\n        else:\n            newDisks = get_disks(vdev['children'])\n            disks = disks + newDisks\n\n    return disks\n\ndef main():\n    with libzfs.ZFS() as zfs:\n        z_pools = {}\n\n        for p in zfs.pools:\n            pool = p.asdict()\n            disks = []\n            for group in pool['groups']:\n                disks = disks + get_disks(pool['groups'][group])\n            z_pools[pool['name']] = disks\n\n    print(json.dumps(z_pools, indent=4))\nif __name__ == '__main__':\n    main()\n";
const { BetterCockpitFile, errorString, useSpawn } = index;
async function getScanGroup() {
  try {
    const cmdString = ["/usr/bin/env", "python3", "-c", get_scan_script];
    const state = useSpawn(cmdString, { superuser: "try" });
    const scans = (await state.promise()).stdout;
    return scans;
  } catch (state) {
    console.error(errorString(state));
    return null;
  }
}
async function getDiskStats() {
  try {
    const cmdString = ["/usr/bin/env", "python3", "-c", get_disk_stats_script];
    const state = useSpawn(cmdString, { superuser: "try" });
    const diskStats = (await state.promise()).stdout;
    return diskStats;
  } catch (state) {
    console.error(errorString(state));
    return null;
  }
}
const vDevs = ref$1([]);
const errors = [];
async function loadDiskStats(poolDiskStats) {
  try {
    const rawJSON = await getDiskStats();
    const parsedJSON = JSON.parse(rawJSON);
    poolDiskStats.value = parsedJSON;
  } catch (error) {
    console.error("An error occurred getting disk stats:", error);
  }
}
async function loadScanObjectGroup(scanObject) {
  try {
    const rawJSON = await getScanGroup();
    const parsedJSON = JSON.parse(rawJSON);
    scanObject.value = parsedJSON;
  } catch (error) {
    console.error("An error occurred getting scan object group:", error);
  }
}
async function loadDisksThenPools(disks, pools) {
  var _a2, _b, _c, _d, _e, _f;
  try {
    const rawJSON = await getDisks();
    const parsedJSON = JSON.parse(rawJSON);
    console.log("Disks JSON:", parsedJSON);
    for (let i2 = 0; i2 < parsedJSON.length; i2++) {
      const disk = {
        name: parsedJSON[i2].name,
        capacity: isCapacityPatternInvalid(parsedJSON[i2].capacity) ? formatCapacityString(parsedJSON[i2].capacity) : parsedJSON[i2].capacity,
        model: parsedJSON[i2].model,
        type: parsedJSON[i2].type === "Disk" ? "Disk" : parsedJSON[i2].type,
        phy_path: parsedJSON[i2].phy_path || "N/A",
        sd_path: parsedJSON[i2].sd_path || "N/A",
        vdev_path: parsedJSON[i2].type === "NVMe" ? parsedJSON[i2].sd_path : parsedJSON[i2].vdev_path,
        serial: parsedJSON[i2].serial || "N/A",
        usable: parsedJSON[i2].usable || false,
        path: parsedJSON[i2].type === "NVMe" ? parsedJSON[i2].sd_path : parsedJSON[i2].vdev_path,
        guid: "",
        status: parsedJSON[i2].health || "Unknown",
        powerOnHours: parsedJSON[i2].power_on_time || 0,
        powerOnCount: parsedJSON[i2].power_on_count || 0,
        temp: parsedJSON[i2].temp || "N/A",
        rotationRate: parsedJSON[i2].rotation_rate || 0,
        stats: {},
        errors,
        hasPartitions: parsedJSON[i2].has_partitions || false
      };
      disks.value.push(disk);
    }
    console.log("pre-loaded Disks:", disks);
    try {
      const rawJSON2 = await getPools();
      const parsedJSON2 = JSON.parse(rawJSON2);
      for (let i2 = 0; i2 < parsedJSON2.length; i2++) {
        parsedJSON2[i2].groups.data.forEach((vDev) => parseVDevData(vDev, parsedJSON2[i2].name, disks, "data"));
        parsedJSON2[i2].groups.cache.forEach((vDev) => parseVDevData(vDev, parsedJSON2[i2].name, disks, "cache"));
        parsedJSON2[i2].groups.dedup.forEach((vDev) => parseVDevData(vDev, parsedJSON2[i2].name, disks, "dedup"));
        parsedJSON2[i2].groups.log.forEach((vDev) => parseVDevData(vDev, parsedJSON2[i2].name, disks, "log"));
        parsedJSON2[i2].groups.spare.forEach((vDev) => parseVDevData(vDev, parsedJSON2[i2].name, disks, "spare"));
        parsedJSON2[i2].groups.special.forEach((vDev) => parseVDevData(vDev, parsedJSON2[i2].name, disks, "special"));
        if (parsedJSON2[i2].root_dataset != null) {
          const poolData = {
            name: parsedJSON2[i2].name,
            status: parsedJSON2[i2].status_code == "OK" ? parsedJSON2[i2].status : parsedJSON2[i2].properties.health.parsed,
            guid: parsedJSON2[i2].guid,
            properties: {
              rawsize: parsedJSON2[i2].properties.size.parsed,
              size: convertBytesToSize(parsedJSON2[i2].properties.size.parsed),
              allocated: convertBytesToSize(parsedJSON2[i2].properties.allocated.parsed),
              capacity: parsedJSON2[i2].properties.capacity.rawvalue,
              free: convertBytesToSize(parsedJSON2[i2].properties.free.parsed),
              readOnly: parsedJSON2[i2].properties.readonly.parsed,
              sector: parsedJSON2[i2].properties.ashift.rawvalue,
              record: parsedJSON2[i2].root_dataset.properties.recordsize.value,
              compression: parsedJSON2[i2].root_dataset.properties.compression.parsed,
              deduplication: onOffToBool(parsedJSON2[i2].root_dataset.properties.dedup.parsed),
              refreservationRawSize: parsedJSON2[i2].root_dataset.properties.refreservation.parsed,
              refreservationPercent: parsedJSON2[i2].root_dataset ? Number((parsedJSON2[i2].root_dataset.properties.refreservation.parsed / parsedJSON2[i2].properties.size.parsed * 100).toFixed(2)) : 0,
              autoExpand: parsedJSON2[i2].properties.autoexpand.parsed,
              autoReplace: parsedJSON2[i2].properties.autoreplace.parsed,
              autoTrim: onOffToBool(parsedJSON2[i2].properties.autotrim.parsed),
              delegation: parsedJSON2[i2].properties.delegation.parsed,
              listSnapshots: parsedJSON2[i2].properties.listsnapshots.parsed,
              health: parsedJSON2[i2].properties.health.parsed,
              altroot: parsedJSON2[i2].properties.altroot.value,
              available: convertBytesToSize((_c = (_b = (_a2 = parsedJSON2[i2]) == null ? void 0 : _a2.root_dataset) == null ? void 0 : _b.properties) == null ? void 0 : _c.available.parsed)
            },
            failMode: parsedJSON2[i2].properties.failmode.parsed,
            comment: parsedJSON2[i2].properties.comment.value !== "-" ? parsedJSON2[i2].properties.comment.value : "",
            scan: {
              name: parsedJSON2[i2].name,
              function: parsedJSON2[i2].scan.function,
              start_time: parsedJSON2[i2].scan.start_time,
              end_time: parsedJSON2[i2].scan.end_time,
              pause: parsedJSON2[i2].scan.pause,
              state: parsedJSON2[i2].scan.state,
              errors: parsedJSON2[i2].scan.errors,
              percentage: parsedJSON2[i2].scan.percentage,
              total_secs_left: parsedJSON2[i2].scan.total_secs_left,
              bytes_issued: parsedJSON2[i2].scan.bytes_issued,
              bytes_processed: parsedJSON2[i2].scan.bytes_processed,
              bytes_to_process: parsedJSON2[i2].scan.bytes_to_process
            },
            errors,
            statusCode: parsedJSON2[i2].status_code,
            statusDetail: parsedJSON2[i2].status_detail,
            errorCount: parsedJSON2[i2].error_count,
            vdevs: vDevs.value
          };
          pools.value.push(poolData);
          console.log("poolData after JSON load (with root):", poolData);
          vDevs.value = [];
        } else {
          const poolData = {
            name: parsedJSON2[i2].name,
            status: parsedJSON2[i2].status_code == "OK" ? parsedJSON2[i2].status : parsedJSON2[i2].properties.health.parsed,
            guid: parsedJSON2[i2].guid,
            properties: {
              rawsize: parsedJSON2[i2].properties.size.parsed,
              size: convertBytesToSize(parsedJSON2[i2].properties.size.parsed),
              allocated: convertBytesToSize(parsedJSON2[i2].properties.allocated.parsed),
              capacity: Number(parsedJSON2[i2].properties.capacity.rawvalue),
              free: convertBytesToSize(parsedJSON2[i2].properties.free.parsed),
              readOnly: parsedJSON2[i2].properties.readonly.parsed,
              sector: parsedJSON2[i2].properties.ashift.rawvalue,
              record: "",
              compression: false,
              deduplication: false,
              refreservationRawSize: 0,
              refreservationPercent: parsedJSON2[i2].root_dataset ? Number((parsedJSON2[i2].root_dataset.properties.refreservation.parsed / parsedJSON2[i2].properties.size.parsed * 100).toFixed(2)) : 0,
              autoExpand: parsedJSON2[i2].properties.autoexpand.parsed,
              autoReplace: parsedJSON2[i2].properties.autoreplace.parsed,
              autoTrim: onOffToBool(parsedJSON2[i2].properties.autotrim.parsed),
              delegation: parsedJSON2[i2].properties.delegation.parsed,
              listSnapshots: parsedJSON2[i2].properties.listsnapshots.parsed,
              health: parsedJSON2[i2].properties.health.parsed,
              altroot: parsedJSON2[i2].properties.altroot.value,
              available: convertBytesToSize((_f = (_e = (_d = parsedJSON2[i2]) == null ? void 0 : _d.root_dataset) == null ? void 0 : _e.properties) == null ? void 0 : _f.available.parsed)
            },
            failMode: parsedJSON2[i2].properties.failmode.parsed,
            comment: parsedJSON2[i2].properties.comment.value !== "-" ? parsedJSON2[i2].properties.comment.value : "",
            scan: {
              name: parsedJSON2[i2].name,
              function: parsedJSON2[i2].scan.function,
              start_time: parsedJSON2[i2].scan.start_time,
              end_time: parsedJSON2[i2].scan.end_time,
              pause: parsedJSON2[i2].scan.pause,
              state: parsedJSON2[i2].scan.state,
              errors: parsedJSON2[i2].scan.errors,
              percentage: parsedJSON2[i2].scan.percentage,
              total_secs_left: parsedJSON2[i2].scan.total_secs_left,
              bytes_issued: parsedJSON2[i2].scan.bytes_issued,
              bytes_processed: parsedJSON2[i2].scan.bytes_processed,
              bytes_to_process: parsedJSON2[i2].scan.bytes_to_process
            },
            errors,
            statusCode: parsedJSON2[i2].status_code,
            statusDetail: parsedJSON2[i2].status_detail,
            errorCount: parsedJSON2[i2].error_count,
            vdevs: vDevs.value
          };
          pools.value.push(poolData);
          console.log("poolData after JSON load (no root):", poolData);
          vDevs.value = [];
        }
      }
      const poolDiskTypes = pools.value.map((pool) => {
        const vDevDiskTypes = pool.vdevs.map((vDev) => {
          const diskTypes = vDev.disks.map((disk) => disk.type);
          const allSameDiskType2 = diskTypes.every((type2) => type2 === diskTypes[0]);
          return allSameDiskType2 ? diskTypes[0] : "Hybrid";
        });
        const allSameDiskType = vDevDiskTypes.every((type2) => type2 === vDevDiskTypes[0]);
        return allSameDiskType ? vDevDiskTypes[0] : "Hybrid";
      });
      pools.value.forEach((pool, index2) => {
        pool.diskType = poolDiskTypes[index2];
      });
      console.log("loaded Pools:", pools);
      await loadDisksExtraData(disks.value, pools.value);
      console.log("loaded Disks:", disks);
    } catch (error) {
      console.error("An error occurred getting pools:", error);
    }
  } catch (error) {
    console.error("An error occurred getting disks/pools:", error);
  }
}
async function loadDatasets(datasets) {
  try {
    const rawJSON = await getDatasets();
    const parsedJSON = JSON.parse(rawJSON);
    for (let i2 = 0; i2 < parsedJSON.length; i2++) {
      const dataset = {
        name: parsedJSON[i2].name,
        id: parsedJSON[i2].id,
        mountpoint: parsedJSON[i2].properties.mountpoint.value,
        pool: parsedJSON[i2].pool,
        encrypted: parsedJSON[i2].encrypted,
        key_loaded: parsedJSON[i2].key_loaded,
        type: parsedJSON[i2].type,
        inherit: false,
        properties: {
          guid: parsedJSON[i2].properties.guid.parsed,
          encryption: parsedJSON[i2].properties.encryption.parsed,
          accessTime: parsedJSON[i2].properties.atime.value,
          caseSensitivity: parsedJSON[i2].properties.casesensitivity.value,
          compression: parsedJSON[i2].properties.compression.value,
          deduplication: parsedJSON[i2].properties.dedup.value,
          dNodeSize: parsedJSON[i2].properties.dnodesize.value,
          extendedAttributes: parsedJSON[i2].properties.xattr.value,
          recordSize: parsedJSON[i2].properties.recordsize.value,
          quota: {
            value: parsedJSON[i2].properties.quota.value,
            raw: parsedJSON[i2].properties.quota.parsed,
            unit: getSizeUnitFromString(getQuotaRefreservUnit(parsedJSON[i2].properties.quota.parsed))
          },
          readOnly: parsedJSON[i2].properties.readonly.value,
          isReadOnly: onOffToBool(parsedJSON[i2].properties.readonly.value),
          available: parsedJSON[i2].properties.available.parsed,
          creation: parsedJSON[i2].properties.creation.value,
          snapshotCount: parsedJSON[i2].properties.snapshot_count.value,
          mounted: parsedJSON[i2].properties.mounted.value,
          usedbyRefreservation: convertBytesToSize(parsedJSON[i2].properties.usedbyrefreservation.parsed),
          usedByDataset: convertBytesToSize(parsedJSON[i2].properties.usedbydataset.parsed),
          canMount: parsedJSON[i2].properties.canmount.value,
          aclInheritance: parsedJSON[i2].properties.aclinherit.value,
          aclType: parsedJSON[i2].properties.acltype.value,
          checksum: parsedJSON[i2].properties.checksum.value,
          refreservation: {
            raw: parsedJSON[i2].properties.refreservation.parsed,
            value: parsedJSON[i2].properties.refreservation.value,
            unit: getSizeUnitFromString(getQuotaRefreservUnit(parsedJSON[i2].properties.refreservation.parsed))
          },
          used: parsedJSON[i2].properties.used.parsed
        },
        children: parsedJSON[i2].children,
        parentFS: getParentPath(parsedJSON[i2].name)
      };
      datasets.value.push(dataset);
    }
    console.log("loaded Datasets:", datasets);
  } catch (error) {
    console.error("An error occurred getting datasets:", error);
  }
}
function cleanDiskPath(path) {
  if (!path)
    return "";
  if (/\/dev\/sd[a-z][0-9]+$/.test(path)) {
    return path.replace(/[0-9]+$/, "");
  }
  if (/\/dev\/nvme\d+n\d+p\d+$/.test(path)) {
    return path.replace(/p\d+$/, "");
  }
  if (/-part\d+$/.test(path)) {
    return path.replace(/-part\d+$/, "");
  }
  return path;
}
async function loadDisksExtraData(disks, pools) {
  try {
    pools.forEach((pool) => {
      pool.vdevs.forEach((vDev) => {
        vDev.disks.forEach((usedDisk) => {
          const cleanedUsedDiskPath = cleanDiskPath(usedDisk.path);
          const selectedDisk = findDiskByPath(disks, cleanedUsedDiskPath);
          let statsObject;
          if (selectedDisk && selectedDisk.type == "NVMe" || selectedDisk && selectedDisk.type == "Disk" || !usedDisk.stats) {
            statsObject = vDev.stats;
          } else {
            statsObject = usedDisk.stats;
          }
          if (selectedDisk) {
            selectedDisk.guid = usedDisk.guid;
            selectedDisk.path = usedDisk.path;
            selectedDisk.stats = statsObject;
            const index2 = disks.findIndex(
              (disk) => [cleanDiskPath(disk.sd_path), cleanDiskPath(disk.phy_path), cleanDiskPath(disk.vdev_path)].includes(cleanedUsedDiskPath)
            );
            if (index2 !== -1) {
              disks[index2] = { ...selectedDisk };
            } else {
              console.error("Original disk not found in the disks array");
            }
          } else {
            console.log("Selected disk not found", usedDisk);
          }
        });
      });
    });
  } catch (error) {
    console.error("An error occurred getting extra disk data:", error);
  }
}
function parseVDevData(vDev, poolName, disks, vDevType) {
  const vDevData = {
    name: vDev.name,
    type: vDevType,
    status: vDev.status,
    stats: vDev.stats,
    guid: vDev.guid,
    selectedDisks: [],
    disks: [],
    poolName,
    path: vDev.path,
    diskType: determineDiskType(vDev, disks),
    errors: []
  };
  if (vDevData.type === "disk") {
    vDevData.path = "N/A";
  }
  const phyPathRegex = `/dev/disk/by-path/[0-9a-zA-Z:.-]+(?:-part[0-9]+)?$`;
  const sdPathRegex = `/dev/sd[a-z0-9]+[0-9]*$`;
  const nvmePathRegex = `/dev/nvme[0-9]+n[0-9]+(?:p[0-9]+)?$`;
  const vDevPathRegex = `/dev/disk/by-vdev/[0-9a-zA-Z-]+(?:-part[0-9]+)?$`;
  const idPathRegex = `/dev/disk/by-id/[0-9a-zA-Z:-]+(?:-part[0-9]+)?$`;
  const labelPathRegex = `/dev/disk/by-label/[0-9a-zA-Z-]+(?:-part[0-9]+)?$`;
  const partLabelPathRegex = `/dev/disk/by-partlabel/[0-9a-zA-Z-]+(?:-part[0-9]+)?$`;
  const partUUIDRegex = `/dev/disk/by-partuuid/[0-9a-zA-Z-]+$`;
  const uuidRegex = `/dev/disk/by-uuid/[0-9a-zA-Z-]+$`;
  const phyPathPrefix = "/dev/disk/by-path/";
  const sdPathPrefix = "/dev/";
  const idPathPrefix = "/dev/disk/by-id/";
  const labelPathPrefix = "/dev/disk/by-label/";
  const partLabelPathPrefix = "/dev/disk/by-partlabel/";
  function findDiskByPath2(vDevData2, disks2) {
    const partitionSuffixMatch = vDevData2.path.match(/(?:-part|p)?(\d+)$/);
    const partitionSuffix = partitionSuffixMatch ? partitionSuffixMatch[0] : "";
    const cleanedVDevPath = vDevData2.path.replace(/(?:-part|p)\d+$/, "");
    return disks2.value.find((disk) => {
      if (disk.sd_path.includes("nvme")) {
        return disk.sd_path + (partitionSuffix ? partitionSuffix : "") === vDevData2.path;
      } else {
        const standardDiskPath = disk.sd_path + (partitionSuffix ? partitionSuffix.replace(/^p/, "") : "");
        return disk.phy_path === cleanedVDevPath || standardDiskPath === vDevData2.path || disk.vdev_path === cleanedVDevPath || disk.id_path === cleanedVDevPath || disk.label_path === cleanedVDevPath || disk.part_label_path === cleanedVDevPath || disk.part_uuid === vDevData2.path || disk.uuid === vDevData2.path;
      }
    });
  }
  if (vDev.children.length < 1) {
    const diskVDev = ref$1();
    const diskName = ref$1("");
    const diskPath = ref$1("");
    diskVDev.value = findDiskByPath2(vDevData, disks);
    if (!diskVDev.value) {
      console.error(`Disk not found for path: ${vDevData.path}.`);
      diskVDev.value = createMissingDisk(vDev.path, vDev.name, vDevType, poolName);
    }
    if (vDevData.path.match(phyPathRegex)) {
      diskPath.value = diskVDev.value.phy_path;
      diskName.value = diskVDev.value.phy_path.replace(phyPathPrefix, "");
    } else if (vDevData.path.match(nvmePathRegex)) {
      diskPath.value = diskVDev.value.sd_path || diskVDev.value.phy_path || diskVDev.value.vdev_path;
      diskName.value = diskVDev.value.sd_path ? diskVDev.value.sd_path.replace(sdPathPrefix, "") : diskVDev.value.name;
    } else if (vDevData.path.match(sdPathRegex)) {
      diskPath.value = diskVDev.value.sd_path;
      diskName.value = diskVDev.value.sd_path.replace(sdPathPrefix, "");
    } else if (vDevData.path.match(vDevPathRegex)) {
      diskPath.value = diskVDev.value.vdev_path;
      diskName.value = diskVDev.value.name;
    } else if (vDevData.path.match(idPathRegex)) {
      diskPath.value = diskVDev.value.id_path;
      diskName.value = diskVDev.value.id_path.replace(idPathPrefix, "");
    } else if (vDevData.path.match(labelPathRegex)) {
      diskPath.value = diskVDev.value.label_path;
      diskName.value = diskVDev.value.label_path.replace(labelPathPrefix, "");
    } else if (vDevData.path.match(partLabelPathRegex)) {
      diskPath.value = diskVDev.value.part_label_path;
      diskName.value = diskVDev.value.part_label_path.replace(partLabelPathPrefix, "");
    } else if (vDevData.path.match(partUUIDRegex)) {
      diskPath.value = diskVDev.value.part_uuid;
      diskName.value = diskVDev.value.name;
    } else if (vDevData.path.match(uuidRegex)) {
      diskPath.value = diskVDev.value.uuid;
      diskName.value = diskVDev.value.name;
    }
    const notAChildDisk = {
      name: diskName.value,
      path: diskPath.value,
      guid: vDev.guid,
      type: diskVDev.value.type,
      health: diskVDev.value.status,
      stats: diskVDev.value.stats,
      capacity: isCapacityPatternInvalid(diskVDev.value.capacity) ? formatCapacityString(diskVDev.value.capacity) : diskVDev.value.capacity,
      model: diskVDev.value.model,
      phy_path: diskVDev.value.phy_path,
      sd_path: diskVDev.value.sd_path,
      vdev_path: diskVDev.value.vdev_path !== "N/A" ? diskVDev.value.vdev_path : diskVDev.value.sd_path,
      serial: diskVDev.value.serial,
      powerOnHours: diskVDev.value.powerOnHours,
      powerOnCount: diskVDev.value.powerOnCount,
      temp: diskVDev.value.temp,
      rotationRate: diskVDev.value.rotationRate,
      vDevName: vDev.name,
      poolName,
      vDevType,
      errors
    };
    if (!vDevData.disks.some((disk) => disk.guid === notAChildDisk.guid)) {
      vDevData.disks.push(notAChildDisk);
    }
  } else {
    vDev.children.forEach((child) => {
      handleDiskChild(child, vDevData, disks, vDev.name, poolName, vDevType);
    });
  }
  vDevs.value.push(vDevData);
}
function handleDiskChild(child, vDevData, disks, vDevName, poolName, vDevType) {
  const cleanedChildPath = cleanDiskPath(child.path);
  let fullDiskData = disks.value.find((disk) => {
    const cleanedDiskSdPath = cleanDiskPath(disk.sd_path);
    const cleanedPhyPath = cleanDiskPath(disk.phy_path);
    const cleanedVdevPath = cleanDiskPath(disk.vdev_path);
    const cleanedDiskPath = cleanDiskPath(disk.path);
    return cleanedDiskSdPath === cleanedChildPath || cleanedPhyPath === cleanedChildPath || cleanedVdevPath === cleanedChildPath || cleanedDiskPath === cleanedChildPath || child.path.startsWith(cleanedDiskSdPath) || child.path.startsWith(cleanedPhyPath) || child.path.startsWith(cleanedVdevPath) || child.path.startsWith(cleanedDiskPath);
  });
  if (!fullDiskData) {
    console.warn(`Disk not found for path: ${child.path}. Cleaned path: ${cleanedChildPath}`);
    return;
  }
  const childDisk = {
    name: child.name || fullDiskData.name,
    path: child.path,
    guid: child.guid,
    type: fullDiskData.type,
    health: fullDiskData.health,
    stats: child.stats || {},
    capacity: fullDiskData.capacity,
    model: fullDiskData.model,
    phy_path: fullDiskData.phy_path,
    sd_path: fullDiskData.sd_path,
    vdev_path: fullDiskData.vdev_path,
    serial: fullDiskData.serial,
    powerOnHours: fullDiskData.powerOnHours,
    powerOnCount: fullDiskData.powerOnCount,
    temp: fullDiskData.temp,
    rotationRate: fullDiskData.rotationRate,
    vDevName,
    poolName,
    vDevType,
    errors: []
  };
  if (!vDevData.disks.some((disk) => disk.guid === childDisk.guid)) {
    vDevData.disks.push(childDisk);
  }
  return childDisk;
}
function createMissingDisk(path, vDevName, vDevType, poolName) {
  console.log(`Creating placeholder for missing disk at path: ${path}`);
  return {
    name: "Missing Disk",
    path,
    guid: "N/A",
    type: "N/A",
    health: "MISSING",
    stats: {},
    capacity: "Unknown",
    model: "N/A",
    phy_path: path,
    sd_path: "",
    vdev_path: "",
    serial: "N/A",
    powerOnHours: 0,
    powerOnCount: "0",
    temp: "0",
    rotationRate: 0,
    vDevName,
    poolName,
    vDevType,
    errors: [`Disk missing from pool: ${poolName}, vDev: ${vDevName}`]
  };
}
async function loadSnapshots(snapshots) {
  try {
    const rawJSON = await getSnapshots();
    const allSnapshots = [];
    for (const dataset in rawJSON) {
      rawJSON[dataset].forEach((snapshot) => {
        const snap = {
          name: snapshot.name,
          id: snapshot.id,
          snapName: snapshot.snapshot_name,
          dataset: snapshot.dataset,
          pool: snapshot.pool,
          mountpoint: snapshot.mountpoint,
          type: snapshot.type,
          guid: snapshot.properties.guid.value,
          creationTimestamp: snapshot.properties.creation.rawvalue,
          properties: snapshot.properties,
          holds: snapshot.holds
        };
        allSnapshots.push(snap);
      });
    }
    snapshots.value = allSnapshots.sort((a2, b2) => parseFloat(a2.creationTimestamp) - parseFloat(b2.creationTimestamp));
  } catch (error) {
    console.error("An error occurred getting snapshots:", error);
  }
}
async function loadSnapshotsInPool(snapshots, poolName) {
  try {
    const rawJSON = await getSnapshotsOfPool(poolName);
    const allSnapshots = [];
    for (const dataset in rawJSON) {
      rawJSON[dataset].forEach((snapshot) => {
        const snap = {
          name: snapshot.name,
          id: snapshot.id,
          snapName: snapshot.snapshot_name,
          dataset: snapshot.dataset,
          pool: snapshot.pool,
          mountpoint: snapshot.mountpoint,
          type: snapshot.type,
          guid: snapshot.properties.guid.value,
          creationTimestamp: snapshot.properties.creation.rawvalue,
          properties: snapshot.properties,
          holds: snapshot.holds
        };
        allSnapshots.push(snap);
      });
    }
    snapshots.value = allSnapshots.sort((a2, b2) => parseFloat(a2.creationTimestamp) - parseFloat(b2.creationTimestamp));
    console.log("loaded snapshots in:", poolName, "\n", snapshots);
  } catch (error) {
    console.error("An error occurred getting snapshots:", error);
  }
}
async function loadSnapshotsInDataset(snapshots, datasetName, snapshotNotFound, snapshotFound) {
  try {
    const rawJSON = await getSnapshotsOfDataset(datasetName);
    const allSnapshots = [];
    for (const dataset in rawJSON) {
      rawJSON[dataset].forEach((snapshot) => {
        const snap = {
          name: snapshot.name,
          id: snapshot.id,
          snapName: snapshot.snapshot_name,
          dataset: snapshot.dataset,
          pool: snapshot.pool,
          mountpoint: snapshot.mountpoint,
          type: snapshot.type,
          guid: snapshot.properties.guid.value,
          creationTimestamp: snapshot.properties.creation.rawvalue,
          properties: {
            clones: snapshot.properties.clones.parsed,
            creation: {
              rawTimestamp: snapshot.properties.creation.rawvalue,
              parsed: convertTimestampToLocal(snapshot.properties.creation.parsed),
              value: snapshot.properties.creation.value
            },
            referenced: snapshot.properties.referenced,
            used: snapshot.properties.used
          },
          holds: snapshot.holds
        };
        allSnapshots.push(snap);
      });
    }
    snapshots.value = allSnapshots.sort((a2, b2) => parseFloat(a2.creationTimestamp) - parseFloat(b2.creationTimestamp));
    if (snapshots.value.length === 0) {
      if (snapshotNotFound) {
        snapshotNotFound.value = true;
      }
    } else {
      if (snapshotFound) {
        snapshotFound.value = true;
      }
    }
    console.log("loaded snapshots in:", datasetName, "\n", snapshots);
  } catch (error) {
    console.error("An error occurred getting snapshots:", error);
  }
}
function determineDiskType(vDev, disks) {
  const childDisks = vDev.children.map((child) => child.name);
  const diskTypes = childDisks.map((diskName) => {
    const disk = disks.value.find((disk2) => disk2.name === diskName);
    return disk ? disk.type : "MISSING";
  });
  const uniqueDiskTypes = new Set(diskTypes);
  if (uniqueDiskTypes.has("MISSING")) {
    return "MISSING";
  } else if (uniqueDiskTypes.size === 1) {
    return Array.from(uniqueDiskTypes)[0];
  } else if (uniqueDiskTypes.has("Disk")) {
    return "Disk";
  } else if (uniqueDiskTypes.has("SSD") || uniqueDiskTypes.has("HDD") || uniqueDiskTypes.has("NVMe")) {
    return "Hybrid";
  } else {
    return "Unknown";
  }
}
const _hoisted_1$1 = { class: "w-full h-dvh min-h-dvh overflow-visible bg-default text-default" };
const _hoisted_2 = {
  key: 0,
  class: "p-2"
};
const _hoisted_3 = {
  key: 1,
  class: "p-2"
};
const _hoisted_4 = {
  key: 2,
  class: "p-2"
};
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "ZFS",
  props: {
    tag: {}
  },
  setup(__props) {
    const props = __props;
    const truncateText = ref$1("overflow-hidden whitespace-nowrap text-ellipsis");
    const pools = ref$1([]);
    const disks = ref$1([]);
    const datasets = ref$1([]);
    const importablePools = ref$1([]);
    const importableDestroyedPools = ref$1([]);
    const snapshots = ref$1([]);
    const disksLoaded = ref$1(false);
    const poolsLoaded = ref$1(false);
    const fileSystemsLoaded = ref$1(false);
    const clearLabels = ref$1(false);
    const scanActivities = ref$1(/* @__PURE__ */ new Map());
    const scanObjectGroup = ref$1({});
    const scanIntervalID = ref$1();
    const trimActivities = ref$1(/* @__PURE__ */ new Map());
    const poolDiskStats = ref$1({});
    const diskStatsIntervalID = ref$1();
    async function initialLoad(disks2, pools2, datasets2, snapshots2) {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      fileSystemsLoaded.value = false;
      await loadDisksThenPools(disks2, pools2);
      await loadDatasets(datasets2);
      await scanNow();
      await loadScanActivities(pools2, scanActivities);
      await checkDiskStats();
      await loadTrimActivities(pools2, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
      fileSystemsLoaded.value = true;
    }
    initialLoad(disks, pools, datasets);
    async function scanNow() {
      await loadScanObjectGroup(scanObjectGroup);
    }
    async function checkDiskStats() {
      await loadDiskStats(poolDiskStats);
    }
    const dashboardComponent = ref$1();
    const loadDashboardComponent = async () => {
      const module = await __vitePreload(() => import("./Dashboard.15012e25.js"), true ? ["./Dashboard.15012e25.js","./Card.vue_vue_type_script_setup_true_lang.bc7f376e.js","./Status.vue_vue_type_script_setup_true_lang.004e1912.js","./LoadingSpinner.vue_vue_type_script_setup_true_lang.1e29135c.js","./CheckCircleIcon.cda533e2.js"] : void 0, import.meta.url);
      dashboardComponent.value = module.default;
    };
    const poolListComponent = ref$1();
    const loadPoolListComponent = async () => {
      const module = await __vitePreload(() => import("./PoolsList.dd55bcc8.js"), true ? ["./PoolsList.dd55bcc8.js","./Status.vue_vue_type_script_setup_true_lang.004e1912.js","./LoadingSpinner.vue_vue_type_script_setup_true_lang.1e29135c.js","./disclosure.64516100.js"] : void 0, import.meta.url);
      poolListComponent.value = module.default;
    };
    const fileSystemListComponent = ref$1();
    const loadFileSystemListComponent = async () => {
      const module = await __vitePreload(() => import("./FileSystemList.4182c8dc.js"), true ? ["./FileSystemList.4182c8dc.js","./LoadingSpinner.vue_vue_type_script_setup_true_lang.1e29135c.js","./SnapshotsList.vue_vue_type_script_setup_true_lang.cdee9bc6.js","./disclosure.64516100.js"] : void 0, import.meta.url);
      fileSystemListComponent.value = module.default;
    };
    watchEffect(() => {
      if (props.tag === "dashboard") {
        loadDashboardComponent();
      }
      if (props.tag === "pools") {
        loadPoolListComponent();
      }
      if (props.tag === "filesystems") {
        loadFileSystemListComponent();
      }
    });
    provide("pools", pools);
    provide("importable-pools", importablePools);
    provide("importable-destroyed-pools", importableDestroyedPools);
    provide("disks", disks);
    provide("style-truncate-text", truncateText);
    provide("datasets", datasets);
    provide("disks-loaded", disksLoaded);
    provide("datasets-loaded", fileSystemsLoaded);
    provide("pools-loaded", poolsLoaded);
    provide("clear-labels", clearLabels);
    provide("snapshots", snapshots);
    provide("scan-object-group", scanObjectGroup);
    provide("pool-disk-stats", poolDiskStats);
    provide("scan-interval", scanIntervalID);
    provide("disk-stats-interval", diskStatsIntervalID);
    provide("scan-activities", scanActivities);
    provide("trim-activities", trimActivities);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", null, [
        createBaseVNode("div", _hoisted_1$1, [
          props.tag === "dashboard" ? (openBlock(), createElementBlock("div", _hoisted_2, [
            (openBlock(), createBlock(resolveDynamicComponent(dashboardComponent.value)))
          ])) : createCommentVNode("", true),
          props.tag === "pools" ? (openBlock(), createElementBlock("div", _hoisted_3, [
            (openBlock(), createBlock(resolveDynamicComponent(poolListComponent.value)))
          ])) : createCommentVNode("", true),
          props.tag === "filesystems" ? (openBlock(), createElementBlock("div", _hoisted_4, [
            (openBlock(), createBlock(resolveDynamicComponent(fileSystemListComponent.value)))
          ])) : createCommentVNode("", true)
        ])
      ]);
    };
  }
});
const _hoisted_1 = { class: "min-h-screen h-full w-full min-w-fit flex flex-col bg-default overflow-auto" };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "App",
  setup(__props) {
    const show = ref$1(true);
    const navTag = ref$1("dashboard");
    const version2 = "1.1.15-6built_from_source";
    const currentNavigationItem = computed(() => navigation.find((item) => item.current));
    const navigationCallback = (item) => {
      navTag.value = item.tag;
    };
    const navigation = reactive([
      { name: "Dashboard", tag: "dashboard", current: computed(() => navTag.value == "dashboard"), show: true },
      { name: "Pools", tag: "pools", current: computed(() => navTag.value == "pools"), show: true },
      { name: "File Systems", tag: "filesystems", current: computed(() => navTag.value == "filesystems"), show: true }
    ].filter((item) => item.show));
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1, [
        createVNode(unref(HoustonAppContainer), {
          moduleName: "ZFS",
          appVersion: unref(version2)
        }, {
          default: withCtx(() => [
            createVNode(_sfc_main$2, {
              navigationItems: navigation,
              currentNavigationItem: currentNavigationItem.value,
              navigationCallback,
              show: show.value
            }, null, 8, ["navigationItems", "currentNavigationItem", "show"]),
            createVNode(_sfc_main$1, { tag: navTag.value }, null, 8, ["tag"])
          ]),
          _: 1
        }, 8, ["appVersion"])
      ]);
    };
  }
});
const app = createApp(_sfc_main);
app.mount("#app");
export {
  upperCaseWord as $,
  createVNode as A,
  withCtx as B,
  normalizeClass as C,
  unref as D,
  toDisplayString as E,
  createCommentVNode as F,
  formatStatus as G,
  normalizeStyle as H,
  Fragment as I,
  renderList as J,
  createBlock as K,
  resolveDynamicComponent as L,
  clearErrors as M,
  Notification as N,
  convertBytesToSize as O,
  useId as P,
  nextTick as Q,
  watchEffect as R,
  cloneVNode as S,
  Transition as T,
  h as U,
  onUnmounted as V,
  renderSlot as W,
  convertTimestampToLocal as X,
  convertSecondsToString as Y,
  createTextVNode as Z,
  __vitePreload as _,
  loadDatasets as a,
  renameSnapshot as a$,
  convertRawTimestampToString as a0,
  detachDisk as a1,
  offlineDisk as a2,
  onlineDisk as a3,
  trimDisk as a4,
  withModifiers as a5,
  removeVDevFromPool as a6,
  setRefreservation as a7,
  destroyDataset as a8,
  unmountFileSystem as a9,
  truncateName as aA,
  Modal as aB,
  getFullDiskInfo as aC,
  convertSizeToBytes as aD,
  getImportablePools as aE,
  getImportableDestroyedPools as aF,
  withKeys as aG,
  vShow as aH,
  isBoolCompression as aI,
  vModelRadio as aJ,
  importPool as aK,
  attachDisk as aL,
  replaceDisk as aM,
  onUpdated as aN,
  createEncryptedDataset as aO,
  getSizeNumberFromString as aP,
  getSizeUnitFromString as aQ,
  getQuotaRefreservUnit as aR,
  onOffToBool as aS,
  configureDataset as aT,
  getSnapshotTimestamp as aU,
  createSnapshot as aV,
  renameFileSystem as aW,
  changePassphrase as aX,
  isPassphraseValid as aY,
  unlockFileSystem as aZ,
  cloneSnapshot as a_,
  lockFileSystem as aa,
  mountFileSystem as ab,
  reactive as ac,
  getValue as ad,
  yesNoToBool as ae,
  createStaticVNode as af,
  loadSnapshots as ag,
  loadSnapshotsInPool as ah,
  loadSnapshotsInDataset as ai,
  destroySnapshot as aj,
  rollbackSnapshot as ak,
  withDirectives as al,
  vModelCheckbox as am,
  isBoolOnOff as an,
  _sfc_main$2 as ao,
  getTimestampString as ap,
  vModelSelect as aq,
  vModelText as ar,
  configurePool as as,
  shallowRef as at,
  Teleport as au,
  getCurrentInstance as av,
  isRef as aw,
  ZFSManager as ax,
  CardContainer as ay,
  getDiskIDName as az,
  loadScanObjectGroup as b,
  sendSnapshot as b0,
  index as b1,
  formatRecentSnaps as b2,
  getRawTimestampFromString as b3,
  doesDatasetExist as b4,
  doesDatasetHaveSnaps as b5,
  checkInheritance as b6,
  testSSH as b7,
  computed as c,
  defineComponent as d,
  loadScanActivities as e,
  loadDiskStats as f,
  getCapacityColor as g,
  loadTrimActivities as h,
  inject as i,
  destroyPool as j,
  labelClear as k,
  loadDisksThenPools as l,
  resilverPool as m,
  isPoolUpgradable as n,
  onMounted as o,
  pushNotification as p,
  exportPool as q,
  ref$1 as r,
  scrubPool as s,
  trimPool as t,
  upgradePool as u,
  provide as v,
  watch as w,
  openBlock as x,
  createElementBlock as y,
  createBaseVNode as z
};
